// CSBuildView.cpp : implementation of the CCSBuildView class
//

#include "stdafx.h"
//#include "types.h"
#include "MainFrm.h"
#include "CSBuild.h"
#include "Actuator.h"

#include "CSBuildDoc.h"
#include "CSBuildView.h"
#include "dlg_ObjectCounts.h"
#include "ViewLevelInfo.h"
#include "GlobalInfo.h"
#include "WarningDialog.h"
#include "Misc.h"
#include "EditActiveTimers.h"
#include "GetKey.h"
#include "FinePrint.h"
#include "EditingOptions.h"
#include "ShowLocations.h"
#include "ShowSkins.h"
#include "dlg_InsertObject.h"
#include "ListDSAs.h"
#include "Clones.h"
#include "LocateText.h"
#include "LocateDecoration.h"
#include "SwapLevels.h"
#include "Hints.h"
#include "AdvancedSearch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

bool IsValidTarget(LOCATIONREL target);


extern CMainFrame *pCMainFrame;
extern CString encipheredDataFile;
extern ui32 expectedGraphicsSignature1;
extern ui32 expectedGraphicsSignature2;
extern ui32 expectedCSBgraphicsSignature1;
extern ui32 expectedCSBgraphicsSignature2;
extern char hintKey[8];
extern bool RecordDesignOption;
extern bool DMRulesOption;
extern bool invisibleMonsters;
extern bool drawAsSize4Monsters;
extern bool extendedWallDecorations;
CCSBuildView *pMainView = NULL;

CROSSREF crossref;

char toolType2bitmapRow[9] = {1,2,5,3,7,6,0,0,1};
ROOMTYPE bitmapRow2toolType[12] = {roomBLOCKING, //roomFALSEWALL,
                                   roomSTONE,
                                   roomOPEN,
                                   roomSTAIRS,
                                   roomSTAIRS,
                                   roomPIT,
                                   roomTELEPORTER,
                                   roomDOOR,
                                   roomDOOR,
                                   roomDOOR,
                                   roomDOOR,
                                   roomNONBLOCKING}; //roomFALSEWALL};
int bitmapRow2toolSubType[12] = { 0,  //invisible FALSEWALL
                                  0,  //STONE
                                  0,  //OPEN space
                                  1,  //STAIRS down
                                 -1,  //STAIRS up
                                  0,  //PIT
                                  0,  //TELEPORTER
                                  0,  //DOOR closed east/west
                                  1,  //DOOR closed north/south
                                  2,  //DOOR open east/west
                                  3,  //DOOR open north/south
                                  1}; //Visible FALSEWALL

char *toolNames[12] = {
  "Invisible Trick Wall",
  "Wall",
  "Open Cell",
  "Stairs Down",
  "Stairs Up",
  "Pit",
  "Teleporter",
  "East/West Closed Door",
  "North/South Closed Door",
  "East/West Open Door",
  "North/South Open Door",
  "Visible Trick Wall"
};

int fontHeight = 15;
/////////////////////////////////////////////////////////////////////////////
// CCSBuildView

IMPLEMENT_DYNCREATE(CCSBuildView, CView)

BEGIN_MESSAGE_MAP(CCSBuildView, CView)
	//{{AFX_MSG_MAP(CCSBuildView)
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
	ON_UPDATE_COMMAND_UI(ID_DownLevel, OnUpdateDownLevel)
	ON_UPDATE_COMMAND_UI(ID_UpLevel, OnUpdateUpLevel)
	ON_COMMAND(ID_DownLevel, OnDownLevel)
	ON_COMMAND(ID_UpLevel, OnUpLevel)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_ViewObjectCounts, OnViewObjectCounts)
	ON_WM_KILLFOCUS()
	ON_WM_CAPTURECHANGED()
	ON_COMMAND(IDM_LevelInfo, OnLevelInfo)
	ON_COMMAND(IDM_GlobalInfo, OnGlobalInfo)
	ON_COMMAND(ID_VERIFY_TargetOfActuators, OnVERIFYTargetOfActuators)
	ON_COMMAND(ID_VerifyObjects, OnVerifyObjects)
	ON_COMMAND(ID_EditActiveTimers, OnEditActiveTimers)
	ON_COMMAND(ID_VerifyMonsters, OnVerifyMonsters)
	ON_COMMAND(IDM_CheckDecorations, OnCheckDecorations)
	ON_WM_CHAR()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(IDM_Encrypt, OnEncrypt)
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_COMMAND(IDM_PitsAndStairs, OnPitsAndStairs)
	ON_COMMAND(IDM_EditOptions, OnEditOptions)
	ON_COMMAND(IDM_FindObject, OnFindObject)
	ON_COMMAND(IDM_CheckAll, OnCheckAll)
	ON_COMMAND(ID_EditDSA, OnEditDSA)
	ON_COMMAND(ID_EditLevelInfo, OnEditLevelInfo)
	ON_COMMAND(IDM_WritePortraits, OnWritePortraits)
	ON_COMMAND(IDM_ReadPortraits, OnReadPortraits)
	ON_COMMAND(ID_TargetLines, OnTargetLines)
	ON_COMMAND(IDM_CheckText, OnCheckText)
	ON_COMMAND(IDM_DumpText, OnDumpText)
	ON_COMMAND(IDM_LocateText, OnLocateText)
	ON_COMMAND(IDM_WriteAscii, OnWriteAscii)
	ON_COMMAND(IDM_VerifyTimers, OnVerifyTimers)
	ON_WM_SETFOCUS()
	ON_COMMAND(ICM_CheckCharacterPortraits, OnCheckCharacterPortraits)
	ON_UPDATE_COMMAND_UI(ID_TargetLines, OnUpdateTargetLines)
	ON_COMMAND(IDC_SwapLevels, OnSwapLevels)
	ON_COMMAND(IDM_LocateDecoration, OnLocateDecoration)
	ON_COMMAND(IDM_PortraitFiles, OnPortraitFiles)
	ON_COMMAND(IDC_Skins, OnSkins)
	ON_COMMAND(IDM_Hints, OnHints)
	ON_COMMAND(IDM_AdvancedSearch, OnAdvancedSearch)
	ON_COMMAND(IDM_ImportCharacterData, OnImportCharacterData)
	ON_COMMAND(IDM_WriteCharacterData, OnWriteCharacterData)
	ON_COMMAND(IDM_BitmapDump, OnBitmapDump)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCSBuildView construction/destruction

void CCSBuildView::ReadBitmaps(CDC *pDC)
{
  if (m_tileBitmapValid) return;
  int n;
  int red, green, blue;
  char msg[100];
  char *tileBitmap;
  FILE *bitmapFile;
  CDC myDC;
  CBitmap *oldBM;
  char badfileMsg[] = "tiles.bmp appears damaged";
  BITMAPFILEHEADER bmfh;
  BITMAPCOREHEADER bmci;
  bitmapFile = fopen("tiles.bmp","rb");
  if (bitmapFile == NULL) DIE("Cannot find tiles.bmp file");
  if (fread(&bmfh,1,sizeof(bmfh),bitmapFile) != sizeof(bmfh))DIE(badfileMsg);
  if (fread(&m_bmi.bmiHeader,1,4,bitmapFile) != 4) DIE(badfileMsg);
  if (m_bmi.bmiHeader.biSize == sizeof(m_bmi.bmiHeader))
  {
    if (fread((char *)&m_bmi.bmiHeader + 4,1,sizeof(m_bmi.bmiHeader)-4,bitmapFile) != sizeof(m_bmi.bmiHeader)-4) DIE(badfileMsg);
  }
  else if (m_bmi.bmiHeader.biSize == sizeof(bmci))
  {
    if (fread((char *)&bmci + 4,1,sizeof(bmci)-4,bitmapFile) != sizeof(bmci)-4)DIE(badfileMsg);
    m_bmi.bmiHeader.biWidth = bmci.bcWidth;
    m_bmi.bmiHeader.biHeight = bmci.bcHeight;
    m_bmi.bmiHeader.biPlanes = bmci.bcPlanes;
    m_bmi.bmiHeader.biBitCount = bmci.bcPlanes;
    m_bmi.bmiHeader.biSizeImage = m_bmi.bmiHeader.biWidth*m_bmi.bmiHeader.biHeight*3;
  }
  else 
  {
    DIE(badfileMsg);
  };
  if (m_bmi.bmiHeader.biBitCount != 24)
  {
    DIE("tiles.bmp is not a 24-bit per pixel bitmap");
  };
  if ((m_bmi.bmiHeader.biWidth % TILECOLUMNS) != 0)
  {
    sprintf(msg,"tiles.bmp Width is not a multiple of %d",TILECOLUMNS);
    DIE(msg);
  };
  if ((m_bmi.bmiHeader.biHeight % TILEROWS) != 0)
  {
    sprintf(msg,"tiles.bmp Height is not a multiple of &d",TILEROWS);
    DIE(msg);
  };
  if (m_bmi.bmiHeader.biHeight != (m_bmi.bmiHeader.biWidth/TILECOLUMNS*TILEROWS))
  {
    sprintf(msg,"tiles.bmp  Height not width times %d/%d",TILEROWS,TILECOLUMNS);
    DIE(msg);
  };
  if (m_bmi.bmiHeader.biSizeImage != (unsigned)(m_bmi.bmiHeader.biHeight*m_bmi.bmiHeader.biWidth*m_bmi.bmiHeader.biBitCount/8))
  {
    DIE("tiles.bmp  Size is not width*height");
  };
  m_tileSize = m_bmi.bmiHeader.biWidth/3;
  tileBitmap = (char *)malloc(m_bmi.bmiHeader.biSizeImage, MALLOC026);
  if (fread(tileBitmap,1,m_bmi.bmiHeader.biSizeImage,bitmapFile) != m_bmi.bmiHeader.biSizeImage)
  {
    DIE(badfileMsg);
  };
  m_tileBitmap.CreateCompatibleBitmap(pDC,m_tileSize*(TILECOLUMNS+29),m_tileSize*(TILEROWS+2));
  myDC.CreateCompatibleDC(pDC);
  oldBM = myDC.SelectObject(&m_tileBitmap);
  n = SetDIBitsToDevice(
                    myDC.m_hDC,
                    0,             //destX
                    0,             //destY
                    m_bmi.bmiHeader.biWidth,
                    m_bmi.bmiHeader.biHeight,
                    0,             //srcX
                    0,             //srcY
                    0,             //first scan line
                    m_bmi.bmiHeader.biHeight,
                    tileBitmap,    //the pixels
                    &m_bmi, //the bmi structure
                    DIB_RGB_COLORS);
  // Copy column 0 to columns TILECOLUMN through TILECOLUMNS+14
  for (n=TILECOLUMNS; n<TILECOLUMNS+14; n++)
  {
    myDC.BitBlt(n*m_tileSize,
                0,
                m_tileSize,
                m_tileSize*TILEROWS,
                &myDC,
                0,
                0,
                SRCCOPY);
  }
  int r, y, row, col, c, x;
  COLORREF pixel0, pixel1;
  // Add the contents flags to rows 3 through 16.
  for (r=0; r<TILEROWS; r++)
  {
    y = r*m_tileSize;
    for (row=0; row<m_tileSize; row++)
    {
      for (col=0; col<m_tileSize; col++)
      {
        pixel0 = myDC.GetPixel(col,y+row);
        pixel1 = myDC.GetPixel(col+2*m_tileSize,y+row);
        if (pixel0 == pixel1) continue;
        for (c=2; c<16; c++)
        {
          x = m_tileSize * (c + 1);
          if (c&1) myDC.SetPixel(x+col,y+row,pixel1);
          if (c&2) myDC.SetPixel(x+m_tileSize-1-row,y+col,pixel1);
          if (c&4) myDC.SetPixel(x+m_tileSize-1-col,y+m_tileSize-1-row,pixel1);
          if (c&8) myDC.SetPixel(x+row,y+m_tileSize-1-col,pixel1);
        };
      };
    };
  };
  myDC.BitBlt((TILECOLUMNS+14)*m_tileSize,
              0,
              15*m_tileSize,
              TILEROWS*m_tileSize,
              &myDC,
              (TILECOLUMNS-1)*m_tileSize,
              0,
              SRCCOPY);
  for (r=0; r<TILEROWS; r++)
  {
    y = m_tileSize * r;
    for (row=0; row<m_tileSize; row++)
    {
      for (col=0; col<m_tileSize; col++)
      {
        pixel0 = myDC.GetPixel(col, y+row);
        pixel1 = myDC.GetPixel(m_tileSize+col, y+row);
        if (pixel0 == pixel1) continue;
        for (c=TILECOLUMNS+14; c<TILECOLUMNS+29; c++)
        {
          myDC.SetPixel(c*m_tileSize+col, y+row, pixel1);
        };
      };
    };
  };
  // Copy row 0 to row TILEROWS;
  myDC.BitBlt(0,
              TILEROWS*m_tileSize,
              m_tileSize*(TILECOLUMNS+14),
              m_tileSize,
              &myDC,
              0,
              0,
              SRCCOPY);
  // Copy row TILEROWS-2 to row TILEROWS+1
  myDC.BitBlt(0,
              (TILEROWS+1)*m_tileSize,
              m_tileSize*(TILECOLUMNS+14),
              m_tileSize,
              &myDC,
              0,
              m_tileSize*(TILEROWS-2),
              SRCCOPY);
  for (r=TILEROWS*m_tileSize; r<(TILEROWS+2)*m_tileSize; r++)
  {
    for (c=0; c<(TILECOLUMNS+29)*m_tileSize; c++)
    {
      pixel0 = myDC.GetPixel(c,r);

      //Add a little green to pixel
      red   = (pixel0) & 0xff;
      green = (pixel0>>8) & 0xff;
      blue  = (pixel0>>16) & 0xff;
      green = (2*green + 255) / 3;
      red = 2*red/3;
      blue = 2*blue/3;
      pixel0 =  red | (green << 8) | (blue<<16);
      myDC.SetPixel(c, r, pixel0);
    };
  };
  for (r=(0)*m_tileSize; r<(1)*m_tileSize; r++)
  {
    for (c=0; c<(TILECOLUMNS+29)*m_tileSize; c++)
    {
      pixel0 = myDC.GetPixel(c,r);

      //Add a little red to pixel
      red   = (pixel0) & 0xff;
      green = (pixel0>>8) & 0xff;
      blue  = (pixel0>>16) & 0xff;
      red = (2*red + 255) / 3;
      green = 2*green/3;
      blue = 2*blue/3;
      pixel0 =  red | (green << 8) | (blue<<16);
      myDC.SetPixel(c, r, pixel0);
    };
  };
  for (r=(11)*m_tileSize; r<(12)*m_tileSize; r++)
  {
    for (c=0; c<(TILECOLUMNS+29)*m_tileSize; c++)
    {
      pixel0 = myDC.GetPixel(c,r);

      //Add a little red to pixel
      red   = (pixel0) & 0xff;
      green = (pixel0>>8) & 0xff;
      blue  = (pixel0>>16) & 0xff;
      red = (2*red + 255) / 3;
      green = 2*green/3;
      blue = 2*blue/3;
      pixel0 =  red | (green << 8) | (blue<<16);
      myDC.SetPixel(c, r, pixel0);
    };
  };
  myDC.SelectObject(oldBM);
  free (tileBitmap);
  fclose(bitmapFile);
  m_tileBitmapValid = true;
}


CCSBuildView::CCSBuildView()
{
	// TODO: add construction code here
  int i;
  pMainView = this;
  m_tileBitmapValid = false;
  m_bitmapDump = false;
  m_LButton = false;
  m_mouseRow = m_mouseCol = m_mousePos = -1;
  m_mouseLevel = 0;
  pDoc->m_currentDisplayLevel = 0;
  m_currentTileTool = 2;
   
  for (i=0; i<MAXACLINE; i++)
  {
    m_actuatorLine[i].SetRect(-1,0,0,0);
    m_teleportLine[i].SetRect(-1,0,0,0);
  };
  //m_savedBackgroundBrush = SelectObject(&backgroundBrush);
}

CCSBuildView::~CCSBuildView()
{
}

BOOL CCSBuildView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
  BOOL result;
	result = CView::PreCreateWindow(cs);
  const char *classStr = AfxRegisterWndClass(
                     CS_DBLCLKS|CS_HREDRAW|CS_OWNDC|CS_VREDRAW,
                     0,
                     0,
                     0);
  cs.lpszClass = classStr;
  return result;
}

void CCSBuildView::DrawCell(CDC *pDC, CDC *memDC, 
                            int level, int col, int row,
                            int markCell)
{
  CELLFLAG cellFlag;
  ROOMTYPE roomType;
  int imageRow, imageCol;
  int roomState;
  int corner, center;
  RN obj;
  DBTYPE dbType;
  cellFlag = pDoc->GetCellFlag(level,col,row);
  roomType = RoomType(cellFlag);
  switch (roomType)
  {
  case roomSTONE:
    imageRow = 1;
    break;
  case roomOPEN:
    imageRow = 2;
    break;
  case roomBLOCKING: //roomFALSEWALL:
  case roomNONBLOCKING:
    if (cellFlag & 0x4) 
    {
      //Invisible
      imageRow = 0;
      if (cellFlag & 1) imageRow = TILEROWS;
    }
    else
    {
      //Visible
      imageRow = 11;
      if (cellFlag & 1) imageRow = TILEROWS+1;
    };
    break;
  case roomSTAIRS:
    imageRow = 3;
    if (cellFlag & 4) imageRow++;
    break;
  case roomPIT:
    imageRow = 5;
    break;
  case roomTELEPORTER:
    imageRow = 6;
    break;
  case roomDOOR:
    imageRow = 7;
    if (cellFlag & 8) imageRow = 8;
    roomState = cellFlag&7;
    if (  (roomState == 0)
        ||(roomState == 1)
        ||(roomState == 5) ) imageRow += 2;
    break;
  default:
    imageRow = 1;
  };
  obj = pDoc->FindFirstObject(level,col,row);
  corner = 0;
  center = 0;
  while (obj != RNeof)
  {
    dbType = obj.dbType();
    switch (dbType)
    {
    case dbDOOR: break;
    case dbTELEPORTER: break;
    case dbACTUATOR: 
      if (  (roomType == roomSTONE)
          ||(roomType == roomBLOCKING) // ||((roomType == roomFALSEWALL) && ((cellFlag &0x4) == 0))
         )
      {
        corner |= (1<<obj.pos());
      }
      else
      {
        center = 1;
      };
      break;
    case dbMONSTER:
    case dbTEXT:
    case dbWEAPON:
    case dbCLOTHING:
    case dbSCROLL:
    case dbPOTION:
    case dbCHEST:
    case dbMISC:
      if (roomType == roomSTONE)
      {
        corner |= (1<<obj.pos());
      }
      else
      {
        corner |= (1<<obj.pos());
      };
      break;
    case dbMISSILE:
      corner |= (1<<obj.pos());
      break;
    case dbCLOUD: 
      corner |= 1;
      break;
    };
    obj = pDoc->GetDBRecordLink(obj);
  };
  imageCol = 0;
  if (center == 0)
  {
    if (corner != 0) imageCol = corner + 1;
  }
  else
  {
    if (corner != 0) 
    {
      imageCol = corner + 16;
    }
    else 
    {
      imageCol = 1;
    };
  };
  pDC->BitBlt(col*m_tileSize,
              row*m_tileSize,
              m_tileSize,
              m_tileSize,
              memDC,
              imageCol*m_tileSize,
              imageRow*m_tileSize,
              SRCCOPY);
  if (markCell==1)
  {
    pDC->BitBlt(col*m_tileSize,
                row*m_tileSize,
                m_tileSize,
                m_tileSize,
                memDC,
                1*m_tileSize,
                12*m_tileSize,
                0x660046);
  };
  if (markCell==2)
  {
    pDC->BitBlt(col*m_tileSize,
                row*m_tileSize,
                m_tileSize,
                m_tileSize,
                memDC,
                2*m_tileSize,
                12*m_tileSize,
                0x660046);
  };
}


/////////////////////////////////////////////////////////////////////////////
// CCSBuildView drawing

void CCSBuildView::DrawPartyCircle(CDC *pDC)
{
    int x, y;
    CPen *pOldPen;
    CPen pen;
    pen.CreatePen(PS_SOLID,1,RGB(255,0,0));
    if (pDoc->DungeonFormat())
    {
      x = pDoc->StartingX();
      y = pDoc->StartingY();
    }
    else
    {
      x = pDoc->PartyX();
      y = pDoc->PartyY();
    };
    x = x*m_tileSize - m_tileSize/2;
    y = y*m_tileSize - m_tileSize/2;
    pDC->SelectStockObject(NULL_BRUSH);
    pOldPen = pDC->SelectObject(&pen);
    pDC->Ellipse(x,y,x+2*m_tileSize,y+2*m_tileSize);
    pDC->Ellipse(x+2, y+2, x+2*m_tileSize-2, y+2*m_tileSize-2);
    pDC->SelectObject(pOldPen);
}

void CCSBuildView::OnDraw(CDC* pDC)
{
  static bool error = false;
  static bool firstTime = true;
  CDC myDC;
  LOCATIONREL locr;
  CBitmap *origBitmap;
  int row, col;
  int toolX, toolY;
  RN obj;
	ASSERT_VALID(pDoc);
  if (firstTime)
  {
    TEXTMETRIC tm;
    pDC->GetTextMetrics(&tm);
    fontHeight = tm.tmHeight;
    firstTime = false;
  };
  if (error)return;
	// TODO: add draw code for native data here
  try
  {
    ReadBitmaps(pDC); //if not yet accomplished
  }
  catch (int)
  {
    error = true;
    PostQuitMessage(1);
  };
  if (!pDoc->IsValid()) return;
  myDC.CreateCompatibleDC(pDC);
  origBitmap = myDC.SelectObject(&m_tileBitmap);
  for (row=0; row<=pDoc->LastRow(pDoc->m_currentDisplayLevel); row++)
  {
    for (col=0; col<=pDoc->LastColumn(pDoc->m_currentDisplayLevel); col++)
    {
      DrawCell(pDC, &myDC, pDoc->CurrentDisplayLevel(), col, row);
    };
  };

  if (m_bitmapDump)
  {
    FILE *f;
    f = fopen("BitmapDump.bmp","wb");
    if (f==NULL)
    {
      MessageBox("Cannot open \"BitmapDump.bmp\"","Error",MB_OK);
    }
    else
    {
      char *bits;
      int bmsize;
      int mapWidth, mapHeight;
      CDC printDC;
      CBitmap printBitmap;
    
      BITMAP bitmap;
      BITMAPFILEHEADER bmfh;
      BITMAPINFOHEADER bmih;
      

      mapWidth  = pDoc->LastColumn(pDoc->m_currentDisplayLevel)+1;
      mapHeight = pDoc->LastRow(pDoc->m_currentDisplayLevel)+1;

      printDC.CreateCompatibleDC(pDC);
      printBitmap.CreateCompatibleBitmap(pDC,mapWidth*m_tileSize,mapHeight*m_tileSize);
      printDC.SelectObject(&printBitmap);

      printDC.BitBlt(0,0,mapWidth*m_tileSize,mapHeight*m_tileSize,pDC,0,0,SRCCOPY);


      printBitmap.GetBitmap(&bitmap);
      bmsize = bitmap.bmWidthBytes*bitmap.bmHeight;
      bmfh.bfType = ('M'<<8)+'B';
      bmfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + bmsize;
      bmfh.bfReserved1 = 0;
      bmfh.bfReserved2 = 0;
      bmfh.bfOffBits = sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER);


      bmih.biSize = sizeof(BITMAPINFOHEADER);
      bmih.biWidth = bitmap.bmWidth; 
      bmih.biHeight =  -bitmap.bmHeight; 
      bmih.biPlanes = 1; 
      bmih.biBitCount = bitmap.bmBitsPixel; 
      bmih.biCompression = BI_RGB; 
      bmih.biSizeImage = 0; 
      bmih.biXPelsPerMeter = 0; 
      bmih.biYPelsPerMeter = 0; 
      bmih.biClrUsed = 0; 
      bmih.biClrImportant = 0; 

      bits = (char *)malloc(bmsize,MALLOC002);
      printBitmap.GetBitmapBits(bmsize, bits);
      fwrite(&bmfh, sizeof(BITMAPFILEHEADER), 1, f);
      fwrite(&bmih, sizeof(bmih), 1, f);
      fwrite(bits, bmsize, 1, f);
      free(bits);
      m_bitmapDump = false;
      fclose(f);
    };
  };
  if (pDoc->m_currentDisplayLevel == pDoc->PartyLevel())
  {
    DrawPartyCircle(pDC);
  };
  for (row=0; row<TILEROWS-1; row++)
  {
    pDC->BitBlt((pDoc->LastColumn(pDoc->m_currentDisplayLevel) + 3 + row) * m_tileSize,
                m_tileSize/2,
                m_tileSize,
                m_tileSize,
                &myDC,
                0,
                row*m_tileSize,
                SRCCOPY);
  };
  toolX = (pDoc->LastColumn(pDoc->m_currentDisplayLevel) + 3)*m_tileSize;
  toolY =     m_tileSize + m_tileSize/2;  
  pDC->SetTextColor(RGB(255,255,255));
  pDC->SetBkColor(RGB(0,0,0));
  pDC->BitBlt(toolX + m_currentTileTool * m_tileSize,
              toolY,
              m_tileSize,
              m_tileSize,
              &myDC,
              0,
              (TILEROWS-1) * m_tileSize,
              SRCCOPY);
  pDC->TextOut(toolX,toolY+m_tileSize*3/2,toolNames[m_currentTileTool]);
  myDC.SelectObject(origBitmap);
}

/////////////////////////////////////////////////////////////////////////////
// CCSBuildView printing

BOOL CCSBuildView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCSBuildView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCSBuildView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CCSBuildView diagnostics

#ifdef _DEBUG
void CCSBuildView::AssertValid() const
{
	CView::AssertValid();
}

void CCSBuildView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCSBuildDoc* CCSBuildView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCSBuildDoc)));
	return (CCSBuildDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCSBuildView message handlers

char stoneOctants[4] = {1,0,2,3};
char openOctants[4] = {1,2,0,3};

int CCSBuildView::Position(int x, int y)
{
  int octant, left, top;
  CELLFLAG cf;
  ROOMTYPE rt;
  left = x / m_tileSize * m_tileSize;
  top =  y / m_tileSize * m_tileSize;
  octant = 0;
  if (x-left < m_tileSize/2) octant |= 8;
  if (y-top >= m_tileSize/2) octant |= 4;
  if (y-top > x-left) octant |= 2;
  if (m_tileSize-(y-top) > x-left) octant |= 1;
  cf = pDoc->GetCellFlag(pDoc->m_currentDisplayLevel, 
                         x/m_tileSize,
                         y/m_tileSize);
  rt = RoomType(cf);
  if (rt == roomSTONE) return stoneOctants[octant&3];
  else return openOctants[octant>>2];
}

void CCSBuildView::EraseLine(CRect *rect)
{
  int x1, y1, x2, y2;
  CDC *pDC;
  CDCHOLDER CDCHolder;
  CDC myDC;
  CBitmap *origBitmap;
  char flags[1024]; //32 x 32
  bool partyCellCircle = false;
  int width, height, absWidth, absHeight, x, y;
  int i, temp;
  int row, col;
  int tl, tr, bl, br;
  int pX, pY;
  x1 = rect->TopLeft().x*m_tileSize + m_tileSize/2;
  y1 = rect->TopLeft().y*m_tileSize + m_tileSize/2;
  x2 = rect->BottomRight().x*m_tileSize + m_tileSize/2;
  y2 = rect->BottomRight().y*m_tileSize + m_tileSize/2;
  memset(flags,0,1024);
  absWidth = width = x2-x1;
  if (width < 0) absWidth = -width;
  absHeight = height = y2-y1;
  if (height < 0) absHeight = -height;
  if (absWidth >= absHeight)
  { // Mostly horizontal line.
    if (width == 0) width = absWidth = m_tileSize;
    if (x1 > x2)
    { //Go left to right.
      temp = x1; x1 = x2; x2 = temp; width = -width;
      temp = y1; y1 = y2; y2 = temp; height = -height;
    };
    x = x1 + m_tileSize/2;
    for (i=0; i<width/m_tileSize; i++)
    {
      y = y1 + (x-x1)*height/width;
      tl = 32*((y+3)/m_tileSize) + (x-3)/m_tileSize;
      tr = 32*((y-3)/m_tileSize) + (x-3)/m_tileSize;
      bl = 32*((y+3)/m_tileSize) + (x+3)/m_tileSize;
      br = 32*((y-3)/m_tileSize) + (x+3)/m_tileSize;
      if ((tl>=0)&&(tl<=1023)) flags[tl] = 1;
      if ((tr>=0)&&(tr<=1023)) flags[tr] = 1;
      if ((bl>=0)&&(bl<=1023)) flags[bl] = 1;
      if ((br>=0)&&(br<=1023)) flags[br] = 1;
      x += m_tileSize;
    };
  }
  else
  { // Mostly vertical line
    if (height == 0) return;
    if (y1 > y2)
    { //Go top to bottom.
      temp = x1; x1 = x2; x2 = temp; width = -width;
      temp = y1; y1 = y2; y2 = temp; height = -height;
    };
    y = y1 + m_tileSize/2;
    for (i=0; i<height/m_tileSize; i++)
    {
      x = x1 + (y-y1)*width/height;
      tl = 32*((y+3)/m_tileSize) + (x-3)/m_tileSize;
      tr = 32*((y-3)/m_tileSize) + (x-3)/m_tileSize;
      bl = 32*((y+3)/m_tileSize) + (x+3)/m_tileSize;
      br = 32*((y-3)/m_tileSize) + (x+3)/m_tileSize;
      if ((tl>=0)&&(tl<=1023)) flags[tl] = 1;
      if ((tr>=0)&&(tr<=1023)) flags[tr] = 1;
      if ((bl>=0)&&(bl<=1023)) flags[bl] = 1;
      if ((br>=0)&&(br<=1023)) flags[br] = 1;
      y += m_tileSize;
    };
  };
  GetDC(pDC);
  myDC.CreateCompatibleDC(pDC);
  origBitmap = myDC.SelectObject(&m_tileBitmap);
  pX = pDoc->PartyX();
  pY = pDoc->PartyY();
  for (row=0; row<=pDoc->LastRow(pDoc->m_currentDisplayLevel); row++)
  for (col=0; col<=pDoc->LastColumn(pDoc->m_currentDisplayLevel); col++)
  {
    if (flags[32*row + col]) 
    {
      DrawCell(pDC, &myDC, pDoc->CurrentDisplayLevel(),col, row);
      if (  (col >= pX-1)
          &&(col <= pX+1)
          &&(row >= pY-1)
          &&(row <= pY+1)
         ) partyCellCircle = true;
    };
  };
  if (   partyCellCircle 
      && (pDoc->CurrentDisplayLevel() == pDoc->PartyLevel()))
  {
    DrawPartyCircle(pDC);
  };
  ReleaseDC(pDC);
}

void CCSBuildView::DrawLine(CDC *pDC, CRect *rect, COLORREF color)
{
  CPen pen;
  CPen *oldPen;
  pen.CreatePen(PS_SOLID,3,color);
  oldPen = pDC->SelectObject(&pen);
  pDC->MoveTo(rect->TopLeft().x*m_tileSize + m_tileSize/2,
              rect->TopLeft().y*m_tileSize + m_tileSize/2);
  pDC->LineTo(rect->BottomRight().x*m_tileSize + m_tileSize/2,
              rect->BottomRight().y*m_tileSize + m_tileSize/2);
  pDC->SelectObject(oldPen);
}

bool CCSBuildView::GetTargets(const RN objActuator,
                              const LOCATIONREL& locr,
                              const int n,
                              LOCATIONREL& locrt)
{
  DB3 *pActuator;
  pActuator = pDoc->GetRecordAddressDB3(objActuator);
  locrt = pActuator->GetNthTarget(locr, n);
  if (locrt.l() == -1) return false;
  return true;
}


CCSBuildView::TARGET::TARGET(void)
{
  m_next = NULL;
}

CCSBuildView::TARGET::~TARGET(void)
{
  ASSERT(m_next == NULL);
}

CCSBuildView::TARGETS::TARGETS(void)
{
  m_first = NULL;
}

CCSBuildView::TARGETS::~TARGETS(void)
{
  Clear();
}

void CCSBuildView::TARGETS::Clear(void)
{
  TARGET *temp;
  while (m_first != NULL)
  {
    temp = m_first;
    m_first = temp->m_next;
    temp->m_next = NULL;
    delete temp;
  };
}

void CCSBuildView::TARGETS::AddTarget(LOCATIONREL locr)
{
  TARGET *pT;
  pT = new TARGET;
  pT->m_locr = locr;
  pT->m_next = m_first;
  m_first = pT;
}  


void CCSBuildView::DrawTeleportorLines(int level, int col, int row)
{
  CDC *pDC;
  CDCHOLDER CDCHolder;
  LOCATIONREL locr;
  RN objTeleporter;
  DB1 *pTeleporter;
  int destLevel;
  int numTeleporter = 0;
  int j;
  GetDC(pDC);
  for (objTeleporter = pDoc->FindFirstTeleporter(level,col,row);
       objTeleporter != RNeof;
       objTeleporter = pDoc->FindNextTeleporter(objTeleporter))
  {
    pTeleporter = pDoc->GetRecordAddressDB1(objTeleporter);
    destLevel = pTeleporter->destLevel();
    if (numTeleporter < MAXACLINE)
    {
      locr.l(pTeleporter->destLevel());
      locr.x(pTeleporter->destX());
      locr.y(pTeleporter->destY());
      locr.p(0);
      m_targets.AddTarget(locr);
    };
    if ((destLevel == level) && (numTeleporter<MAXACLINE))
    {
      for (j=0; j<numTeleporter; j++)
      {
        if (m_teleportLine[j].right != pTeleporter->destX())continue;
        if (m_teleportLine[j].bottom!= pTeleporter->destY())continue;
        break;
      };
      if (j == numTeleporter)
      {
        m_teleportLine[numTeleporter].SetRect(
                      col,
                      row,
                      pTeleporter->destX(),
                      pTeleporter->destY());
        DrawLine(pDC, &m_teleportLine[numTeleporter++],RGB(255,0,255));
      };
    };
  };
  ReleaseDC;
}

void CCSBuildView::DrawTeleporteeLines(const LOCATIONREL& locr)
{
  CDCHOLDER CDCHolder;
  LOCATIONREL teleporterLocr;
  RN objTeleporter;
  CDC *pDC;
  int numTeleporter = 0;
  GetDC(pDC);
  int j;
//  for (locrs.First(); locrs.Next();)
//  {
//    objTeleporter = pDoc->FindFirstTeleporter(locrs);
//    if (objTeleporter == RNeof) continue;
//  pTeleporter = pDoc->GetRecordAddressDB1(objTeleporter);
//    destLevel = pTeleporter->destLevel();
//    if (pTeleporter->destLevel() != locr.l()) continue;
//    if (pTeleporter->destX() != locr.x()) continue;
//    if (pTeleporter->destY() != locr.y()) continue;
  for (teleporterLocr = crossref.FirstTrigger(locr, 0);
       teleporterLocr.l() >= 0;
       teleporterLocr = crossref.NextTrigger())
  {
    if (teleporterLocr.l() != locr.l()) continue;
    if (numTeleporter>=MAXACLINE) continue;
    teleporterLocr.p(0);
    m_targets.AddTarget(teleporterLocr);
    for (j=0; j<numTeleporter; j++)
    {
      if (m_teleportLine[j].right != teleporterLocr.x())continue;
      if (m_teleportLine[j].bottom!= teleporterLocr.y())continue;
      break;
    };
    if (j == numTeleporter)
    {
      m_teleportLine[numTeleporter].SetRect(
                    teleporterLocr.x(),
                    teleporterLocr.y(),
                    locr.x(),
                    locr.y());
      DrawLine(pDC, &m_teleportLine[numTeleporter++],RGB(128,128,0));
    };
  };
  ReleaseDC;
}

void CCSBuildView::DrawActuatorLines(const LOCATIONREL& locr)
{
  CDCHOLDER CDCHolder;
  RN objActuator, obj, p;
  CDC *pDC;
  //int x, y;
  int j, n;
  int numActuator = 0;
  LOCATIONREL locrt;
  GetDC(pDC);
  for (obj = pDoc->FindFirstObject(locr);
       obj != RNeof;
       obj = pDoc->GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbACTUATOR)
    {
      objActuator = obj;
    }
    else
    {
      if (obj.dbType() != dbMONSTER)
      {
        continue;
      }
      else
      {
        DB4 *pDB4;
        pDB4 = pDoc->GetRecordAddressDB4(obj);
        for (p=pDB4->possession(); p!=RNeof; p=pDoc->GetDBRecordLink(p))
        {
          if (p.dbType() == dbACTUATOR) break;
        };
        if (p == RNeof) continue;
        objActuator = p;
      };
    };
    for (n=0; GetTargets(objActuator,locr,n,locrt); n++)
    {
      if (numActuator < MAXACLINE)
      {
        m_targets.AddTarget(locrt);
      };
      if (locrt.l() != locr.l()) continue;
      for (j=0; j<numActuator; j++)
      {
        if (m_actuatorLine[j].right != locrt.x())continue;
        if (m_actuatorLine[j].bottom!= locrt.y())continue;
        break;
      };
      if (j == numActuator)
      {
        m_actuatorLine[numActuator].SetRect(
                      locr.x(),
                      locr.y(),
                      locrt.x(),
                      locrt.y());
        DrawLine(pDC, &m_actuatorLine[numActuator++], RGB(255,0,0));
      };
    };
  };
  ReleaseDC;
}

void CCSBuildView::DrawActuateeLines(const LOCATIONREL& locr)
{
  CDCHOLDER CDCHolder;
  int j;
  CDC *pDC;
  GetDC(pDC);
  int numActuator = 0;
  LOCATIONREL actuatorLocr, locrt;
  //ACTUATORCLASS acClass;
  RN objActuator;
  for (actuatorLocr = crossref.FirstTrigger(locr, 1);
       actuatorLocr.l() >= 0;
       actuatorLocr = crossref.NextTrigger())
  {
    if (actuatorLocr.l() != pDoc->CurrentDisplayLevel()) continue;
    if (numActuator < MAXACLINE)
    {
      m_targets.AddTarget(actuatorLocr);
    };
    for (j=0; j<numActuator; j++)
    {//Delete duplicates
      if (m_actuatorLine[j].left != actuatorLocr.x())continue;
      if (m_actuatorLine[j].top  != actuatorLocr.y())continue;
      break;
    };
    if (j == numActuator)
    {
      m_actuatorLine[numActuator].SetRect(
                    actuatorLocr.x(),
                    actuatorLocr.y(),
                    locr.x(),
                    locr.y());
      DrawLine(pDC, &m_actuatorLine[numActuator++], RGB(0,128,192));
    };
  };
  ReleaseDC;
}

void CCSBuildView::ClearNotesArea(int *top, int *left)
{
  CDCHOLDER CDCHolder;
  CDC *pDC;
  int toolX, toolY;
  GetDC(pDC);
  toolX = (pDoc->LastColumn(pDoc->m_currentDisplayLevel) + 2)*m_tileSize;
  toolY =     m_tileSize + m_tileSize/2;  
  *left = toolX;
  *top = toolY + 60;
  pDC->BitBlt(*left,
              *top,
              800,
              600,
              pDC,
              0,
              0,
              BLACKNESS);
  ReleaseDC;
}

int CCSBuildView::ListCellType(int top, int left,
                               int col, int row)
{
  CDCHOLDER CDCHolder;
  int y;
  CDC *pDC;
  CELLFLAG cf;
  CString line;
  GetDC(pDC);
  LOCATIONREL locr;
  LOCATIONABS loca;
  y = top;
  locr.l(pDoc->m_currentDisplayLevel);
  locr.x(col);
  locr.y(row);
  locr.p(0);
  cf = pDoc->GetCellFlag(locr);
  switch(RoomType(cf))
  {
  case roomSTAIRS:
    line.Format("Stairs(%s)",
                (cf&4)?"Up":"Down");
    pDC->TextOut(left, y,
                 line, line.GetLength());
    y += fontHeight;
    break;
  case roomBLOCKING:
  case roomNONBLOCKING:
    if ((cf & 0x04) != 0) line = "Invisible Trick Wall";
    else                  line = "Visible Trick Wall";
    if (cf & 1) line += " Non-blocking";
    else        line += " Blocking";
    pDC->TextOut(left, y,
                 line, line.GetLength());
    y += fontHeight;
    break;
  case roomPIT:
    if (cf & 1) line = "False, ";
    else        line = "Real, ";
    if (cf & 4) line += "Obscure ";
    else        line += "Obvious ";
    line += "Pit";
    if (cf & 8) line += "(Open)";
    else        line += "(Closed)";
    pDC->TextOut(left, y,
                 line, line.GetLength());
    y += fontHeight;
    break;
  default: break;
  };
  ReleaseDC;
  return y - top;
}

/*
int CCSBuildView::ListTargets(int top, int left)
{
  CDCHOLDER CDCHolder;
  int y;
  CDC *pDC;
  TARGET *pT;
  CString targetLine;
  GetDC(pDC);
  LOCATIONREL locr;
  LOCATIONABS loca;
  y = top;
  for (pT=m_targets.First(); pT!=NULL; pT=m_targets.Next(pT))
  {
    locr = pT->Locr();
    loca = locr;
    targetLine.Format("%d(%02d,%02d)%d",
        loca.l, loca.x,loca.y, loca.p);
    pDC->TextOut(left, y,
                 targetLine, targetLine.GetLength());
    y += fontHeight;
  };
  ReleaseDC;
  return y - top;
}
*/
int CCSBuildView::ListCellObjects(int top, int left,
                                  int col, int row)
{
  CDCHOLDER CDCHolder;
  CDC *pDC;
  CString line;
  CString remainder;
  CString triggerName;
  MODIFIEDOBJECTTYPE trigger;
  RN obj;
  LOCATIONREL locr, locrt;
  CELLFLAG cf;
  int y, n;
  DBTYPE objType;
  int numObject = 0;
  GetDC(pDC);
  locr.l(pDoc->m_currentDisplayLevel);
  locr.x(col);
  locr.y(row);
  locr.p(0);
  cf = pDoc->GetCellFlag(locr);
  y = top;
  for (obj = pDoc->FindFirstObject(locr);
       obj != RNeof;
       obj = pDoc->GetDBRecordLink(obj))
  {
    if (numObject > 10)
    {
      pDC->TextOut(left, y, "...and more...",14);
      y+=fontHeight;
      break;
    };
    objType = obj.dbType();
    switch(objType)
    {
    case dbTELEPORTER:
      line = obj.Name(RoomType(locr));
      if (cf & 8) line += "Active";
      else line += "Inactive";
      if (cf & 4) line += "-Visible-";
      else line += "-Invisible-";
      line+=pDoc->GetRecordAddressDB1(obj)->dest().Format();
      break;
    case dbSCROLL:
      {
        DB7 *pDB7;
        RN RNtext;
        CString rawline;
        pDB7 = pDoc->GetRecordAddressDB7(obj);
        RNtext = pDB7->text();
        if (RNtext.dbType() != dbTEXT)
        {
          line = "Scoll with illegal contents";
          break;
        };
        rawline = pDoc->GetRawText(RNtext, TEXTTYPE_SCROLL);
        line = DecodeText(rawline, TEXTTYPE_SCROLL);
        line.Replace("\n"," ");
        line = CString("Scroll \"") + line + "\"";
      };
      break;
    case dbMONSTER:
      {
        DB4 *pDB4;
        RN possession;
        int totalhp;
        int i;
        MONSTERTYPE mt;
        pDB4 = pDoc->GetRecordAddressDB4(obj);
        for (i=0, totalhp=0; i<pDB4->numMonster(); i++)
        {
          totalhp += pDB4->hitPoints(i);
        };
        mt = pDB4->monsterType();
        line.Format("%d %s HP=%d",pDB4->numMonster(),mt.Name(pDB4->alternateGraphics()),totalhp);
        for (possession = pDB4->possession();
             possession != RNeof;
             possession = pDoc->GetDBRecordLink(possession))
        {
          line += "(";
          line += possession.Name(RoomType(locr));
          line += ")";
        };
      };
      break;
    case dbPOTION:
      {
        DB8 *pDB8;
        POTIONTYPE pt;
        pDB8 = pDoc->GetRecordAddressDB8(obj);
        pt = pDB8->potionType();
        line.Format("%s",pt.Name());
      };
      break;
    case dbTEXT:
      {
        ROOMTYPE rt;
        CString rawline;
        rt = RoomType(locr);
        if (rt == roomSTONE)
        {
          rawline = pDoc->GetRawText(obj, TEXTTYPE_WALL);
          line = DecodeText(rawline, TEXTTYPE_WALL);
          line.Replace("\n", "/");
        }
        else
        {
          rawline = pDoc->GetRawText(obj, TEXTTYPE_MIRROR);
          line = DecodeText(rawline, TEXTTYPE_MIRROR);
          line.Replace("\n"," ");
        };
      };
      break;
    case dbACTUATOR:
      {
        DB3 *pDB3;
        ACTUATORCLASS ac;
        CString graphic;
        ROOMTYPE rt;
        rt = RoomType(locr);
        pDB3 = pDoc->GetRecordAddressDB3(obj);
        ac = pDB3->actuatorClass(rt);
        if (ac == AC_MONSTERGENERATOR)
        {
          MONSTERTYPE mt;
//          CString graphic;
          mt = pDB3->Cast2AC_MonsterGenerator(rt)->monsterType();
//          graphic.Format("(%d)",pDB3->Cast2AC_MonsterGenerator(rt)->alternateGraphics());
          line = CString(mt.Name(pDB3->Cast2AC_MonsterGenerator(rt)->alternateGraphics())) + " Generator";
        }
        else if (ac == AC_PORTRAIT)
        {
          LOCATIONREL textLocr;
          textLocr = locr;
          switch (obj.pos())
          {
          case 0: textLocr.y(textLocr.y()-1); break;
          case 1: textLocr.x(textLocr.x()+1); break;
          case 2: textLocr.y(textLocr.y()+1); break;
          case 3: textLocr.x(textLocr.x()-1); break;
          };
          ROOMTYPE textRoomType;
          textRoomType = RoomType(textLocr);
          if (textRoomType == roomOPEN)
          {
            RN RNtext;
            RNtext = pDoc->FindFirstTextRecord(textLocr);
            if (RNtext != RNeof)
            {
              CString temp, text;
              int i;
              temp = pDoc->GetRawText(RNtext, TEXTTYPE_MIRROR);
              text = DecodeText(temp, TEXTTYPE_MIRROR);
              i = text.Find('\012');
              line += text.Left(i);
            }
            else
            {
              line = pDB3->Name(rt);
            };
          }
          else
          {
            line = pDB3->Name(rt);
          };
        }
        else
        {
          if (ac == AC_DSA)
          {
            ACTUATOR_DSA *pDSArec;
            DSA *pDSA;
            int dsaLevelIndex, dsaIndex;
            line = pDB3->Name(rt);
            pDSArec = pDB3->Cast2AC_DSA(rt);
            dsaLevelIndex = pDSArec->DSAselector();
            dsaIndex = pDoc->getDSA(locr.l(), dsaLevelIndex);
            if (dsaIndex > 255)
            {
              line += "-Illegal";
            }
            else
            {
              pDSA = pDoc->getDSA(dsaIndex);
              line += '-';
              line += pDSA->Description();
            };
          }
          else
          {
            line = pDB3->ShortName(rt);
          };
        };
        graphic = pDB3->GraphicName(locr);
        line += "(" + graphic + ")";
        trigger = pDB3->TriggerObject(locr);
        triggerName = trigger.Name();

        if (triggerName != "NONE")
        {
          line += "(" + triggerName + ")";
        };
        for (n=0; GetTargets(obj,locr,n,locrt); n++)
        {
          line += locrt.Format();
        };
        if (pDB3->OnceOnly(rt)) line += ",OO";
      };
      break;
    case dbCLOTHING:
      {
        DB6 *pDB6;
        CLOTHINGTYPE ct;
        pDB6 = pDoc->GetRecordAddressDB6(obj);
        ct = pDB6->clothingType();
        line.Format("%s",ct.Name());
      };
      break;
    case dbWEAPON:
      {
        DB5 *pDB5;
        WEAPONTYPE wt;
        pDB5 = pDoc->GetRecordAddressDB5(obj);
        wt = pDB5->weaponType();
        line.Format("%s",wt.Name());
      };
      break;
    case dbDOOR:
      {
        bool withSwitch;
        CELLFLAG cf;
        DB0 *pDB0;
        RN door;
        char *condition;
        CString doorName;
        int doorType;
        door = pDoc->FindFirstDoor(locr);
        if (door == RNeof)
        {
          line.Format("Missing Door Record");
          break;
        };
        pDB0 = pDoc->GetRecordAddressDB0(door);
        cf = pDoc->GetCellFlag(locr);
        if (pDB0==NULL)
        {
          line = "Missing Door Record";
          break;
        };
        withSwitch = pDB0->doorSwitch() != 0;
        condition = "Open";
        if ((cf & 7) == 0) condition = "Open";
        if ((cf & 7) == 4) condition = "Closed";
        if ((cf & 7) == 5) condition = "Bashed";
        doorType = pDB0->doorType();
        doorType = pDoc->DoorType(locr.l(),doorType);
        doorName = DoorTypeName(doorType);
        line.Format("%s Door%s(%s)",
                     doorName,        
                     withSwitch?"(switch)":"",
                     condition);
      };
      break;
    case dbCHEST:
      line = "Chest";
      break;
    case dbMISC:
      line = obj.Name(RoomType(locr));
      break;
    default:
      line = "???";
      break;
    };
    remainder = NicelyDecapitalize(line);
    CSize size;
    while ((size=pDC->GetTextExtent(remainder)).cx > 750-left)
    {
      int len;
      line = remainder;
      for (len=line.GetLength(); len>0; len--)
      {
        size = pDC->GetTextExtent(line, len);
        if (size.cx < 750-left) break;
      };
      if (len < 10) len = 10;
      remainder = CString("--->") + line.Right(line.GetLength() - len);
      line = line.Left(len);
      pDC->TextOut(left,y,line,line.GetLength());
      y += fontHeight;
    };
    pDC->TextOut(left,y,remainder,remainder.GetLength());
    y += fontHeight;
  };
  ReleaseDC;
  return y - top;;
}

int CCSBuildView::ListTriggers(int top, int left,
                               int col, int row)
{
  CDCHOLDER CDCHolder;
  CDC *pDC;
  CString line;
  CString remainder;
  CString triggerName;
  int type;
  bool iAmTarget;
  MODIFIEDOBJECTTYPE trigger;
  RN obj;
  LOCATIONREL myLocr, triggerLocr, targetLocr;
  CELLFLAG cf;
  int y, n;
  DBTYPE objType;
  int numObject = 0;
  GetDC(pDC);
  myLocr.l(pDoc->m_currentDisplayLevel);
  myLocr.x(col);
  myLocr.y(row);
  myLocr.p(0);
  y = top;
  for (type=0; type<2; type++) //teleporters then actuators
  {
    for (triggerLocr = crossref.FirstTrigger(myLocr,type);
         triggerLocr.l() >= 0;
         triggerLocr = crossref.NextTrigger())
    {
      cf = pDoc->GetCellFlag(triggerLocr);
      line = CString("  At ") + triggerLocr.Format();
      pDC->TextOut(left, y, line, line.GetLength());
      y += fontHeight;
      for (obj = pDoc->FindFirstObject(triggerLocr);
           obj != RNeof;
           obj = pDoc->GetDBRecordLink(obj))
      {
        if (numObject > 10)
        {
          pDC->TextOut(left, y, "...and more...",14);
          y+=fontHeight;
          break;
        };
        objType = obj.dbType();
        switch(obj.dbType())
        {
        case dbTELEPORTER:
          if (type != 0) break;
          line = obj.Name(RoomType(triggerLocr));
          if (cf & 8) line += "Active";
          else line += "Inactive";
          if (cf & 4) line += "-Visible-";
          else line += "-Invisible-";
          line+=pDoc->GetRecordAddressDB1(obj)->dest().Format();
          break;
        case dbACTUATOR:
          if (type != 1) break;
          iAmTarget = false;
          for (n=0; GetTargets(obj,triggerLocr,n,targetLocr); n++)
          {
            if (targetLocr == myLocr) {iAmTarget = true; break;};
          };
          if (iAmTarget)
          {
            DB3 *pDB3;
            ACTUATORCLASS ac;
            CString graphic;
            ROOMTYPE rt;
            rt = RoomType(triggerLocr);
            pDB3 = pDoc->GetRecordAddressDB3(obj);
            ac = pDB3->actuatorClass(rt);
            line = pDB3->ShortName(rt);
            graphic = pDB3->GraphicName(triggerLocr);
            line += "(" + graphic + ")";
            trigger = pDB3->TriggerObject(triggerLocr);
            triggerName = trigger.Name();

            if (triggerName != "NONE")
            {
              line += "(" + triggerName + ")";
            };
            if (pDB3->OnceOnly(rt)) line += ",OO";
          }
          else
          {
            line = "";
          };
          break;
        default:
          line = "";
          break;
        };
        if (line != "")
        {
          remainder = NicelyDecapitalize(line);
          CSize size;
          while ((size=pDC->GetTextExtent(remainder)).cx > 750-left)
          {
            int len;
            line = remainder;
            for (len=line.GetLength(); len>0; len--)
            {
              size = pDC->GetTextExtent(line, len);
              if (size.cx < 750-left) break;
            };
            if (len < 10) len = 10;
            remainder = CString("--->") + line.Right(line.GetLength() - len);
            line = line.Left(len);
            pDC->TextOut(left,y,line,line.GetLength());
            y += fontHeight;
          };
          pDC->TextOut(left,y,remainder,remainder.GetLength());
          y += fontHeight;
        };
      };
    };
  };
  ReleaseDC;
  return y - top;;
}

void CCSBuildView::HandleLines(int col, int row, ROOMTYPE /*rt*/)
{ //We only get here if the row or col has changed
  // or if the map has been redrawn.
  CDCHOLDER CDCHolder;
  int level;
  CDC *pDC;
  int top, left;
  CCSBuildDoc *pDoc;
  RN objTeleporter, objActuator;
  int i;
  LOCATIONREL locr;
  pDoc = GetDocument();
  GetDC(pDC);
  level = pDoc->m_currentDisplayLevel;
  locr.l(level);
  locr.x(col);
  locr.y(row);
  m_targets.Clear();
  ClearNotesArea(&top, &left);
  for (i=0; i<MAXACLINE; i++)
  {
    // First erase any old lines
    if (m_teleportLine[i].left != -1)
    {
      EraseLine(&m_teleportLine[i]);
      m_teleportLine[i].left = -1;
    };
    if (m_actuatorLine[i].left != -1)
    {
      EraseLine(&m_actuatorLine[i]);
      m_actuatorLine[i].left = -1;
    };
  };
  top += ListCellType(top, left, col, row);
  if (pDoc->m_targetMode)
  {
    DrawTeleporteeLines(locr);
    DrawActuateeLines(locr);
    ListTriggers(top, left, col, row);
  }
  else
  {
    DrawTeleportorLines(level, col, row);
    DrawActuatorLines(locr);
    ListCellObjects(top, left, col, row);
  };
  //top += ListTargets(top, left);
  ReleaseDC;
}

void CCSBuildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//static mouseRow=-1, mouseCol=-1, level=-1, mousePos=-1;
  int newMouseRow, newMouseCol, newMousePos;
  bool newPos = false;
  ROOMTYPE rt;
  int rowOffset, colOffset;
  if ((nFlags & MK_LBUTTON) == 0) m_LButton = false;
  if (m_tileBitmapValid & pDoc->IsValid())
  {
    newMouseRow = point.y/m_tileSize;
    newMouseCol = point.x/m_tileSize;
    if (    (newMouseRow <= pDoc->LastRow(pDoc->m_currentDisplayLevel))
         && (newMouseCol <= pDoc->LastColumn(pDoc->m_currentDisplayLevel))
         && (newMouseRow >= 0)
         && (newMouseCol >= 0) )
    {
      newMousePos = Position(point.x, point.y);
      if (   (newMouseRow != m_mouseRow)
          || (newMouseCol != m_mouseCol)
          || (pDoc->m_currentDisplayLevel != m_mouseLevel))
      { 
        newPos = true;
        m_mouseRow = newMouseRow;
        m_mouseCol = newMouseCol;
        m_mouseLevel    = pDoc->m_currentDisplayLevel;
        rt = RoomType(pDoc->GetCellFlag(
               m_mouseLevel, m_mouseCol, m_mouseRow));
        HandleLines(m_mouseCol, m_mouseRow, rt);
      }
      else
      {
        if (newMousePos != m_mousePos)
        {
          m_mousePos = newMousePos;
          newPos = true;
        };
      };
      if (newPos) 
      {
        if (m_LButton)
        {
          if (!CheckLClickOnDungeonMap(point.x, point.y, true))
          {
            m_LButton = false;
          };
        };
        colOffset = pDoc->OffsetX(pDoc->m_currentDisplayLevel);
        rowOffset = pDoc->OffsetY(pDoc->m_currentDisplayLevel);
        pCMainFrame->SetPositionStatus(
                    m_mouseLevel,
                    m_mouseCol+colOffset,
                    m_mouseRow+rowOffset,
                    m_mousePos);
      };
    }
    else
    {
      if (m_mousePos != -1)
      {
        pCMainFrame->SetPositionStatus(-1,-1,-1,-1);
        m_mousePos = -1;
      };
    };
  };
	CView::OnMouseMove(nFlags, point);
}

BOOL CCSBuildView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
  RECT clientRect;
  int xSize, ySize;
  if ((!pDoc->IsValid()) || (!m_tileBitmapValid))
  {
    pDC->BitBlt(0,
                0,
                1000,
                1000,
                pDC,
                0,
                0,
                BLACKNESS);
	  return 1;
  };
  xSize = m_tileSize * (pDoc->LastColumn(pDoc->m_currentDisplayLevel) + 1);
  ySize = m_tileSize * (pDoc->LastRow(pDoc->m_currentDisplayLevel) + 1);
  GetClientRect(&clientRect);
  pDC->BitBlt(xSize,
              0,
              1000,
              1000,
              pDC,
              0,
              0,
              BLACKNESS);
  pDC->BitBlt(0,
              ySize,
              xSize,
              1000,
              pDC,
              0,
              0,
              BLACKNESS);
	return 1;
}

void CCSBuildView::OnUpdateDownLevel(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(true);
}

void CCSBuildView::OnUpdateUpLevel(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(true);
}

void CCSBuildView::OnDownLevel() 
{
	// TODO: Add your command handler code here
  short controlState;
  int delta;
  if (!pDoc->IsValid()) return;
  controlState = GetKeyState(VK_CONTROL);
  if (controlState < 0) delta = pDoc->NumLevel() - 1 - pDoc->m_currentDisplayLevel;
  else delta = 1;
  if (delta > 10) delta = 10;
	if (pDoc->m_currentDisplayLevel + delta < pDoc->NumLevel()) 
  {
    pDoc->m_currentDisplayLevel += delta;
    m_mouseLevel += delta;
    pCMainFrame->SetPositionStatus(
         m_mouseLevel,
         m_mouseCol + pDoc->OffsetX(m_mouseLevel),
         m_mouseRow + pDoc->OffsetY(m_mouseLevel),
         m_mousePos);
  };
  Invalidate();
}

void CCSBuildView::OnUpLevel() 
{
	// TODO: Add your command handler code here
  short controlState;
  int delta;
  controlState = GetKeyState(VK_CONTROL);
  if (controlState < 0) delta = pDoc->m_currentDisplayLevel;
  else delta = 1;
  if (delta > 10) delta = 10;
  if (pDoc->m_currentDisplayLevel > 0)
  {
    pDoc->m_currentDisplayLevel -= delta;
    m_mouseLevel -= delta;
    pCMainFrame->SetPositionStatus(
         m_mouseLevel,
         m_mouseCol + pDoc->OffsetX(m_mouseLevel),
         m_mouseRow + pDoc->OffsetY(m_mouseLevel),
         m_mousePos);
  };
  Invalidate();
}

bool CCSBuildView::CheckClickOnTileTools(int x, int y)
{
  int levelPixelWidth;
  levelPixelWidth  = (pDoc->LastColumn(pDoc->m_currentDisplayLevel) + 1) * m_tileSize;
  y = (y - m_tileSize/2);
  x = x - levelPixelWidth - 2 * m_tileSize;
  if ( (y>=0) && (x>=0) )
  {
    x = x / m_tileSize;
    y = y / m_tileSize;
    if ( (y==0) && (x<TILEROWS-1) )
    { //Click on tile tool selection
      m_currentTileTool = x;
      Invalidate();
      return true;
    };
  };
  return false;
}



bool CCSBuildView::CheckLClickOnDungeonMap(int x, int y, bool drag)
{
  CELLFLAG cf;
  int i;
  int numCells;
  int subtype;
  bool result = false;
  ROOMTYPE roomType;
  LOCATIONREL locr;
  CELL_CHECKPOINT *pCCtemp;
  CELL_CHECKPOINT *pCCBefore[MAXCELLPERCHECKPOINT], *pCCAfter[MAXCELLPERCHECKPOINT];
  for (i=0; i<MAXCELLPERCHECKPOINT; i++)
  {
    pCCBefore[i] = pCCAfter[i] = NULL;
  };
  locr.l(pDoc->m_currentDisplayLevel);
  locr.x(x / m_tileSize);
  locr.y(y / m_tileSize);
  locr.p(0);
  if (   (locr.x() <= pDoc->LastColumn(pDoc->m_currentDisplayLevel)) 
      && (locr.y() <= pDoc->LastRow(pDoc->m_currentDisplayLevel)) )
  {
    cf = pDoc->GetCellFlag(locr);
    roomType = RoomType(cf);
    pCCBefore[0] = pDoc->CheckpointCell(locr);
    switch (bitmapRow2toolType[m_currentTileTool])
    { //New roomType
    case roomOPEN: //new roomTYPE
      result = PlaceOpenRoom(locr, drag, &pCCBefore[1]); 
      break;
    case roomSTONE: //New roomTYPE
      result = PlaceStoneRoom(locr, drag); 
      break;
    case roomSTAIRS: //new roomTYPE
      subtype = bitmapRow2toolSubType[m_currentTileTool];
      PlaceStairsRoom(locr, subtype, &pCCBefore[1]);
      break;
    case roomPIT: //new roomTYPE
      PlacePitRoom(locr,drag,&pCCBefore[1]);
      break;
    case roomTELEPORTER: //new roomTYPE
      PlaceTeleporterRoom(locr,&pCCBefore[1]);
      break;
    case roomBLOCKING: //new roomTYPE
    case roomNONBLOCKING:
      result = PlaceFalseWallRoom(locr, drag, &pCCBefore[1]);
      if (!result) break;
      pDoc->SetFalseWallVisible(
                    locr, 
                    bitmapRow2toolSubType[m_currentTileTool] != 1);
      break;
    case roomDOOR: //new roomTYPE
      subtype = bitmapRow2toolSubType[m_currentTileTool];
      PlaceDoorRoom(locr, subtype, &pCCBefore[1]);
      break;
    default: MessageBox("I have not implemented placing\nthis cell type","Sorry");
    };
    for (i=0; i<MAXCELLPERCHECKPOINT; i++)
    {
      if (pCCBefore[i] != NULL)
      {
        pCCAfter[i] = pDoc->CheckpointCell(pCCBefore[i]->Location());
        if (*pCCBefore[i] == *pCCAfter[i])
        {
          delete pCCBefore[i]; pCCBefore[i] = NULL;
          delete pCCAfter[i];  pCCAfter[i] = NULL;
        }
        else
        {
          delete pCCAfter[i]; pCCAfter[i] = NULL;
        };
      };
    };
    numCells = 0;
    for (i=0; i<MAXCELLPERCHECKPOINT; i++)
    {
      if (pCCBefore[i] != NULL)
      {
        pCCtemp = pCCBefore[i];
        pCCBefore[i] = NULL;
        pCCBefore[numCells++] = pCCtemp;
      };
    };
    for (i=0; i<numCells; i++)
    {
      if (i<numCells-1) 
      {
        pCCBefore[i]->SetFlag(CCF_NextOneGoesWithThisOne);
      };
      if (i > 0)
      {
        pCCBefore[i]->SetFlag(CCF_PrevOneGoesWithThisOne);
      };
      pDoc->WriteCellUndo(pCCBefore[i]);
      pCCBefore[i] = NULL;
    };
    // We need to set the tile type in the dungeon.
    return result;
  };
  return result;
}

void CCSBuildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
  m_LButton = false;
  if (pDoc->IsValid())  
  {
    if (!CheckClickOnTileTools(point.x, point.y))
       m_LButton = CheckLClickOnDungeonMap(point.x, point.y, false);
  };
	CView::OnLButtonDown(nFlags, point);
}

bool CCSBuildView::CheckRClickOnDungeonMap(int x, int y)
{
  CELLFLAG cf;
  ROOMTYPE rt;
  LOCATIONREL locr;
  int row, col;
  col = x / m_tileSize;
  row = y / m_tileSize;
  if (   (col <= pDoc->LastColumn(pDoc->m_currentDisplayLevel)) 
      && (row <= pDoc->LastRow(pDoc->m_currentDisplayLevel)) )
  {
    locr.l(pDoc->m_currentDisplayLevel);
    locr.x(col);
    locr.y(row);
    cf = pDoc->GetCellFlag(pDoc->m_currentDisplayLevel, col, row);
    rt = RoomType(cf);
    switch (rt)
    {
    case roomOPEN:
    case roomTELEPORTER:
    case roomPIT:
    case roomDOOR:
    case roomSTAIRS:
      EditRoomNonSTONE(col, row, rt);
      break;
    case roomSTONE:
      EditRoomSTONE(col, row);
      break;
    case roomBLOCKING:
      //if ((cf & 0x4) == 0)
      //{
        EditRoomSTONE(col, row);
        break;
      //}
      //else
      //{
    case roomNONBLOCKING:
        EditRoomNonSTONE(col, row, rt);
        break;
      //};
    };
    crossref.RebuildTriggers(locr);
    return true;
  };
  return false;
}

void CCSBuildView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
  if (pDoc->IsValid())  
  {
     CheckRClickOnDungeonMap(point.x, point.y);
  };
	CView::OnRButtonDown(nFlags, point);
}

void CCSBuildView::OnViewObjectCounts() 
{
	// TODO: Add your command handler code here
  dlg_ObjectCounts dlg;
  if (!pDoc->IsValid()) return;
  dlg.DoModal();
}

void CCSBuildView::OnKillFocus(CWnd* pNewWnd) 
{
	CView::OnKillFocus(pNewWnd);
	m_LButton = false;
	// TODO: Add your message handler code here
	
}

void CCSBuildView::OnCaptureChanged(CWnd *pWnd) 
{
	// TODO: Add your message handler code here
	m_LButton = false;
	CView::OnCaptureChanged(pWnd);
}

void CCSBuildView::OnLevelInfo() 
{
	// TODO: Add your command handler code here
  if (!pDoc->IsValid()) return;
	ViewLevelInfo dlg;
  //dlg.m_level = pDoc->CurrentDisplayLevel();
  dlg.DoModal();
}

void CCSBuildView::OnGlobalInfo() 
{
	// TODO: Add your command handler code here
	if (!pDoc->IsValid()) return;
  GlobalInfo dlg;
  dlg.DoModal();
  Invalidate();
}


void CCSBuildView::CheckOneFilterTarget(
            EXPOOL_DATA_TYPE filterType,
            char isTarget[64][32][32],
            char *name,
            CHKERRMSG *result,
            LOCATIONREL *filterLoc)
{

  
  ui32 key;
  ui32 *pRecord;
  i32 size;
  //LOCATIONREL locr;
  LOCATIONREL target;
  if (filterLoc == NULL)
  {
    key = (EDT_SpecialLocations << 24) + filterType;
    size = expool.Locate(key,&pRecord);
    if (size < 1) return;
    target.Integer(*pRecord);
  }
  else
  {
    target = *filterLoc;
  };
  if (target.l() < 0) return;
  isTarget[target.l()][target.x()][target.y()] |= 1<<target.p();
  if (!IsValidTarget(target))
  {
    CString msg;
    msg.Format("%s has no target",name);
    result->NewError(msg);
    //result += msg;
  };
  if (   (RoomType(target) != roomSTONE)  
      //&& (RoomType(target) != roomFALSEWALL)
      && (RoomType(target) != roomBLOCKING)
      && (RoomType(target) != roomNONBLOCKING)
      && (target.p() != 0))
  {
    CString msg;
    msg.Format("Warning %s targets non-zero position",name);
    result->NewError(msg);
    //result += msg;
  };
  return;
}



void CCSBuildView::CheckTargetsOfFilters(
                     char isTarget[64][32][32],
                     CHKERRMSG  *result)
{
  LOCATIONREL filterLoc;
  CheckOneFilterTarget(ESL_MONSTERATTACKFILTER, isTarget,"MonsterAttackFilter", result,NULL);
  CheckOneFilterTarget(ESL_FEEDINGFILTER, isTarget,"FeedingFilter", result,NULL);
  CheckOneFilterTarget(ESL_MONSTERMOVEFILTER, isTarget,"MonsterMoveFilter", result,NULL);
  CheckOneFilterTarget(ESL_VIEWINGFILTER, isTarget,"ViewingFilter", result,NULL);
  CheckOneFilterTarget(ESL_SOUNDFILTER, isTarget,"SoundFilter", result,NULL);
  CheckOneFilterTarget(ESL_PARTYATTACKFILTER, isTarget,"PartyAttackFilter", result,NULL);
  CheckOneFilterTarget(ESL_INDIRECTACTION, isTarget,"IndirectAction", result,NULL);
  CheckOneFilterTarget(ESL_ADJUSTSKILLSFILTER, isTarget,"AdjustSkillsFilter", result,NULL);
  CheckOneFilterTarget(ESL_DELETEMONSTERFILTER, isTarget,"DeleteMonsterFilter", result,NULL);
  filterLoc = pDoc->SpellFilterLocation();
  CheckOneFilterTarget(ESL_ILLEGAL, isTarget,"SpellFilter", result,&filterLoc);
}


void CCSBuildView::CheckTargetsOfObjectList(
                    RN obj,
                    LOCATIONREL locr,
                    char isTarget[64][32][32],
                    CHKERRMSG *result)
{
  DBTYPE objType;
  LOCATIONABS loca;
  ROOMTYPE rt;
  CString line = "";
  loca = locr;
  rt = RoomType(pDoc->GetCellFlag(locr));
  for ( ; obj != RNeof; obj = pDoc->GetDBRecordLink(obj))
  {
    objType = obj.dbType();
    switch (objType)
    {
    case dbACTUATOR:
      {
        DB3 *pActuator;
        ACTUATORCLASS ac;
        line = "";
        pActuator = pDoc->GetRecordAddressDB3(obj);
        ac = pActuator->actuatorClass(RoomType(pDoc->GetCellFlag(locr)));
        switch (ac)
        {
        case AC_DISABLED:
          break;
        case AC_ANDOR:
          line = pActuator->Cast2AC_AndOr(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_DSA:
          line = pActuator->Cast2AC_DSA(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_COUNTER:
          line = pActuator->Cast2AC_Counter(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_PUSHBUTTON:
          line = pActuator->Cast2AC_PushButton(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_PRESSUREPAD:
          line = pActuator->Cast2AC_PressurePad(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_OBJECTHOLDER:
          line = pActuator->Cast2AC_ObjectHolder(rt)->CheckTarget(locr, isTarget);
          break;
        case AC_ENDGAME:
          //line = pActuator->Cast2AC_EndGame(rt)->CheckTarget(locr, isTarget);
          break;
        case AC_SWAPOBJECT:
          line = pActuator->Cast2AC_SwapObject(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_PORTRAIT:
          line = pActuator->Cast2AC_Portrait(rt)->CheckTarget(locr,isTarget);
          break;
        case AC_LAUNCHER:
          break;
        case AC_MONSTERGENERATOR:
          break;
        default:
          line = "Not Implemented\n";
        };
        if (line != "")
        {
          CString location;
          location.Format("%02d(%02d,%02d) [%04x]",
                  loca.l,loca.x,loca.y, obj.ConvertToInteger());
          result->NewError(location);
    
          (*result) += line;
        };
      };
      break;
    case dbMONSTER:
      {
        DB4 *pMonster;
        RN possession;
        pMonster = pDoc->GetRecordAddressDB4(obj);
        possession = pMonster->possession();
        if (possession != RNeof)
        {
          CheckTargetsOfObjectList(possession, locr, isTarget, result);
        };
      };
    default:
      break;
    };
  };
}

void CCSBuildView::CheckTargetsOfActuatorAt(
                  LOCATIONREL locr,
                  char isTarget[64][32][32],
                  CHKERRMSG *result)
{
  CString line, location;
  RN obj;
  obj = pDoc->FindFirstObject(locr);
  CheckTargetsOfObjectList(obj, locr, isTarget, result);
  return;
}
                  
void CCSBuildView::CheckTriggerForActuatorAt(
                  LOCATIONREL locr,
                  char isTarget[16][32][32],
                  CHKERRMSG *result)
{
  RN obj;
  CString line, location;
  ROOMTYPE rt;
  ACTUATORCLASS ac;
  DB3 *pActuator;
  LOCATIONABS loca;
  loca = locr;
  for (obj = pDoc->FindFirstActuator(locr);
       obj != RNeof;
       obj = pDoc->FindNextActuator(obj))
  {
    if (obj.dbType() != dbACTUATOR) continue;
    locr.p(obj.pos());
    loca.p=obj.pos;
    pActuator = pDoc->GetRecordAddressDB3(obj);
    rt = RoomType(locr);
    ac = pActuator->actuatorClass(rt);
    switch (ac)
    {
    case AC_DSA:
      line = pActuator->Cast2AC_DSA(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_PRESSUREPAD:
      line = pActuator->Cast2AC_PressurePad(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_PUSHBUTTON:
      line = pActuator->Cast2AC_PushButton(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_SWAPOBJECT:
      line = pActuator->Cast2AC_SwapObject(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_UNKNOWN:
    case AC_DISABLED:
      line = pActuator->Cast2AC_Disabled(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_OBJECTHOLDER:
      line = pActuator->Cast2AC_ObjectHolder(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_LAUNCHER:
      line = pActuator->Cast2AC_Launcher(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_MONSTERGENERATOR:
      line = pActuator->Cast2AC_MonsterGenerator(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_PORTRAIT:
      //line = pActuator->Cast2AC_Portrait(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_ANDOR:
      line = pActuator->Cast2AC_AndOr(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_COUNTER:
      line = pActuator->Cast2AC_Counter(rt)->CheckTrigger(locr, isTarget);
      break;
    case AC_ENDGAME:
      line = pActuator->Cast2AC_EndGame(rt)->CheckTrigger(locr, isTarget);
      break;
    default:
      NotImplemented();
      break;
    };
    if (line != "")
    {
      location.Format("%02d(%02d,%02d)%d ",
               loca.l,loca.x,loca.y, loca.p);
      result->NewError(location);
      (*result) += line;
    };
  };
  return;
}

void CCSBuildView::CheckActuators(LOCATIONREL locr,
                                     CHKERRMSG *result)
{
  RN RNact;
  ACTUATORCLASS ac;
  DB3 *pDB3;
  ROOMTYPE rt=roomOPEN;
  int edge;
  ACTUATOR_AndOr *pAndOr;
  ACTUATOR_PressurePad *pPressurePad;
  bool rType = false;
  for (RNact = pDoc->FindFirstActuator(locr);
       RNact != RNeof;
       RNact = pDoc->FindNextActuator(RNact))
  {
    if (!rType) rt = RoomType(locr);
    rType = true;
    pDB3 = pDoc->GetRecordAddressDB3(RNact);
    ac = pDB3->actuatorClass(rt);
    switch (ac)
    {
    case AC_ANDOR:
      pAndOr = pDB3->Cast2AC_AndOr(rt);
      edge = pAndOr->Edge();
      if (    (edge != 0)
           && ((pDoc->EditingOptions() & EDIT_OPT_AllowEnhancedAndOr) == 0))
      {
        CString msg;
        LOCATIONABS loca;
        loca = locr;
        loca.p = RNact.pos();
        msg.Format("%02d(%02d,%02d)%d - Warning - Enhanced AndOr\n",
          loca.l, loca.x, loca.y, loca.p);
        result->NewError(msg);
      };
      break;
    case AC_PRESSUREPAD:
      pPressurePad = pDB3->Cast2AC_PressurePad(rt);
      if (pPressurePad->actuatorType() == 9)
      {
        if(pPressurePad->value() > 0x20)
        {
          CString msg;
          LOCATIONABS loca;
          loca = locr;
          loca.p = RNact.pos();
          msg.Format("%02d(%02d,%02d)%d - Warning - Disabled 'Party Steps On' PressurePad\n",
            loca.l, loca.x, loca.y, loca.p);
          result->NewError(msg);
        };
      };
      break;
    default:
      break;
    };
  };
  return;
}

void CCSBuildView::OnVERIFYTargetOfActuators(void) 
{
	// Every actuator should have a legitimate target.
  // And every actuator should have a legitimate trigger.
  // You should not target non-zero positions in non-STONE cells.
  WarningDialog dlg;
  dlg.m_title = "Actuator Target Warnings";
  char isTarget[64][32][32];
  CHKERRMSG result;
  memset (isTarget,0,sizeof (isTarget));
  LOCATIONREL locr;
  if (!pDoc->IsValid()) return;
  for (locr.Next(); locr.l()!=-1; locr.Next())
  {
    CheckTargetsOfActuatorAt(locr, isTarget, &result);
    CheckTargetsOfFilters(isTarget, &result);
    CheckActuators(locr, &result);
  };
  for (locr.First(); locr.l()!=-1; locr.Next())
  {
    CheckTriggerForActuatorAt(locr, isTarget, &result);
  };
  dlg.m_chkErrMsg = &result;
  if (result.FirstError() != NULL) dlg.DoModal();
  else pDoc->Information("No Problems Found");
}

void CCSBuildView::VerifyObjectList(RN obj, 
                                    CHKERRMSG *result, 
                                    LOCATIONREL locr,
                                    int containerMask)
{
  DBCOMMON *pObject;
//  CString line;
  LOCATIONABS loca;
  RN possession, contents, flyingObject;
  if (obj == RNeof) return;
  if (!obj.IsDBIndexOK()) return;
  locr.p(obj.pos());
  pObject = pDoc->GetCommonAddress(obj);
  switch (obj.dbType())
  {
   case dbDOOR:
    pObject->CastToDB0()->Verify(locr, result);
    break;
  case dbTELEPORTER:
    pObject->CastToDB1()->Verify(locr, result);
    break;
  case dbTEXT:
    pObject->CastToDB2()->Verify(locr, result, containerMask);
    break;
  case dbACTUATOR:
    pObject->CastToDB3()->Verify(locr, result);
    break;
  case dbMONSTER:
    pObject->CastToDB4()->Verify(locr, result);
    possession = pObject->CastToDB4()->possession();
    VerifyObjectList(possession, 
                     result, 
                     locr, 
                     containerMask|(1<<dbMONSTER));
    break;
  case dbWEAPON:
    pObject->CastToDB5()->Verify(locr, result);
    break;
  case   dbCLOTHING:
    pObject->CastToDB6()->Verify(locr, result);
    break;
  case dbSCROLL:
    pObject->CastToDB7()->Verify(locr, 
                                 result,
                                 containerMask|(1<<dbSCROLL));
    //wordsOfWisdom = pObject->CastToDB7()->text();
      //MarkObjectList(wordsOfWisdom, locr);
    break;
  case dbPOTION:
    pObject->CastToDB8()->Verify(locr, result);
    break;
  case dbCHEST:
    pObject->CastToDB9()->Verify(locr, result);
    contents = pObject->CastToDB9()->contents();
    VerifyObjectList(contents, 
                     result, 
                     locr,
                     containerMask|(1<<dbCHEST));
    break;
  case dbMISC:
    pObject->CastToDB10()->Verify(locr, result);
    break;
  case dbEXPOOL:
    break;
  case db12:
  case db13:
    break;
  case dbMISSILE:
    pObject->CastToDB14()->Verify(locr, result);
    flyingObject = pObject->CastToDB14()->flyingObject();
    if (!flyingObject.IsMagicSpell())
    {
      VerifyObjectList(flyingObject, 
                       result, 
                       locr,
                       containerMask|(1<<dbMISSILE));
    };
    break;
  case dbCLOUD:
    pObject->CastToDB15()->Verify(locr, result);
    break;
  };
}

void CCSBuildView::VerifyTimerObjects(CHKERRMSG *result)
{
  LOCATIONREL locr;
  int tt;
  locr.l(-1);
  for (i32 i=0; i<pDoc->NumTimers(); i++)
  {
    tt = pDoc->Timer(i)->timerFunction;
    switch (tt)
    {
    case 24: 
    case 25: VerifyObjectList(
                   pDoc->Timer(i)->timerObj8(), 
                   result,
                   locr,
                   1<<17);
             break;
    case 48:
    case 49: VerifyObjectList(
                   pDoc->Timer(i)->timerObj6(), 
                   result,
                   locr,
                   1<<17); // The flying object
             break;
    case 60:
    case 61: VerifyObjectList(
                   pDoc->Timer(i)->timerObj8(), 
                   result,
                   locr,
                   1<<17);
             break;
    };
  };
}


void CCSBuildView::VerifyCharacterObjects(CHKERRMSG *result)
{
  int i, j;
  LOCATIONREL locr;
  locr.l(-1);
  for (i=0; i<pDoc->NumCharacter(); i++)
  {
    for (j=0; j<30; j++)
    {
      if (pDoc->CharacterPossession(i,j) != RNnul)      
      {
         VerifyObjectList(pDoc->CharacterPossession(i,j), 
                          result, 
                          locr,
                          1<<16);
      };
    };
  };
  if (pDoc->ObjectInHand() != RNnul)
  {
    VerifyObjectList(pDoc->ObjectInHand(), result, locr, 1<<16);
  };

}



void CCSBuildView::VerifyAllObjects(CHKERRMSG *result)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  RN obj;
  ROOMTYPE rt;
  CELLFLAG cf;
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    cf = pDoc->GetCellFlag(locr);
    if ((cf & 0x10) != 0)
    {
      //There should be an object here.
      obj = pDoc->FindFirstObject(locr);
      if (obj == RNeof)
      {
        result->NewError(locr.Format());
        (*result) += " CF & 0x10 but **NO** Object";
      };
    };
    rt = RoomType(locr);
    switch (rt)
    {
    case roomTELEPORTER:
      if (pDoc->FindFirstTeleporter(locr) == RNeof)
      {
        result->NewError(locr.Format() + " Teleporter without teleporter");
        result->Location(locr);
      };
      break;
    case roomOPEN:
    case roomSTONE:
    case roomPIT:
    case roomSTAIRS:
    case roomBLOCKING:
    case roomNONBLOCKING:
    case roomDOOR:
      break;
    default:
      {
        CString msg;
        msg = locr.Format() + " Unknown Cell Type";
        result->NewError(msg);
        result->ErrorType(CEMT_UNKNOWNCELL);
        result->Location(locr);
      };
    };
    for (obj=pDoc->FindFirstObject(locr);
         obj != RNeof;
         obj = pDoc->GetDBRecordLink(obj))
    {
      if (!obj.IsDBIndexOK())
      {
        CString line;
        loca = locr;
        line.Format("%d(%02d,%02d) Bogus Object Index",
                    loca.l, loca.x, loca.y);
        result->NewError(line);
      };
      VerifyObjectList(obj, result, locr, 0);
    };
  };
  VerifyCharacterObjects(result);
  VerifyTimerObjects(result);
}

void CCSBuildView::OnVerifyObjects() 
{
	// TODO: Add your command handler code here
  int i, j, n, nument, index;
  ui16 *backlink;
  CLONES clones(this);
  LOCATIONREL locr;
  LOCATIONABS loca;
  //CProgressCtrl progress;
  clones.Clear();
  CString warn, line;
  CHKERRMSG result;
  RN obj, possession;
  bool warning = false;
  //RECT prect = {100,100,600,160};
  if (!pDoc->IsValid()) return;
  //progress.Create(WS_CAPTION|WS_VISIBLE|WS_CHILD,prect,this,12);
  //progress.SetWindowText("Scanning Dungeon");
  VerifyAllObjects(&result);
  clones.MarkDungeonObjects();
  clones.Analyze(&result);
  //progress.SetWindowText("Producing Report");
  if (result.FirstError() != NULL)
  {
    warning = true;
    WarningDialog Warning;
    Warning.m_title = "Cloned Object Warning";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
    if (Warning.m_repaired) return;
  };
  result.Clear();
  for (n=0; n<16; n++) //For each database type
  {
    if (n == dbEXPOOL) continue;
    nument = pDoc->GetDBSize(n);
    backlink = (ui16 *)malloc(2 * nument, MALLOC040);
    memset(backlink, 0xff, 2 * nument);
    for (i=1; i<pDoc->dataMapLength(); i++)
    {
      obj.ConstructFromInteger(i);
      if (obj.dbNum() != n) continue;
      index = obj.dbIndex();
      if (index == 0xffff) continue;
      if (index >= nument)
      {
        result.NewError("Illegal indirect index\n");
        //obj.dbIndex(0xffff);
      }
      else
      {
        backlink[index] = (ui16)i;
      };
    };
    for (i=0; i<nument; i++)
    {
      if (pDoc->GetCommonAddress((DBTYPE)n, i)->link() == RNnul) continue;
      if (    (backlink[i] == 0xffff)
           && ((pDoc->EditingOptions() & EDIT_OPT_AllowOrphanedObjects) == 0)
         )
      {
        CString m, name;
        int tx, ty;
        DB3 *pDB3;
        DB2 *pDB2;
        ACTUATORCLASS ac;
        result.NewError("orphaned object ");
        m.Format("(%d)",i);
        result += m;
        switch(n)
        {
        case dbDOOR: 
          {
            result += "DOOR";
            DB0 *pDB0;
            pDB0 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB0();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB0);
            result.DBType(dbDOOR);
          };
          break;
        case dbTELEPORTER:
          {
            result += "TELEPORTER";
            DB1 *pDB1;
            pDB1 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB1();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB1);
            result.DBType(dbTELEPORTER);
          };
          break;
        case dbMONSTER:
          {
            result += "MONSTER";
            DB4 *pDB4;
            pDB4 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB4();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB4);
            result.DBType(dbMONSTER);
          };
          break;
        case dbWEAPON:
          {
            result += "WEAPON";
            DB5 *pDB5;
            pDB5 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB5();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB5);
            result.DBType(dbWEAPON);
          };
          break;
        case dbCLOTHING:
          {
            result += "CLOTHING";
            DB6 *pDB6;
            pDB6 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB6();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB6);
            result.DBType(dbCLOTHING);
          };
          break;
        case dbSCROLL:
          {
            result += "SCROLL";
            DB7 *pDB7;
            pDB7 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB7();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB7);
            result.DBType(dbSCROLL);
          };
          break;
        case dbCHEST:
          {
            result += "CHEST";
            DB9 *pDB9;
            pDB9 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB9();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB9);
            result.DBType(dbCHEST);
          };
          break;
        case dbPOTION:
          {
            result += "POTION";
            DB8 *pDB8;
            pDB8 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB8();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB8);
            result.DBType(dbPOTION);
          };
          break;
        case dbMISC:
          {
            result += "MISC-";
            DB10 *pDB10;
            pDB10 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB10();
            result += pDB10->miscType().Name();
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB10);
            result.DBType(dbMISC);
          };
          break;
        case dbTEXT: 
          result += "TEXT";
          {
            char text[1000];
            int len;
            pDB2 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB2();
            len = pDoc->ExpandText(text+1,pDB2,TEXTTYPE_MIRROR,998);
            text[0] = ' ';
            result += CString(text,len+1);
            result.ErrorType(CEMT_ORPHANEDOBJECT);
            result.DBCommonAddress(pDB2);
            result.DBType(dbTEXT);
          };
          break;
        case dbACTUATOR: 
          m.Format("ACTUATOR(%d) ",i);
          result += m; 
          result.ErrorType(CEMT_ORPHANEDOBJECT);
          result.DBType(dbACTUATOR);
          pDB3 = pDoc->GetCommonAddress((DBTYPE)n,i)->CastToDB3();
          result.DBCommonAddress(pDB3);
          ac = pDB3->actuatorClass((ROOMTYPE)0);
          name = pDB3->Name((ROOMTYPE)0);
          switch(ac)
          {
          case AC_ANDOR:
            result += name;
            if (pDB3->Cast2AC_AndOr((ROOMTYPE)0)->localAction())
            {
              tx = ty = -1;
            }
            else
            {
              tx = pDB3->Cast2AC_AndOr((ROOMTYPE)0)->targetX();
              ty = pDB3->Cast2AC_AndOr((ROOMTYPE)0)->targetY();
            };
            break;
          case AC_COUNTER:
            result += name;
            if (pDB3->Cast2AC_Counter((ROOMTYPE)0)->localAction())
            {
              tx = ty = -1;
            }
            else
            {
              tx = pDB3->Cast2AC_Counter((ROOMTYPE)0)->targetX();
              ty = pDB3->Cast2AC_Counter((ROOMTYPE)0)->targetY();
            };
            break;
          case AC_PUSHBUTTON:
            result += name;
            if (pDB3->Cast2AC_PushButton((ROOMTYPE)0)->localAction())
            {
              tx = ty = -1;
            }
            else
            {
              tx = pDB3->Cast2AC_PushButton((ROOMTYPE)0)->targetX();
              ty = pDB3->Cast2AC_PushButton((ROOMTYPE)0)->targetY();
            };
            break;
          case AC_DISABLED:
            result += name;
            tx = -1;//((ACTUATOR_PushButton *)pDB3)->targetX();
            ty = -1;//((ACTUATOR_PushButton *)pDB3)->targetY();
            break;
          default:
            tx = -1;
            ty = -1;
          };
          m.Format("   target=(%d,%d) (relative)",tx,ty);
          result += m;
          break;
        default: m.Format("database %d", n); result += m; break;
        };
      };
    };
    free (backlink);
  };
  for (i=1; i<pDoc->dataMapLength(); i++)
  {
    if (pDoc->DataDBIndex(i) == 0xffff) continue;
    if (!clones.IsIndirectIndexReferenced(i))
    {
      DBCOMMON *pDBCommon;
      int dbIndex;
      DBTYPE dbType;
      dbType = pDoc->DataType(i);
      dbIndex = pDoc->DataDBIndex(i);
      if (dbIndex == 0xffff) continue;
      if (dbIndex >= db.NumEntry(dbType)) continue;
      pDBCommon = pDoc->GetCommonAddress(dbType, dbIndex);
      if (pDBCommon->link() == RNnul) continue;
      CString str;
      str.Format("%s-%d Valid Indirect Pointer is nowhere referenced",
                         dbNames[pDoc->DataType(i)],i);
      result.NewError(str);
      result.ErrorType(CEMT_INDIRECTNOTREFERENCED);
      result.Index1(i);
    };
  };
  if (result.FirstError() != NULL)
  {
    warning = true;
    WarningDialog Warning;
    Warning.m_title = "Orphaned Object Warning";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
  };
  result.Clear();
  for (i=0; i<pDoc->NumCharacter(); i++)
  {
    for (j=0; j<30; j++)
    {
      possession = pDoc->CharacterPossession(i, j);
      if (possession == RNnul) continue;
      if (pDoc->GetDBRecordLink(possession) != RNeof)
      {
        CString msg;
        msg.Format("Character %d possession %d is list",
                   i, j);
        result.NewError(msg);
        result.ErrorType(CEMT_CHARPOSSESSIONISLIST);
        result.Index1(i);
        result.Index2(j);
      };
    };
  };
  if (result.FirstError() != NULL)
  {
    warning = true;
    WarningDialog Warning;
    Warning.m_title = "Character Possession Warning";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
  };
  if (!warning)
  {
    pDoc->Information("No Problem Found with Objects");
  };
}

void CCSBuildView::OnEditActiveTimers() 
{
	// TODO: Add your command handler code here
	EditActiveTimers dlg;
  dlg.DoModal();
}

void CCSBuildView::OnVerifyMonsters() 
{
	// TODO: Add your command handler code here
	LOCATIONREL locr;
  RN obj;
  ROOMTYPE rt;
  MONSTERTYPE mt;
  int numMonster, posFlag, pos, i;
  DBTYPE dbType;
  DB3 *pActuator;
  DB4 *pMonster;
  ACTUATOR_MonsterGenerator *pMonsterGenerator;
  ACTUATORCLASS ac;
  CHKERRMSG result;
  if (!pDoc->IsValid()) return;
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    rt = RoomType(locr);
    for (obj = pDoc->FindFirstObject(locr);
         obj != RNeof;
         obj = pDoc->GetDBRecordLink(obj))
    {
      dbType = obj.dbType();
      switch (dbType)
      {
      case dbACTUATOR:
        pActuator = pDoc->GetRecordAddressDB3(obj);
        ac = pActuator->actuatorClass(rt);
        switch (ac)
        {
        case AC_MONSTERGENERATOR:
          pMonsterGenerator = pActuator->Cast2AC_MonsterGenerator(rt);
          mt = pMonsterGenerator->monsterType();
          if (!pDoc ->IsValidMonsterType(locr.l(), mt))
          {
            CString msg;
            msg = locr.Format() +  " Illegal Monster Generator";
            result.NewError(msg);
          };
          if (!invisibleMonsters && pMonsterGenerator->invisible())
          {
            CString msg;
            msg = locr.Format() +  " Invisible-Monster Generator";
            result.NewError(msg);
          };
          if (!drawAsSize4Monsters && pMonsterGenerator->drawAsSize4())
          {
            CString msg;
            msg = locr.Format() +  " DrawAsSize4-Monster Generator";
            result.NewError(msg);
          };
          break;
        case AC_PRESSUREPAD:
        case AC_SWAPOBJECT:
        case AC_LAUNCHER:
        case AC_ENDGAME:
        case AC_PUSHBUTTON:
        case AC_COUNTER:
        case AC_ANDOR:
        case AC_DISABLED:
        case AC_OBJECTHOLDER:
        case AC_PORTRAIT:
        case AC_DSA:
          break;
        default:
          NotImplemented();
          return;
        };
        break;
      case dbMONSTER:
        pMonster = pDoc->GetRecordAddressDB4(obj);
        mt = pMonster->monsterType();
        if (!pDoc ->IsValidMonsterType(locr.l(), mt))
        {
          CString msg;
          LOCATIONABS loca;
          loca = locr;
          msg.Format("%02d(%02d,%02d) Illegal Monster Type",
                     loca.l, loca.x, loca.y);
          result.NewError(msg);
        };
        if (!invisibleMonsters && pMonster->Invisible())
        {
          CString msg;
          LOCATIONABS loca;
          loca = locr;
          msg.Format("%02d(%02d,%02d) Invisible Monster",
                     loca.l, loca.x, loca.y);
          result.NewError(msg);
        };
        if (!drawAsSize4Monsters && pMonster->DrawAsSize4())
        {
          CString msg;
          LOCATIONABS loca;
          loca = locr;
          msg.Format("%02d(%02d,%02d) DrawAsSize4 Monster",
                     loca.l, loca.x, loca.y);
          result.NewError(msg);
        };
        numMonster = pMonster->numMonster();
        posFlag = 0;
        for (i=0; i<numMonster; i++)
        {
          int shift[4] = {0,2,4,6}; //Compiler optimization failure
          // (x>>i) Shift count treated as constant in loop.
          pos = (pMonster->positions() >> (shift[i])) & 3;
          if ((posFlag & (1<<pos)) != 0)
          {
            CString msg;
            LOCATIONABS loca;
            loca = locr;
            msg.Format("Monsters at %d(%02d,%02d) improperly positioned",
                          loca.l, loca.x, loca.y);
            result.NewError(msg);
            result.ErrorType(CEMT_MONSTERPOSITIONEDBADLY);
            result.Index1(obj.ConvertToInteger());
          };
          posFlag |= (1 << pos);
        };
        break;
      case dbTELEPORTER:
      case dbDOOR:
      case dbTEXT:
      case dbMISC:
      case dbWEAPON:
      case dbPOTION:
      case dbCLOTHING:
      case dbCHEST:
      case dbSCROLL:
      case dbMISSILE:
      case dbCLOUD:
        break;
      default:
        NotImplemented();
        return;
      };
    };
  };
  if (result.FirstError() != NULL)
  {
    WarningDialog dlg;
    dlg.m_title = "Monster Warning";
    dlg.m_chkErrMsg = &result;
    dlg.DoModal();
  }
  else
  {
    pDoc->Information("No Problem Found with Monsters");
  };
}

CString CCSBuildView::DecorationError(char *w, LOCATIONREL locr) 
{
  CString msg;
  LOCATIONABS loca;
  loca = locr;
  msg.Format("There is an illegal %s Decoration at"
             "%d(%d,%d)",w, loca.l, loca.x, loca.y);
  return msg;
}


void CCSBuildView::OnCheckDecorations() 
{
	// TODO: Add your command handler code here
  LOCATIONREL locr;
  int level;
  int i;
  FLOORTYPE ft;
  WALLTYPE wt;
  CHKERRMSG result;
  ROOMTYPE rt;
  CELLFLAG cf;
  RN obj;
  DB3 *pActuator;
  int graphicOrdinal;
  for (level=0; level<pDoc->NumLevel(); level++)
  {
    for (i=0; i<pDoc->NumFloorDecorations(level); i++)
    {
      if (!pDoc->IsLegalFloorDecorationIndex(level,i+1))
      {
        CString msg;
        msg.Format("Level %d specifies an illegal Floor Decoration "
                   "type at ordinal %d",level,i+1);
        result.NewError(msg);
      };
    };
  };
  for (level=0; level<pDoc->NumLevel(); level++)
  {
    for (i=0; i<pDoc->NumWallDecorations(level); i++)
    {
      if (!pDoc->IsLegalWallDecorationIndex(level,i+1))
      {
        CString msg;
        msg.Format("Level %d specifies an illegal Wall Decoration "
                   "type at ordinal %d",level,i+1);
        result.NewError(msg);
      };
    };
  };
  for (locr.First(); locr.Next();)
  {
    rt = RoomType(locr);
    cf = pDoc->GetCellFlag(locr);
    if (rt == roomSTONE)
    {
      for (obj = pDoc->FindFirstTextRecord(locr);
           obj != RNeof;
           obj = pDoc->FindNextTextRecord(obj))
      {
        if (cf & (8 >> obj.pos()))
        {
          CString location;
          location = locr.Format();
          result.NewError(location + " Text and Random Decoration");
          result.ErrorType(CEMT_TEXTPLUSRANDOMDECORATION);
          locr.p(obj.pos());
          result.Location(locr);
        };
      };
      if (pDoc->NumRandomWallDecorations(locr.l()) > 0)
      {
        if ( (cf & 8) && (roomDOOR == RoomType(locr+LOCATIONREL(0,0,-1))))
        {
          CString location;
          location = locr.Format();
          result.NewError(location + " Random Decoration on DoorFrame");
          result.ErrorType(CEMT_RANDOMDECORATIONONDOORFRAME);
          result.Location(locr);
          result.Index1(8);
        };
        if ( (cf & 4) && (roomDOOR == RoomType(locr+LOCATIONREL(0,1,0))))
        {
          CString location;
          location = locr.Format();
          result.NewError(location + " Random Decoration on DoorFrame");
          result.ErrorType(CEMT_RANDOMDECORATIONONDOORFRAME);
          result.Location(locr);
          result.Index1(4);
        };
        if ( (cf & 2) && (roomDOOR == RoomType(locr+LOCATIONREL(0,0,1))))
        {
          CString location;
          location = locr.Format();
          result.NewError(location + " Random Decoration on DoorFrame");
          result.ErrorType(CEMT_RANDOMDECORATIONONDOORFRAME);
          result.Location(locr);
          result.Index1(2);
        };
        if ( (cf & 1) && (roomDOOR == RoomType(locr+LOCATIONREL(0,-1,0))))
        {
          CString location;
          location = locr.Format();
          result.NewError(location + " Random Decoration on DoorFrame");
          result.ErrorType(CEMT_RANDOMDECORATIONONDOORFRAME);
          result.Location(locr);
          result.Index1(1);
        };
        if ((pDoc->EditingOptions() & EDIT_OPT_AllowRanSkinDec) == 0)
        {
          if ( (cf & 15) && skinCache.GetSkin(locr) )
          { //We do not include a test for default skin for this level because Zyx did 
            // not want it that way.  I initially included the test and then deleted it.
            CString location;
            location = locr.Format();
            result.NewError(location + " Random Decoration on Skinned Wall");
            result.ErrorType(CEMT_RANDOMDECORATIONONSKINNEDWALL);
            result.Location(locr);
          };
        };
      };
    }
    else if (rt == roomOPEN)
    {
      if ((pDoc->EditingOptions() & EDIT_OPT_AllowRanSkinDec) == 0)
      {
        if ( (cf & 8) && skinCache.GetSkin(locr) )
        { //We do not include a test for default skin for this level because Zyx did 
          // not want it that way.  I initially included the test and then deleted it.
          CString location;
          location = locr.Format();
          result.NewError(location + " Random Decoration on Skinned Floor");
          result.ErrorType(CEMT_RANDOMDECORATIONONSKINNEDFLOOR);
          result.Location(locr);
        };
      };
    };
    for (obj = pDoc->FindFirstActuator(locr);
         obj != RNeof;
         obj = pDoc->FindNextActuator(obj))
    {
      pActuator = pDoc->GetRecordAddressDB3(obj);
      graphicOrdinal = pActuator->GraphicOrdinal(locr);
      if (   (rt != roomSTONE)
          && (graphicOrdinal > pDoc->NumFloorDecorations(locr.l())))
      {
        result.NewError(DecorationError("Floor",locr));
      };
      if (   (rt == roomSTONE)
          && (graphicOrdinal >pDoc->NumWallDecorations(locr.l())))
      {
        result.NewError(DecorationError("Wall",locr));
      };
    };
  };
  if (result.FirstError() == NULL)
  {
    pDoc->Information("No Problem with Decorations");
  }
  else
  {
    WarningDialog Warning;
    Warning.m_title = "Problem with Decorations";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
  };
}

void CCSBuildView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
  switch (nChar)
  {
  case '1':
      m_currentTileTool = 0;
      Invalidate();
      break;
  case '2':
      m_currentTileTool = 1;
      Invalidate();
      break;
  case '3':
      m_currentTileTool = 2;
      Invalidate();
      break;
  case '4':
      m_currentTileTool = 3;
      Invalidate();
      break;
  case '5':
      m_currentTileTool = 4;
      Invalidate();
      break;
  case '6':
      m_currentTileTool = 5;
      Invalidate();
      break;
  case '7':
      m_currentTileTool = 6;
      Invalidate();
      break;
  case '8':
      m_currentTileTool = 7;
      Invalidate();
      break;
  case '9':
      m_currentTileTool = 8;
      Invalidate();
      break;
  case '0':
      m_currentTileTool = 9;
      Invalidate();
      break;
  case '-':
      m_currentTileTool = 10;
      Invalidate();
      break;
  case '=':
      m_currentTileTool = 11;
      Invalidate();
      break;
  };
	CView::OnChar(nChar, nRepCnt, nFlags);
}

void CCSBuildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == 0x22) OnDownLevel();  //Page Down
  if (nChar == 0x21) OnUpLevel();    //Page Up
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CCSBuildView::OnEncrypt() 
{
	// TODO: Add your command handler code here

  GetKey dlg;
  int i;
  if (encipheredDataFile != "")
  {
    encipheredDataFile = "";
  }
  else
  {
    dlg.m_signature1 = expectedGraphicsSignature1;
    dlg.m_signature2 = expectedGraphicsSignature2;
    dlg.m_CSBsignature1 = expectedCSBgraphicsSignature1;
    dlg.m_CSBsignature2 = expectedCSBgraphicsSignature2;
    for (i=0; i<8; i++) if (hintKey[i] == 0) break;
    dlg.m_hintKey = CString(&hintKey[0],i);
    if (dlg.DoModal() == IDOK)
    {
      encipheredDataFile = dlg.m_key;
      if (encipheredDataFile != "") pDoc->Compressed(false);
      expectedGraphicsSignature1 = dlg.m_signature1;
      expectedGraphicsSignature2 = dlg.m_signature2;
      expectedCSBgraphicsSignature1 = dlg.m_CSBsignature1;
      expectedCSBgraphicsSignature2 = dlg.m_CSBsignature2;
      for (i=0; i<8; i++) hintKey[i] = 0;
      for (i=0; i<dlg.m_hintKey.GetLength(); i++)
      {
        hintKey[i] = dlg.m_hintKey.GetAt(i);
      };
    };
  };
}

BOOL CCSBuildView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	if(!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext)) return false;
//  FinePrint dlg;
//  dlg.DoModal();
//  if (dlg.m_agree != 0) return false;
  return true;	
}

void CCSBuildView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	
}

void CCSBuildView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_LButton = false;
	CView::OnLButtonUp(nFlags, point);
}

DROPEFFECT CCSBuildView::OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CView::OnDragEnter(pDataObject, dwKeyState, point);
}

void CCSBuildView::OnDragLeave() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CView::OnDragLeave();
}

void CCSBuildView::OnEditUndo() 
{
	// TODO: Add your command handler code here
	// Oh boy!  Here we go.  We have 
  CELL_CHECKPOINT *pCCAfter;
  CELL_CHECKPOINT *pCCBefore;
  bool previous, another;
  
  do
  {
    if (!pDoc->BackspaceCellUndo())
    {
      InternalError("No Undo available");
      return;
    };
    pCCBefore = pDoc->ReadCellUndoAtCursor();
    if (pCCBefore == NULL)
    {
      pDoc->Sorry("Something wrong with undo list");
      return;
    };
    previous = pCCBefore->Flags(CCF_PrevOneGoesWithThisOne);
    another =  pCCBefore->Flags(CCF_NextOneGoesWithThisOne);
    pCCAfter = pDoc->CheckpointCell(pCCBefore->Location());
    if (another)  pCCAfter->SetFlag(CCF_NextOneGoesWithThisOne);
    if (previous) pCCAfter->SetFlag(CCF_PrevOneGoesWithThisOne);
    VERIFY(pCCBefore == pDoc->ReplaceCellUndo(pCCAfter));
    pDoc->UndoCell(pCCBefore);
    delete pCCBefore;
    pDoc->SetModifiedFlag();
  } while (previous);
  Invalidate();
}


void CCSBuildView::OnEditRedo() 
{
	// TODO: Add your command handler code here
  bool previous, another;
  CELL_CHECKPOINT *pCCAfter, *pCCBefore;
  do
  {
    if ((pCCAfter=pDoc->ReadCellUndoAtCursor()) == NULL)return;
    previous = pCCAfter->Flags(CCF_PrevOneGoesWithThisOne);
    another =  pCCAfter->Flags(CCF_NextOneGoesWithThisOne);    
    pCCBefore = pDoc->CheckpointCell(pCCAfter->Location());
    if (another)  pCCBefore->SetFlag(CCF_NextOneGoesWithThisOne);
    if (previous) pCCBefore->SetFlag(CCF_PrevOneGoesWithThisOne);
    pDoc->UndoCell(pCCAfter);
    VERIFY(pCCAfter == pDoc->ReplaceCellUndo(pCCBefore));
    pDoc->ForwardSpaceCellUndo();
    delete pCCAfter;
    pDoc->SetModifiedFlag();
    Invalidate();
  } while (another);
}

CString CCSBuildView::PitError(LOCATIONREL locr)
{
  LOCATIONREL locrBelow;
  LOCATIONABS loca;
  CString result, type;
  ROOMTYPE rt;
  loca = locr;
  locrBelow = locr;
  locrBelow.Vertical(+1);
  if (locrBelow.l() < 0)
  {
    if ((pDoc->EditingOptions() & EDIT_OPT_AllowIllegalPits) == 0)
    {
      result.Format("Pit at %d(%02d,%02d) goes nowhere",
                    loca.l, loca.x, loca.y);
      return result;
    };
  };
  rt = RoomType(locrBelow);
  switch (rt)
  {
  case roomSTONE: type = "Stone"; break;
  case roomSTAIRS: type = "Stairs"; break;
  case roomDOOR: type = "Door"; break;
  default: return result;
  };
  if ((pDoc->EditingOptions() & EDIT_OPT_AllowIllegalPits) == 0)
  {
    result.Format("A pit at %d(%02d,%02d) falls into a %s\n",
                   loca.l, loca.x, loca.y,type);
  };
  return result;
}

CString CCSBuildView::StairsError(LOCATIONREL locr)
{
  CELLFLAG cf;
  int numWall;
  int direction, cfDir;
  LOCATIONABS loca;
  CString result;
  ROOMTYPE rt;
  LOCATIONREL locrOther;
  if (pDoc->EditingOptions() & EDIT_OPT_AllowIllegalStairs)
             return result;
  locrOther = locr;
  loca = locr;
  cf = pDoc->GetCellFlag(locr);
  if (cf & 4) locrOther.Vertical(-1);
  else locrOther.Vertical(+1);
  if (locrOther.l() < 0)
  {
    result.Format("Stairs at %d(%02d,%02d) go nowhere\n",
                  loca.l, loca.x, loca.y);
    return result;
  };
  rt = RoomType(locrOther);
  if (    (rt != roomSTAIRS)
       || (((pDoc->GetCellFlag(locrOther)^cf)&4)==0))
  {
    result.Format("Stairs at %d(%02d,%02d) unmatched",
                  loca.l, loca.x, loca.y);
    return result;
  };
  numWall = CountAttachedWalls(locr);
  if (numWall != 3)
  {
    result.Format("Stairs at %d(%02d,%02d) not enclosed by 3 walls",
                  loca.l, loca.x, loca.y);
    return result;
  };
  direction = FindStairExit(locr);
  direction = (direction ^ 1) & 1; //N/S = 1
  cfDir = (cf & 8) >> 3;
  if (cfDir != direction)
  {
    result.Format("Stairs at %d(%02d,%02d) have wrong direction",
                  loca.l, loca.x, loca.y);
    return result;
  };
  return result;
}

void CCSBuildView::OnPitsAndStairs() 
{
	// TODO: Add your command handler code here
	CHKERRMSG result;
  ROOMTYPE rt;
  RN obj;
  bool error;
  LOCATIONREL locr;
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    rt = RoomType(locr);
    switch(rt)
    {
    case roomPIT:
      result.NewError(PitError(locr));
      break;
    case roomSTAIRS:
      result.NewError(StairsError(locr));
      error = false;
      for (obj=pDoc->FindFirstObject(locr);
           obj!=RNeof;
           obj=pDoc->GetDBRecordLink(obj))
      {
        switch (obj.dbType())
        {
        case dbMISC:
        case dbCHEST:
        case dbPOTION:
        case dbCLOTHING:
        case dbWEAPON:
        case dbSCROLL:
          if (pDoc->EditingOptions() & EDIT_OPT_AllowObjectsOnStairs) break;
          error = true;
          break;
        case dbMONSTER:
          error = true;
          break;
        default:
          break;
        };
        if (error) break;
      };
      if (error)
      {
        CString emsg;
        LOCATIONABS loca;
        loca = locr;
        emsg.Format("%d(%02d,%02d) Inappropriate Object in stairwell\n",
                    loca.l, loca.x, loca.y);
        result.NewError(emsg);
      };
      break;
    };
  };
  if (result.FirstError() != NULL)
  {
    WarningDialog Warning;
    Warning.m_title = "Pit/Stairwell Warning";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
  }
  else
  {
    pDoc->Information("Pits and Stairs seem OK");
  };
}

void CCSBuildView::OnEditOptions() 
{
	// TODO: Add your command handler code here
  EditingOptions dlg;
  dlg.DoModal();
}

bool CCSBuildView::SearchList(RN first, 
                              dlg_InsertObject *dlg,
                              LOCATIONREL& locr) 
{
  RN obj;
  MODIFIEDOBJECTTYPE mot;
 
  for (obj=first; obj!=RNeof; obj=pDoc->GetDBRecordLink(obj))
  {
    switch(obj.dbType())
    {
    case dbWEAPON:
      if (dlg->m_option1Value) break;
      if (dlg->m_dbType != dbWEAPON) break;
      if (   pDoc->GetRecordAddressDB5(obj)->weaponType()
          == dlg->m_weaponType) return true;
      break;;
    case dbMISC:
      if (dlg->m_option1Value) break;
      if (dlg->m_dbType != dbMISC) break;
      if (   pDoc->GetRecordAddressDB10(obj)->miscType()
          == dlg->m_miscType) return true;
      break;
    case dbPOTION:
      if (dlg->m_option1Value) break;
      if (dlg->m_dbType != dbPOTION) break;
      if (   pDoc->GetRecordAddressDB8(obj)->potionType()
          == dlg->m_potionType) return true;
      break;
    case dbCLOTHING:
      if (dlg->m_option1Value) break;
      if (dlg->m_dbType != dbCLOTHING) break;
      if (   pDoc->GetRecordAddressDB6(obj)->clothingType()
          == dlg->m_clothingType) return true;
      break;
    case dbMONSTER:
      if (dlg->m_option1Value) break;
      if (   (dlg->m_dbType == dbMONSTER)
          && (pDoc->GetRecordAddressDB4(obj)->monsterType()
              == dlg->m_monsterType)) return true;
      if (SearchList(pDoc->GetRecordAddressDB4(obj)->possession(),
                     dlg,
                     locr))
      {
        return true;
      }
      break;;
    case dbCHEST:
      if (dlg->m_option1Value) break;
      if (dlg->m_dbType == dbCHEST) return true;
      if (SearchList(pDoc->GetRecordAddressDB9(obj)->contents(),
                     dlg,
                     locr))
      {
        return true;
      };
      break;
    case dbACTUATOR:
      if (!dlg->m_option1Value) break;
      if (!dlg->m_option1Value) break;
      mot = pDoc->GetRecordAddressDB3(obj)->TriggerObject(locr);
      if (!mot.IsValid()) break;
      if (mot == dlg->m_modifiedObjectType)
      {
        return true;
      };
    default:
      break;
    };
  };
  return false;
}

void CCSBuildView::OnFindObject() 
{
	// TODO: Add your command handler code here
  LEVELINFO levelInfo;
  RN obj, objContents;
  LOCATIONREL locr;
  DBTYPE dbType;
  int typeMask;
  int result;
  levelInfo.level = -1;
  locr.l(-1);
  typeMask = 0;
  typeMask |= 1<<dbMISC;
  typeMask |= 1<<dbWEAPON;
  typeMask |= 1<<dbCLOTHING;
  typeMask |= 1<<dbPOTION;
  typeMask |= 1<<dbMONSTER;
  typeMask |= 1<<dbCHEST;
  dlg_InsertObject dlg(locr, typeMask);
  dlg.m_title = "Search For Object";
  dlg.m_option1Title = "Find lock operated by object";
  dlg.m_allowedOptions[dbWEAPON] |= 1;
  dlg.m_allowedOptions[dbPOTION] |= 1;
  dlg.m_allowedOptions[dbCLOTHING] |= 1;
  dlg.m_allowedOptions[dbMISC] |= 1;
  dlg.m_allowedOptions[dbCHEST] |= 1;
  result = dlg.DoModal();
  MISCTYPE miscType;
  if (result == IDCANCEL) return;
  dbType = dlg.m_dbType;
  if (dbType != dbILLEGAL) 
  {
    OBJECTLIST objectList;
    //List the locations and fire up the dialog "ShowLocations"
    for (locr.First(); locr.l()!=-1; locr.Next())
    {
      if (SearchList(pDoc->FindFirstObject(locr),
                     &dlg,
                     locr))
      {
        //Add the location to the list.
        locr.p(pDoc->FindFirstObject(locr).pos());
        objectList.Insert(RNnul,locr);
      };
    };
    if (objectList.NumEnt() != 0)
    {
      ShowLocations dlg(&objectList);
      dlg.DoModal();
    };
  };
}

void CCSBuildView::OnCheckAll() 
{
	// TODO: Add your command handler code here
  OnVERIFYTargetOfActuators();
  OnVerifyObjects();
  OnVerifyMonsters();
  OnCheckDecorations();
	OnPitsAndStairs();
  OnCheckText();
}

void CCSBuildView::OnEditDSA() 
{
	// TODO: Add your command handler code here
	ListDSAs dlg;
  dlg.DoModal();
	
}

void CCSBuildView::OnEditLevelInfo() 
{
	// TODO: Add your command handler code here
	ViewLevelInfo dlg;
  if (!pDoc->IsValid()) return;
  dlg.DoModal();
}

CString GetPortraitFile(void)
{
  int result;
  CFileDialog dlg(FALSE,
                  "BMP",
                  "Portraits",
                  OFN_PATHMUSTEXIST,
                  "Bitmap Files(*.BMP)|*.BMP||");
  result = dlg.DoModal();
  if (result == IDCANCEL) return CString("");
  return dlg.m_ofn.lpstrFile;
}

#define portraitPixelWidth 32
#define portraitByteWidth 16
#define portraitPixelHeight 29

void CCSBuildView::OnWritePortraits() 
{
  BITMAPFILEHEADER bmFileHeader;
  BITMAPINFOHEADER bmInfoHeader;
  int color = 0, c;
  unsigned int word0=0, word1=0, word2=0, word3=0, nibble;
  unsigned int bmiColors[16] =
  { 
    0x00000000,
    0x006d6d6d,
    0x00919191,
    0x006d2400,
    0x0000dada,
    0x00914800,
    0x00009100,
    0x0000da00,
    0x00ff0000,
    0x00ffb600,
    0x00da916d,
    0x00ffff00,
    0x00484848,
    0x00b6b6b6,
    0x000000ff,
    0x00ffffff  
  };
  CString name;
  name = GetPortraitFile();
  if (name == "") return;
	// TODO: Add your command handler code here
	FILE *f;
  int ch, row, col, inIndex, outIndex;
  char bitmap[(portraitPixelWidth+8)*portraitPixelHeight];
  f = fopen(name,"wb");
  if (f == NULL)
  {
    Strange("Cannot open bitmap file for writing");
    return;
  };
  bmFileHeader.bfType = ('M'<<8) + 'B';
  bmFileHeader.bfSize =  sizeof(bmFileHeader)
                       + sizeof(bmInfoHeader)
                       + sizeof (bmiColors)
                       + 4 * (portraitPixelWidth+8)*portraitPixelHeight/2;
  bmFileHeader.bfReserved1 = 0;
  bmFileHeader.bfReserved2 = 0;
  bmFileHeader.bfOffBits =  sizeof(bmFileHeader)
                          + sizeof(bmInfoHeader)
                          + sizeof(bmiColors);
  bmInfoHeader.biSize = sizeof(bmInfoHeader);
  bmInfoHeader.biWidth = portraitPixelWidth + 8;
  bmInfoHeader.biHeight = 4 * portraitPixelHeight;
  bmInfoHeader.biPlanes = 1;
  bmInfoHeader.biBitCount = 4;
  bmInfoHeader.biCompression = BI_RGB;
  bmInfoHeader.biSizeImage = 4*(portraitPixelWidth+8)*portraitPixelHeight/2;
  bmInfoHeader.biXPelsPerMeter = 2835;
  bmInfoHeader.biYPelsPerMeter = 2835;
  bmInfoHeader.biClrUsed = 16;
  bmInfoHeader.biClrImportant = 0;
  fwrite(&bmFileHeader,1,sizeof(bmFileHeader),f);
  fwrite(&bmInfoHeader,1,sizeof(bmInfoHeader),f);
  fwrite(bmiColors,1,sizeof(bmiColors),f);
  for (ch=3; ch>=0; ch--)
  {
    outIndex = (portraitPixelWidth+8)/2 * portraitPixelHeight;
    inIndex = 0;
    color = ch*portraitPixelHeight;
    for (row=0; row<portraitPixelHeight; row++)
    {
      outIndex -= (portraitPixelWidth+8)/2;
      for (col=0; col<portraitPixelWidth; col++)
      {
        if ((col%16) == 0)
        {
          word3 = ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+0];
          word2 = ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+1];
          word1 = ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+2];
          word0 = ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+3];
          word0 = (word0 * 0x10001) >> 8;
          word1 = (word1 * 0x10001) >> 8;
          word2 = (word2 * 0x10001) >> 8;
          word3 = (word3 * 0x10001) >> 8;
        };
        nibble = 0;
        nibble |= (word0>>12) & 0x8;
        nibble |= (word1>>13) & 0x4;
        nibble |= (word2>>14) & 0x2;
        nibble |= (word3>>15) & 0x1;
        word0 <<= 1;
        word1 <<= 1;
        word2 <<= 1;
        word3 <<= 1;
        if ((col%2) == 0)
        {
          bitmap[outIndex+col/2] = (char)((nibble<<4) & 0xf0);
        }
        else
        {
          bitmap[outIndex+col/2] |= nibble;
        };
      };
      c = (((color&31)/2)<<4)+(color&31)/2;
      bitmap[outIndex+col/2+0] = (char)c;
      bitmap[outIndex+col/2+1] = (char)c;
      bitmap[outIndex+col/2+2] = (char)c;
      bitmap[outIndex+col/2+3] = (char)c;
      color++;
      inIndex += portraitByteWidth/2;
    };
    fwrite(bitmap,1,(portraitPixelWidth+8)*portraitPixelHeight/2,f);
  };
  fclose(f);
}

void CCSBuildView::OnReadPortraits() 
{
	// TODO: Add your command handler code here
	
  BITMAPFILEHEADER bmFileHeader;
  BITMAPINFOHEADER bmInfoHeader;
  unsigned int word0=0, word1=0, word2=0, word3=0, nibble;
  unsigned int bmiColors[16];
  CString name;
  name = GetPortraitFile();
  if (name == "") return;
	// TODO: Add your command handler code here
	FILE *f;
  int ch, row, col, inIndex, outIndex;
  char bitmap[(portraitPixelWidth+8)*portraitPixelHeight];
  f = fopen(name,"rb");
  if (f == NULL)
  {
    Strange("Cannot open bitmap for reading");
    return;
  };
  if (fread(&bmFileHeader,1,sizeof(bmFileHeader),f) != sizeof(bmFileHeader))
  {
    Strange("Cannot read header");
    return;
  };
  if (bmFileHeader.bfType != ('M'<<8) + 'B')
  {
    Strange("That does not look like a bitmap file");
    return;
  };
  if (fread(&bmInfoHeader,1,sizeof(bmInfoHeader),f) != sizeof(bmInfoHeader))
  {
    Strange("Cannot read the InfoHeader");
    return;
  };
  if (   (bmInfoHeader.biWidth != portraitPixelWidth+8)
       ||(bmInfoHeader.biHeight != 4 * portraitPixelHeight) )
  {
    CString msg;
    msg.Format("The bitmap must be exactly\n%d by %d",
                portraitPixelWidth+8,
                4 * portraitPixelHeight);
    Strange(msg);
    return;
  };
  if (bmInfoHeader.biBitCount != 4)
  {
    Strange("That is not a 16-color bitmap");
    return;
  };
  if (fread(bmiColors,1,sizeof(bmiColors),f) != sizeof(bmiColors))
  {
    Strange("Cannot read palette");
    return;
  };
  for (ch=3; ch>=0; ch--)
  {
    outIndex = (portraitPixelWidth+8)/2 * portraitPixelHeight;
    inIndex = 0;
    if (fread(bitmap,1,(portraitPixelWidth+8)*portraitPixelHeight/2,f) 
           != (portraitPixelWidth+8)*portraitPixelHeight/2)
    {
      Strange("Cannot read pixel data");
      return;
    };
    for (row=0; row<portraitPixelHeight; row++)
    {
      outIndex -= (portraitPixelWidth+8)/2;
      for (col=0; col<portraitPixelWidth; col++)
      {
        if ((col%2) == 0)
        {
          nibble = (bitmap[outIndex+col/2]>>4) & 15;
        }
        else
        {
          nibble = bitmap[outIndex+col/2] & 15;
        };
        word0 <<= 1;
        word1 <<= 1;
        word2 <<= 1;
        word3 <<= 1;
        word3 |= nibble & 1; nibble>>=1;
        word2 |= nibble & 1; nibble>>=1;
        word1 |= nibble & 1; nibble>>=1;
        word0 |= nibble & 1; nibble>>=1;
        if ((col%16) == 15)
        {
          word0 = (word0 * 0x10001) >> 8;
          word1 = (word1 * 0x10001) >> 8;
          word2 = (word2 * 0x10001) >> 8;
          word3 = (word3 * 0x10001) >> 8;
          ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+0] = (WORD)word3;
          ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+1] = (WORD)word2;
          ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+2] = (WORD)word1;
          ((WORD *)pDoc->Portrait(ch))[inIndex+col/16*4+3] = (WORD)word0;
          word3 = word2 = word1 = word0 = 0;
        };
      };
      inIndex += portraitByteWidth/2;
    };
  };
  fclose(f);
}

void CCSBuildView::OnTargetLines() 
{
	// TODO: Add your command handler code here
  pDoc->m_targetMode = !pDoc->m_targetMode;;	
}

void CCSBuildView::OnUpdateTargetLines(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here	
	pCmdUI->Enable(true);
  pCmdUI->SetCheck(pDoc->m_targetMode);
}


struct TEXTLIST
{
  int length;
  int dbIndex;
  int indirectTextIndex;
  int compressedTextIndex;
};

class SAFELIST //So we need not worry about freeing it.
{
private:
  TEXTLIST *t;
  int m_size;
public:
  SAFELIST(void) {t = NULL; m_size=0;};
  ~SAFELIST(void) {Clear();};
  void Allocate(int num)
  {
    t = (TEXTLIST *)realloc(t,num*sizeof(TEXTLIST),MALLOC074);
    m_size = num;
  };
  void Clear(void){if (t != NULL) free(t); t = NULL;};
  TEXTLIST& operator[](int i){return t[i];};
  int Size(void)const{return m_size;};
  void Size(int n){m_size = n;};
};

bool CCSBuildView::CheckDB2Indices(void) const
{
  CHKERRMSG result;
  int i, numEnt, indirectTextIndex;
  DB2 *pDB2;
  numEnt = db.NumEntry(dbTEXT);
  for (i=0; i<numEnt; i++)
  {
    pDB2 = pDoc->GetRecordAddressDB2(i);
    if (pDB2->link() == RNnul) continue;
    indirectTextIndex = pDB2->index();
    if (pDoc->IsValidIndirectTextIndex(indirectTextIndex)) continue;
    result.NewError("Text Record has illegal indirect index");
  };
  if (result.FirstError() == NULL) return true;
  {
    WarningDialog warning;
    warning.m_chkErrMsg = &result;
    warning.DoModal();
  };
  return false;
}

bool CCSBuildView::CheckCompressedTextIndices(void) const
{
  CHKERRMSG result;
  int i, numEnt, compressedTextIndex;
  numEnt = pDoc->NumWordsInTextArray();
  for (i=0; i<numEnt; i++)
  {
    compressedTextIndex = pDoc->CompressedTextIndex(i);
    if (compressedTextIndex == -1) continue;
    if (pDoc->IsValidCompressedTextIndex(compressedTextIndex)) continue;
    result.NewError("Text Indirect Index has illegal "
                    "compressed text index");
  };
  if (result.FirstError() == NULL) return true;
  {
    WarningDialog warning;
    warning.m_chkErrMsg = &result;
    warning.DoModal();
  };
  return false;
}

bool CCSBuildView::ReleaseUnusedCompressedText(SAFELIST& textList)
{//textList is sorted by compressedTextIndex.
  int unusedSpace, i, numIndirectIndex;
  int nextIndex, gap;
  unusedSpace = 0;
  numIndirectIndex = textList.Size();
  for (i=0; i<numIndirectIndex-1; i++)
  {
    if (i < numIndirectIndex-1) nextIndex = textList[i+1].compressedTextIndex;
    else nextIndex = pDoc->SizeOfCompressedText();;
    gap = nextIndex - textList[i].compressedTextIndex - textList[i].length;
    if (gap > 0)
    {
      unusedSpace += gap;
    };
  };
  if (unusedSpace > 0)
  {
    CString msg;
    int ans;
    msg.Format("We found %d words of unused compressed text\n"
               "space.  Should we recover this and restart?",
               unusedSpace);
    ans = ShouldWe(msg);
    if (ans == IDYES)
    {
      return true;
    };
  };
  return false;
}

void CCSBuildView::OnCheckText() 
{
	// TODO: Add your command handler code here
  int numText, delta, i, j;
  int indirectTextIndex, numIndirectIndex;
  int compressedTextIndex;
  bool textError = false;
  CProgressCtrl progress;
  RECT prect = {100,100,600,160};
  DB2 *pDB2;
  SAFELIST textList;
  TEXTLIST temp;
  CHKERRMSG result;
  //First we are going to look through the DB2 (dbTEXT)
  //entries to make sure they each has a decent indirectText
  //index.
  if (!CheckDB2Indices()) return;

  // All the indirectTextIndices are OK.  We can proceed
  // to check the compressedTextIndicies.
  if (!CheckCompressedTextIndices()) return;

  //We are going to check for cloned indirect entries.
  //Now..First...fill the array with needed information.
  numText = db.NumEntry(dbTEXT);
  textList.Allocate(numText);
  j = 0;
  for (i=0; i<numText; i++)
  {
    pDB2 = pDoc->GetRecordAddressDB2(i);
    if (pDB2->link() == RNnul) continue;
    indirectTextIndex = pDB2->index();
    textList[j].dbIndex  = i;
    textList[j].indirectTextIndex = indirectTextIndex;
    j++;
  };
  numText = j;
  //Now sort the array by indirectTextIndex.
  for (delta=numText/2; delta>0; delta/=2)
  {
    for (j=0; j<delta; j++) //Sort each string
    {
      i = j;
      while (i < numText-delta)
      {
        if (textList[i].indirectTextIndex 
                 > textList[i+delta].indirectTextIndex)
        {
          temp = textList[i];
          textList[i] = textList[i+delta];
          textList[i+delta] = temp;
          if (i>= delta) i -= 2*delta;
        };
        i += delta;
      };
    };
  };
  progress.Create(WS_CAPTION|WS_VISIBLE|WS_CHILD,prect,this,12);
  progress.SetWindowText("Searching Text Records");
  progress.SetRange(0,(short)numText);
  //Look for entries with duplicate indirectTextIndex values.
  for (i=0; i<numText-1; i++)
  {
     progress.SetPos(i);
     if (textList[i].indirectTextIndex
            == textList[i+1].indirectTextIndex)
    {
      char ASCIItext[100];
      int j, len;
      LOCATIONREL locr;
      pDoc->ExpandText(ASCIItext,
                       pDoc->GetRecordAddressDB2(textList[i].dbIndex),
                       TEXTTYPE_MIRROR,
                       99);
      len = strlen(ASCIItext);
      for (j=0; j<len; j++)
      {
        if (ASCIItext[j] == 10) ASCIItext[j] = '/';
      };
      result.NewError("Cloned Indirect Text Index Entry = ");
      result += ASCIItext;
      result.ErrorType(CEMT_CLONEDINDIRECTTEXTENTRY);
      result.Index1(textList[i].indirectTextIndex);
      result.Index2(textList[i].dbIndex);
      //Now, list all the parents
      for (j=i; j<numText; j++)
      {
        if (textList[j].indirectTextIndex 
                 != textList[i].indirectTextIndex) break;
        result.NewError("   Parent");
        result.ErrorType(CEMT_CLONEDINDIRECTTEXTINDEXPARENT);
        result.Index1(textList[j].dbIndex);
        locr = SearchForRecord(dbTEXT, textList[j].dbIndex);
        result += locr.Format();
      };
      i = j;
    };
  };
  progress.DestroyWindow();
  if (result.FirstError() != NULL)
  {
    WarningDialog warning;
    warning.m_chkErrMsg = &result;
    warning.DoModal();
    if (result.AnyRepairs()) return;
  };
  //First, we are going to find any unused space in
  //the compressed text array.  If we can release some
  //of the array we will do that and quit.
  //Unused space is identified by the end of one
  //text being less than the start of the next text.
  //Keep in mind that overlapping text must end at the
  //same place because it ends at a nibble of 31.
  numIndirectIndex = pDoc->NumWordsInTextArray();
  result.Clear();
  textList.Clear();
  textList.Allocate(numIndirectIndex);
  j = 0;
  for (i=0; i<numIndirectIndex; i++)
  {
    compressedTextIndex = pDoc->CompressedTextIndex(i);
    if (compressedTextIndex == -1) continue;
    textList[j].compressedTextIndex = compressedTextIndex;
    textList[j].indirectTextIndex = i;
    textList[j].length = pDoc->ComputeTextLength(i);
    j++;
  };
  numIndirectIndex = j;//Number of active entries.
  //Sort the list by compressedTextIndex;
  for (delta=numIndirectIndex/2; delta>0; delta/=2)
  {
    for (i=0; i<delta; i++)
    {
      j = i;
      while (j < numIndirectIndex-delta)
      {
        if (textList[j+delta].compressedTextIndex
              < textList[j].compressedTextIndex)
        {
          temp = textList[j];
          textList[j] = textList[j+delta];
          textList[j+delta] = temp;
          if (j >= delta) j -= 2*delta;
        };
        j+= delta;
      };
    };
  };
  textList.Size(j);
  if (ReleaseUnusedCompressedText(textList)) return;

  //Now look for overlapped compressed text.
  //Gather information about each active indirect index.
  for (i=0; i<numText-1; i++)
  {
    if (textList[i].compressedTextIndex 
             == textList[i+1].compressedTextIndex) continue;
    if (textList[i].compressedTextIndex+textList[i].length 
                        > textList[i+1].compressedTextIndex)
    {
      result.NewError("OVERLAPPED TEXT");
      result.ErrorType(CEMT_OVERLAPPEDTEXT);
      result.Index1(textList[i].dbIndex);
      result.Index2(textList[i+1].dbIndex);
    };
  };
  if (result.FirstError() != NULL)
  {
    WarningDialog Warning;
    Warning.m_title = "Overlapped Text Warning";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
    textError = true;
  };
  result.Clear();
  i = 0;
  while (i<numText-1)
  {
    if (textList[i].compressedTextIndex!=textList[i+1].compressedTextIndex)
    {
      i++;
      continue;
    };
    result.NewError("Shared Compressed Text");
    result.ErrorType(CEMT_CLONEDTEXT1);
    result.Index1(textList[i].dbIndex);
    for (j=i+1; j<numText; j++)
    {
      if (textList[i].compressedTextIndex != textList[j].compressedTextIndex) break;
      result.NewError("      Compressed Text");
      result.ErrorType(CEMT_CLONEDTEXT2);
      result.Index1(textList[j].dbIndex);
    };
    i = j;
  };
  if (result.FirstError() != NULL)
  {
    WarningDialog Warning;
    Warning.m_title = "Shared Text Warning";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
    textError = true;
  };
  if (!textError) pDoc->Information("No Text Errors");
}

void CCSBuildView::DumpText(RN obj, FILE *f, LOCATIONREL locr)
{
  DBTYPE dbType;
  DB4 *pDB4;
  DB7 *pDB7;
  DB9 *pDB9;
  for (;obj != RNeof; obj = pDoc->GetDBRecordLink(obj))
  {
    dbType = obj.dbType();
    switch(dbType)
    {
    case dbDOOR:
    case dbTELEPORTER:
    case dbACTUATOR:
    case dbWEAPON:
    case dbCLOTHING:
    case dbPOTION:
    case dbMISC:
      break; //Ignore
    case dbMONSTER:
      pDB4 = pDoc->GetRecordAddressDB4(obj);
      DumpText(pDB4->possession(), f, locr);
      break;
    case dbSCROLL:
      pDB7 = pDoc->GetRecordAddressDB7(obj);
      DumpText(pDB7->text(), f, locr);
      break;
    case dbCHEST:
      pDB9 = pDoc->GetRecordAddressDB9(obj);
      DumpText(pDB9->contents(), f, locr);
      break;
    case dbTEXT:
      fprintf(f,"%s %s\n",
              locr.Format(),
              pDoc->GetRawText(obj, TEXTTYPE_MIRROR));
      break;
    default:
      NotImplemented();
    };
  };
}

void CCSBuildView::OnDumpText() 
{
	// TODO: Add your command handler code here
  FILE *f;
  RN obj;
  int i, j;
  CString str;
  LOCATIONREL locr;
  f = fopen("TextDump.txt","w");
  if (f == NULL)
  {
    pDoc->Sorry("Cannot open 'TextDump.txt' for writing");
    return;
  };
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    DumpText(pDoc->FindFirstObject(locr), f, locr);
  };
  for (i=0; i<pDoc->NumCharacter(); i++)
  {
    for (j=0; j<30; j++)
    {
      if (pDoc->CharacterPossession(i,j) != RNnul)      
      {
         DumpText(pDoc->CharacterPossession(i,j), f, locr);
      };
    };
  };
  if (pDoc->ObjectInHand() != RNnul)
  {
    DumpText(pDoc->ObjectInHand(), f, locr);
  };
  for (i=0; i<pDoc->NumTimers(); i++)
  {
    switch (pDoc->Timer(i)->timerFunction)
    {
    case 24: 
    case 25: DumpText(
                   pDoc->Timer(i)->timerObj8(), 
                   f,
                   locr);
             break;
    case 48:
    case 49: DumpText(
                   pDoc->Timer(i)->timerObj6(), 
                   f,
                   locr); // The flying object
             break;
    case 60:
    case 61: DumpText(
                   pDoc->Timer(i)->timerObj8(), 
                   f,
                   locr);
             break;
    };
  };
  fclose(f);
}

void CCSBuildView::OnLocateText() 
{
	// TODO: Add your command handler code here
	LocateText dlg;
  dlg.DoModal();
}

void CCSBuildView::OnLocateDecoration() 
{
	// TODO: Add your command handler code here
	LocateDecoration dlg;
  dlg.DoModal();
}

char *roomtypeName[8] = 
{
  "STONE     ",
  "OPEN      ",
  "PIT       ",
  "STAIRS    ",
  "DOOR      ",
  "TELEPORTER",
  "FALSEWALL ",
  "ILLEGAL   "
};

void CCSBuildView::OnWriteAscii() 
{
	// TODO: Add your command handler code here
  FILE *f;
  //int i;
  LOCATIONREL locr;
  CELLFLAG cf;
  ROOMTYPE rt;
	CFileDialog dlg(false,
                  "txt",
                  "AsciiDump.txt",
                  OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                  "Text File(*.txt)|*.txt||");
  if (dlg.DoModal() != IDOK) return;
  f=fopen(dlg.m_ofn.lpstrFile,"w");
  if (f==NULL)
  {
    pDoc->Sorry("Cannot open that file");
    return;
  };
  fprintf(f,"##Dungeon\n");
  fprintf(f,"#\n#levels partyLocation Start AutoRecord DMRules InvisibleMonsters DrawAsSize4 WallDecorations\n");
  fprintf(f,"  %3d   %2d(%02d,%02d)%d    (%02d,%02d)%d %s    %s        %s           %s           %s\n",
             pDoc->NumLevel(),
             pDoc->PartyLevel(),pDoc->PartyX(),pDoc->PartyY(),pDoc->PartyFacing(),
             pDoc->StartingX(), pDoc->StartingY(),pDoc->StartingFacing(),
             RecordDesignOption?"Yes":"No",
             DMRulesOption?"Yes":"No",
             invisibleMonsters?"Yes":"No",
             drawAsSize4Monsters?"Yes":"No",
             extendedWallDecorations?"Yes":"No"
             );
  pDoc->DumpLevelInfo(f);
  pDoc->DumpDatabases(f);
  pDoc->DumpObjectIndirectIndexTable(f);
  pDoc->DumpRawText(f);
  fprintf(f,"#\n##Dungeon Map\n");
  fprintf(f,"#\n#location roomtype      flags contents\n");
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    cf = pDoc->GetCellFlag(locr);
    rt = (ROOMTYPE)((cf>>5) & 0x7);
    fprintf(f," %3d(%2d,%2d) %s  0x%02x %7d\n",
              locr.l(),
              locr.x(),
              locr.y(),
              roomtypeName[rt],
              cf & 0x1f,
              pDoc->FindFirstObject(locr).ConvertToInteger());
  };
  fclose(f);
}

void CCSBuildView::OnVerifyTimers() 
{
	// TODO: Add your command handler code here
  CHKERRMSG result;
  int n, i, i1, i2;
  TIMER *pT, *pT1, *pT2;
	n = pDoc->NumTimers();
  for (i=0; i<n; i++)
  {
    pT = pDoc->Timer(i);
    //The ith timer entry should be less or equal to
    //the (2*i+1)th and the (2*i+2)th entry.
    i1 = 2*i+1;
    i2 = 2*i+2;
    if (i1 < n)
    {
      pT1 = pDoc->Timer(i1);
      if (pDoc->TestTimerLess(pT1, pT))
      {
        result.NewError("Timer Entry out of order");
      };
    };
    if (i2 < n)
    {
      pT2 = pDoc->Timer(i2);
      if (pDoc->TestTimerLess(pT2, pT))
      {
        result.NewError("Timer Entry out of order");
      };
    };
  };
  if (result.FirstError() != NULL)
  {
    WarningDialog Warning;
    Warning.m_title = "Timer Queue Errors";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
  }
  else
  {
    pDoc->Information("No Timer Queue Errors");
  };
}

void CCSBuildView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
  m_LButton = false;	
	// TODO: Add your message handler code here
	
}

void SwapError(void)
{
  Error("A error has occurred during the swapping\n"
        "of dungeon levels.  The dungeon may have been\n"
        "damaged.  You should probably quit\n"
        "WITHOUT SAVING");
}

void CCSBuildView::OnSwapLevels() 
{
	// TODO: Add your command handler code here
	SwapLevels dlg;
  unsigned int L1, L2;
  if (!pDoc->VerifyLevelData())
  {
    Error("I cannot swap levels.\n"
          "There is an inconsistency in the data.");
    return;
  };
  if (dlg.DoModal() == IDOK)
  {
    for (L1=dlg.m_firstLevel; L1<=dlg.m_firstLevelThrough; L1+=dlg.m_delta)
    {
      for (L2=dlg.m_secondLevel; L2<=dlg.m_secondLevelThrough; L2+=dlg.m_delta)
      {
        EXTRACTED_LEVEL *pEX1, *pEX2;
        pEX2 = pDoc->RemoveLevel(L2);
        if (pEX2 == NULL)
        {
          SwapError();
          return;
        };
        pEX1 = pDoc->RemoveLevel(L1);
        if (pEX1 == NULL)
        {
          SwapError();
          delete pEX2;
          return;
        };
        if (   pDoc->InsertLevel(L1, pEX2)
            && pDoc->InsertLevel(L2, pEX1) )
        {
          SwapAllReferences(L1, L2);
        }
        else
        {
          SwapError();
          delete pEX1;
          delete pEX2;
        };
        delete pEX1;
        delete pEX2;
      };
    };
  };
}


void CCSBuildView::OnPortraitFiles() 
{
	// TODO: Add your command handler code here
	OBJECTLIST portraitList;
}

void CCSBuildView::OnSkins() 
{
	// TODO: Add your command handler code here
  ShowSkins dlg;
  dlg.m_currentL = pDoc->CurrentDisplayLevel();
  dlg.DoModal();
}

void CCSBuildView::OnHints() 
{
	// TODO: Add your command handler code here
  Hints dlg;
  dlg.m_currentL = pDoc->CurrentDisplayLevel();
  dlg.DoModal();
}

void CCSBuildView::OnAdvancedSearch() 
{
	// TODO: Add your command handler code here
	AdvancedSearch dlg;
  dlg.DoModal();
}


CString GetCharacterDataFile(void)
{
  int result;
  CFileDialog dlg(FALSE,
                  "bin",
                  "CharacterData",
                  OFN_PATHMUSTEXIST,
                  "Binary Files(*.bin)|*.bin||");
  result = dlg.DoModal();
  if (result == IDCANCEL) return CString("");
  return dlg.m_ofn.lpstrFile;
}


void CCSBuildView::OnImportCharacterData() 
{
	// TODO: Add your command handler code here
  CString name;
  int i;
	char temp[4*sizeof(CHARDESC)];
  name = GetCharacterDataFile();
  if (name == "") return;
	// TODO: Add your command handler code here
	FILE *f;
  f = fopen(name,"rb");
  if (f == NULL)
  {
    Strange("Cannot open bitmap for reading");
    return;
  };
  if (fread(temp,1,sizeof(CHARDESC)*4,f) != sizeof(CHARDESC)*4)
  {
    Strange("Cannot read header");
    return;
  };
	for (i=0; i<3; i++)
	{
		pDoc->ImportChar(i,(CHARDESC *)(temp+i*sizeof(CHARDESC)));
	};
  fclose(f);
	
}

void CCSBuildView::OnWriteCharacterData() 
{
	// TODO: Add your command handler code here
	
  CString name;
  name = GetCharacterDataFile();
  if (name == "") return;
	FILE *f;
  f = fopen(name,"wb");
  if (f == NULL)
  {
    Strange("Cannot open bitmap file for writing");
    return;
  };
  fwrite(pDoc->CharacterData(),1,4*sizeof(CHARDESC),f);
  fclose(f);
}

void CCSBuildView::OnBitmapDump() 
{
	// TODO: Add your command handler code here
	m_bitmapDump = true;
  Invalidate();
}
