
enum CLONEFLAGS
{
  CLF_1stReference = 1,
  CLF_2ndReference = 2
};

class CLONE
{
public:
  CLONE *m_next;
  RN     m_parentID; //RNeof  = No parent
                      //RNnul  = A dungeon Cell
                      //RNff81 = A Timer
                      //RNff82 = A Character's Possessions
};

class CLONES
{
  CWnd *m_parentWindow;
  BYTE *(m_dbFlags[16]);
  int  m_sizes[16];
  CLONE  *m_cloneList;
  CHKERRMSG m_cloneParents;
public:
  CLONES(CWnd *parentWindow);
  ~CLONES(void);
  //void MarkObjectList(RN obj, 
  //                    LOCATIONREL locr, 
  //                    CHKERRMSG *result,
  //                    CLONEFLAGS clf);
  void Clear(void);
  BYTE *FindFlag(int objIndex) const;
  void MarkObjectList(RN obj, bool markClones);
  void MarkCellObjects(void);
  void MarkTimerObjects(void);
  void MarkCharacterObjects(void);
  void MarkDungeonObjects(void);
  void MarkMonsterPossessions(void);
  void MarkScrollTexts(void);
  void MarkChestContents(void);
  void MarkMissileObjects(void);
  bool IsObjectReferenced(DBTYPE db, int index) const;
  bool IsObjectCloned(DBTYPE db, int index) const;
  bool IsIndirectIndexReferenced(int indirectIndex) const;
  bool IsIndirectIndexCloned(int indirectIndex) const;
  bool CloneParentAlreadyContains(RN list, 
                                  RN clone,
                                  CEMT errorType);
  void FindCloneParentList(
                   RN list,
                   LOCATIONREL locr);
  void FindCloneParentContainer(
               RN chest, //or monster or scroll or whatever
               LOCATIONREL locr);
  void FindCloneParentTimers();
  void FindCloneParentCharacters(void);
  void FindCloneParentCells(void);
  void FindCloneParents(void);
  void Analyze(CHKERRMSG *result);
  //void AnalyzeObjectList(int indirectIndex, 
  //                       RN list, 
  //                       CHKERRMSG *result,
  //                       LOCATIONREL locr);
  //void AnalyzeContainer(int indirectIndex, 
  //                      RN chest, //or whatever
  //                      CHKERRMSG *result,
  //                      LOCATIONREL locr);
  void AnalyzeOneIndirectIndex(int indirectIndex,
                               CHKERRMSG *result);
  //void AnalyzeCellParents(int dbnum,
  //                        int dbindex,
  //                        CHKERRMSG *result);
  //void AnalyzeCharacterParents(int indirectIndex, 
  //                             CHKERRMSG *result);
  //void AnalyzeTimerParents(int indirectIndex, 
  //                         CHKERRMSG *result);
  void AnalyzeParents(int dbnum, 
                      int dbindex,
                      CHKERRMSG *result);
};