// DatabaseEditor.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "DatabaseEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define AUTO_READ

#ifdef AUTO_READ
int oldDatabaseType;
int oldKey;
int oldSubKey;
#endif

/////////////////////////////////////////////////////////////////////////////
// DatabaseEditor dialog


DatabaseEditor::DatabaseEditor(CWnd* pParent /*=NULL*/)
	: CDialog(DatabaseEditor::IDD, pParent)
{
	//{{AFX_DATA_INIT(DatabaseEditor)
	m_size = 0;
	m_d0 = _T("");
	m_d1 = _T("");
	m_d10 = _T("");
	m_d11 = _T("");
	m_d12 = _T("");
	m_d13 = _T("");
	m_d14 = _T("");
	m_d15 = _T("");
	m_d2 = _T("");
	m_d3 = _T("");
	m_d4 = _T("");
	m_d5 = _T("");
	m_d6 = _T("");
	m_d7 = _T("");
	m_d8 = _T("");
	m_d9 = _T("");
	m_explanation = _T("");
	m_textData = _T("");
	m_dataTypeDecimal = 0;
	//}}AFX_DATA_INIT
}


void DatabaseEditor::TextToVar(int& var, int num, int len)
{
  int i, col;
  col = 4*num;
  char txt[4];
  for (i=0; i<4; i++)
  {
    txt[i] = 0;
    if (col+i < len)
    {
      txt[i] = m_textData[col+i];
    };
  };
  var = *(int *)txt;
}

void DatabaseEditor::DoDataExchange(CDataExchange* pDX)
{
  int i, oldDataTypeDecimal;
	CDialog::DoDataExchange(pDX);
  if (!pDX->m_bSaveAndValidate)
  {
    // Move integer variables to the dialog strings)
    switch (m_dataTypeDecimal)
    {
      case 0:
        // Decimal values.
        for (i=0; i<16; i++)
        {
          m_d[i]->Format("%d", m_dataValues[i]);
        };
        break;
      case 1:
        // Hex values.
        for (i=0; i<16; i++)
        {
          m_d[i]->Format("0x%x", m_dataValues[i]);
        };
        break;
      case 2:
        {
          // text values.
          int len;
          for (len=0; len<64; len++) if (*((char *)m_dataValues+len) == 0) break;
          m_textData = CString((char *)m_dataValues,64);
        };
        break;
    };
  };
  oldDataTypeDecimal = m_dataTypeDecimal;
	//{{AFX_DATA_MAP(DatabaseEditor)
	DDX_Control(pDX, IDC_SubKeyTitle, m_subKeyTitle);
	DDX_Control(pDX, IDC_SubKey, m_subKey);
	DDX_Control(pDX, IDC_Key, m_key);
	DDX_Control(pDX, IDC_KeyTitle, m_keyTitle);
	DDX_Control(pDX, IDC_DatabaseType, m_databaseType);
	DDX_Text(pDX, IDC_Size, m_size);
	DDX_Text(pDX, IDC_D0, m_d0);
	DDX_Text(pDX, IDC_D1, m_d1);
	DDX_Text(pDX, IDC_D10, m_d10);
	DDX_Text(pDX, IDC_D11, m_d11);
	DDX_Text(pDX, IDC_D12, m_d12);
	DDX_Text(pDX, IDC_D13, m_d13);
	DDX_Text(pDX, IDC_D14, m_d14);
	DDX_Text(pDX, IDC_D15, m_d15);
	DDX_Text(pDX, IDC_D2, m_d2);
	DDX_Text(pDX, IDC_D3, m_d3);
	DDX_Text(pDX, IDC_D4, m_d4);
	DDX_Text(pDX, IDC_D5, m_d5);
	DDX_Text(pDX, IDC_D6, m_d6);
	DDX_Text(pDX, IDC_D7, m_d7);
	DDX_Text(pDX, IDC_D8, m_d8);
	DDX_Text(pDX, IDC_D9, m_d9);
  DDX_Text(pDX, IDC_Explanation, m_explanation);
	DDX_Text(pDX, IDC_TextData, m_textData);
	DDV_MaxChars(pDX, m_textData, 64);
	DDX_Radio(pDX, IDC_DataTypeDecimal, m_dataTypeDecimal);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
    switch (oldDataTypeDecimal)
    {
      case 2:
      {
        //Move the text to the integer variables.
        int i, len;
        len = m_textData.GetLength();
        for (i=0; i<16; i++)
        {
          TextToVar(m_dataValues[i],i,len);
        };
      };
      break;
      case 0:
      {
        // Move decimal values to integer variables.
        for (i=0; i<16; i++)
        {
          sscanf((LPCSTR)(*m_d[i]),"%d", &m_dataValues[i]);
        };
      };
      break;
      case 1:
      {
        // Move hex values to integer variables
        for (i=0; i<16; i++)
        {
          sscanf((LPCSTR)(*m_d[i]),"%x", &m_dataValues[i]);
        };
      };
      break;
    };
  };
}


BEGIN_MESSAGE_MAP(DatabaseEditor, CDialog)
	//{{AFX_MSG_MAP(DatabaseEditor)
	ON_BN_CLICKED(IDC_Read, OnRead)
	ON_CBN_SELCHANGE(IDC_DatabaseType, OnSelchangeDatabaseType)
	ON_BN_CLICKED(IDC_Write, OnWrite)
	ON_BN_CLICKED(IDC_DataTypeText, OnDataTypeText)
	ON_BN_CLICKED(IDC_DataTypeDecimal, OnDataTypeDecimal)
	ON_EN_CHANGE(IDC_TextData, OnChangeTextData)
	ON_BN_CLICKED(IDC_DataTypeHex, OnDataTypeHex)
	ON_CBN_SELCHANGE(IDC_Key, OnSelchangeKey)
	ON_CBN_SELCHANGE(IDC_SubKey, OnSelchangeSubKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DatabaseEditor message handlers

BOOL DatabaseEditor::OnInitDialog() 
{
  int i;
  CWnd *pWnd;
  m_d[0]  = &m_d0;
  m_d[1]  = &m_d1;
  m_d[2]  = &m_d2;
  m_d[3]  = &m_d3;
  m_d[4]  = &m_d4;
  m_d[5]  = &m_d5;
  m_d[6]  = &m_d6;
  m_d[7]  = &m_d7;
  m_d[8]  = &m_d8;
  m_d[9]  = &m_d9;
  m_d[10] = &m_d10;
  m_d[11] = &m_d11;
  m_d[12] = &m_d12;
  m_d[13] = &m_d13;
  m_d[14] = &m_d14;
  m_d[15] = &m_d15;
  for (i=0; i<16; i++)
  {
    m_dataValues[i] = 0;
  };
	CDialog::OnInitDialog();
	pWnd = GetDlgItem(IDC_KeyTitle);
	// TODO: Add extra initialization here
	pWnd->SetWindowText("");
	pWnd = GetDlgItem(IDC_SubKeyTitle);
	pWnd->SetWindowText("");
  Visiblize();
#ifdef AUTO_READ
  oldDatabaseType = m_databaseType.GetCurSel();
  oldKey = m_key.GetCurSel();
#endif
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DatabaseEditor::OnRead() 
{
  int databaseType;
  ui32 *pData;
  int key;
  int i;
  int exSize;
	// TODO: Add your control notification handler code here
#ifndef AUTO_READ
  UpdateData(true);
#endif
  databaseType = m_databaseType.GetCurSel();
  if (databaseType < 0) return;
	key = m_key.GetCurSel();
  if (databaseType == EDBT_AltMonGraphics) key |= (m_subKey.GetCurSel() << 8);
  exSize = expool.Locate((EDT_Database << 24) | (databaseType << 16) | key, &pData); 
  if (exSize == -1)
  {
    MessageBox("No such record","Search failed", MB_OK);
    m_size = 0;
    for (i=0; i<16; i++)
    {
      m_dataValues[i] = 0;
    };
  }
  else
  {
    m_size = exSize;
    for (i=0; i<16; i++)
    {
      m_dataValues[i] = 0;
    };
    for (i=0; i<exSize; i++)
    {
      m_dataValues[i] = pData[i];
    };
  };
#ifndef AUTO_READ
  UpdateData(false);
#endif
}


void DatabaseEditor::AddMonsterNames() 
{
  m_key.AddString("00 - Scorpion");
  m_key.AddString("01 - SlimeDevil");
  m_key.AddString("02 - Giggler");
  m_key.AddString("03 - FlyingEye");
  m_key.AddString("04 - Hellhound");
  m_key.AddString("05 - 5");
  m_key.AddString("06 - Screamer");
  m_key.AddString("07 - RockPile");
  m_key.AddString("08 - Rive");
  m_key.AddString("09 - StoneGolem");
  m_key.AddString("10 -  Mummy");
  m_key.AddString("11 - BlackFlame");
  m_key.AddString("12 - Skeleton");
  m_key.AddString("13 - Couatl");
  m_key.AddString("14 - Vexirk");
  m_key.AddString("15 - Worm");
  m_key.AddString("16 - AntMan");         
  m_key.AddString("17 - Muncher");        
  m_key.AddString("18 - DethKnight");     
  m_key.AddString("19 - Zytaz");          
  m_key.AddString("20 - WaterElemental"); 
  m_key.AddString("21 - Oitu");           
  m_key.AddString("22 - Demon");          
  m_key.AddString("23 - LordChaos");      
  m_key.AddString("24 - Dragon");         
  m_key.AddString("25 - LordOrder");      
  m_key.AddString("26 - GreyLord");       
  m_key.SetCurSel(0);
  m_keyTitle.SetWindowText("CSB Monster index/name");
};

void DatabaseEditor::OnSelchangeDatabaseType() 
{
  int i;
	// TODO: Add your control notification handler code here
  UpdateData(true);
  m_key.ResetContent();
  m_subKey.ResetContent();
  switch (m_databaseType.GetCurSel())
  {
  case 0: // Object Weight
    m_key.AddString("Chest");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Object type");
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    m_explanation = "One word entry giving integer weight";
    break;
  case 1: // Delete Duplicate Timer Entries
    m_key.AddString("Not Used");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Not Used");
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    m_explanation = "One word entry: non-zero causes duplicate timer entries to be"
                    " discarded (the original code did this).  Zero causes all"
                    " timer messages to be delivered (more intuitive IMHO)";
    break;
  case 2: // Runtime File Signatures
    m_key.AddString("CSBGraphics.dat");
    m_key.AddString("Graphics.dat");
    m_key.AddString("CSBwin.exe");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Filename");
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    m_explanation = "An integer specifying the digital signature of"
                    " the runtime file that is to be used with"
                    " this dungeon.  Setting value to zero (or debuging mode)"
                    " disables signature checking.";
    break;
  case 3: // Debuging mode
    m_key.AddString("Not Used");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Not Used");
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    m_explanation = "Any non-zero value disables signature checking for"
                    " CSBGraphics.dat, Graphics.dat, and CSBwin.exe."; 
    break;
  case 4: //global variables
    m_key.AddString("0-15");
    m_key.AddString("16-31");
    m_key.AddString("32-47");
    m_key.AddString("48-63");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Global Variable numbers");
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    m_explanation = "Global variables referenced in DSAs using the"
                    " &GVnnn@ and GVnnn! instruction words.";
    break;
  case 5: // Disable Saves
    m_key.AddString("Not Used");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Not Used");
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    m_explanation = "Any record will disable saves"; 
    break;
  case 6: // Monster Names
    AddMonsterNames();
    m_explanation = "Up to four names for this monster separated "
                    "by vertical bar.  Max 64 characters total";
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    break;
  case 7: // DSA traces
    AddMonsterNames();
    m_subKey.AddString("Not Used");
    m_subKeyTitle.SetWindowText("Not Used");
    break;
  case 8: //Alternate Monster Graphics
    AddMonsterNames();
    m_keyTitle.SetWindowText("Monster index/name");
    for (i=0; i<63; i++)
    {
      char text[20];
      sprintf(text,"%d",i);
      //m_subKey.AddString("abc");
      //m_subKey.AddString("def");
      m_subKey.AddString(text);
    };
    m_subKey.SetCurSel(0);
    m_subKeyTitle.SetWindowText("Dungeon Level");
    m_explanation = "A record should be size=4.  "
                    "For one monster type on a particular level you can specify"
                    " the four alternate graphic numbers to be used.  Negative one"
                    " means to use standard alternate graphics.  Negative two means"
                    " to use no alternate graphics";
    break;
  default:
    return;
  };
#ifdef AUTO_READ
  if ((oldDatabaseType != m_databaseType.GetCurSel()) || (oldKey != m_key.GetCurSel()))
  {
    OnRead();
  };
  oldDatabaseType = m_databaseType.GetCurSel();
  oldKey = m_key.GetCurSel();
#endif
  UpdateData(false);
}

void DatabaseEditor::OnWrite() 
{
	// TODO: Add your control notification handler code here
  int databaseType;
  int key;
  int count;
  int size;
  CString text;
	// TODO: Add your control notification handler code here
  UpdateData(true);
  databaseType = m_databaseType.GetCurSel();
  if (databaseType < 0) return;
	key = m_key.GetCurSel();
  if (databaseType == 8) key |= (m_subKey.GetCurSel() << 8);
  size = m_size;
  count = 0;
  expool.Write(
        (EDT_Database << 24) | (databaseType << 16) | key,
        (ui32 *)m_dataValues,
        size);
  MODIFY
}


void DatabaseEditor::SetVisible(int id, bool visible)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd != NULL) pWnd->ShowWindow(visible);
}

void DatabaseEditor::Visiblize(void)
{
  SetVisible(IDC_TextData, m_dataTypeDecimal==2);
  SetVisible(IDC_D0, m_dataTypeDecimal!=2);
  SetVisible(IDC_D1, m_dataTypeDecimal!=2);
  SetVisible(IDC_D2, m_dataTypeDecimal!=2);
  SetVisible(IDC_D3, m_dataTypeDecimal!=2);
  SetVisible(IDC_D4, m_dataTypeDecimal!=2);
  SetVisible(IDC_D5, m_dataTypeDecimal!=2);
  SetVisible(IDC_D6, m_dataTypeDecimal!=2);
  SetVisible(IDC_D7, m_dataTypeDecimal!=2);
  SetVisible(IDC_D8, m_dataTypeDecimal!=2);
  SetVisible(IDC_D9, m_dataTypeDecimal!=2);
  SetVisible(IDC_D10, m_dataTypeDecimal!=2);
  SetVisible(IDC_D11, m_dataTypeDecimal!=2);
  SetVisible(IDC_D12, m_dataTypeDecimal!=2);
  SetVisible(IDC_D13, m_dataTypeDecimal!=2);
  SetVisible(IDC_D14, m_dataTypeDecimal!=2);
  SetVisible(IDC_D15, m_dataTypeDecimal!=2);
  SetVisible(IDC_S0, m_dataTypeDecimal!=2);
  SetVisible(IDC_S1, m_dataTypeDecimal!=2);
  SetVisible(IDC_S2, m_dataTypeDecimal!=2);
  SetVisible(IDC_S3, m_dataTypeDecimal!=2);
  SetVisible(IDC_S4, m_dataTypeDecimal!=2);
  SetVisible(IDC_S5, m_dataTypeDecimal!=2);
  SetVisible(IDC_S6, m_dataTypeDecimal!=2);
  SetVisible(IDC_S7, m_dataTypeDecimal!=2);
  SetVisible(IDC_S8, m_dataTypeDecimal!=2);
  SetVisible(IDC_S9, m_dataTypeDecimal!=2);
  SetVisible(IDC_S10, m_dataTypeDecimal!=2);
  SetVisible(IDC_S11, m_dataTypeDecimal!=2);
  SetVisible(IDC_S12, m_dataTypeDecimal!=2);
  SetVisible(IDC_S13, m_dataTypeDecimal!=2);
  SetVisible(IDC_S14, m_dataTypeDecimal!=2);
  SetVisible(IDC_S15, m_dataTypeDecimal!=2);
#ifdef AUTO_READ
  SetVisible(IDC_Read, false);
#endif
}

void DatabaseEditor::OnDataTypeHex() 
{
  BOOL hex;
	// TODO: Add your control notification handler code here
  hex = m_dataTypeDecimal == 1;
  UpdateData(true);
  /*
  for (i=0; i<16; i++)
  {
    if (*m_d[i] == "") continue;
    if (hex)
    {
      n = sscanf(*m_d[i],"%x",&data);
    }
    else
    {
      n = sscanf(*m_d[i], "%d", &data);
    };
    if (n != 1)
    {
      *m_d[i] = "";
    }
    else
    {
      if (m_dataTypeDecimal == 1)
      {
        m_d[i]->Format("0x%x", data);
      }
      else
      {
        m_d[i]->Format("%d", data);
      };
    };
  };
  */
  Visiblize();
  UpdateData(false);
}


void DatabaseEditor::OnDataTypeText() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
  Visiblize();
  UpdateData(false);
}

void DatabaseEditor::OnDataTypeDecimal() 
{
	// TODO: Add your control notification handler code here
  OnDataTypeHex();	
}

void DatabaseEditor::OnChangeTextData() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
  UpdateData(true);
  m_size = (m_textData.GetLength() + 4)/4;
  if (m_size > 16) m_size = 16;
  UpdateData(false);
	
}


void DatabaseEditor::OnSelchangeKey() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
#ifdef AUTO_READ
	if (m_key.GetCurSel() != oldKey)
  {
    OnRead();
  };
  oldKey = m_key.GetCurSel();
#endif
  UpdateData(false);
}

void DatabaseEditor::OnSelchangeSubKey() 
{
	// TODO: Add your control notification handler code here
	
  UpdateData(true);
#ifdef AUTO_READ
	if (m_subKey.GetCurSel() != oldSubKey)
  {
    OnRead();
  };
  oldSubKey = m_subKey.GetCurSel();
#endif
  UpdateData(false);
}
