// DesignedActuator.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "myCListCtrl.h"
#include "DSAHelp.h"
#include "WarningDialog.h"

#include "DesignedActuator.h"
#include "misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// DesignedActuator dialog


DesignedActuator::DesignedActuator(CWnd* pParent /*=NULL*/)
                                   : CDialog(DesignedActuator::IDD, pParent)
                                   
{
	//{{AFX_DATA_INIT(DesignedActuator)
	m_description = _T("");
	m_groupID = 0;
	m_stateLocation = 0;
	m_initialState = 0;
	m_master = 0;
	m_C0Text = _T("");
	m_C1Text = _T("");
	m_C2Text = _T("");
	m_C3Text = _T("");
	m_editInBigWindow = FALSE;
	m_S0Text = _T("");
	m_S1Text = _T("");
	m_S2Text = _T("");
	m_S3Text = _T("");
	m_T0Text = _T("");
	m_T1Text = _T("");
	m_T2Text = _T("");
	m_T3Text = _T("");
	m_displayState = 0;
	//}}AFX_DATA_INIT
  m_errorControlID = -1;
  m_errorColumn = -1;
}

void DesignedActuator::Show(int IDC, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(IDC);
  if (pWnd != NULL) pWnd->ShowWindow(show);
}

void DesignedActuator::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
  if (!pDX->m_bSaveAndValidate)
  {
    m_description = m_DSA.Description();
    m_groupID = m_DSA.GroupID();
    m_stateLocation = m_DSA.StateLocation();
    if (m_stateLocation == 3)
    {
      m_stateLocation = 0;
      m_master = 1;
    };
    m_initialState = m_DSA.State();
  };
	//{{AFX_DATA_MAP(DesignedActuator)
	DDX_Control(pDX, IDC_FirstDisplayState, m_firstDisplayStateCtrl);
	DDX_Control(pDX, IDC_SpinState, m_spinState);
	DDX_Control(pDX, IDC_InitialStateTitle, m_initialStateTitle);
	DDX_Control(pDX, IDC_InitialState, m_initialStateControl);
	DDX_Text(pDX, IDC_Description, m_description);
	DDV_MaxChars(pDX, m_description, 80);
	DDX_Text(pDX, IDC_GroupID, m_groupID);
	DDV_MinMaxUInt(pDX, m_groupID, 0, 255);
	DDX_Radio(pDX, IDC_LocalState, m_stateLocation);
	DDX_Text(pDX, IDC_InitialState, m_initialState);
	DDV_MinMaxUInt(pDX, m_initialState, 0, 65535);
	DDX_Radio(pDX, IDC_Master, m_master);
	DDX_Text(pDX, IDC_C0Text, m_C0Text);
	DDX_Text(pDX, IDC_C1Text, m_C1Text);
	DDX_Text(pDX, IDC_C2Text, m_C2Text);
	DDX_Text(pDX, IDC_C3Text, m_C3Text);
	DDX_Check(pDX, IDC_EditInBigWindow, m_editInBigWindow);
	DDX_Text(pDX, IDC_S0Text, m_S0Text);
	DDX_Text(pDX, IDC_S1Text, m_S1Text);
	DDX_Text(pDX, IDC_S2Text, m_S2Text);
	DDX_Text(pDX, IDC_S3Text, m_S3Text);
	DDX_Text(pDX, IDC_T0Text, m_T0Text);
	DDX_Text(pDX, IDC_T1Text, m_T1Text);
	DDX_Text(pDX, IDC_T2Text, m_T2Text);
	DDX_Text(pDX, IDC_T3Text, m_T3Text);
	DDX_Text(pDX, IDC_FirstDisplayState, m_displayState);
	DDV_MinMaxUInt(pDX, m_displayState, 0, 999);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    //m_list.SetDSA(&m_DSA);
    Show(IDC_InitialState, 
          (m_stateLocation==1) && (m_master==0));
    Show(IDC_InitialStateTitle, 
          (m_stateLocation==1) && (m_master==0));
    Show(IDC_LocalState, m_master == 0);
    Show(IDC_GlobalState, m_master == 0);
    Show(IDC_ParameterB, m_master == 0);

  };
  if (pDX->m_bSaveAndValidate) 
  {
    //m_list.GetDSA(&m_DSA);
    m_DSA.FirstDisplayedState(m_displayState);
    m_DSA.Description(m_description);
    m_DSA.GroupID(m_groupID);
    m_DSA.StateLocation(m_stateLocation);
    if (m_master == 1)m_DSA.StateLocation(3);
    m_DSA.State(m_initialState);
  };
}

BEGIN_MESSAGE_MAP(DesignedActuator, CDialog)
	//{{AFX_MSG_MAP(DesignedActuator)
	ON_WM_LBUTTONDOWN()
	ON_WM_CTLCOLOR()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_Help, OnHelp)
	ON_BN_CLICKED(IDC_LocalState, OnLocalState)
	ON_BN_CLICKED(IDC_Master, OnMaster)
	ON_BN_CLICKED(IDC_Slave, OnSlave)
	ON_BN_CLICKED(IDC_ParameterB, OnParameterB)
	ON_EN_CHANGE(IDC_FirstDisplayState, OnChangeFirstDisplayState)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SpinState, OnDeltaposSpinState)
	ON_EN_KILLFOCUS(IDC_C0Text, OnKillfocusC0Text)
	ON_EN_KILLFOCUS(IDC_C1Text, OnKillfocusC1Text)
	ON_EN_KILLFOCUS(IDC_C2Text, OnKillfocusC2Text)
	ON_EN_KILLFOCUS(IDC_C3Text, OnKillfocusC3Text)
	ON_EN_KILLFOCUS(IDC_S0Text, OnKillfocusS0Text)
	ON_EN_KILLFOCUS(IDC_S1Text, OnKillfocusS1Text)
	ON_EN_KILLFOCUS(IDC_S2Text, OnKillfocusS2Text)
	ON_EN_KILLFOCUS(IDC_S3Text, OnKillfocusS3Text)
	ON_EN_KILLFOCUS(IDC_T0Text, OnKillfocusT0Text)
	ON_EN_KILLFOCUS(IDC_T1Text, OnKillfocusT1Text)
	ON_EN_KILLFOCUS(IDC_T2Text, OnKillfocusT2Text)
	ON_EN_KILLFOCUS(IDC_T3Text, OnKillfocusT3Text)
	ON_EN_SETFOCUS(IDC_C0Text, OnSetfocusC0Text)
	ON_EN_SETFOCUS(IDC_C1Text, OnSetfocusC1Text)
	ON_EN_SETFOCUS(IDC_C2Text, OnSetfocusC2Text)
	ON_EN_SETFOCUS(IDC_C3Text, OnSetfocusC3Text)
	ON_EN_SETFOCUS(IDC_S0Text, OnSetfocusS0Text)
	ON_EN_SETFOCUS(IDC_S1Text, OnSetfocusS1Text)
	ON_EN_SETFOCUS(IDC_S2Text, OnSetfocusS2Text)
	ON_EN_SETFOCUS(IDC_S3Text, OnSetfocusS3Text)
	ON_EN_SETFOCUS(IDC_T0Text, OnSetfocusT0Text)
	ON_EN_SETFOCUS(IDC_T1Text, OnSetfocusT1Text)
	ON_EN_SETFOCUS(IDC_T2Text, OnSetfocusT2Text)
	ON_EN_SETFOCUS(IDC_T3Text, OnSetfocusT3Text)
	ON_EN_SETFOCUS(IDC_FirstDisplayState, OnSetfocusFirstDisplayState)
	ON_EN_SETFOCUS(IDC_Description, OnSetfocusDescription)
	ON_EN_SETFOCUS(IDC_GroupID, OnSetfocusGroupID)
	ON_BN_CLICKED(IDC_Export, OnExport)
	ON_BN_CLICKED(IDC_GlobalState, OnLocalState)
	ON_BN_CLICKED(IDC_Import, OnImport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DesignedActuator message handlers
/*
void DesignedActuator::FillStateTable(void)
{
  CWnd *pWnd;

  pWnd = GetDlgItem(IDC_EditCell);
  pWnd->SetWindowPos(&wndTop,
                    m_leftOfListWindow + m_stateColumnWidth,
                    m_topOfListWindow + 1,
                    52,
                    15,
                    0);
}
*/

void DesignedActuator::ExtractProgramsFromRecord(void)
{
  m_S0Text = m_DSA.Pgm(m_displayState,0);
  m_S1Text = m_DSA.Pgm(m_displayState,3);
  m_S2Text = m_DSA.Pgm(m_displayState,6);
  m_S3Text = m_DSA.Pgm(m_displayState,9);
  m_C0Text = m_DSA.Pgm(m_displayState,1);
  m_C1Text = m_DSA.Pgm(m_displayState,4);
  m_C2Text = m_DSA.Pgm(m_displayState,7);
  m_C3Text = m_DSA.Pgm(m_displayState,10);
  m_T0Text = m_DSA.Pgm(m_displayState,2);
  m_T1Text = m_DSA.Pgm(m_displayState,5);
  m_T2Text = m_DSA.Pgm(m_displayState,8);
  m_T3Text = m_DSA.Pgm(m_displayState,11);
}

bool DesignedActuator::Encode(int i, CString& p, int ID)
{
  int n;
  n = m_DSA.Pgm(m_displayState, i, p);
  if (n < 0) return true;
  m_encodeErrorID = ID;
  m_encodeErrorCol = n;
  return false;
}

#define ENCODE(a,b,c) if (!Encode(a,b,c)) return false;       

bool DesignedActuator::EncodeProgramsIntoRecord(void)
{
  ENCODE(0 ,m_S0Text,IDC_S0Text)
  ENCODE(3 ,m_S1Text,IDC_S1Text)
  ENCODE(6 ,m_S2Text,IDC_S2Text)
  ENCODE(9 ,m_S3Text,IDC_S3Text)
  ENCODE(1 ,m_C0Text,IDC_C0Text)
  ENCODE(4 ,m_C1Text,IDC_C1Text)
  ENCODE(7 ,m_C2Text,IDC_C2Text)
  ENCODE(10,m_C3Text,IDC_C3Text)
  ENCODE(2 ,m_T0Text,IDC_T0Text)
  ENCODE(5 ,m_T1Text,IDC_T1Text)
  ENCODE(8 ,m_T2Text,IDC_T2Text)
  ENCODE(11,m_T3Text,IDC_T3Text)
  return true;
}

BOOL DesignedActuator::OnInitDialog() 
{
	CDialog::OnInitDialog();
  m_displayState = m_DSA.FirstDisplayedState();
  ExtractProgramsFromRecord();
  UpdateData(false);
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void DesignedActuator::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
//  TRACE0("DesignedActuator::OnLButonDown\n");
	CDialog::OnLButtonDown(nFlags, point);
}


void DesignedActuator::OnOK() 
{
	// TODO: Add extra validation here
	//m_list.OnOK();
  int errorID = m_errorControlID;
  if (m_errorControlID >= 0)
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_errorControlID);
    if (pWnd != NULL)
    {
      if (!KillFocus(m_errorControlID))
      {
        MessageBox("Fix your program before exiting!","Sorry",MB_TOPMOST);
        SetFocus(errorID);
        GotoDlgCtrl(pWnd);
        return;
      };
    };
  };
	CDialog::OnOK();
}

HBRUSH DesignedActuator::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

int DesignedActuator::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  //RECT rect = {1,160,795,457};
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	//m_list.Create(LVS_NOCOLUMNHEADER|WS_VISIBLE|WS_CHILD,
  //               rect,
  //                this,
  //                  IDD_EditDSA);
	// TODO: Add your specialized creation code here
  //BuildStateTable(&m_DSA);
  //m_list.SetBkColor(RGB(192,255,192));
  //m_list.SetTextBkColor(RGB(192,255,192));

  //m_list.SetDSA(&m_DSA);
  //m_list.SetDSA(&m_DSA);
	
	return 0;
}

//void DesignedActuator::OnSelchangeStartingState() 
//{
	// TODO: Add your control notification handler code here
	//UpdateData(true);
  //UpdateData(false);
//}

void DesignedActuator::OnHelp() 
{
	// TODO: Add your control notification handler code here
	DSAHelp dlg;
  dlg.DoModal();
}

void DesignedActuator::OnLocalState() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  UpdateData(false);
}

void DesignedActuator::OnMaster() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  UpdateData(false);
}

void DesignedActuator::OnSlave() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  UpdateData(false);
}

void DesignedActuator::OnParameterB() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  UpdateData(false);
	
}

void DesignedActuator::OnChangeFirstDisplayState() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
  char buf[81];
  int len;
  unsigned int origFirst;
  len = m_firstDisplayStateCtrl.GetLine(0,buf,80);
  if (len == 0) return;
  if (MessageBoxActive())return;
  origFirst = m_displayState;
	UpdateData(true);
  if (m_displayState == origFirst) return;
  if (m_displayState > 999)
  {
    m_displayState = 999;
  };
  m_DSA.FirstDisplayedState(m_displayState);
  ExtractProgramsFromRecord();
  UpdateData(false);
}

void DesignedActuator::OnDeltaposSpinState(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
  if (m_errorControlID >= 0)
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_errorControlID);
    if (pWnd != NULL)
    {
      if (!KillFocus(m_errorControlID))
      return;
    };
      //MessageBox("Fix your program before selecting another state!","Sorry",MB_TOPMOST);
  };
	UpdateData(true);
  if (!EncodeProgramsIntoRecord())
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_encodeErrorID);
    if (pWnd != NULL) GotoDlgCtrl(pWnd);
    MessageBox("Fix your program before selecting another state!","Sorry",MB_TOPMOST);
    return;
  };
  unsigned int newfirst;
  newfirst = m_displayState + pNMUpDown->iDelta;
  if (newfirst > 2000000) newfirst = 0;
  if (newfirst == m_displayState) return;
  m_displayState = newfirst;
  TRACE1("DeltaSpin setting dislayState=%d\n",m_displayState);
  m_DSA.FirstDisplayedState(m_displayState);
  ExtractProgramsFromRecord();
  UpdateData(false);
  *pResult = 0;
}

bool DesignedActuator::KillFocus(int windowID)
{
  CWnd *pWnd;
  CString txt;
  int error, index;
  //TRACE2("%x KillFocus index=%x\n",windowID, index);
  pWnd = GetDlgItem(windowID);
  index = WindowID2Index(windowID);
  if (index < 0) return true;
  if (pWnd == NULL) return true;
  pWnd->GetWindowText(txt);
  error = m_DSA.Pgm(m_displayState,index,txt);
  TRACE2("%x  Error=%d\n",windowID, error);
  if (error >= 0)
  {
    TRACE2("%x   m_errorControlID=%d\n",windowID, m_errorControlID);
    if (m_errorControlID == -1)
    {
      TRACE1("%x   m_errorControlID = -1\n",windowID);
      m_errorControlID = windowID;
      TRACE2("%x   KillFocus set m_errorColumn=%d\n",windowID, error);
      m_errorColumn = error;
    };
    return false;
  };
  if (m_errorControlID == windowID)
  {
    TRACE1("%x  m_activeEditControlID == windowID\n",windowID);
    m_errorControlID = -1;
    TRACE1("%x   KillFocus setting m_errorColumn=-1\n",windowID);
    m_errorColumn = -1;
  };
  return true;
}

void DesignedActuator::OnKillfocusC0Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_C0Text);

}


void DesignedActuator::OnKillfocusC1Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_C1Text);
	
}

void DesignedActuator::OnKillfocusC2Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_C2Text);
	
}

void DesignedActuator::OnKillfocusC3Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_C3Text);
	
}

void DesignedActuator::OnKillfocusS0Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_S0Text);
	
}

void DesignedActuator::OnKillfocusS1Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_S1Text);
	
}

void DesignedActuator::OnKillfocusS2Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_S2Text);
	
}

void DesignedActuator::OnKillfocusS3Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_S3Text);
	
}

void DesignedActuator::OnKillfocusT0Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_T0Text);
	
}

void DesignedActuator::OnKillfocusT1Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_T1Text);
	
}

void DesignedActuator::OnKillfocusT2Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_T2Text);
	
}

void DesignedActuator::OnKillfocusT3Text() 
{
	// TODO: Add your control notification handler code here
  KillFocus(IDC_T3Text);
	
}

int DesignedActuator::WindowID2Index(int windowID)
{
  if (windowID == IDC_S0Text) return 0;
  if (windowID == IDC_S1Text) return 3;
  if (windowID == IDC_S2Text) return 6;
  if (windowID == IDC_S3Text) return 9;

  if (windowID == IDC_C0Text) return 1;
  if (windowID == IDC_C1Text) return 4;
  if (windowID == IDC_C2Text) return 7;
  if (windowID == IDC_C3Text) return 10;

  if (windowID == IDC_T0Text) return 2;
  if (windowID == IDC_T1Text) return 5;
  if (windowID == IDC_T2Text) return 8;
  if (windowID == IDC_T3Text) return 11;
  return -1;
}

void DesignedActuator::SetFocus(int windowID)
{
  TRACE3("%x SetFocus errorControlID=%x errorColumn=%d\n", 
               windowID,m_errorControlID,m_errorColumn);
  if (m_errorControlID == -1)
  {
    m_errorControlID = windowID;
  }
  else
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_errorControlID);
    if (pWnd == NULL) return;
    if (m_errorControlID == windowID)
    {
      m_errorControlID = -1;
      if (m_errorColumn >= 0)
      {
        int last;
        last = ((CEdit *)pWnd)->LineLength();
        TRACE2("%x Setting Selection to %d\n",windowID, m_errorColumn);
        ((CEdit *)pWnd)->SetSel(m_errorColumn,last);
      };
      return;
    }
    else
    {
      TRACE2("%x SetFocus About to GotoDlgCtrl %x\n",windowID, m_errorControlID);
      GotoDlgCtrl(pWnd);
      TRACE1("%x Finished GotDlgCtrl\n",windowID);
      MessageBox("There is an error in a program\nYou must first fix that.","Sorry",MB_OK|MB_TOPMOST);
    };
  };
}

void DesignedActuator::OnSetfocusC0Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_C0Text);	

}

void DesignedActuator::OnSetfocusC1Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_C1Text);	
	
}

void DesignedActuator::OnSetfocusC2Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_C2Text);	
	
}

void DesignedActuator::OnSetfocusC3Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_C3Text);	
	
}

void DesignedActuator::OnSetfocusS0Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_S0Text);	
	
}

void DesignedActuator::OnSetfocusS1Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_S1Text);	
	
}

void DesignedActuator::OnSetfocusS2Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_S2Text);	
	
}

void DesignedActuator::OnSetfocusS3Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_S3Text);	
	
}

void DesignedActuator::OnSetfocusT0Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_T0Text);	
	
}

void DesignedActuator::OnSetfocusT1Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_T1Text);	
	
}

void DesignedActuator::OnSetfocusT2Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_T2Text);	
	
}

void DesignedActuator::OnSetfocusT3Text() 
{
	// TODO: Add your control notification handler code here
  SetFocus(IDC_T3Text);	
	
}

void DesignedActuator::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void DesignedActuator::OnSetfocusFirstDisplayState() 
{
	// TODO: Add your control notification handler code here
  if (m_errorControlID >= 0)
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_errorControlID);
    if (pWnd != NULL) GotoDlgCtrl(pWnd);
    MessageBox("Fix your program before editing another state!","Sorry",MB_TOPMOST);
    return;
  };	
}

void DesignedActuator::OnSetfocusDescription() 
{
	// TODO: Add your control notification handler code here
  if (m_errorControlID >= 0)
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_errorControlID);
    if (pWnd != NULL) GotoDlgCtrl(pWnd);
    MessageBox("Fix your program before changing description!","Sorry",MB_TOPMOST);
    return;
  };
}

void DesignedActuator::OnSetfocusGroupID() 
{
	// TODO: Add your control notification handler code here
  if (m_errorControlID >= 0)
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(m_errorControlID);
    if (pWnd != NULL) GotoDlgCtrl(pWnd);
    MessageBox("Fix your program before changing groupID!","Sorry",MB_TOPMOST);
    return;
  };
	
}

void DesignedActuator::OnExport() 
{
	// TODO: Add your control notification handler code here
  m_DSA.Export();	
}

void DesignedActuator::OnImport() 
{
	// TODO: Add your control notification handler code here
  m_DSA.Import();	
  ExtractProgramsFromRecord();
  UpdateData(false);
}
