// EditActiveTimers.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "EditActiveTimers.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditActiveTimers dialog


EditActiveTimers::EditActiveTimers(CWnd* pParent /*=NULL*/)
	: CDialog(EditActiveTimers::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditActiveTimers)
	m_currentTime = 0;
	//}}AFX_DATA_INIT
}


void EditActiveTimers::DoDataExchange(CDataExchange* pDX)
{
  CString line;
  LOCATIONREL locr;
  LOCATIONABS loca;
  int i;
  TIMER *pTimer;
  m_currentTime = pDoc->Time();
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditActiveTimers)
	DDX_Control(pDX, IDC_LIST1, m_timerList);
	DDX_Text(pDX, IDC_CurrentTime, m_currentTime);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    m_timerList.ResetContent();
    for (i=0; i<pDoc->NumTimers(); i++)
    {
      pTimer = pDoc->Timer(i);
      locr.l((pTimer->time >> 24) & 0xff);
      locr.x(pTimer->uByte6);
      locr.y(pTimer->uByte7);
      locr.p(pTimer->uByte8);
      loca = locr;
      switch (pTimer->timerFunction)
      {
      case 37:
      case 65:
        line.Format("%06d %02d %02d(%02d,%02d)",
                     pTimer->time & 0xffffff,
                     pTimer->timerFunction,
                     loca.l,
                     loca.x,
                     loca.y);
      break;
      case 11:
        line.Format("%06d %02d %1d",
                    pTimer->time & 0xffffff,
                    pTimer->timerFunction,
                    pTimer->uByte5);
        break;
      case 53:
        line.Format("%06d %02d Watchdog",
                    pTimer->time & 0xffffff,
                    pTimer->timerFunction);
        break;
      case 60:
      case 61:
        line.Format("%06d %02d %02d(%02d,%02d) Queued Monster",
                     pTimer->time & 0xffffff,
                     pTimer->timerFunction,
                     loca.l,
                     loca.x,
                     loca.y);
        break;
      case 70:
        line.Format("%06d %02d Adjust Light by %d",
                     pTimer->time & 0xffffff,
                     pTimer->timerFunction,
                     pTimer->word6());
        break;
      case 48:
      case 49:
        {
          RN obj;
          int pos;
          int direction, deltaEnergy;
          obj = pTimer->timerObj6();
          pos = obj.pos();
          locr.x(BITS0_4(pTimer->word8()));
          locr.y(BITS5_9(pTimer->word8()));
          locr.p(pos);
          loca = locr;
          direction = BITS10_11(pTimer->word8());
          deltaEnergy = BITS12_15(pTimer->word8());
          line.Format("%06d %02d %02d(%02d,%02d)%d Missile dir=%d deltaQ=%d",
                       pTimer->time & 0xffffff,
                       pTimer->timerFunction,
                       loca.l,
                       loca.x,
                       loca.y,
                       loca.p,
                       direction,
                       deltaEnergy);
        };
        break;                    
      default:
        line.Format("%06d %02d Unknown",
                    pTimer->time & 0xffffff,
                    pTimer->timerFunction);
        break;
      };
      m_timerList.AddString(line);
    };
  };
}


BEGIN_MESSAGE_MAP(EditActiveTimers, CDialog)
	//{{AFX_MSG_MAP(EditActiveTimers)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditActiveTimers message handlers
