// EditClothes.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "EditClothes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditClothes dialog

int DB6::Edit(LOCATIONREL locr, RN RNclothing)
{
  EditClothes dlg(locr, RNclothing);
  dlg.m_pClothing = this;
  return dlg.DoModal();
}



EditClothes::EditClothes(LOCATIONREL locr,
                         RN RNclothing,
                         CWnd* pParent /*=NULL*/)
	: CDialog(EditClothes::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditClothes)
	m_broken = FALSE;
	m_charges = 0;
	m_cursed = FALSE;
	m_important = FALSE;
	//}}AFX_DATA_INIT
  m_locr = locr;
  m_RNclothing = RNclothing;
}

void EditClothes::ExtractDataFromRecord(void)
{
  m_important    = m_pClothing->important();
  m_cursed       = m_pClothing->cursed();
  m_charges      = m_pClothing->charges();
  m_clothingType = m_pClothing->clothingType();
  m_broken       = m_pClothing->broken();
}

bool EditClothes::EncodeDataIntoRecord(void)
{
  m_pClothing->important(m_important?true:false);
  m_pClothing->cursed(m_cursed?true:false);
  m_pClothing->charges(m_charges);
  m_pClothing->clothingType(m_clothingType);
  m_pClothing->broken(m_broken?true:false);
  return true;
}




void EditClothes::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditClothes)
	DDX_Control(pDX, IDC_ClothingType, m_objectType);
	DDX_Check(pDX, IDC_Broken, m_broken);
	DDX_Text(pDX, IDC_Charges, m_charges);
	DDV_MinMaxUInt(pDX, m_charges, 0, 15);
	DDX_Check(pDX, IDC_Cursed, m_cursed);
	DDX_Check(pDX, IDC_Important, m_important);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
    m_clothingType = (CLOTHINGTYPE)m_objectType.GetItemData(m_objectType.GetCurSel());
  };
}


BEGIN_MESSAGE_MAP(EditClothes, CDialog)
	//{{AFX_MSG_MAP(EditClothes)
	ON_CBN_SELCHANGE(IDC_ClothingType, OnSelchangeClothingType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditClothes message handlers

void EditClothes::OnSelchangeClothingType() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
  UpdateData(false);
	
}

BOOL EditClothes::OnInitDialog() 
{
  int i;
  CString title;
  LOCATIONABS loca;
  ExtractDataFromRecord();
  loca = m_locr;
	CDialog::OnInitDialog();
  i = m_clothingType.FillComboBox(&m_objectType);
  m_objectType.SetCurSel(i);
  title.Format("Clothing [%04X] %02d(%02d,%02d)%d",
                  m_RNclothing.ConvertToInteger(),
                  loca.l,loca.x,loca.y,m_RNclothing.pos());
  SetWindowText(title);
  UpdateData(false);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditClothes::OnOK() 
{
	// TODO: Add extra validation here
	
  if (!UpdateData(true)) return;
	if (!EncodeDataIntoRecord()) return;
	CDialog::OnOK();
}
