// EditDisabled.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "Actuator.h"
#include "EditDisabled.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditDisabled dialog


EditDisabled::EditDisabled(LOCATIONREL locr, 
                           CWnd* pParent /*=NULL*/)
	: CDialog(EditDisabled::IDD, pParent)
{
  m_locr = locr;
  m_levelInfo = m_locr;
	//{{AFX_DATA_INIT(EditDisabled)
	m_graphicTitle = _T("");
	//}}AFX_DATA_INIT
}


void EditDisabled::DoDataExchange(CDataExchange* pDX)
{
  if (!pDX->m_bSaveAndValidate)
  {
    if ((pDoc->GetRoomType(m_locr) == roomSTONE) || (pDoc->GetRoomType(m_locr) == roomBLOCKING))
    {
      m_graphicTitle = "Wall Graphic";
    }
    else
    {
      m_graphicTitle = "Floor Graphic";
    };
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditDisabled)
	DDX_Control(pDX, IDC_WallGraphic, m_wallGraphic);
	DDX_Text(pDX, IDC_GraphicTitle, m_graphicTitle);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    if ((pDoc->GetRoomType(m_locr) == roomSTONE) || (pDoc->GetRoomType(m_locr) == roomBLOCKING))
    {
      FillWallDecorationsComboBox();
      m_wallGraphic.SetCurSel(m_pDisabled->wallGraphicOrdinal());
    }
    else
    {
      FillFloorDecorationsComboBox();
      m_wallGraphic.SetCurSel(m_pDisabled->floorGraphicOrdinal());
    };
  };
  if (pDX->m_bSaveAndValidate)
  {
    if ((pDoc->GetRoomType(m_locr) == roomSTONE) || (pDoc->GetRoomType(m_locr) == roomBLOCKING))
    {
      m_pDisabled->wallGraphicOrdinal(m_wallGraphic.GetCurSel());
    }
    else
    {
      m_pDisabled->floorGraphicOrdinal(m_wallGraphic.GetCurSel());
    };
  };
}


BEGIN_MESSAGE_MAP(EditDisabled, CDialog)
	//{{AFX_MSG_MAP(EditDisabled)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditDisabled message handlers


int ACTUATOR_Disabled::Edit(LOCATIONREL locr)
{
  EditDisabled dlg(locr);
  dlg.m_pDisabled = this;
  return dlg.DoModal();
}

void EditDisabled::ExtractDataFromRecord(void)
{
}

void EditDisabled::EncodeDataInRecord(void)
{
}



BOOL EditDisabled::OnInitDialog() 
{
  ExtractDataFromRecord();
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditDisabled::FillWallDecorationsComboBox()
{
  int i;
  WALLTYPE wt;
  m_wallGraphic.ResetContent();
  m_wallGraphic.AddString("none");
  for (i=0; i<pDoc->NumWallDecorations(m_levelInfo.level); i++)
  {
    if (pDoc->IsLegalWallDecorationIndex(m_levelInfo.level,i+1))
    {
      wt = pDoc->WallDecorationType(m_levelInfo.level,i);
      m_wallGraphic.AddString(wt.Name());
    }
    else
    {
      m_wallGraphic.AddString("illegal");
    };
  };
}

void EditDisabled::FillFloorDecorationsComboBox()
{
  int i;
  FLOORTYPE ft;
  m_wallGraphic.ResetContent();
  m_wallGraphic.AddString("none");
  for (i=0; i<pDoc->NumFloorDecorations(m_levelInfo.level); i++)
  {
    ft = pDoc->FloorDecorationType(m_levelInfo.level,i+1);
    m_wallGraphic.AddString(ft.Name());
  };
}

