// EditMiscObject.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "EditMiscObject.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditMiscObject dialog


EditMiscObject::EditMiscObject(LOCATIONREL locr,
                               RN RNmisc,
                               CWnd* pParent /*=NULL*/)
	: CDialog(EditMiscObject::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditMiscObject)
	m_cursed = FALSE;
	m_important = FALSE;
	m_value = 0;
	m_partyA = -1;
	//}}AFX_DATA_INIT
  m_locr = locr;
  m_RNmisc = RNmisc;
}

void EditMiscObject::ExtractDataFromRecord(void)
{
  m_important = m_pMisc->important();
  m_cursed    = m_pMisc->cursed();
  m_value     = m_pMisc->value();
  m_miscType  = m_pMisc->miscType();
}

bool EditMiscObject::EncodeDataIntoRecord(void)
{
  m_pMisc->important(m_important?true:false);
  m_pMisc->cursed(m_cursed?true:false);
  m_pMisc->miscType(m_miscType);
  m_pMisc->value(m_value);
  return true;
}

void EditMiscObject::Show(int id, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->ShowWindow(show);
}

void EditMiscObject::DoDataExchange(CDataExchange* pDX)
{
  MISCTYPE mt;
  bool heroBones;
  mt = "Bones(Party)";
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditMiscObject)
	DDX_Control(pDX, IDC_ObjectType, m_objectType);
	DDX_Check(pDX, IDC_Cursed, m_cursed);
	DDX_Check(pDX, IDC_Important, m_important);
	DDX_Text(pDX, IDC_Value, m_value);
	DDV_MinMaxUInt(pDX, m_value, 0, 3);
	DDX_Radio(pDX, IDC_PartyA, m_partyA);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
    m_miscType = m_objectType.GetItemData(m_objectType.GetCurSel());
  };
  heroBones = m_miscType == mt;
  if (!pDX->m_bSaveAndValidate)
  {
    {
      Show(IDC_ValueLabel, !heroBones);
      Show(IDC_Value,      !heroBones);
      Show(IDC_PartyA,     heroBones);
      Show(IDC_PartyB,     heroBones);
      Show(IDC_PartyC,     heroBones);
      Show(IDC_PartyD,     heroBones);
    };
    if (heroBones)
    {
      m_partyA = m_value;
    };
  };
  if (pDX->m_bSaveAndValidate)
  {
    if (heroBones)
    {
      m_value = m_partyA;
    };
  };
}


BEGIN_MESSAGE_MAP(EditMiscObject, CDialog)
	//{{AFX_MSG_MAP(EditMiscObject)
	ON_CBN_SELCHANGE(IDC_ObjectType, OnSelchangeObjectType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditMiscObject message handlers

int DB10::Edit(LOCATIONREL locr, RN RNmisc)
{
  EditMiscObject dlg(locr, RNmisc);
  dlg.m_pMisc = this;
  return dlg.DoModal();
}

void EditMiscObject::OnSelchangeObjectType() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
  UpdateData(false);
}

BOOL EditMiscObject::OnInitDialog() 
{
  int i;
  LOCATIONABS loca;
  CString title;
  loca = m_locr;
  ExtractDataFromRecord();
  CDialog::OnInitDialog();
  i = m_miscType.FillComboBox(&m_objectType);
  m_objectType.SetCurSel(i);
  title.Format("Misc Object [%04X] %02d(%02d,%02d)%d",
                  m_RNmisc.ConvertToInteger(),
                  loca.l,loca.x,loca.y,m_RNmisc.pos());
  SetWindowText(title);
  UpdateData(false);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditMiscObject::OnOK() 
{
	// TODO: Add extra validation here
  if (!UpdateData(true)) return;
	if (!EncodeDataIntoRecord()) return;
	CDialog::OnOK();
}
