// EditObjectHolder.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "Actuator.h"
#include "EditObjectHolder.h"
#include "EditTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditObjectHolder dialog


EditObjectHolder::EditObjectHolder(LOCATIONREL locr,
                                   CWnd* pParent /*=NULL*/)
	: CDialog(EditObjectHolder::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditObjectHolder)
	m_audible = FALSE;
	m_clearConditionMet = FALSE;
	m_clearConditionNotMet = FALSE;
	m_delay = 0;
	m_onlyOnce = FALSE;
	m_setConditionMet = FALSE;
	m_setConditionNotMet = FALSE;
	m_toggleConditionMet = FALSE;
	m_toggleConditionNotMet = FALSE;
	m_skillConditionMet = FALSE;
	m_skillConditionNotMet = FALSE;
	m_targetColumn = 0;
	m_targetRow = 0;
	//}}AFX_DATA_INIT
  m_locr = locr;
  m_levelInfo = m_locr;
}

void EditObjectHolder::Enable(int id, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd != NULL) pWnd->ShowWindow(show);
}

void EditObjectHolder::DoDataExchange(CDataExchange* pDX)
{
  if (!pDX->m_bSaveAndValidate)
  {
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditObjectHolder)
	DDX_Control(pDX, IDC_TargetPosition, m_targetPosition);
	DDX_Control(pDX, IDC_NeededObject, m_neededObject);
	DDX_Control(pDX, IDC_Graphic, m_graphic);
	DDX_Check(pDX, IDC_Audible, m_audible);
	DDX_Check(pDX, IDC_ClearConditionMet, m_clearConditionMet);
	DDX_Check(pDX, IDC_ClearConditionNotMet, m_clearConditionNotMet);
	DDX_Text(pDX, IDC_Delay, m_delay);
	DDX_Check(pDX, IDC_OnlyOnce, m_onlyOnce);
	DDX_Check(pDX, IDC_SetConditionMet, m_setConditionMet);
	DDX_Check(pDX, IDC_SetConditionNotMet, m_setConditionNotMet);
	DDX_Check(pDX, IDC_ToggleConditionMet, m_toggleConditionMet);
	DDX_Check(pDX, IDC_ToggleConditionNotMet, m_toggleConditionNotMet);
	DDX_Check(pDX, IDC_SkillConditionMet, m_skillConditionMet);
	DDX_Check(pDX, IDC_SkillConditionNotMet, m_skillConditionNotMet);
	DDX_Text(pDX, IDC_TargetColumn, m_targetColumn);
	DDX_Text(pDX, IDC_TargetRow, m_targetRow);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    FillWallDecorationsComboBox();
    m_graphic.SetCurSel(m_pObjectHolder->wallGraphicOrdinal());
    m_neededObjectIndex = 
        m_particularObjectType.FillComboBox(&m_neededObject);
    m_neededObject.SetCurSel(m_neededObjectIndex);
    Enable(IDC_TargetColumn,  !m_localAction);
    Enable(IDC_TargetRow,     !m_localAction);
    Enable(IDC_TargetPosition,!m_localAction);
    Enable(IDC_ColumnLabel,   !m_localAction);
    Enable(IDC_RowLabel,      !m_localAction);
    Enable(IDC_PositionLabel, !m_localAction);
    m_targetPosition.SetCurSel(m_targetPos);
  };
  if (pDX->m_bSaveAndValidate)
  {
    m_targetPos = m_targetPosition.GetCurSel();
    m_pObjectHolder->wallGraphicOrdinal(m_graphic.GetCurSel());
    m_neededObjectIndex = m_neededObject.GetCurSel();
    m_particularObjectType = MODIFIEDOBJECTTYPE(
            m_neededObject.GetItemData(m_neededObjectIndex));
  };
}


BEGIN_MESSAGE_MAP(EditObjectHolder, CDialog)
	//{{AFX_MSG_MAP(EditObjectHolder)
	ON_BN_CLICKED(IDC_ClearConditionMet, OnClearConditionMet)
	ON_BN_CLICKED(IDC_ClearConditionNotMet, OnClearConditionNotMet)
	ON_BN_CLICKED(IDC_SetConditionMet, OnSetConditionMet)
	ON_BN_CLICKED(IDC_SetConditionNotMet, OnSetConditionNotMet)
	ON_BN_CLICKED(IDC_ToggleConditionMet, OnToggleConditionMet)
	ON_BN_CLICKED(IDC_ToggleConditionNotMet, OnToggleConditionNotMet)
	ON_BN_CLICKED(IDC_SkillConditionMet, OnSkillConditionMet)
	ON_BN_CLICKED(IDC_SkillConditionNotMet, OnSkillConditionNotMet)
	ON_BN_CLICKED(IDC_Browse, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditObjectHolder message handlers

int ACTUATOR_ObjectHolder::Edit(LOCATIONREL locr)
{
  EditObjectHolder dlg(locr);
  dlg.m_pObjectHolder = this;
  return dlg.DoModal();
}

void EditObjectHolder::ExtractDataFromRecord(void)
{
  ACTUATORACTION act;
  m_setConditionMet=m_setConditionNotMet=m_clearConditionMet
        =m_clearConditionNotMet=m_toggleConditionMet
        =m_toggleConditionNotMet=false;

  act = m_pObjectHolder->action();
  m_localAction = m_pObjectHolder->localAction();
  if (m_localAction)
  {
    switch (m_pObjectHolder->localActionType())
    {
    case 1:
    case 2:
      break;
    case 10:
      m_skillConditionMet = true;
      m_skillConditionNotMet = true;
      break;
    default: //Do nothing
      break;
    };
  }
  else
  {
    LOCATIONREL locr;
    LOCATIONABS loca;
    locr.x(m_pObjectHolder->targetX());
    locr.y(m_pObjectHolder->targetY());
    locr.l(m_levelInfo.level);
    locr.p(m_pObjectHolder->targetPos());
    loca = locr;
    m_targetColumn = loca.x;
    m_targetRow    = loca.y;
    m_targetPos    = loca.p;
    switch (act)
    {
    case AA_HOLD:   m_setConditionMet = true;
                    m_clearConditionNotMet = true;
                    break;
    case AA_SET:    m_setConditionMet = true; 
                    m_setConditionNotMet = true;
                    break;
    case AA_CLEAR:  m_clearConditionNotMet = true; 
                    m_clearConditionMet = true; 
                    break;
    case AA_TOGGLE: m_toggleConditionNotMet = true;
                    m_toggleConditionMet = true; 
                    break;
    };
  };
  m_onlyOnce = m_pObjectHolder->onceOnly();
  m_delay = m_pObjectHolder->delay();
  m_audible = m_pObjectHolder->audible();
  m_particularObjectType = m_pObjectHolder->neededObject(m_locr);
}

void EditObjectHolder::EncodeDataInRecord(void)
{
  ACTUATORACTION ac;
  m_pObjectHolder->localAction(m_localAction);
  if (!m_localAction)
  {
    LOCATIONABS loca;
    LOCATIONREL locr;
    if (m_setConditionMet && !m_clearConditionNotMet) ac = AA_SET;
    else if (m_clearConditionMet && !m_setConditionNotMet) ac = AA_CLEAR;
    else if (m_toggleConditionMet) ac = AA_TOGGLE;
    else if (m_setConditionMet && m_clearConditionNotMet) ac = AA_HOLD;
    else 
    {
      if (!m_clearConditionMet && m_setConditionNotMet) ac = AA_SET;
      else if (!m_setConditionMet && m_clearConditionNotMet) ac = AA_CLEAR;
      else if (m_toggleConditionNotMet) ac = AA_TOGGLE;
      else ac = AA_HOLD;
    }
    loca.x = m_targetColumn;
    loca.y = m_targetRow;
    loca.l = m_levelInfo.level;
    loca.p = m_targetPos;
    locr = loca;
    m_pObjectHolder->targetX(locr.x());
    m_pObjectHolder->targetY(locr.y());
    m_pObjectHolder->targetPos(locr.p());
  }
  else //if (localAction)
  {
    ac = AA_SET; //Not really used!
    if (m_skillConditionMet)
    {
      m_pObjectHolder->localActionType(10);
    }
    else
    {
      m_pObjectHolder->localActionType(2);
    };
  };
  m_pObjectHolder->action(ac);
  m_pObjectHolder->onceOnly(m_onlyOnce != 0);
  m_pObjectHolder->delay(m_delay);
  m_pObjectHolder->audible(m_audible != 0);
  m_pObjectHolder->neededObject(m_particularObjectType.Integer());
}

void EditObjectHolder::UpdateAction(void)
{
  CheckDlgButton(IDC_SkillConditionMet,m_skillConditionMet);
  CheckDlgButton(IDC_SkillConditionNotMet,m_skillConditionNotMet);
  CheckDlgButton(IDC_SetConditionMet,m_setConditionMet);
  CheckDlgButton(IDC_SetConditionNotMet,m_setConditionNotMet);
  CheckDlgButton(IDC_ClearConditionMet,m_clearConditionMet);
  CheckDlgButton(IDC_ClearConditionNotMet,m_clearConditionNotMet);
  CheckDlgButton(IDC_ToggleConditionMet,m_toggleConditionMet);
  CheckDlgButton(IDC_ToggleConditionNotMet,m_toggleConditionNotMet);
  Enable(IDC_TargetColumn,  !m_localAction);
  Enable(IDC_TargetRow,     !m_localAction);
  Enable(IDC_TargetPosition,!m_localAction);
  Enable(IDC_ColumnLabel,   !m_localAction);
  Enable(IDC_RowLabel,      !m_localAction);
  Enable(IDC_PositionLabel, !m_localAction);
}

void EditObjectHolder::FillWallDecorationsComboBox()
{
  int i;
  WALLTYPE wt;
  m_graphic.ResetContent();
  m_graphic.AddString("none");
  for (i=0; i<pDoc->NumWallDecorations(m_levelInfo.level); i++)
  {
    wt = pDoc->WallDecorationType(m_levelInfo.level,i);
    m_graphic.AddString(wt.Name());
  };
}

void EditObjectHolder::OnSkillConditionMet() 
{
	// TODO: Add your control notification handler code here
  m_skillConditionMet = !m_skillConditionMet;
  if (m_skillConditionMet)
  {
    m_localAction = true;
    m_skillConditionNotMet = true;
    m_setConditionMet = false;
    m_setConditionNotMet = false;
    m_clearConditionNotMet = false;
    m_clearConditionMet = false;
    m_toggleConditionMet = false;
    m_toggleConditionNotMet = false;
  }
  else
  {
    m_skillConditionNotMet = false;
  };
  UpdateAction();
	
}

void EditObjectHolder::OnSkillConditionNotMet() 
{
	// TODO: Add your control notification handler code here
  m_skillConditionNotMet = !m_skillConditionNotMet;
  if (m_skillConditionNotMet)
  {
    m_localAction = true;
    m_skillConditionMet = true;
    m_setConditionMet = false;
    m_setConditionNotMet = false;
    m_clearConditionNotMet = false;
    m_clearConditionMet = false;
    m_toggleConditionMet = false;
    m_toggleConditionNotMet = false;
  }
  else
  {
    m_skillConditionMet = false;
  };
  UpdateAction();
	
}


void EditObjectHolder::OnClearConditionMet() 
{
	// TODO: Add your control notification handler code here
	
  m_clearConditionMet = !m_clearConditionMet;
  if (m_clearConditionMet)
  {
    m_localAction = false;
    m_skillConditionMet = false;
    m_skillConditionNotMet = false;
    m_setConditionMet = false;
    m_setConditionMet = false;
    m_setConditionNotMet = false;
    m_clearConditionNotMet = true;
    m_toggleConditionMet = false;
    m_toggleConditionNotMet = false;
  }
  else
  {
    m_clearConditionNotMet = false;
  };
  UpdateAction();
}

void EditObjectHolder::OnClearConditionNotMet() 
{
	// TODO: Add your control notification handler code here
	
  m_clearConditionNotMet = !m_clearConditionNotMet;
  if (m_clearConditionNotMet)
  {
    m_localAction = false;
    m_skillConditionMet = false;
    m_skillConditionNotMet = false;
    m_setConditionNotMet = false;
    if (!m_setConditionMet) m_clearConditionMet = true;
    m_toggleConditionMet = false;
    m_toggleConditionNotMet = false;
  }
  else
  {
    m_clearConditionMet = false;
  };	
  UpdateAction();
}

void EditObjectHolder::OnSetConditionMet() 
{
	// TODO: Add your control notification handler code here
	
  m_setConditionMet = !m_setConditionMet;
  if (m_setConditionMet)
  {
    m_localAction = false;
    m_skillConditionMet = false;
    m_skillConditionNotMet = false;
    if (!m_clearConditionNotMet) m_setConditionNotMet = true;
    m_clearConditionMet = false;
    m_toggleConditionMet = false;
    m_toggleConditionNotMet = false;
  }
  else
  {
    m_setConditionNotMet = false;
  };
  UpdateAction();
}

void EditObjectHolder::OnSetConditionNotMet() 
{
	// TODO: Add your control notification handler code here
	
  m_setConditionNotMet = !m_setConditionNotMet;
  if (m_setConditionNotMet)
  {
    m_localAction = false;
    m_skillConditionMet = false;
    m_skillConditionNotMet = false;
    m_setConditionMet = true;
    m_clearConditionMet = false;
    m_clearConditionNotMet = false;
    m_toggleConditionMet = false;
    m_toggleConditionNotMet = false;
  }
  else
  {
    m_clearConditionNotMet = true;
  };
  UpdateAction();
}

void EditObjectHolder::OnToggleConditionMet() 
{
	// TODO: Add your control notification handler code here
	
  m_toggleConditionMet = !m_toggleConditionMet;
  if (m_toggleConditionMet)
  {
    m_localAction = false;
    m_skillConditionMet = false;
    m_skillConditionNotMet = false;
    m_setConditionMet = false;
    m_setConditionNotMet = false;
    m_clearConditionMet = false;
    m_clearConditionNotMet = false;
    m_toggleConditionNotMet = true;
  }
  else
  {
    m_toggleConditionNotMet = false;
  };
  UpdateAction();
}

void EditObjectHolder::OnToggleConditionNotMet() 
{
	// TODO: Add your control notification handler code here
	
  m_toggleConditionNotMet = !m_toggleConditionNotMet;
  if (m_toggleConditionNotMet)
  {
    m_localAction = false;
    m_skillConditionMet = false;
    m_skillConditionNotMet = false;
    m_setConditionMet = false;
    m_setConditionNotMet = false;
    m_clearConditionMet = false;
    m_clearConditionNotMet = false;
    m_toggleConditionMet = true;
  }
  else
  {
    m_toggleConditionMet = false;
  };
  UpdateAction();
}


BOOL EditObjectHolder::OnInitDialog() 
{
  ExtractDataFromRecord();
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditObjectHolder::OnOK() 
{
	// TODO: Add extra validation here
	
  UpdateData(true);
  EncodeDataInRecord();	
	CDialog::OnOK();
}



void EditObjectHolder::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	
  LOCATIONABS loca, locaObjectHolder;
  LOCATIONREL locrTarget;
  UpdateData(true);
  loca.l = m_locr.l();
  loca.x = m_targetColumn;
  loca.y = m_targetRow;
  locrTarget = loca;
  locaObjectHolder = m_locr;
	EditTarget dlg(locrTarget,"Object Holder",locaObjectHolder,false);
  if (dlg.DoModal() == IDOK)
  {
    locrTarget.l(dlg.m_locr.l());
    locrTarget.x(dlg.m_locr.x());
    locrTarget.y(dlg.m_locr.y());
    loca = locrTarget;
    m_targetColumn = loca.x;
    m_targetRow = loca.y;
    UpdateData(false);
  };
}
