// EditPushButton.cpp : implementation file
//

#include "stdafx.h"
//#include "types.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "Actuator.h"
#include "EditPushButton.h"
#include "Misc.h"
#include "EditTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString TranslateObjectName(const char *name);

/////////////////////////////////////////////////////////////////////////////
// EditPushButton dialog


EditPushButton::EditPushButton(LOCATIONREL locr,
                               CWnd* pParent /*=NULL*/)
	: CDialog(EditPushButton::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditPushButton)
	m_rotateConditionMet = FALSE;
	m_rotateConditionNotMet = FALSE;
	m_skillConditionMet = FALSE;
	m_skillConditionNotMet = FALSE;
	m_onlyIfLast = FALSE;
	m_forceRotate = -1;
  m_particularObjectType = TranslateObjectName("APPLE");
	m_gift = -1;
	//}}AFX_DATA_INIT
  m_locr = locr;
  m_levelInfo = m_locr;
}

enum SPECIFICATIONS
{
  MS = 0x001,  //Set          - condition met
  NS = 0x002,  //Set          - condition Not met
  MC = 0x004,  //Clear        - conditon Met
  NC = 0x008,  //Clear        - condition Not met
  MT = 0x010,  //Toggle       - condition Met
  NT = 0x020,  //Toggle       - condition Not met
  MR = 0x040,  //Rotate       - condition Met
  NR = 0x080,  //Rotate       - condition Not met
  MK = 0x100,  //sKill adjust - condition Met
  NK = 0x200   //sKill adjust - condition Not met
};

unsigned short PBlegalActions[240] = {
  // PB_SwitchAnything
  MS+NS, // simple target O  set   
  MC+NC, // simple target O  clear
  MT+NT, // simple target O  toggle
  0,     // simple target O  hold
  MS+NS, // simple target NC set
  MC+NC, // simple target NC clear
  MT+NT, // simple target NC toggle
  0,     // simple target NC hold
  MR+NR, // simple rotate O  set
  MR+NR, // simple rotate O  clear
  MR+NR, // simple rotate O  toggle
  0,     // simple rotate O  hold
  MR+NR, // simple rotate NC set
  MR+NR, // simple rotate NC clear
  MR+NR, // simple rotate NC toggle
  0,     // simple rotate NC hold
  MK+NK, // simple skill  O  set
  MK+NK, // simple skill  O  clear
  MK+NK, // simple skill  O  toggle
  0,     // simple skill  O  hold
  MK+NK, // simple skill  NC set
  MK+NK, // simple skill  NC clear
  MK+NK, // simple skill  NC toggle
  0,     // simple skill  NC hold

  //PB_SwitchHand
  MS,    // WallSwitch target O  set
  MC,    // WallSwitch target O  clear
  MT,    // WallSwitch target O  toggle
  MS+NC, // WallSwitch target O  hold
  NS,    // WallSwitch target NC set
  NC,    // WallSwitch target NC clear
  NT,    // WallSwitch target NC toggle
  NS+MC, // WallSwitch target NC hold
  MR,    // WallSwitch rotate O  set
  MR,    // WallSwitch rotate O  clear
  MR,    // WallSwitch rotate O  toggle
  MR,    // WallSwitch rotate O  hold
  NR,    // WallSwitch rotate NC set
  NR,    // WallSwitch rotate NC clear
  NR,    // WallSwitch rotate NC toggle
  NR,    // WallSwitch rotate NC hold
  MK,    // WallSwitch skill  O  set
  MK,    // WallSwitch skill  O  clear
  MK,    // WallSwitch skill  O  toggle
  MK,    // WallSwitch skill  O  hold
  NK,    // WallSwitch skill  NC set
  NK,    // WallSwitch skill  NC clear
  NK,    // WallSwitch skill  NC toggle
  NK,    // WallSwitch skill  NC hold

  //PB_LockKeep
  MS,    // KeyKeep target O  set
  MC,    // KeyKeep target O  clear
  MT,    // KeyKeep target O  toggle
  MS+NC, // KeyKeep target O  hold
  NS,    // KeyKeep target NC set
  NC,    // KeyKeep target NC clear
  NT,    // KeyKeep target NC toggle
  NS+MC, // KeyKeep target NC hold
  MR,    // KeyKeep rotate O  set
  MR,    // KeyKeep rotate O  clear
  MR,    // KeyKeep rotate O  toggle
  MR+NR, // KeyKeep rotate O  hold
  NR,    // KeyKeep rotate NC set
  NR,    // KeyKeep rotate NC clear
  NR,    // KeyKeep rotate NC toggle
  MR+NR, // KeyKeep rotate NC hold
  MK,    // KeyKeep skill  O  set
  MK,    // KeyKeep skill  O  clear
  MK,    // KeyKeep skill  O  toggle
  MK+NK, // KeyKeep skill  O  hold
  NK,    // KeyKeep skill  NC set
  NK,    // KeyKeep skill  NC clear
  NK,    // KeyKeep skill  NC toggle
  MK+NK, // KeyKeep skill  NC hold

  //PB_LockRemove
  MS,    // KeyRemove target O  set
  MC,    // KeyRemove target O  clear
  MT,    // KeyRemove target O  toggle
  MS+NC, // KeyRemove target O  hold
  NS,    // KeyRemove target NC set
  NC,    // KeyRemove target NC clear
  NT,    // KeyRemove target NC toggle
  MC+NS, // KeyRemove target NC hold
  MR,    // KeyRemove rotate O  set
  MR,    // KeyRemove rotate O  clear
  MR,    // KeyRemove rotate O  toggle
  MR+NR, // KeyRemove rotate O  hold
  NR,    // KeyRemove rotate NC set
  NR,    // KeyRemove rotate NC clear
  NR,    // KeyRemove rotate NC toggle
  MR+NR, // KeyRemove rotate NC hold
  MK,    // KeyRemove skill  O  set
  MK,    // KeyRemove skill  O  clear
  MK,    // KeyRemove skill  O  toggle
  MK+NK, // KeyRemove skill  O  hold
  NK,    // KeyRemove skill  NC set
  NK,    // KeyRemove skill  NC clear
  NK,    // KeyRemove skill  NC toggle
  MK+NK, // KeyRemove skill  NC hold

  //PB_LastLockRotate
  MS+MR,      // StaffRotate target O  set
  MC+MR,      // StaffRotate target O  clear
  MT+MR,      // StaffRotate target O  toggle
  MS+NC+MR+NR,// StaffRotate target O  hold
  NS+NR,      // StaffRotate target NC set
  NC+NR,      // StaffRotate target NC clear
  NT+NR,      // StaffRotate target NC toggle
  NS+MC+MR+NR,// StaffRotate target NC hold
  MR,         // StaffRotate rotate O  set
  MR,         // StaffRotate rotate O  clear
  MR,         // StaffRotate rotate O  toggle
  MR+NR,      // StaffRotate rotate O  hold
  NR,         // StaffRotate rotate NC set
  NR,         // StaffRotate rotate NC clear
  NR,         // StaffRotate rotate NC toggle
  MR+NR,      // StaffRotate rotate NC hold
  MK,         // StaffRotate skill  O  set
  MK,         // StaffRotate skill  O  clear
  MK,         // StaffRotate skill  O  toggle
  MK+NK,      // StaffRotate skill  O  hold
  NK,         // StaffRotate skill  NC set
  NK,         // StaffRotate skill  NC clear
  NK,         // StaffRotate skill  NC toggle
  MK+NK,      // StaffRotate skill  NC hold

  //PB_LastLockDelete
  MS,         // StaffRemove target O  set
  MC,         // StaffRemove target O  clear
  MT,         // StaffRemove target O  toggle
  MS+NC,      // StaffRemove target O  hold
  NS,         // StaffRemove target NC set
  NC,         // StaffRemove target NC clear
  NT,         // StaffRemove target NC toggle
  NS+MC,      // StaffRemove target NC hold
  MR,         // StaffRemove rotate O  set
  MR,         // StaffRemove rotate O  clear
  MR,         // StaffRemove rotate O  toggle
  MR+NR,      // StaffRemove rotate O  hold
  NR,         // StaffRemove rotate NC set
  NR,         // StaffRemove rotate NC clear
  NR,         // StaffRemove rotate NC toggle
  MR+NR,      // StaffRemove rotate NC hold
  MK,         // StaffRemove skill  O  set
  MK,         // StaffRemove skill  O  clear
  MK,         // StaffRemove skill  O  toggle
  MK+NK,      // StaffRemove skill  O  hold
  NK,         // StaffRemove skill  NC set
  NK,         // StaffRemove skill  NC clear
  NK,         // StaffRemove skill  NC toggle
  MK+NK,      // StaffRemove skill  NC hold

  //PB_AlcoveAnything
  MS,         // AlcoveAnything target O  set
  MC,         // AlcoveAnything target O  clear
  MT,         // AlcoveAnything target O  toggle
  MS+NC,      // AlcoveAnything target O  hold
  NS,         // AlcoveAnything target NC set
  NC,         // AlcoveAnything target NC clear
  NT,         // AlcoveAnything target NC toggle
  NS+MC,      // AlcoveAnything target NC hold
  MR,         // AlcoveAnything rotate O  set
  MR,         // AlcoveAnything rotate O  clear
  MR,         // AlcoveAnything rotate O  toggle
  MR+NR,      // AlcoveAnything rotate O  hold
  NR,         // AlcoveAnything rotate NC set
  NR,         // AlcoveAnything rotate NC clear
  NR,         // AlcoveAnything rotate NC toggle
  MR+NR,      // AlcoveAnything rotate NC hold
  MK,         // AlcoveAnything skill  O  set
  MK,         // AlcoveAnything skill  O  clear
  MK,         // AlcoveAnything skill  O  toggle
  MK+NK,      // AlcoveAnything skill  O  hold
  NK,         // AlcoveAnything skill  NC set
  NK,         // AlcoveAnything skill  NC clear
  NK,         // AlcoveAnything skill  NC toggle
  MK+NK,      // AlcoveAnything skill  NC hold

  //PB_AlcoveObject
  MS,         // AlcoveObject target O  set
  MC,         // AlcoveObject target O  clear
  MT,         // AlcoveObject target O  toggle
  MS+NC,      // AlcoveObject target O  hold
  NS,         // AlcoveObject target NC set
  NC,         // AlcoveObject target NC clear
  NT,         // AlcoveObject target NC toggle
  NS+MC,      // AlcoveObject target NC hold
  MR,         // AlcoveObject rotate O  set
  MR,         // AlcoveObject rotate O  clear
  MR,         // AlcoveObject rotate O  toggle
  MR+NR,      // AlcoveObject rotate O  hold
  NR,         // AlcoveObject rotate NC set
  NR,         // AlcoveObject rotate NC clear
  NR,         // AlcoveObject rotate NC toggle
  MR+NR,      // AlcoveObject rotate NC hold
  MK,         // AlcoveObject skill  O  set
  MK,         // AlcoveObject skill  O  clear
  MK,         // AlcoveObject skill  O  toggle
  MK+NK,      // AlcoveObject skill  O  hold
  NK,         // AlcoveObject skill  NC set
  NK,         // AlcoveObject skill  NC clear
  NK,         // AlcoveObject skill  NC toggle
  MK+NK,      // AlcoveObject skill  NC hold

  //PB_AlcoveNotObject
  MS,         // AlcoveNotObject target O  set
  MC,         // AlcoveNotObject target O  clear
  MT,         // AlcoveNotObject target O  toggle
  MS+NC,      // AlcoveNotObject target O  hold
  NS,         // AlcoveNotObject target NC set
  NC,         // AlcoveNotObject target NC clear
  NT,         // AlcoveNotObject target NC toggle
  NS+MC,      // AlcoveNotObject target NC hold
  MR,         // AlcoveNotObject rotate O  set
  MR,         // AlcoveNotObject rotate O  clear
  MR,         // AlcoveNotObject rotate O  toggle
  MR+NR,      // AlcoveNotObject rotate O  hold
  NR,         // AlcoveNotObject rotate NC set
  NR,         // AlcoveNotObject rotate NC clear
  NR,         // AlcoveNotObject rotate NC toggle
  MR+NR,      // AlcoveNotObject rotate NC hold
  MK,         // AlcoveNotObject skill  O  set
  MK,         // AlcoveNotObject skill  O  clear
  MK,         // AlcoveNotObject skill  O  toggle
  MK+NK,      // AlcoveNotObject skill  O  hold
  NK,         // AlcoveNotObject skill  NC set
  NK,         // AlcoveNotObject skill  NC clear
  NK,         // AlcoveNotObject skill  NC toggle
  MK+NK,      // AlcoveNotObject skill  NC hold

  // PB_GiftFromGod
  MS+MR, // God'sGift target O  set
  MC+MR, // God'sGift target O  clear
  MT+MR, // God'sGift target O  toggle
  MS+MR, // God'sGift target O  hold
  MS+MR, // God'sGift target NC set
  MC+MR, // God'sGift target NC clear
  MT+MR, // God'sGift target NC toggle
  MS+MR, // God'sGift target NC hold
  MS+MR, // God'sGift rotate O  set
  MC+MR, // God'sGift rotate O  clear
  MT+MR, // God'sGift rotate O  toggle
  MS+MR, // God'sGift rotate O  hold
  MS+MR, // God'sGift rotate NC set
  MC+MR, // God'sGift rotate NC clear
  MT+MR, // God'sGift rotate NC toggle
  MS+MR, // God'sGift rotate NC hold
  MK,    // God'sGift skill  O  set
  MK,    // God'sGift skill  O  clear
  MK,    // God'sGift skill  O  toggle
  MK,    // God'sGift skill  O  hold
  MK,    // God'sGift skill  NC set
  MK,    // God'sGift skill  NC clear
  MK,    // God'sGift skill  NC toggle
  MK,    // God'sGift skill  NC hold
};

bool EditPushButton::IsAlcove(void)
{
  RN actuator;
  DB3 *pActuator;
  int k;
  ACTUATORCLASS ac;
  ROOMTYPE rt;
  WALLTYPE wt;
  rt = RoomType(pDoc->GetCellFlag(m_locr));
  for (actuator = pDoc->FindFirstActuator(m_locr);
       actuator != RNeof;
       actuator = pDoc->FindNextActuator(actuator))
  {
    if (actuator.pos() != m_locr.p()) continue;
    pActuator = pDoc->GetRecordAddressDB3(actuator);
    ac = pActuator->actuatorClass(rt);
    switch (ac)
    {
    case AC_DSA:
    case AC_PRESSUREPAD: 
      continue;
    case AC_ANDOR:
      k = pActuator->Cast2AC_AndOr(rt)->wallGraphicOrdinal();
      break;
    case AC_PUSHBUTTON:
      k =pActuator->Cast2AC_PushButton(rt)->wallGraphicOrdinal();
      break;
    case AC_DISABLED:
      k = pActuator->Cast2AC_Disabled(rt)->wallGraphicOrdinal();
      break;
    case AC_PORTRAIT:
      k = pActuator->Cast2AC_Portrait(rt)->graphic();
      break;
    default:NotImplemented();
      k = 0;
      break;
    };
    if (k == 0) continue;
    wt = pDoc->WallDecorationType(m_locr.l(),k-1);
    if (wt.IsAlcove()) return true;
  };
  return false;
}

void EditPushButton::ExtractDataFromRecord(void)
{
  bool localAction = false;
  switch (m_pPushButton->actuatorType())
  {
  case 1:
    if (IsAlcove())
    {
      m_PBtype = PB_AlcoveAnything;
    }
    else
    {
      m_PBtype = PB_SwitchAnything;
    };
    m_remove = false;
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    };
    break;
  case 2:
    if (IsAlcove())
    {
      m_PBtype = PB_AlcoveObject;
    }
    else
    {
      m_PBtype = PB_SwitchHand;
    };
    m_remove = true;
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    };
    break;
  case 3:
    if (IsAlcove())
    {
      m_PBtype = PB_AlcoveNotObject;
    }
    else
    {
      m_PBtype = PB_LockKeep;;
    };
    m_remove = false;
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    };
    break;
  case 4:
    m_PBtype = PB_LockRemove;
    m_remove = true;
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    };
    break;
  case 11:
    m_PBtype = PB_LastLockRotate;
    m_remove = true;
    m_action = m_pPushButton->action();
    m_NC = m_pPushButton->normallyClosed();
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    };
    break;
  case 17:
    m_PBtype = PB_LastLockDelete;
    m_action = m_pPushButton->action();
    m_NC = m_pPushButton->normallyClosed();
    m_remove = true;
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = m_pPushButton->normallyClosed();
    };
    break;
  case 12:
    m_PBtype = PB_GiftFromGod;
    m_action = m_pPushButton->action();
    m_NC = false;
    m_remove = false;
    localAction = m_pPushButton->localAction();
    if (!localAction)
    {
      m_column = m_pPushButton->targetX() + m_levelInfo.left;
      m_row = m_pPushButton->targetY() + m_levelInfo.top;
      m_positionIndex = m_pPushButton->targetPos();
      m_effect = 0; //targeted
      m_action = m_pPushButton->action();
      m_NC = false;
    }
    else
    {
      m_column = m_levelInfo.left;
      m_row = m_levelInfo.top;
      m_positionIndex = 0;
      if (m_pPushButton->localActionType() == 10)
      {
        m_effect = 2; //skills
      }
      else
      {
        m_effect = 1; //rotate
      };
      m_action = m_pPushButton->action();
      m_NC = false;
    };
    m_giftType = m_pPushButton->GiftType();
    break;
  default:
    NotImplemented();
  };
  if (!localAction)
  {
    m_column = m_pPushButton->targetX() + m_levelInfo.left;
    m_row = m_pPushButton->targetY() + m_levelInfo.top;
    m_positionIndex = m_pPushButton->targetPos();
  }
  else
  {
    m_column = m_levelInfo.left;
    m_row = m_levelInfo.top;
    m_positionIndex = 0;
  };
  m_onlyOnce = m_pPushButton->onceOnly();
  m_delay = m_pPushButton->delay();
  m_audible = m_pPushButton->audible();
  m_particularObjectType = m_pPushButton->neededObject(m_locr);
}

void EditPushButton::EncodeDataInRecord(void)
{
  int v;
  switch (m_PBtype)
  {
  case PB_SwitchAnything:  //"Anything"
    m_pPushButton->actuatorType(1);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(0);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_SwitchHand: //"Hand"
    m_pPushButton->actuatorType(2); //The wallswitch/No Alcove case
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(0);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_LockKeep:
    m_pPushButton->actuatorType(3); //
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(m_particularObjectType);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_LockRemove:
    m_pPushButton->actuatorType(4); //
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(m_particularObjectType);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_AlcoveAnything:
    m_pPushButton->actuatorType(1); //The Alcove case
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(m_particularObjectType);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_AlcoveObject:
    m_pPushButton->actuatorType(2); //The Alcove case
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(m_particularObjectType);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_AlcoveNotObject:
    m_pPushButton->actuatorType(3); //The Alcove case
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    if (   m_rotateConditionMet
        || m_rotateConditionNotMet
       )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(2);
    }
    else if (   m_skillConditionMet
             || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    m_pPushButton->neededObject(m_particularObjectType);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  case PB_GiftFromGod:
    m_pPushButton->actuatorType(12); //If last and empty hand then rotate/give gift
    m_pPushButton->normallyClosed(m_NC);
    m_pPushButton->audible(m_audible?true:false);
    m_pPushButton->delay(m_delay);
    //if (   m_rotateConditionMet
    //    || m_rotateConditionNotMet
    //   )
    //{
    //  m_pPushButton->localAction(true);
    //  m_pPushButton->localActionType(2);
    //}
    if (   m_skillConditionMet
      //       || m_skillConditionNotMet
            )
    {
      m_pPushButton->localAction(true);
      m_pPushButton->localActionType(10);
    }
    else
    {
      m_pPushButton->localAction(false);
      m_pPushButton->targetX(m_column-m_levelInfo.left);
      m_pPushButton->targetY(m_row-m_levelInfo.top);
      m_pPushButton->targetPos(m_positionIndex);
    };
    m_pPushButton->action(m_action);
    v = m_giftControl.GetItemData(m_gift);
    m_pPushButton->GiftType(v);
    //m_pPushButton->neededObject(0);
    m_pPushButton->onceOnly(m_onlyOnce?true:false);
    m_pPushButton->wallGraphicOrdinal(m_wallGraphicIndex);
    break;
  default:
    NotImplemented();
  };
}

void EditPushButton::MarkActions(void)
{
  int j, k;
  j = ((m_PBtype*3 + m_effect)*2 + (m_NC?1:0))*4 + m_action;
  k = PBlegalActions[j];
  m_setConditionMet       = (k&MS) != 0;
  m_setConditionNotMet    = (k&NS) != 0;
  m_clearConditionMet     = (k&MC) != 0;
  m_clearConditionNotMet  = (k&NC) != 0;
  m_toggleConditionMet    = (k&MT) != 0;
  m_toggleConditionNotMet = (k&NT) != 0;
  m_rotateConditionMet    = (k&MR) != 0;
  m_rotateConditionNotMet = (k&NR) != 0;
  m_skillConditionMet     = (k&MK) != 0;
  m_skillConditionNotMet  = (k&NK) != 0;
}

void EditPushButton::Show(int ID, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(ID);
  if (pWnd != NULL) pWnd->ShowWindow(show);
}

void EditPushButton::DoDataExchange(CDataExchange* pDX)
{
  bool localAction;
  bool showTarget;
  int i, k, n;
  if (!pDX->m_bSaveAndValidate)
  {
    MarkActions();
    switch (m_PBtype)
    {
    case PB_SwitchAnything:
      m_anything = 0;
      break;
    case PB_SwitchHand:
      m_anything = 1;
      break;
    case PB_LockKeep:
      m_anything = 2;
      break;
    case PB_LockRemove:
      m_anything = 2;
      break;
    case PB_LastLockRotate:
      m_anything = 2;
      break;
    case PB_LastLockDelete:
      m_anything = 2;
      break;
    case PB_AlcoveAnything:
      m_anything = 3;
      break;
    case PB_AlcoveObject:
      m_anything = 4;
      break;
    case PB_AlcoveNotObject:
      m_anything = 5;
      break;
    case PB_GiftFromGod:
      m_anything = 6;
      break;
    default:
      NotImplemented();
      m_anything = 0;
      break;
    };
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditPushButton)
	DDX_Control(pDX, IDC_Gift, m_giftControl);
	DDX_Control(pDX, IDC_NeededObject, m_neededObject);
	DDX_Control(pDX, IDC_Position, m_position);
	DDX_Control(pDX, IDC_Graphic, m_graphic);
	DDX_Check(pDX, IDC_Audible, m_audible);
	DDX_Text(pDX, IDC_Column, m_column);
	DDX_Text(pDX, IDC_Delay, m_delay);
	DDX_Check(pDX, IDC_OnlyOnce, m_onlyOnce);
	DDX_Text(pDX, IDC_Row, m_row);
	DDX_Radio(pDX, IDC_Anything, m_anything);
	DDX_Check(pDX, IDC_Remove, m_remove);
	DDX_Check(pDX, IDC_ClearConditionMet, m_clearConditionMet);
	DDX_Check(pDX, IDC_ClearConditionNotMet, m_clearConditionNotMet);
	DDX_Check(pDX, IDC_SetConditionMet, m_setConditionMet);
	DDX_Check(pDX, IDC_SetConditionNotMet, m_setConditionNotMet);
	DDX_Check(pDX, IDC_ToggleConditionMet, m_toggleConditionMet);
	DDX_Check(pDX, IDC_ToggleConditionNotMet, m_toggleConditionNotMet);
	DDX_Check(pDX, IDC_RotateConditionMet, m_rotateConditionMet);
	DDX_Check(pDX, IDC_RotateConditionNotMet, m_rotateConditionNotMet);
	DDX_Check(pDX, IDC_SkillConditionMet, m_skillConditionMet);
	DDX_Check(pDX, IDC_SkillConditionNotMet, m_skillConditionNotMet);
	DDX_Check(pDX, IDC_OnlyIfLast, m_onlyIfLast);
	DDX_Radio(pDX, IDC_ForceRotate, m_forceRotate);
	DDX_CBIndex(pDX, IDC_Gift, m_gift);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    m_position.SetCurSel(m_positionIndex);
    switch (m_PBtype)
    {
    case PB_SwitchAnything: //"Anything"
      SetDlgItemText(IDC_MetLabel," \nWhen\nPressed");
      Show(IDC_NotMetLabel, false);
      Show(IDC_SetConditionNotMet, false);
      Show(IDC_ClearConditionNotMet, false);
      Show(IDC_ToggleConditionNotMet, false);
      Show(IDC_SkillConditionNotMet, false);
      Show(IDC_RotateConditionNotMet, false);
      Show(IDC_NeededObject, false);
      Show(IDC_NeededObjectLabel, false);
      Show(IDC_Remove, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_OnlyIfLast, false);
      Show(IDC_ForceRotate, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_SwitchHand: //"Hand"
      SetDlgItemText(IDC_MetLabel," \nHand is\nFull");
      SetDlgItemText(IDC_NotMetLabel," \nHand is\nEmpty");
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_NeededObject, false);
      Show(IDC_NeededObjectLabel, false);
      Show(IDC_Remove, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_OnlyIfLast, false);
      Show(IDC_ForceRotate, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_LockKeep:
      SetDlgItemText(IDC_MetLabel,"Holding\nSpecial\nObject");
      SetDlgItemText(IDC_NotMetLabel,"Not Holding\nSpecial\nObject");
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_NeededObject, true);
      Show(IDC_NeededObjectLabel, true);
      Show(IDC_Remove, true);
      Show(IDC_OnlyIfLast, true);
      Show(IDC_ForceRotate, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_LastLockRotate:
      Show(IDC_ForceRotate, true);
      Show(IDC_DeleteIfActivated, true);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_LockRemove:
      SetDlgItemText(IDC_MetLabel,"Holding\nSpecial\nObject");
      SetDlgItemText(IDC_NotMetLabel,"Not Holding\nSpecial\nObject");
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_NeededObject, true);
      Show(IDC_NeededObjectLabel, true);
      Show(IDC_Remove, true);
      Show(IDC_OnlyIfLast, true);
      Show(IDC_ForceRotate, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_AlcoveAnything:
      SetDlgItemText(IDC_MetLabel,"First\nObject\nPlaced");
      SetDlgItemText(IDC_NotMetLabel,"Last\nObject\nRemoved");
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_Remove, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_OnlyIfLast, false);
      Show(IDC_ForceRotate, false);
      Show(IDC_NeededObject, false);
      Show(IDC_NeededObjectLabel, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_AlcoveObject:
      SetDlgItemText(IDC_MetLabel,"Special\nObject\nPlaced");
      SetDlgItemText(IDC_NotMetLabel,"Special\nObject\nRemoved");
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_NeededObject, true);
      Show(IDC_NeededObjectLabel, true);
      Show(IDC_Remove, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_OnlyIfLast, false);
      Show(IDC_ForceRotate, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_AlcoveNotObject:
      SetDlgItemText(IDC_MetLabel,"Non-Special\nObject\nPlaced");
      SetDlgItemText(IDC_NotMetLabel,"Non-Special\nObject\nRemoved");
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_NeededObject, true);
      Show(IDC_NeededObjectLabel, true);
      Show(IDC_Remove, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_OnlyIfLast, false);
      Show(IDC_ForceRotate, false);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;
    case PB_LastLockDelete:
      SetDlgItemText(IDC_MetLabel,"Holding\nSpecial\nObject");
      SetDlgItemText(IDC_NotMetLabel,"Not Holding\nSpecial\nObject");
      Show(IDC_MetLabel, true);
      Show(IDC_NotMetLabel, true);
      Show(IDC_SetConditionNotMet, true);
      Show(IDC_ClearConditionNotMet, true);
      Show(IDC_ToggleConditionNotMet, true);
      Show(IDC_SkillConditionNotMet, true);
      Show(IDC_RotateConditionNotMet, true);
      Show(IDC_NeededObject, true);
      Show(IDC_NeededObjectLabel, true);
      Show(IDC_Remove, true);
      Show(IDC_DeleteIfActivated, true);
      Show(IDC_OnlyIfLast, true);
      Show(IDC_ForceRotate, true);
      Show(IDC_Gift, false);
      Show(IDC_ObjectInHandTitle, false);
      localAction =   m_rotateConditionMet
                   || m_rotateConditionNotMet
                   || m_skillConditionNotMet
                   || m_skillConditionMet;
      showTarget = !localAction;
      break;      
    case PB_GiftFromGod:
      SetDlgItemText(IDC_MetLabel," \nWhen\nPressed");
      Show(IDC_NotMetLabel, false);
      Show(IDC_SetConditionNotMet, false);
      Show(IDC_ClearConditionNotMet, false);
      Show(IDC_ToggleConditionNotMet, false);
      Show(IDC_SkillConditionNotMet, false);
      Show(IDC_RotateConditionNotMet, false);
      Show(IDC_NeededObject, false);
      Show(IDC_NeededObjectLabel, false);
      Show(IDC_Remove, false);
      Show(IDC_DeleteIfActivated, false);
      Show(IDC_OnlyIfLast, false);
      Show(IDC_ForceRotate, false);
      Show(IDC_Gift, true);
      Show(IDC_ObjectInHandTitle, true);
      localAction =  m_skillConditionMet != 0;
      showTarget = !localAction;
      m_giftControl.ResetContent();
      AddGift(511, "Nothing");
      AddGift(054, "Rock");
      AddGift(128, "Boulder");
      AddGift(051, "Arrow");
      AddGift(052, "Slayer");
      AddGift(055, "Poison Dart");
      AddGift(056, "Throwing Star");
      AddGift(032, "Dagger");
      AddGift(004, "Torch");
      n = m_giftControl.GetCount();
      m_gift = -1;
      for (i=0; i<n; i++)
      {
        if (m_giftControl.GetItemData(i) == (unsigned)m_giftType) break;
      };
      if (i == n)
      {
        i = m_giftControl.FindStringExact(-1, "Nothing");
      };
      m_gift = i;
      m_giftControl.SetCurSel(m_gift);
      break;
    default:
      NotImplemented();
      showTarget = false;
    };

    Show(IDC_ColumnLabel,  showTarget);
    Show(IDC_RowLabel,     showTarget);
    Show(IDC_PositionLabel,showTarget);
    Show(IDC_Column,       showTarget);
    Show(IDC_Row,          showTarget);
    Show(IDC_Position,     showTarget);
    Show(IDC_Browse,       showTarget);
    FillWallDecorationsComboBox();
    m_graphic.SetCurSel(m_pPushButton->wallGraphicOrdinal());
    //if (m_neededObject.IsWindowVisible())
    //{
      m_neededObjectIndex =
          m_particularObjectType.FillComboBox(&m_neededObject);
      m_neededObject.SetCurSel(m_neededObjectIndex);
    //};
  };
  if (pDX->m_bSaveAndValidate)
  {
    // Need to compute the four variables that define 
    // the actuator:
    // m_action, m_NC, and m_effect
    // We already know m_PBtype.
    k = 0;
    if (m_setConditionMet)       k += MS;
    if (m_setConditionNotMet)    k += NS;
    if (m_clearConditionMet)     k += MC;
    if (m_clearConditionNotMet)  k += NC;
    if (m_toggleConditionMet)    k += MT;
    if (m_toggleConditionNotMet) k += NT;
    if (m_rotateConditionMet)    k += MR;
    if (m_rotateConditionNotMet) k += NR;
    if (m_skillConditionMet)     k += MK;
    if (m_skillConditionNotMet)  k += NK;
    // Now search actions table for an entry of
    // this m_PBtype with the proper flags.
    for (i=0; i<240; i++)
    {
      if (i/24 != m_PBtype) continue;
      if (PBlegalActions[i] == k) break;
    };
    if (i == 240) 
    {
      InternalError();
    };
    i = i%240;
    m_action      = (ACTUATORACTION)(i % 4);
    m_effect      = (i/8) % 3;
    m_NC          = ((i/4) % 2) != 0;
    m_PBtype      = (PBTYPE)((i/24) % 10);
    m_pPushButton->wallGraphicOrdinal(m_graphic.GetCurSel());
    m_neededObjectIndex = m_neededObject.GetCurSel();
    if (m_neededObjectIndex >= 0)
    {
      m_particularObjectType = MODIFIEDOBJECTTYPE(
              m_neededObject.GetItemData(m_neededObjectIndex));
    }
    else
    {
      m_particularObjectType = TranslateObjectName("APPLE");
    };
    m_positionIndex = m_position.GetCurSel();
  };
}


BEGIN_MESSAGE_MAP(EditPushButton, CDialog)
	//{{AFX_MSG_MAP(EditPushButton)
	ON_BN_CLICKED(IDC_Anything, OnAnything)
	ON_BN_CLICKED(IDC_SetConditionMet, OnSetConditionMet)
	ON_BN_CLICKED(IDC_SetConditionNotMet, OnSetConditionNotMet)
	ON_BN_CLICKED(IDC_ToggleConditionMet, OnToggleConditionMet)
	ON_BN_CLICKED(IDC_ToggleConditionNotMet, OnToggleConditionNotMet)
	ON_BN_CLICKED(IDC_ClearConditionMet, OnClearConditionMet)
	ON_BN_CLICKED(IDC_ClearConditionNotMet, OnClearConditionNotMet)
	ON_BN_CLICKED(IDC_ForceRotate, OnForceRotate)
	ON_BN_CLICKED(IDC_OnlyIfLast, OnOnlyIfLast)
	ON_BN_CLICKED(IDC_Remove, OnRemove)
	ON_BN_CLICKED(IDC_DeleteIfActivated, OnDeleteIfActivated)
	ON_BN_CLICKED(IDC_RotateConditionMet, OnRotateConditionMet)
	ON_BN_CLICKED(IDC_RotateConditionNotMet, OnRotateConditionNotMet)
	ON_BN_CLICKED(IDC_SkillConditionMet, OnSkillConditionMet)
	ON_BN_CLICKED(IDC_SkillConditionNotMet, OnSkillConditonNotMet)
	ON_BN_CLICKED(IDC_LocalAction, OnLocalAction)
	ON_BN_CLICKED(IDC_Browse, OnBrowse)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_FullHand, OnAnything)
	ON_BN_CLICKED(IDC_Object, OnAnything)
	ON_BN_CLICKED(IDC_SetConditionNotMet, OnSetConditionNotMet)
	ON_BN_CLICKED(IDC_ToggleConditionNotMet, OnToggleConditionNotMet)
	ON_BN_CLICKED(IDC_ClearConditionNotMet, OnClearConditionNotMet)
	ON_BN_CLICKED(IDC_AlcoveObject, OnAnything)
	ON_BN_CLICKED(IDC_AlcoveAnything, OnAnything)
	ON_BN_CLICKED(IDC_AlcoveNotObject, OnAnything)
	ON_BN_CLICKED(IDC_GiftFromGod, OnAnything)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditPushButton message handlers


void EditPushButton::UpdateAction(int mask)
{
  int i, k;
  int besti, goodi;
  if (mask != 0) UpdateData(true);
  k = 0;
  if (m_setConditionMet)       k += MS;
  if (m_setConditionNotMet)    k += NS;
  if (m_clearConditionMet)     k += MC;
  if (m_clearConditionNotMet)  k += NC;
  if (m_toggleConditionMet)    k += MT;
  if (m_toggleConditionNotMet) k += NT;
  if (m_rotateConditionMet)    k += MR;
  if (m_rotateConditionNotMet) k += NR;
  if (m_skillConditionMet)     k += MK;
  if (m_skillConditionNotMet)  k += NK;
  k ^= mask;
  for (i=0; i<240; i++)
  {
    if (PBlegalActions[i] != k) continue;
    if (m_PBtype != (i/24) % 10) continue;
    m_action = (ACTUATORACTION)(i%4);
    m_effect = (i/8) % 3;
    m_NC = ((i/4) % 2)!=0;
    UpdateData(false);
    return;
  };
  besti = -1;
  goodi = -1;
  for (i=0; i<240; i++)
  {
    if (((PBlegalActions[i] ^ k) & mask) == 0)
    {
      if (goodi == -1) goodi = i;
      if (m_PBtype == (i/24)%10)
        if (besti == -1) besti = i;
    };
  };
  i = -1;
  if (goodi != -1) i = goodi;
  if (besti != -1) i = besti;
  if (i != -1)
  {
    m_action      = (ACTUATORACTION)(i % 4);
    m_effect      = (i/8) % 3;
    m_NC          = ((i/4) % 2) != 0;
    m_PBtype      = (PBTYPE)((i/24) % 10);
    UpdateData(false);
    return;
  };
  m_effect = 0;
  m_NC = false;
  m_action = (ACTUATORACTION)0;
  m_PBtype = PB_SwitchAnything;
  UpdateData(false);
}


int ACTUATOR_PushButton::Edit(LOCATIONREL locr)
{
  EditPushButton dlg(locr);
  dlg.m_pPushButton = this;
  return dlg.DoModal();
}

void EditPushButton::FillWallDecorationsComboBox()
{
  int i;
  WALLTYPE wt;
  m_graphic.ResetContent();
  m_graphic.AddString("none");
  for (i=0; i<pDoc->NumWallDecorations(m_levelInfo.level); i++)
  {
    if (pDoc->IsLegalWallDecorationIndex(m_levelInfo.level, i+1))
    {
      wt = pDoc->WallDecorationType(m_levelInfo.level,i);
      m_graphic.AddString(wt.Name());
    }
    else
    {
      m_graphic.AddString("illegal");
    };
  };
}


void EditPushButton::OnClearConditionMet()
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_ClearConditionMet, m_clearConditionMet);
  UpdateAction(MC);
}

void EditPushButton::OnClearConditionNotMet()
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_ClearConditionNotMet, m_clearConditionNotMet);
  UpdateAction(NC);
}

void EditPushButton::OnSetConditionMet()
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_SetConditionMet, m_setConditionMet);
  UpdateAction(MS);
}

void EditPushButton::OnSetConditionNotMet()
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_SetConditionNotMet, m_setConditionNotMet);
  UpdateAction(NS);
}

void EditPushButton::OnToggleConditionMet()
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_ToggleConditionMet, m_toggleConditionMet);
  UpdateAction(MT);
}

void EditPushButton::OnToggleConditionNotMet()
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_ToggleConditionNotMet, m_toggleConditionNotMet);
  UpdateAction(NT);
}

void EditPushButton::OnRotateConditionMet() 
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_RotateConditionMet, m_rotateConditionMet);
  UpdateAction(MR);	
}

void EditPushButton::OnRotateConditionNotMet() 
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_RotateConditionNotMet, m_rotateConditionNotMet);
  UpdateAction(NR);	
}

void EditPushButton::OnSkillConditionMet() 
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_SkillConditionMet, m_skillConditionMet);
	UpdateAction(MK);
}

void EditPushButton::OnSkillConditonNotMet() 
{
	// TODO: Add your control notification handler code here
  CheckDlgButton(IDC_SkillConditionNotMet, m_skillConditionNotMet);
	UpdateAction(NK);
}

bool EditPushButton::CheckNoAlcove(void)
{
  if (!IsAlcove()) return true;
  {
    int ans;
    ans = AreYouSure("There is an Alcove graphic here.\n"
                     "Do you really want to edit this "
                     "alcove as if it were a pushbutton?");
    return ans == IDYES;
  };
}

bool EditPushButton::CheckForAlcove(void)
{
  if (IsAlcove()) return true;
  {
    int ans;
    ans = AreYouSure("There is no Alcove graphic here.\n"
                     "Do you really want to edit this "
                     "pushbutton as if it were an alcove?");
    return ans == IDYES;
  };
}

void EditPushButton::OnAnything()
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  //We need to compute a new m_PBtype
  switch (m_anything)
  {
  case 0: // "anything'
    if (CheckNoAlcove()) m_PBtype = PB_SwitchAnything;
    UpdateAction(0);
    break;
  case 1: //"Hand"
    if (CheckNoAlcove()) m_PBtype = PB_SwitchHand;
    UpdateAction(0);
    break;
  case 2: //"Wall Switch  - Special Object"
    if (!CheckNoAlcove()) break;
    if (    (m_PBtype != PB_LockRemove)
         && (m_PBtype != PB_LockKeep)
         && (m_PBtype != PB_LastLockRotate)
         && (m_PBtype != PB_LastLockDelete) )
    {
      m_PBtype = PB_LockRemove;
      m_remove = true;
      m_onlyIfLast = false;
    };
    UpdateAction(0);
    break;
  case 3: //"Alcove - Anything"
    if (CheckForAlcove()) m_PBtype = PB_AlcoveAnything;
    UpdateAction(0);
    break;
  case 4: //"Alcove - Special Object"
    if (CheckForAlcove()) m_PBtype = PB_AlcoveObject;
    UpdateAction(0);
    break;
  case 5: //"Alcove - Not Special Object"
    if (CheckForAlcove()) m_PBtype = PB_AlcoveNotObject;
    UpdateAction(0);
    break;
  case 6: //"Gift from God"
    m_PBtype = PB_GiftFromGod;
    UpdateAction(0);
    break;
  default:
    NotImplemented();
  };
  UpdateData(false);
}


void EditPushButton::AddGift(int value, char *name)
{
  int idx;
  idx = m_giftControl.AddString(name);
  m_giftControl.SetItemData(idx, value);
}

BOOL EditPushButton::OnInitDialog()
{
  ExtractDataFromRecord();

  CDialog::OnInitDialog();

  
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditPushButton::OnOK()
{
	// TODO: Add extra validation here
  UpdateData(true);
  EncodeDataInRecord();
	CDialog::OnOK();
}

void EditPushButton::OnForceRotate() 
{
	// TODO: Add your control notification handler code here
  m_PBtype = PB_LastLockRotate;
  m_forceRotate = 0;
  UpdateAction(0);
}

void EditPushButton::OnOnlyIfLast() 
{
	// TODO: Add your control notification handler code here
	m_onlyIfLast = !m_onlyIfLast;
  if (m_onlyIfLast)
  {
    switch (m_PBtype)
    {
    case PB_LockKeep:
    case PB_LockRemove:
      if (m_forceRotate == 0)
      {
        m_PBtype = PB_LastLockRotate;
        m_forceRotate = 0;
        m_remove = true;
      }
      else
      {
        m_PBtype = PB_LastLockDelete;
        m_forceRotate = 1;
        m_remove = true;
      };
      break;
    case PB_GiftFromGod:
      m_onlyIfLast = true;
      break;
    default:
      InternalError();
      break;
    };
  }
  else
  {
    switch (m_PBtype)
    {
    case PB_LastLockRotate:
    case PB_LastLockDelete:
      if (m_remove)
      {
        m_PBtype = PB_LockRemove;
      }
      else
      {
        m_PBtype = PB_LockKeep;
      };
      break;
    default:
      InternalError();
      break;
    };
  };
  UpdateAction(0);
}

void EditPushButton::OnRemove() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  switch (m_PBtype)
  {
  case PB_LockKeep:
    m_PBtype = PB_LockRemove;
    m_remove = true;
    break;
  case PB_LockRemove:
    m_PBtype = PB_LockKeep;
    m_remove = false;
    break;
  case PB_LastLockRotate:
  case PB_LastLockDelete:
    m_PBtype = PB_LockKeep;
    m_remove = false;
    m_onlyIfLast = false;
    break;
  case PB_GiftFromGod:
    m_remove = false;
    break;
  default:
    NotImplemented();
    break;
  };
  UpdateAction(false);
}

void EditPushButton::OnDeleteIfActivated() 
{
	// TODO: Add your control notification handler code here
  m_PBtype = PB_LastLockDelete;
  m_forceRotate = 1;
  UpdateAction(0);
}

void EditPushButton::OnLocalAction() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
  UpdateData(false);
}

void EditPushButton::OnBrowse() 
{
	// TODO: Add your control notification handler code here
  LOCATIONABS loca, locaPushButton;
  LOCATIONREL locrTarget;
  UpdateData(true);
  loca.l = m_locr.l();
  loca.x = m_column;
  loca.y = m_row;
  locrTarget = loca;
  locaPushButton = m_locr;
	EditTarget dlg(locrTarget,"Push Button",locaPushButton,false);
  if (dlg.DoModal() == IDOK)
  {
    locrTarget.l(dlg.m_locr.l());
    locrTarget.x(dlg.m_locr.x());
    locrTarget.y(dlg.m_locr.y());
    loca = locrTarget;
    m_column = loca.x;
    m_row = loca.y;
    UpdateData(false);
  };
}

BOOL EditPushButton::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CString s;
  int id;
  switch (pHelpInfo->iCtrlId)
  {
  case IDC_Browse:      id = IDH_EditPushbutton_Browse;      break;
  case IDC_Anything:    id = IDH_EditPushbutton_Anything;    break;
  case IDC_FullHand:    id = IDH_EditPushbutton_FullHand;    break;
  case IDC_Object:      id = IDH_EditPushbutton_Object;      break;
  case IDC_GiftFromGod: id = IDH_EditPushbutton_GiftFromGod; break;
  case IDC_SkillConditionMet:
  case IDC_RotateConditionMet:
  case IDC_SetConditionMet:
  case IDC_ClearConditionMet:
  case IDC_ToggleConditionMet:
  case IDC_SkillConditionNotMet:
  case IDC_RotateConditionNotMet:
  case IDC_SetConditionNotMet:
  case IDC_ClearConditionNotMet:
  case IDC_ToggleConditionNotMet:
    id = IDH_EditPushbutton_Action; break;
  case IDC_Delay:
    id = IDH_Context_MessageDelay; break;
  default: id = IDH_Context_None;
  };
	s.LoadString(id);
  HelpMsg(s);
  return true;
}
