// EditRoomOpen.cpp : implementation file
//

#include "stdafx.h"
//#include "types.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "CSBuildView.h"
#include "ObjectListBox.h"
#include "Misc.h"
#include "EditRoomOpen.h"
#include "dlg_InsertObject.h"
#include "myCListCtrl.h"
#include "DesignedActuator.h"
#include "Clones.h"
#include "Clipboard.h"
#include "ShowLocations.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditRoomOpen dialog


EditRoomOpen::EditRoomOpen(LOCATIONREL locr, CWnd* pParent /*=NULL*/)
	: CDialog(EditRoomOpen::IDD, pParent) 
{
	//{{AFX_DATA_INIT(EditRoomOpen)
	m_Visible = FALSE;
	m_RandomFloor = FALSE;
	m_Open = FALSE;
	m_openDoor = -1;
	m_footprints = FALSE;
	//}}AFX_DATA_INIT
  {
    m_locr = locr;
    m_levelInfo = locr;
    m_lists[0] = &m_EO_0_List;
    m_lists[1] = &m_EO_1_List;
    m_lists[2] = &m_EO_2_List;
    m_lists[3] = &m_EO_3_List;
    m_lists[4] = &m_EO_C_List;
  };
  m_interestingObject = RNeof;
  m_interestingObjectIndex = -1;
}


void EditRoomOpen::Hide(int ID)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(ID);
  if (pWnd != NULL) pWnd->ShowWindow(false);
}

void EditRoomOpen::DoDataExchange(CDataExchange* pDX)
{
  RN obj;
  int i, depth, pos;
  DBTYPE dbType;
  CELLFLAG cf;
  if (!pDX->m_bSaveAndValidate)
  {
    cf = pDoc->GetCellFlag(m_locr);
    switch(RoomType(cf))
    {
      case roomOPEN:
        m_RandomFloor= (cf & 8) != 0;
        break;
      //case roomFALSEWALL:
      case roomBLOCKING:
      case roomNONBLOCKING:
        m_Visible = (cf&4)!=0;
        m_Open    = (cf&1)!=0;
        break;
      case roomTELEPORTER:
        m_Visible = (cf&4)!=0;
        m_Open    = (cf&8)!=0;
        break;
      case roomPIT:
        m_Visible     = (cf&1)!=0;
        m_Open        = (cf&8)!=0;
        m_RandomFloor = (cf&4)!=0;
        break;
      case roomSTAIRS:
        m_openDoor = (cf & 8) == 0?0:1;
        break;
      case roomDOOR:
        m_openDoor = cf & 7;
        if (m_openDoor > 5) m_openDoor = 0;
        break;
    };
    m_footprints = pDoc->GetExtendedCellFlag(m_locr,ECF_FOOTPRINTS);
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditRoomOpen)
	DDX_Control(pDX, IDC_TargetOf, m_targetOf);
	DDX_Control(pDX, IDC_EO_C_List, m_EO_C_List);
	DDX_Control(pDX, IDC_EO_3_List, m_EO_3_List);
	DDX_Control(pDX, IDC_EO_2_List, m_EO_2_List);
	DDX_Control(pDX, IDC_EO_1_List, m_EO_1_List);
	DDX_Control(pDX, IDC_EO_0_List, m_EO_0_List);
	DDX_Check(pDX, IDC_Visible, m_Visible);
	DDX_Check(pDX, IDC_RandomFloor, m_RandomFloor);
	DDX_Check(pDX, IDC_Open, m_Open);
	DDX_Radio(pDX, IDC_OpenDoor, m_openDoor);
	DDX_Check(pDX, IDC_Footprints, m_footprints);
	//}}AFX_DATA_MAP

  if (pDX->m_bSaveAndValidate)
  {
    cf = pDoc->GetCellFlag(m_locr);
    switch (RoomType(cf))
    {
    case roomOPEN:
      cf &= 0xf7;
      if (m_RandomFloor) cf |= 8;
      break;
    //case roomFALSEWALL:
    case roomBLOCKING:
    case roomNONBLOCKING:
      cf &= ~5;
      if (m_Open) cf |= 1;
      if (m_Visible) cf |= 4;
      break;
    case roomTELEPORTER:
      cf &= ~12;
      if (m_Open) cf |= 8;
      if (m_Visible) cf |= 4;
      break;
    case roomPIT:
      cf &= ~13;
      if (m_Open) cf |= 8;
      if (m_Visible) cf |= 1;
      if (m_RandomFloor) cf |= 4;
      break;
    case roomSTAIRS:
      cf &= ~8;
      if (m_openDoor == 1) cf |= 8;
      break;
    case roomDOOR:
      cf &= ~7;
      cf |= m_openDoor;
      break;
    };
    pDoc->SetCellFlag(m_locr, cf);
    pDoc->SetExtendedCellFlag(m_locr, ECF_FOOTPRINTS, m_footprints!=0);
  };
  if (!pDX->m_bSaveAndValidate)
  {
    for (i=0; i<5; i++) 
    {
      m_saveSel[i] = m_lists[i]->GetCurSel();
      m_lists[i]->ResetContent();
    };
    switch (RoomType(pDoc->GetCellFlag(m_locr)))
    {
    case roomPIT:
      SetWindowText("Edit Pit");
      SetDlgItemText(IDC_Visible,"False Pit - Don't fall through");
      SetDlgItemText(IDC_Open,"Pit is Open (Active)");
      SetDlgItemText(IDC_RandomFloor,"Pit is hard to see when open");
      Hide(IDC_OpenDoor);
      Hide(IDC_ClosedDoor);
      Hide(IDC_BashedDoor);
      Hide(IDC_AlmostOpenDoor);
      Hide(IDC_AlmostClosedDoor);
      Hide(IDC_HalfOpenDoor);
      break;
    //case roomFALSEWALL:
    case roomBLOCKING:
    case roomNONBLOCKING:
      SetWindowText("Edit False Wall");
      SetDlgItemText(IDC_Visible,"Trick Wall is Invisible");
      SetDlgItemText(IDC_Open,"Trick Wall is always non-Blocking");
      Hide(IDC_OpenDoor);
      Hide(IDC_ClosedDoor);
      Hide(IDC_BashedDoor);
      Hide(IDC_AlmostOpenDoor);
      Hide(IDC_AlmostClosedDoor);
      Hide(IDC_HalfOpenDoor);
      Hide(IDC_RandomFloor);
      break;
    case roomSTAIRS:
      SetWindowText("Edit Stairs");
      Hide(IDC_Visible);
      Hide(IDC_Open);
      SetDlgItemText(IDC_OpenDoor,"Traverse Stairs East/West");
      SetDlgItemText(IDC_AlmostOpenDoor,"Traverse Stairs North/South");
      Hide(IDC_BashedDoor);
      Hide(IDC_ClosedDoor);
      Hide(IDC_AlmostClosedDoor);
      Hide(IDC_HalfOpenDoor);
      break;
    case roomOPEN:
      Hide(IDC_Visible);
      Hide(IDC_Open);
      Hide(IDC_OpenDoor);
      Hide(IDC_ClosedDoor);
      Hide(IDC_BashedDoor);
      Hide(IDC_AlmostOpenDoor);
      Hide(IDC_AlmostClosedDoor);
      Hide(IDC_HalfOpenDoor);
      break;
    case roomDOOR:
      SetWindowText("Edit Door");
      Hide(IDC_Visible);
      Hide(IDC_Open);
      Hide(IDC_RandomFloor);
      break;
    case roomTELEPORTER:
      SetWindowText("Edit Teleporter");
      SetDlgItemText(IDC_Open,"Teleporter is Active");
      SetDlgItemText(IDC_Visible,"Teleporter is Visible");
      Hide(IDC_OpenDoor);
      Hide(IDC_ClosedDoor);
      Hide(IDC_BashedDoor);
      Hide(IDC_AlmostOpenDoor);
      Hide(IDC_AlmostClosedDoor);
      Hide(IDC_HalfOpenDoor);
      Hide(IDC_RandomFloor);
      break;
    default:
      NotImplemented();
      break;
    };
    for (depth=1, obj = pDoc->FindFirstObject(m_locr);
        obj != RNeof;
        depth++, obj = pDoc->GetDBRecordLink(obj))
    {
      dbType = obj.dbType();
      switch (dbType)
      {
      case dbDOOR:
        m_EO_C_List.AddDoor(obj,depth);
        pos = 4;
        break;
      case dbTELEPORTER: 
        m_EO_C_List.AddTeleporter(obj,depth);
        pos = 4;
        break;
      case dbTEXT:
        {
          CString s;
          s.Format("<%d>Text",depth);
          i = m_EO_C_List.AddString(s);
          m_EO_C_List.SetItemData(i, obj.ConvertToInteger());
        };
        pos = 4;
        break;
      case dbACTUATOR:
        m_EO_C_List.AddActuator(obj,m_roomType,depth);
        pos = 4;
        break;
      case dbMONSTER:
        m_lists[obj.pos()]->AddMonster(obj,depth);
        pos = obj.pos();
        break;
      case dbWEAPON:
        m_lists[obj.pos()]->AddWeapon(obj,depth);
        pos = obj.pos();
        break;
      case dbCLOTHING:
        m_lists[obj.pos()]->AddClothing(obj,depth);
        pos = obj.pos();
        break;
      case dbSCROLL:
        m_lists[obj.pos()]->AddScroll(obj,depth);
        pos = obj.pos();
        break;
      case dbPOTION:
        m_lists[obj.pos()]->AddPotion(obj,depth);
        pos = obj.pos();
        break;
      case dbCHEST:
        m_lists[obj.pos()]->AddChest(obj,depth);
        pos = obj.pos();
        break;
      case dbMISC:
        m_lists[obj.pos()]->AddMisc(obj,depth);
        pos = obj.pos();
        break;
      case dbCLOUD:
        m_lists[obj.pos()]->AddCloud(obj, depth);
        pos = obj.pos();
        break;
      case dbMISSILE:
        m_lists[obj.pos()]->AddMissile(obj,depth);
        pos = obj.pos();
        break;
      default:NotImplemented();
        pos = -1;
        break;
      };
      if (   (pos >= 0)
          && m_interestingObject.IsDBIndexOK()
          && obj.IsSameObjectAs(m_interestingObject))
      {
        m_interestingObjectPos = pos;
        m_interestingObjectIndex = m_lists[pos]->GetCount()-1;
      };
    };
    for (i=0; i<5; i++)
    {
      m_lists[i]->SetCurSel(m_saveSel[i]);
      if (  (m_lists[i]->GetCurSel() < 0)
          &&(m_lists[i]->GetCount() != 0))
      {
        m_lists[i]->SetCurSel(0);
      };
    };
    FillTargetListBox(&m_targetOf, m_locr, &m_triggerList);
    if (  (m_targetOf.GetCurSel() < 0)
        &&(m_targetOf.GetCount() != 0))
    {
      m_targetOf.SetCurSel(0);
    };
  };
}


BEGIN_MESSAGE_MAP(EditRoomOpen, CDialog)
	//{{AFX_MSG_MAP(EditRoomOpen)
	ON_BN_CLICKED(IDC_EO_C_Edit, OnEOCEdit)
	ON_BN_CLICKED(IDC_EO_0_Delete, OnEO0Delete)
	ON_BN_CLICKED(IDC_EO_1_Delete, OnEO1Delete)
	ON_BN_CLICKED(IDC_EO_2_Delete, OnEO2Delete)
	ON_BN_CLICKED(IDC_EO_3_Delete, OnEO3Delete)
	ON_BN_CLICKED(IDC_EO_C_Delete, OnEOCDelete)
	ON_BN_CLICKED(IDC_EO_C_New, OnEOCNew)
	ON_BN_CLICKED(IDC_EO_0_New, OnEO0New)
	ON_BN_CLICKED(IDC_EO_1_New, OnEO1New)
	ON_BN_CLICKED(IDC_EO_2_New, OnEO2New)
	ON_BN_CLICKED(IDC_EO_3_New, OnEO3New)
	ON_BN_CLICKED(IDC_EO_0_Edit, OnEO0Edit)
	ON_BN_CLICKED(IDC_EO_1_Edit, OnEO1Edit)
	ON_BN_CLICKED(IDC_EO_2_Edit, OnEO2Edit)
	ON_BN_CLICKED(IDC_EO_3_Edit, OnEO3Edit)
	ON_BN_CLICKED(IDC_EO_C_Pop, OnEOCPop)
	ON_BN_CLICKED(IDC_EO_0_Pop, OnEO0Pop)
	ON_BN_CLICKED(IDC_EO_1_Pop, OnEO1Pop)
	ON_BN_CLICKED(IDC_EO_2_Pop, OnEO2Pop)
	ON_BN_CLICKED(IDC_EO_3_Pop, OnEO3Pop)
	ON_LBN_DBLCLK(IDC_EO_0_List, OnDblclkEO0List)
	ON_LBN_DBLCLK(IDC_EO_1_List, OnDblclkEO1List)
	ON_LBN_DBLCLK(IDC_EO_2_List, OnDblclkEO2List)
	ON_LBN_DBLCLK(IDC_EO_3_List, OnDblclkEO3List)
	ON_LBN_DBLCLK(IDC_EO_C_List, OnDblclkEOCList)
	ON_WM_HELPINFO()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(IDC_MoveCW, OnMoveCW)
	ON_COMMAND(IDC_MoveCCW, OnMoveCCW)
	ON_COMMAND(IDC_MoveAcross, OnMoveAcross)
	ON_COMMAND(IDM_Pop, OnPop)
	ON_COMMAND(IDC_EditRoomOpenCopyItem, OnEditRoomOpenCopyItem)
	ON_COMMAND(IDC_EditRoomOpenPasteItem, OnEditRoomOpenPasteItem)
	ON_COMMAND(IDM_PeekAtSource, OnPeekAtSource)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditRoomOpen message handlers

void CCSBuildView::EditRoomNonSTONE(int col, int row, ROOMTYPE rt)
{
  //We also are expedted to handle TELEPORTERS
  LOCATIONREL locr;
  CELL_CHECKPOINT *pCC1, *pCC2;
  locr.l(pDoc->m_currentDisplayLevel);
  locr.x(col);
  locr.y(row);
  locr.p(0);
  EditRoomOpen dlg(locr);
  dlg.m_roomType = rt;
  pCC1 = pDoc->CheckpointCell(locr);
  if (dlg.DoModal() == IDOK) Invalidate();
  pCC2 = pDoc->CheckpointCell(locr);
  if (*pCC1 == *pCC2)
  {
    delete pCC1;
  }
  else
  {
    pDoc->WriteCellUndo(pCC1);
  };
  delete pCC2;
}


RN EditRoomOpen::DetermineSelectedObject(int pos)
{
  int index, value;
  RN obj;
  index = m_lists[pos]->GetCurSel();
  if (index == LB_ERR)
  {
    NoSelection();
    return RNeof;
  };
  value = m_lists[pos]->GetItemData(index);
  obj.ConstructFromInteger(value);
  return obj;
}

void EditRoomOpen::EditObject(int pos)
{
  RN obj;
  UpdateData(true);
	// TODO: Add your control notification handler code here
  obj = DetermineSelectedObject(pos);
  if (obj == RNeof) return;
  ObjectEditor(obj, m_locr);
  UpdateData(false);
}

void EditRoomOpen::OnEOCEdit() 
{
  EditObject(4);
}

void EditRoomOpen::DeleteObject(int position)
{
  RN obj;
  DBTYPE dbType;
  CLONES clones(this);
  obj = DetermineSelectedObject(position);
  if (obj == RNeof) return;
  if (obj == RNnul) return;
  if (obj == RNpit)
  {
    pDoc->Sorry("You cannot delete pits this way.\n"
          "Replace it with an empty square on the map.");
    return;
  };
  dbType = obj.dbType();
  if (dbType == dbDOOR)
  {
    pDoc->Sorry("You cannot delete doors this way.\n"
          "Replace it with an empty square on the map.");
    return;
  };
  if (dbType == dbTELEPORTER)
  {
    pDoc->Sorry("You cannot delete teleporters this way.\n"
          "Replace it with an empty square on the map.");
    return;
  };
  clones.Clear();
  clones.MarkDungeonObjects();
  if (clones.IsObjectCloned(obj.dbType(),obj.dbIndex()))
  {
    pDoc->Sorry("That object is cloned, or is contained\n"
                "in a cloned object, or follows a cloned\n"
                "object in a list of objects.  Fix the cloning.");
  }
  else
  {
    pDoc->RemoveObjectFromRoom(m_locr, obj, true, true);
  };
  UpdateData(false);
}

void EditRoomOpen::InsertObject(int position, ROOMTYPE rt)
{
  int result;
  int typeMask = 0;
  RN obj;
  if (position != 4)
  {
    if (rt != roomSTAIRS)
    {
      if (pDoc->FindFirstMonster(m_locr) == RNeof)
      {
        typeMask |= 1<<dbMONSTER;
      };
      typeMask |= 1<<dbMISC;
      typeMask |= 1<<dbSCROLL;
      typeMask |= 1<<dbCHEST;
      typeMask |= 1<<dbPOTION;
      typeMask |= 1<<dbCLOTHING;
      typeMask |= 1<<dbWEAPON;
      typeMask |= 1<<dbACTUATOR;
    }
    else
    {
      typeMask = 0;
      if ((pDoc->EditingOptions() & EDIT_OPT_AllowObjectsOnStairs) != 0)
      {
        typeMask |= 1<<dbMISC;
      };
    };
  }
  else
  {
    //typeMask |= 1<<dbTELEPORTER;
    //typeMask |= 1<<dbDOOR;
    typeMask |= 1<<dbTEXT;
    typeMask |= 1<<dbACTUATOR;
  };
  dlg_InsertObject dlg(m_locr, typeMask);
  result = dlg.DoModal();
  if (result == IDCANCEL) return;
  obj = dlg.m_insertObject;
  if (obj != RNnul) 
  {
    m_locr.p(position);
    obj.pos(position);
    pDoc->AddObjectToRoom(obj, m_locr);
    m_interestingObject = obj;
    UpdateData(false);
    if (m_interestingObjectPos >= 0)
    {
      m_lists[m_interestingObjectPos]->SetCurSel(m_interestingObjectIndex);
    };
  };
  EditObject(m_interestingObjectPos);
}


void EditRoomOpen::OnEO0Delete() 
{
	// TODO: Add your control notification handler code here
  DeleteObject(0);	
}

void EditRoomOpen::OnEO1Delete() 
{
	// TODO: Add your control notification handler code here
	DeleteObject(1);
}

void EditRoomOpen::OnEO2Delete() 
{
	// TODO: Add your control notification handler code here
	DeleteObject(2);
}

void EditRoomOpen::OnEO3Delete() 
{
	// TODO: Add your control notification handler code here
	DeleteObject(3);
}

void EditRoomOpen::OnEOCDelete() 
{
	// TODO: Add your control notification handler code here
	DeleteObject(4);
}

void EditRoomOpen::OnEOCNew() 
{
	// TODO: Add your control notification handler code here
  InsertObject(4, m_roomType);	
}


void EditRoomOpen::OnEO0New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(0, m_roomType);	
	
}

void EditRoomOpen::OnEO1New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(1, m_roomType);	
	
}

void EditRoomOpen::OnEO2New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(2, m_roomType);	
	
}

void EditRoomOpen::OnEO3New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(3, m_roomType);	
	
}

void EditRoomOpen::OnEO0Edit() 
{
	// TODO: Add your control notification handler code here
	EditObject(0);
}

void EditRoomOpen::OnEO1Edit() 
{
	// TODO: Add your control notification handler code here
	EditObject(1);
}

void EditRoomOpen::OnEO2Edit() 
{
	// TODO: Add your control notification handler code here
	EditObject(2);
}

void EditRoomOpen::OnEO3Edit() 
{
	// TODO: Add your control notification handler code here
	EditObject(3);
}

void EditRoomOpen::PopObject(int pos)
{
  RN obj;
  LOCATIONREL locr;
  locr = m_locr;
  obj = DetermineSelectedObject(pos);
  if (obj == RNeof) return;
  pDoc->RemoveObjectFromRoom(locr, obj, false, true);
  locr.p(pos);
  pDoc->AddObjectToRoom(obj, locr);
  UpdateData(true);
  UpdateData(false);
}

void EditRoomOpen::OnEOCPop() 
{
	// TODO: Add your control notification handler code here
	PopObject(4);
}

void EditRoomOpen::OnEO0Pop() 
{
	// TODO: Add your control notification handler code here	
	PopObject(0);
}

void EditRoomOpen::OnEO1Pop() 
{
	// TODO: Add your control notification handler code here
	PopObject(1);
}

void EditRoomOpen::OnEO2Pop() 
{
	// TODO: Add your control notification handler code here
	PopObject(2);	
}

void EditRoomOpen::OnEO3Pop() 
{
	// TODO: Add your control notification handler code here
	PopObject(3);
}

void EditRoomOpen::OnDblclkEO0List() 
{
	// TODO: Add your control notification handler code here
  OnEO0Edit(); 	
}

void EditRoomOpen::OnDblclkEO1List() 
{
	// TODO: Add your control notification handler code here
  OnEO1Edit(); 	
	
}

void EditRoomOpen::OnDblclkEO2List() 
{
	// TODO: Add your control notification handler code here
  OnEO2Edit(); 	
	
}

void EditRoomOpen::OnDblclkEO3List() 
{
	// TODO: Add your control notification handler code here
	
  OnEO3Edit(); 	
}

void EditRoomOpen::OnDblclkEOCList() 
{
	// TODO: Add your control notification handler code here
	
  OnEOCEdit(); 
}

BOOL EditRoomOpen::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CString s;
  int id;
  switch (pHelpInfo->iCtrlId)
  {
  case IDC_EO_0_List:
  case IDC_EO_1_List:
  case IDC_EO_2_List:
  case IDC_EO_3_List:
  case IDC_EO_C_List:
    id = IDH_EditRoomOpen_List; 
    break;
  case IDC_RandomFloor: id = IDH_EditRoomOpen_RandomFloor; 
    break;
  default: id = IDH_Context_None;
  };
	s.LoadString(id);
  HelpMsg(s);
  return true;
}

void EditRoomOpen::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
  int index;
	if      (GetDlgItem(IDC_EO_0_List) == pWnd) index = 0;
  else if (GetDlgItem(IDC_EO_1_List) == pWnd) index = 1;
  else if (GetDlgItem(IDC_EO_2_List) == pWnd) index = 2;
  else if (GetDlgItem(IDC_EO_3_List) == pWnd) index = 3;
  else if (GetDlgItem(IDC_EO_C_List) == pWnd) index = 4;
  else if (GetDlgItem(IDC_TargetOf)  == pWnd) index = 5;
  else index = -1;
  if (  (index >= 0)&&(index<=4))
  {
    CMenu menu;
    m_activeContextWindow = index;
    if (menu.LoadMenu(IDR_RoomOpenCorners))      
    {
      CMenu* pPopup = menu.GetSubMenu(0);
      CObjectListBox *pBox;
      pBox = m_lists[index];
      //if (pBox->GetCurSel() >= 0)
      //{
        ASSERT(pPopup != NULL);
        if (pBox->GetCurSel() < 0)
        {
          pPopup->EnableMenuItem(1, MF_GRAYED|MF_BYPOSITION);
          pPopup->EnableMenuItem(2, MF_GRAYED|MF_BYPOSITION);
          pPopup->EnableMenuItem(3, MF_GRAYED|MF_BYPOSITION);
          pPopup->EnableMenuItem(4, MF_GRAYED|MF_BYPOSITION);
        };
        if (m_activeContextWindow == 4)
        {
          pPopup->EnableMenuItem(1, MF_GRAYED|MF_BYPOSITION);
          pPopup->EnableMenuItem(2, MF_GRAYED|MF_BYPOSITION);
          pPopup->EnableMenuItem(3, MF_GRAYED|MF_BYPOSITION);
        };
        if (pBox->GetCurSel() < 0)
        {
          pPopup->EnableMenuItem(5, MF_GRAYED|MF_BYPOSITION);
        };
        pPopup->TrackPopupMenu(TPM_CENTERALIGN | TPM_RIGHTBUTTON,
                               point.x, point.y,
                               this);
      //};
    };
  }
  else if (index == 5)
  {
    CMenu menu;
    m_activeContextWindow = index;
    if (menu.LoadMenu(IDR_Triggers))      
    {
      CMenu* pPopup = menu.GetSubMenu(0);
      CObjectListBox *pBox;
      pBox = &m_targetOf;
      if (pBox->GetCurSel() >= 0)
      {
        ASSERT(pPopup != NULL);
        //if (  (pBox->GetCurSel() < 0)
        //    ||(m_activeContextWindow == 4))
        //{
        //  pPopup->EnableMenuItem(1, MF_GRAYED|MF_BYPOSITION);
        //  pPopup->EnableMenuItem(2, MF_GRAYED|MF_BYPOSITION);
        //  pPopup->EnableMenuItem(3, MF_GRAYED|MF_BYPOSITION);
        //  pPopup->EnableMenuItem(4, MF_GRAYED|MF_BYPOSITION);
        //};
        //if (pBox->GetCurSel() < 0)
        //{
        //  pPopup->EnableMenuItem(0, MF_GRAYED|MF_BYPOSITION);
        pPopup->TrackPopupMenu(TPM_CENTERALIGN | TPM_RIGHTBUTTON,
                               point.x, point.y,
                               this);
      };
    };
  };
}

void EditRoomOpen::OnPop() 
{
	// TODO: Add your command handler code here
 switch (m_activeContextWindow)
 {
 case 0: OnEO0Pop(); break;
 case 1: OnEO1Pop(); break;
 case 2: OnEO2Pop(); break;
 case 3: OnEO3Pop(); break;
 case 4: OnEOCPop(); break;
 };
}

void EditRoomOpen::MoveCW(int distance)
{
  CObjectListBox *pBox;
  int index, value, oldpos;
  RN obj;
  UpdateData(true);
  pBox = m_lists[m_activeContextWindow];
  index = pBox->GetCurSel();
  if (index < 0) return; //should not happen
  value = pBox->GetItemData(index);
  obj.ConstructFromInteger(value);
  oldpos = obj.pos();
  obj.pos((oldpos + distance) & 3);
  UpdateData(false);
}

void EditRoomOpen::OnMoveCW() 
{
	// TODO: Add your command handler code here
	MoveCW(1);
}


void EditRoomOpen::OnMoveCCW() 
{
	// TODO: Add your command handler code here
	MoveCW(3);
}

void EditRoomOpen::OnMoveAcross() 
{
	// TODO: Add your command handler code here
	MoveCW(2);
}

static int tips[] =
{
  IDC_EO_0_List            , IDT_EditRoomOpen_List,
  IDC_EO_1_List            , IDT_EditRoomOpen_List,
  IDC_EO_2_List            , IDT_EditRoomOpen_List,
  IDC_EO_3_List            , IDT_EditRoomOpen_List,
  IDC_EO_C_List            , IDT_EditRoomOpen_List,
  IDC_TargetOf             , IDT_EditRoomOpen_List
};

BOOL EditRoomOpen::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_toolTips.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL EditRoomOpen::OnInitDialog() 
{
  CWnd *pWnd;
  m_toolTips.Create(this, 0);
  for (int i=0; i<sizeof(tips)/sizeof(int); i+=2)
  {
    pWnd = GetDlgItem(tips[i]);
    if (pWnd == NULL) continue;
    m_toolTips.AddTool(pWnd,tips[i+1]);
  };
  
  CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void EditRoomOpen::OnEditRoomOpenCopyItem() 
{
	// TODO: Add your command handler code here
  CLIPBOARD clipboard;
  CObjectListBox *pBox;
  int index, value;
  RN obj;
  UpdateData(true);
  pBox = m_lists[m_activeContextWindow];
  index = pBox->GetCurSel();
  if (index < 0) return; //should not happen
  value = pBox->GetItemData(index);
  obj.ConstructFromInteger(value);
  obj.CopyToClipboard(&clipboard);    
  clipboard.SendToClipboard();
}

void EditRoomOpen::OnEditRoomOpenPasteItem() 
{
	// TODO: Add your command handler code here
	CLIPBOARD clipboard;
  CLIPBOARDDATATYPE cdType;
  int objectPosition;
  UpdateData(true);
  objectPosition = m_activeContextWindow & 3;
  if (!clipboard.FetchFromClipboard())
  {
    pDoc->Sorry("There is no appropriate/ndata on the clipboard");
    return;
  };
  cdType = clipboard.GetDataType();
  switch (cdType)
  {
  case CDT_Actuator:
    {
      RN objActuator;
      DB3 *pDB3;
      char data[sizeof (DB3)];
      if (!clipboard.GetBinaryData(data,sizeof(DB3)))
      {
        pDoc->Sorry("The Actuator data on the clipboard\nappears damaged");
        return;
      };
      objActuator = pDoc->FindEmptyDB3Entry(AC_DISABLED);
      if (objActuator == RNnul)
      {
        pDoc->Sorry("Cannot allocate a new Actuator");
        return;
      };
      pDB3 = pDoc->GetRecordAddressDB3(objActuator);
      memcpy(((char *)pDB3)+2, data+2, sizeof(DB3)-2);
      objActuator.pos(objectPosition);
      pDoc->AddObjectToRoom(objActuator, m_locr);
    };
    UpdateData(false);
    break;
  default:
    pDoc->Sorry("I don't know how to paste/nthat object");
  };
}

void EditRoomOpen::OnPeekAtSource() 
{
	// TODO: Add your command handler code here
	// TODO: Add your command handler code here
  ShowLocations dlg(&m_triggerList);
  UpdateData(true);
  dlg.DoModal();
}

