// EditWeapon.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "EditWeapon.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditWeapon dialog


EditWeapon::EditWeapon(LOCATIONREL locr,
                       RN RNweapon,
                       CWnd* pParent /*=NULL*/)
	: CDialog(EditWeapon::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditWeapon)
	m_broken = FALSE;
	m_charges = 0;
	m_cursed = FALSE;
	m_important = FALSE;
	m_poisoned = FALSE;
	m_torchType = FALSE;
	//}}AFX_DATA_INIT
  m_locr = locr;
  m_RNweapon = RNweapon;
}

void EditWeapon::ExtractDataFromRecord(void)
{
  m_important  = m_pWeapon->important();
  m_cursed     = m_pWeapon->cursed();
  m_charges    = m_pWeapon->charges();
  m_weaponType = m_pWeapon->weaponType();
  m_broken     = m_pWeapon->broken();
  m_torchType  = m_pWeapon->b15();
  m_poisoned   = m_pWeapon->poisoned();
}

bool EditWeapon::EncodeDataIntoRecord(void)
{
  m_pWeapon->important(m_important?true:false);
  m_pWeapon->cursed(m_cursed?true:false);
  m_pWeapon->charges(m_charges);
  m_pWeapon->weaponType(m_weaponType);
  m_pWeapon->broken(m_broken?true:false);
  m_pWeapon->b15(m_torchType);
  m_pWeapon->poisoned(m_poisoned?true:false);
  return true;
}



void EditWeapon::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditWeapon)
	DDX_Control(pDX, IDC_WeaponType, m_objectType);
	DDX_Check(pDX, IDC_Broken, m_broken);
	DDX_Text(pDX, IDC_Charges, m_charges);
	DDX_Check(pDX, IDC_Cursed, m_cursed);
	DDX_Check(pDX, IDC_Important, m_important);
	DDX_Check(pDX, IDC_Poisoned, m_poisoned);
	DDX_Check(pDX, IDC_TorchType, m_torchType);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
    m_weaponType = m_objectType.GetItemData(m_objectType.GetCurSel());
  };
}


BEGIN_MESSAGE_MAP(EditWeapon, CDialog)
	//{{AFX_MSG_MAP(EditWeapon)
	ON_CBN_SELCHANGE(IDC_WeaponType, OnSelchangeWeaponType)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditWeapon message handlers

int DB5::Edit(LOCATIONREL locr, RN RNweapon)
{
  EditWeapon dlg(locr, RNweapon);
  dlg.m_pWeapon = this;
  return dlg.DoModal();
}

void EditWeapon::OnSelchangeWeaponType() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
  UpdateData(false);
}


BOOL EditWeapon::OnInitDialog() 
{
  int i;
  CString title;
  LOCATIONABS loca;
  ExtractDataFromRecord();
  loca = m_locr;
	CDialog::OnInitDialog();
  i = m_weaponType.FillComboBox(&m_objectType);
  m_objectType.SetCurSel(i);
  title.Format("Weapon [%04X] %02d(%02d,%02d)%d",
                  m_RNweapon.ConvertToInteger(),
                  loca.l,loca.x,loca.y,m_RNweapon.pos());
  SetWindowText(title);
  UpdateData(false);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditWeapon::OnOK() 
{
	// TODO: Add extra validation here
	
  if (!UpdateData(true)) return;
	if (!EncodeDataIntoRecord()) return;
	CDialog::OnOK();
}


BOOL EditWeapon::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CString s;
  int id;
  switch (pHelpInfo->iCtrlId)
  {
  case IDC_TorchType: id = IDH_EditWeapon_TorchType; break;
  default: id = IDH_Context_None;
  };
	s.LoadString(id);
  HelpMsg(s);
  return true;
}

