// Edit_Teleporter.cpp : implementation file
//

#include "stdafx.h"
//#include "types.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "Edit_Teleporter.h"
#include "EditTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Edit_Teleporter dialog


Edit_Teleporter::Edit_Teleporter(RN obj,
                                 LOCATIONREL locr,
                                 CWnd* pParent /*=NULL*/) 
	: CDialog(Edit_Teleporter::IDD, pParent)
{
  m_locr = locr;
  m_obj = obj;
  m_pDB1 = pDoc->GetRecordAddressDB1(obj);
	//{{AFX_DATA_INIT(Edit_Teleporter)
	m_column = 0;
	m_level = 0;
	m_row = 0;
	m_objectsOnly = -1;
	m_noTurning = -1;
	m_audible = FALSE;
	//}}AFX_DATA_INIT
}

void Edit_Teleporter::ExtractDataFromRecord(void)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  locr.l(m_pDB1->destLevel());
  locr.x(m_pDB1->destX());
  locr.y(m_pDB1->destY());
  loca = locr;
  m_level  = loca.l;
  m_column = loca.x;
  m_row    = loca.y;
  m_noTurning = 0;
  if (m_pDB1->facingMode()) m_noTurning += 4;
  m_noTurning += m_pDB1->rotation();
  m_audible = m_pDB1->audible();
  m_objectsOnly = m_pDB1->what();
  
}

void Edit_Teleporter::EncodeDataIntoRecord(void)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  loca.x = m_column;
  loca.y = m_row;
  loca.l = m_level;
  locr = loca;
	m_pDB1->destLevel(locr.l());
	m_pDB1->destX(locr.x());
	m_pDB1->destY(locr.y());
  if (m_noTurning >= 4) 
  {
    m_pDB1->rotation(m_noTurning - 4);
    m_pDB1->facingMode(true);
  }
  else
  {
    m_pDB1->rotation(m_noTurning);
    m_pDB1->facingMode(false);
  };
  m_pDB1->audible(m_audible!=0);
  m_pDB1->what(m_objectsOnly);
}


void Edit_Teleporter::DoDataExchange(CDataExchange* pDX)
{
  if (!pDX->m_bSaveAndValidate)
  {
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Edit_Teleporter)
	DDX_Text(pDX, IDC_TELEPORTER_COLUMN, m_column);
	DDV_MinMaxUInt(pDX, m_column, 0, 999);
	DDX_Text(pDX, IDC_TELEPORTER_LEVEL, m_level);
	DDV_MinMaxUInt(pDX, m_level, 0, 999);
	DDX_Text(pDX, IDC_TELEPORTER_ROW, m_row);
	DDV_MinMaxUInt(pDX, m_row, 0, 999);
	DDX_Radio(pDX, IDC_ObjectsOnly, m_objectsOnly);
	DDX_Radio(pDX, IDC_NoTurning, m_noTurning);
	DDX_Check(pDX, IDC_Audible, m_audible);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
  };
}


BEGIN_MESSAGE_MAP(Edit_Teleporter, CDialog)
	//{{AFX_MSG_MAP(Edit_Teleporter)
	ON_BN_CLICKED(IDC_Browse, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Edit_Teleporter message handlers

void Edit_Teleporter::OnOK() 
{
	// TODO: Add extra validation here
  if (UpdateData(true) == 0) return;
  EncodeDataIntoRecord();
	CDialog::OnOK();
}

void Edit_Teleporter::OnBrowse() 
{
	// TODO: Add your control notification handler code here
  LOCATIONABS loca, locaTeleporter;
  LOCATIONREL locrTarget;
  UpdateData(true);
  loca.l = m_level;
  loca.x = m_column;
  loca.y = m_row;
  locrTarget = loca;
  locaTeleporter = m_locr;
	EditTarget dlg(locrTarget,"Teleporter",locaTeleporter,true);
  if (dlg.DoModal() == IDOK)
  {
    locrTarget.l(dlg.m_locr.l());
    locrTarget.x(dlg.m_locr.x());
    locrTarget.y(dlg.m_locr.y());
    loca = locrTarget;
    m_level = loca.l;
    m_column = loca.x;
    m_row = loca.y;
    UpdateData(false);
  };
}

BOOL Edit_Teleporter::OnInitDialog() 
{
  CString title;
  LOCATIONABS loca;
  loca = m_locr;
  title.Format("Edit Teleporter [%04x] at %d(%02d,%02d)",
                m_obj.ConvertToInteger(),
                loca.l, loca.x, loca.y);
  SetWindowText(title);
	ExtractDataFromRecord();
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
