// EditingOptions.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "EditingOptions.h"
#include "CSBuildDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditingOptions dialog


EditingOptions::EditingOptions(CWnd* pParent /*=NULL*/)
	: CDialog(EditingOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditingOptions)
	m_allowIllegalStairs = FALSE;
	m_allowIllegalPits = FALSE;
	m_allowEnhancedAndOr = FALSE;
	m_allowUnimportantObjects = FALSE;
	m_allowOrphanedObjects = FALSE;
	m_allowClonedObjects = FALSE;
	m_allowObjectsOnStairs = FALSE;
	m_useDMObjectNames = FALSE;
	m_allowPewRaKath = FALSE;
	m_allowRanSkinDec = FALSE;
	//}}AFX_DATA_INIT
}

void EditingOptions::ExtractDataFromRecord(void)
{
  unsigned int editOpt;
  editOpt = pDoc->EditingOptions();
  m_allowIllegalStairs      = (editOpt & EDIT_OPT_AllowIllegalStairs) != 0;
  m_allowIllegalPits        = (editOpt & EDIT_OPT_AllowIllegalPits) != 0;
  m_allowEnhancedAndOr      = (editOpt & EDIT_OPT_AllowEnhancedAndOr) != 0;
  m_allowUnimportantObjects = (editOpt & EDIT_OPT_AllowUnimportantObjects) != 0;
  m_allowOrphanedObjects    = (editOpt & EDIT_OPT_AllowOrphanedObjects) != 0;
  m_allowClonedObjects      = (editOpt & EDIT_OPT_AllowClonedObjects) != 0;
  m_allowObjectsOnStairs    = (editOpt & EDIT_OPT_AllowObjectsOnStairs) != 0;
  m_useDMObjectNames        = (editOpt & EDIT_OPT_UseDMObjectNames) != 0;
  m_allowPewRaKath          = (editOpt & EDIT_OPT_AllowPewRaKath) != 0;
  m_allowRanSkinDec         = (editOpt & EDIT_OPT_AllowRanSkinDec) != 0;
}

void EditingOptions::EncodeDataIntoRecord(void)
{
  unsigned int editOpt;
  editOpt = 0;
  if (m_allowIllegalStairs)      editOpt |= EDIT_OPT_AllowIllegalStairs;
  if (m_allowIllegalPits)        editOpt |= EDIT_OPT_AllowIllegalPits;
  if (m_allowEnhancedAndOr)      editOpt |= EDIT_OPT_AllowEnhancedAndOr;
  if (m_allowUnimportantObjects) editOpt |= EDIT_OPT_AllowUnimportantObjects;
  if (m_allowOrphanedObjects)    editOpt |= EDIT_OPT_AllowOrphanedObjects;
  if (m_allowPewRaKath)          editOpt |= EDIT_OPT_AllowPewRaKath;
  if (m_allowClonedObjects)      editOpt |= EDIT_OPT_AllowClonedObjects;
  if (m_allowObjectsOnStairs)    editOpt |= EDIT_OPT_AllowObjectsOnStairs;
  if (m_allowRanSkinDec)         editOpt |= EDIT_OPT_AllowRanSkinDec;
  if (m_useDMObjectNames)        editOpt |= EDIT_OPT_UseDMObjectNames;
  pDoc->EditingOptions(editOpt);
}

void EditingOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditingOptions)
	DDX_Check(pDX, IDC_IllegalStairs, m_allowIllegalStairs);
	DDX_Check(pDX, IDC_IllegalPits, m_allowIllegalPits);
	DDX_Check(pDX, IDC_EnhancedAndOr, m_allowEnhancedAndOr);
	DDX_Check(pDX, IDC_UnimportantObjects, m_allowUnimportantObjects);
	DDX_Check(pDX, IDC_OrphanedObjects, m_allowOrphanedObjects);
	DDX_Check(pDX, IDC_ClonedObjects, m_allowClonedObjects);
	DDX_Check(pDX, IDC_ObjectsOnStairs, m_allowObjectsOnStairs);
	DDX_Check(pDX, IDC_DMObjectNames, m_useDMObjectNames);
	DDX_Check(pDX, IDC_PewRaKath, m_allowPewRaKath);
	DDX_Check(pDX, IDC_AllowRanSkinDec, m_allowRanSkinDec);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(EditingOptions, CDialog)
	//{{AFX_MSG_MAP(EditingOptions)
	ON_BN_CLICKED(IDC_SetDefault, OnSetDefault)
	ON_BN_CLICKED(IDC_SetExpert, OnSetExpert)
	ON_BN_CLICKED(IDC_SetSafe, OnSetSafe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditingOptions message handlers

void EditingOptions::SetAllOptions(unsigned int opt)
{
  m_allowIllegalStairs      = (opt & EDIT_OPT_AllowIllegalStairs) != 0;
  m_allowIllegalPits        = (opt & EDIT_OPT_AllowIllegalPits) != 0;
  m_allowEnhancedAndOr      = (opt & EDIT_OPT_AllowEnhancedAndOr) != 0;
  m_allowUnimportantObjects = (opt & EDIT_OPT_AllowUnimportantObjects) != 0;
  m_allowOrphanedObjects    = (opt & EDIT_OPT_AllowOrphanedObjects) != 0;
  m_allowPewRaKath          = (opt & EDIT_OPT_AllowPewRaKath) != 0;
  m_allowRanSkinDec         = (opt & EDIT_OPT_AllowRanSkinDec) != 0;
  m_allowClonedObjects      = (opt & EDIT_OPT_AllowClonedObjects) != 0;
  m_allowObjectsOnStairs    = (opt & EDIT_OPT_AllowObjectsOnStairs) != 0;
}

void EditingOptions::OnSetDefault() 
{
	// TODO: Add your control notification handler code here

  UpdateData(true);
  SetAllOptions(EDIT_OPT_DefaultOptions);
  UpdateData(false);
}

void EditingOptions::OnSetExpert() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(true);
  SetAllOptions(EDIT_OPT_ExpertOptions);
  UpdateData(false);
}

void EditingOptions::OnSetSafe() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(true);
  SetAllOptions(EDIT_OPT_SafeOptions);
  UpdateData(false);
}

BOOL EditingOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  ExtractDataFromRecord();
  UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditingOptions::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(true);
  EncodeDataIntoRecord();
	CDialog::OnOK();
}
