#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "WarningDialog.h"
#include "Misc.h"

static void Search(CHKERRMSG *pcem, RN obj, LOCATIONREL locr)
{
  DB4 *pDB4;
  DB7 *pDB7;
  DB9 *pDB9;
  for (;obj!=RNeof; obj=pDoc->GetDBRecordLink(obj))
  {
    DBTYPE dbType;
    dbType = obj.dbType();
    switch (dbType)
    {
    case dbCLOTHING:
    case dbPOTION:
    case dbDOOR:
    case dbWEAPON:
    case dbMISC:
    case dbACTUATOR:
    case dbTELEPORTER:
      break;  //ignore...no links
    case dbMONSTER:
      pDB4 = pDoc->GetRecordAddressDB4(obj);
      Search(pcem, pDB4->possession(), locr);
      break;
    case dbSCROLL:
      pDB7 = pDoc->GetRecordAddressDB7(obj);
      Search(pcem, pDB7->text(), locr);
      break;
    case dbCHEST:
      pDB9 = pDoc->GetRecordAddressDB9(obj);
      Search(pcem, pDB9->contents(), locr);
      break;
    case dbTEXT:
      if (obj.dbIndex() == pcem->Index1())
      {
        pcem->NewLocation(locr);
      };
      break;
    default: NotImplemented();
    };
  };
}

bool FixSharedText(CHKERRMSG *pcem)
{
  CHKERRMSG *thispcem;
  CHKERRMSG result;
  WarningDialog dlg;
  CString line;
  DB2 *pDB2;
  LOCATIONREL locr;
  int len;
  int textIndex;
  char text[1000];
  pDB2 = pDoc->GetRecordAddressDB2(pcem->Index1());
  textIndex = pDB2->index();
  len = pDoc->ExpandText(text+1,pDB2,TEXTTYPE_MIRROR,998);
  result.NewError(CString(text,len));
  result.NewError(CString(" "));
  dlg.m_chkErrMsg = &result;
  dlg.m_title = "Shared Compressed Text";

  for (thispcem=pcem; thispcem!=NULL; thispcem=thispcem->Next())
  {
    pDB2 = pDoc->GetRecordAddressDB2(thispcem->Index1());
    if (pDB2->index() != textIndex) break;
    //Now attempt to find where this dbTEXT
    //record is referenced in the dungeon.
    locr.l(-1);
    result.Location(locr);
    for (locr.First(); locr.l()>=0; locr.Next())
    {
      Search(thispcem, pDoc->FindFirstObject(locr), locr);
    };
    line.Format("(%05d) @ %s",
                thispcem->Index1(),
                thispcem->Location().Format());
    result.NewError(line);
    if (pcem != thispcem)
    {
      result.ErrorType(CEMT_SINGLESHAREDTEXT);
    };
    result.Index1(thispcem->Index1());
  };
  dlg.DoModal();
  return false;
}

bool FixClonedIndirectTextEntry(CHKERRMSG *pcem)
{
  CHKERRMSG *thispcem;
  CString line;
  DB2 *pDB2;
  ui16 *pText;
  int k, numParent;
  LOCATIONREL locr;
  int len;
  int textIndex;
  pDB2 = pDoc->GetRecordAddressDB2(pcem->Index2());
  textIndex = pDB2->index();
  numParent = 0;
  for (thispcem=pcem->Next(); 
       (thispcem != NULL) && (thispcem->ErrorType() 
                     == CEMT_CLONEDINDIRECTTEXTINDEXPARENT) ;  
       thispcem=thispcem->Next())
  {
         numParent++;
  };
  for (k = 0, thispcem = pcem->Next();
       k < numParent-1;
       k++, thispcem = thispcem->Next())
  {
    //Make a new indirect Text entry for this dbTEXT record
    pDB2 = pDoc->GetRecordAddressDB2(thispcem->Index1());
    pText = pDoc->FindRawText(pDB2->index());
    len = pDoc->ComputeTextLength(pText);
    pDB2->index(pDoc->AddText(pText, len));
  };
  return numParent > 1;
}