#include "stdafx.h"
//#include "types.h"
#include "misc.h"
#include "CSBuildDoc.h"
#include "CSBuildView.h"
#include "Actuator.h"
#include "Clones.h"

extern CCSBuildView *pMainView;

RN CCSBuildDoc::MakeMoreRoomInDB(DBTYPE dbType)
{ //(RN)
  //Oh, dear.  We have run out of space in one of
  //the databases.  What do we do now?  The standard Atari
  //version proceeds to discard objects, first from levels
  //the party does not currently occupy and, as a last
  //resort, from the party's level.
  //
  //The databases have rather arbitary size limits.  Perhaps
  //we can simply make the thing larger.  If it is possible
  //to enlarge the database then we will check to see if that
  //is what the player wants to do.
  //
  // The above comments are from the game's runtime engine.
  // Here we will simply enlarge the database unconditionally.
  RN  rnD5;
  rnD5 = db.Enlarge(dbType); //If possible and player agrees.
  return (rnD5);
}

/*
RN CCSBuildDoc::FindEmptyDBEntry(DBTYPE dbType)
{
  switch (dbType)
  {
  case dbTELEPORTER: return db.FindEmptyDBEntry(dbTELEPORTER);
  case dbDOOR: return db.FindEmptyDBEntry(dbDOOR);
  case dbTEXT: return db.FindEmptyDBEntry(dbTEXT);
  case dbACTUATOR: return db.FindEmptyDBEntry(dbACTUATOR);
  case dbMONSTER: return db.FindEmptyDBEntry(dbMONSTER);
  case dbWEAPON: return db.FindEmptyDBEntry(dbWEAPON);
  case dbCLOTHING: return db.FindEmptyDBEntry(dbCLOTHING);
  case dbSCROLL: return db.FindEmptyDBEntry(dbSCROLL);
  case dbPOTION: return db.FindEmptyDBEntry(dbPOTION);
  case dbCHEST: return db.FindEmptyDBEntry(dbCHEST);
  case dbMISC: return db.FindEmptyDBEntry(dbMISC);
  };
  return RNnul;
}
*/
RN CCSBuildDoc::FindEmptyDB0Entry()
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbDOOR);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB0(result)->Clear();
  return result;
}

RN CCSBuildDoc::FindEmptyDB1Entry()
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbTELEPORTER);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB1(result)->Clear();
  return result;
}

RN CCSBuildDoc::FindEmptyDB2Entry(TEXTTYPE tt, bool assignText)
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbTEXT);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB2(result)->Clear();
  if (!assignText) return result;
  pDoc->SetText(result, "abc", tt);
  return result;
}

RN CCSBuildDoc::FindEmptyDB3Entry(ACTUATORCLASS ac)
{//(RN)
  RN result;
  DB3 *address;
  result = db.FindEmptyDBEntry(dbACTUATOR);
  if (result == RNnul) return result;
  address = GetRecordAddressDB3(result);
  switch (ac)
  {
  case AC_DSA:
    ((ACTUATOR_DSA *)address)->Clear();
    break;
  case AC_PORTRAIT:
    ((ACTUATOR_Portrait *)address)->Clear();
    break;
  case AC_PRESSUREPAD:
    ((ACTUATOR_PressurePad *)address)->Clear();
    break;
  case AC_MONSTERGENERATOR:
    ((ACTUATOR_MonsterGenerator *)address)->Clear();
    break;
  case AC_PUSHBUTTON:
    ((ACTUATOR_PushButton *)address)->Clear();
    break;
  case AC_ANDOR:
    ((ACTUATOR_AndOr *)address)->Clear();
    break;
  case AC_COUNTER:
    ((ACTUATOR_Counter *)address)->Clear();
    break;
  case AC_ENDGAME:
    ((ACTUATOR_EndGame *)address)->Clear();
    break;
  case AC_LAUNCHER:
    ((ACTUATOR_Launcher *)address)->Clear();
    break;
  case AC_OBJECTHOLDER:   //Torch Holder, eg.
    ((ACTUATOR_ObjectHolder *)address)->Clear();
    break;
  case AC_SWAPOBJECT:      //Swap ZoKathRa for Firestaff, eg.
    ((ACTUATOR_SwapObject *)address)->Clear();
    break;
  case AC_DISABLED:
    ((ACTUATOR_Disabled *)address)->Clear();
    break;
  default:
    NotImplemented();
    break;
  };
  return result;
}

RN CCSBuildDoc::FindEmptyDB4Entry(MONSTERTYPE mt)
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbMONSTER);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB4(result)->Clear();
  if (mt.IsValid())
  {
    pDoc->GetRecordAddressDB4(result)->monsterType(mt);
  };
  return result;
}

RN CCSBuildDoc::FindEmptyDB5Entry(WEAPONTYPE wt)
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbWEAPON);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB5(result)->Clear();
  if (wt.IsValid()) pDoc->GetRecordAddressDB5(result)->weaponType(wt);
  return result;
}

RN CCSBuildDoc::FindEmptyDB6Entry(CLOTHINGTYPE clothingType)
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbCLOTHING);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB6(result)->Clear();
  if (clothingType.IsValid())
  {
    pDoc->GetRecordAddressDB6(result)->clothingType(clothingType);
  };
  return result;
}

RN CCSBuildDoc::FindEmptyDB7Entry()
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbSCROLL);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB7(result)->Clear();
  return result;
}


RN CCSBuildDoc::FindEmptyDB8Entry(POTIONTYPE potionType)
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbPOTION);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB8(result)->Clear();
  if (potionType.IsValid())
  {
    pDoc->GetRecordAddressDB8(result)->potionType(potionType);
  };
  return result;
}


RN CCSBuildDoc::FindEmptyDB9Entry()
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbCHEST);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB9(result)->Clear();
  return result;
}

RN CCSBuildDoc::FindEmptyDB10Entry(MISCTYPE miscType)
{//(RN)
  RN result;
  result = db.FindEmptyDBEntry(dbMISC);
  if (result == RNnul) return result;
  pDoc->GetRecordAddressDB10(result)->Clear();
  if (miscType.IsValid()) 
  {
    pDoc->GetRecordAddressDB10(result)->miscType(miscType);
  };
  return result;
}


void CCSBuildDoc::SetCellFlag(int level, int x, int y, CELLFLAG cf)
{
  bool legalX, legalY, legalLevel;
  CELLFLAG *pcf;
  legalLevel = true;
  if (level < 0) legalLevel = false;
  if (level >= pDoc->NumLevel()) legalLevel = false;
  legalY = (y>=0) && (y<=LastRow(level));
  legalX = (x>=0) && (x<=LastColumn(level));
  if (legalX && legalY && legalLevel)
  {
    pcf = &m_pppdPointer10450[level][x][y];
    if (*pcf == cf) return;
    *pcf = cf;
    SetModifiedFlag();
  }
  else
  {
    InternalError("Setting Cellflag outside level");
  };
}

void CCSBuildDoc::SetCellFlag(LOCATIONREL locr, CELLFLAG cf)
{
  SetCellFlag(locr.l(), locr.x(), locr.y(), cf);
}

void CCSBuildDoc::SetCellFlag(LOCATIONABS *loca, CELLFLAG cf)
{
  LOCATIONREL locr;
  locr = *loca;
  SetCellFlag(locr, cf);
}



CELLFLAG CCSBuildDoc::GetCellFlag(int level, int x, int y)
{
  ROOMTYPE rtD4, rtD5;
  //D7W = P1;
  //D6W = P2;
  bool legalX, legalY;
  if (level < 0) return roomILLEGAL;
  if (level >= pDoc->NumLevel()) return roomILLEGAL;
  legalY = (y>=0) && (y<=LastRow(level));
  legalX = (x>=0) && (x<=LastColumn(level));
  if (legalX && legalY)
  {
    return m_pppdPointer10450[level][x][y];
  }
  else
  {
    if (legalY)
    { // Then figure out what to do about illegal x.
      if (x == -1)
      {
        rtD4 = RoomType(m_pppdPointer10450[level][0][y]);
        if (rtD4 == roomOPEN) return 4; // Stone...4 = east side something??
        if (rtD4 == roomPIT) return 4;
        return (CELLFLAG)(roomILLEGAL<<5);
      };
      if (x == LastColumn(level) + 1)
      {
        rtD4 = RoomType(m_pppdPointer10450[level][LastColumn(level)][y]);
        if (rtD4 == roomOPEN) return roomSTONE; // Stone...1=west side something??
        if (rtD4 == roomPIT) return roomSTONE;
        return (CELLFLAG)(roomILLEGAL<<5);
      };
      return (CELLFLAG)(roomILLEGAL<<5);
    };
    if (legalX)
    {
      // What to do if Y is illegal
      if (y == -1)
      {
        rtD5 = RoomType(m_pppdPointer10450[level][x][0]);
        if (rtD5 == roomOPEN) return 2;//Stone...South side something??
        if (rtD5 == roomPIT) return 2;
        return (CELLFLAG)(roomILLEGAL<<5);
      };
      if (y == LastRow(level) + 1)
      {
        rtD5 = RoomType(m_pppdPointer10450[level][x][y-1]);
        if (rtD5 == roomOPEN) return 8;
        if (rtD5 == roomPIT) return 8;
        return (CELLFLAG)(roomILLEGAL<<5);
      };
      return (CELLFLAG)(roomILLEGAL<<5);
    };
    return (CELLFLAG)(roomILLEGAL<<5); // Both x and y illegal.
  };
}

CELLFLAG CCSBuildDoc::GetCellFlag(LOCATIONREL locr)
{
  return GetCellFlag(locr.l(), locr.x(), locr.y());
}

CELLFLAG CCSBuildDoc::GetCellFlag(LOCATIONABS *loca)
{
  LOCATIONREL locr;
  locr = *loca;
  return GetCellFlag(locr);
}

bool CCSBuildDoc::GetExtendedCellFlag(LOCATIONREL locr, int bit)
{
  ui32 *pRecord;
  int size;
  size = expool.Locate((
        EDT_ExtendedCellFlags<<24)+(locr.l()<<5)+locr.x(),
        &pRecord);
  if (size < 8) return false;
  return (pRecord[bit] & (1 << locr.y())) != 0;
}

void CCSBuildDoc::SetExtendedCellFlag(LOCATIONREL locr,
                                      int bit,
                                      bool b)
{
  ui32 key, *pRecord;
  int size;
  key = (EDT_ExtendedCellFlags<<24)+(locr.l()<<5)+locr.x();
  size = expool.Locate(key, &pRecord);
  if (size <= 0)
  {
    if (b)
    {
      ui32 record[8];
      memset(record,0,32);
      record[bit] |= 1<<locr.y();
      expool.Write(key, record, 8);
      MODIFY
    };
    return;
  };
  if (size < 8) return;
  if (b)
  {
    if ((pRecord[bit] & (1<<locr.y())) == 0)
    {
      pRecord[bit] ^= 1<<locr.y();
      MODIFY;
    };
  }
  else
  {
    if ((pRecord[bit] & (1<<locr.y())) != 0)
    {
      pRecord[bit] ^= 1<<locr.y();
      MODIFY;
    };
  };
}

ui8 CCSBuildDoc::DefaultSkin(i32 level)
{
  return skinCache.GetDefaultSkin(level);
}

void CCSBuildDoc::DefaultSkin(i32 level, i32 skinNum)
{
  skinCache.SetDefaultSkin(level, (ui8)skinNum);
}

void CCSBuildDoc::SetRoomType(LOCATIONREL locr, ROOMTYPE rt)
{
  bool legalX, legalY;
  ROOMTYPE oldrt;
  RN RNDoor, RNTeleporter, newRNDoor , next, newRNTeleporter;
  CELLFLAG cf;
  DB1 *pDB1;
  legalY = (locr.y()>=0) && (locr.y()<=LastRow(locr.l()));
  legalX = (locr.x()>=0) && (locr.x()<=LastColumn(locr.l()));
  if ( !legalX || !legalY )
  {
    InternalError("Attempt to change non-existent cell");
    return;
  };
  oldrt = RoomType(GetCellFlag(locr));
  if (oldrt==roomDOOR) 
  {
    RNDoor = pDoc->FindFirstDoor(locr);
    if (RNDoor == RNeof)
    {
      InternalError("Cannot find old Door DB entry");
    }
    else
    {
      RemoveObjectFromRoom(locr, RNDoor, true, true); //Release the DB entry
    };
  }
  else if (oldrt == roomTELEPORTER)
  {
    RNTeleporter = FindFirstTeleporter(locr);
    if (RNTeleporter == RNeof)
    {
      InternalError("Cannot find old Teleporter DB entry");
    };
    while (RNTeleporter != RNeof)
    {
      next = pDoc->GetDBRecordLink(RNTeleporter);
      RemoveObjectFromRoom(locr, RNTeleporter, true, true);//Release the DB entry
      for (RNTeleporter=next; 
           (RNTeleporter!=RNeof)&&(RNTeleporter.dbType()!=dbTELEPORTER);
           RNTeleporter = pDoc->GetDBRecordLink(RNTeleporter));
    };
  };
  if (rt == roomDOOR)
  {
    newRNDoor = FindEmptyDB0Entry();
    if (newRNDoor == RNnul)
    {
      Sorry("Cannot Allocate Door Record");
      return;
    };
    locr.p(0);
    AddObjectToRoom(newRNDoor, locr);
  };

  if (rt == roomTELEPORTER)
  {
    newRNTeleporter = pDoc->FindEmptyDB1Entry();
    if (newRNTeleporter == RNnul)
    {
      Sorry("Cannot Allocate Teleporter Record");
      return;
    };
    pDB1 = pDoc->GetRecordAddressDB1(newRNTeleporter);
    pDB1->dest(locr);
    locr.p(0);
    AddObjectToRoom(newRNTeleporter, locr);
  };

  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  cf = (CELLFLAG)(cf & 0x1f);
  if ((rt == roomBLOCKING) || (rt == roomNONBLOCKING)) rt = (ROOMTYPE)6;
  cf = (CELLFLAG)(cf | (rt<<5));
  m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
  SetModifiedFlag();
}

void CCSBuildDoc::SetStairsUp(LOCATIONREL locr, bool up)
{
  int d;
  CELLFLAG cf;
  if (RoomType(GetCellFlag(locr)) != roomSTAIRS)
  {
    InternalError("Illegal attempt to set stairs up/down");
    return;
  };
  d = up ? 4 : 0;
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((cf & 4) != d)
  {
    cf = (CELLFLAG)(cf ^ 4);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SetStairsDirection(LOCATIONREL locr, int dir)
{
  int d;
  CELLFLAG cf;
  if (RoomType(GetCellFlag(locr)) != roomSTAIRS)
  {
    InternalError("Illegal attempt to set stair direction");
    return;
  };
  d = dir&1 ? 0 : 8;
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((cf & 8) != d)
  {
    cf = (CELLFLAG)(cf ^ 8);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SetFalseWallVisible(LOCATIONREL locr, bool visible)
{
  int d;
  CELLFLAG cf;
  //if (RoomType(GetCellFlag(locr)) != roomFALSEWALL)
  if (    (RoomType(GetCellFlag(locr)) != roomBLOCKING)
       && (RoomType(GetCellFlag(locr)) != roomNONBLOCKING) )
  {
    InternalError("Illegal attempt to set false wall visible");
    return;
  };
  d = visible ? 4 : 0;
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((cf & 4) != d)
  {
    cf = (CELLFLAG)(cf ^ 4);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SetFalseWallOpen(LOCATIONREL locr, bool open)
{
  int d;
  CELLFLAG cf;
  if (    (RoomType(GetCellFlag(locr)) != roomBLOCKING)
       && (RoomType(GetCellFlag(locr)) != roomNONBLOCKING) )
  {
    InternalError("Illegal attempt to set false wall open");
    return;
  };
  d = open ? 1 : 0;
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((cf & 1) != d)
  {
    cf = (CELLFLAG)(cf ^ 1);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SetDoorNS(LOCATIONREL locr, bool NS)
{
  int d;
  CELLFLAG cf;
  if (RoomType(GetCellFlag(locr)) != roomDOOR)
  {
    InternalError("Illegal attempt to set door direction");
    return;
  };
  d = NS ? 8 : 0;
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((cf & 8) != d)
  {
    cf = (CELLFLAG)(cf ^ 8);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SetTeleporterActive(LOCATIONREL locr, bool active)
{
  int d;
  CELLFLAG cf;
  if (RoomType(GetCellFlag(locr)) != roomTELEPORTER)
  {
    InternalError("Illegal attempt to set teleporter active");
    return;
  };
  d = active ? 8 : 0;
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((cf & 8) != d)
  {
    cf = (CELLFLAG)(cf ^ 8);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SetDoorState(LOCATIONREL locr, unsigned int s)
{
  CELLFLAG cf;
  if ((s > 7) || (RoomType(GetCellFlag(locr)) != roomDOOR))
  {
    InternalError("Illegal attempt to set door direction");
    return;
  };
  cf = m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if ((unsigned)(cf & 7) != s)
  {
    cf = (CELLFLAG)((cf & 0xf8) | s);
    m_pppdPointer10450[locr.l()][locr.x()][locr.y()] = cf;
    SetModifiedFlag();
  };
}



RN CCSBuildDoc::FindFirstActuator(int level, int x, int y)
{
  RN obj;
  for (obj=FindFirstObject(level,x,y); 
       obj!=RNeof; 
       obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbACTUATOR) return obj;
  };
  return RNeof;
}

RN CCSBuildDoc::FindFirstActuator(const LOCATIONREL locr)
{
  return FindFirstActuator(locr.l(), locr.x(), locr.y());
}

RN CCSBuildDoc::FindNextActuator(RN obj)
{
  for (obj=GetDBRecordLink(obj); obj!=RNeof; obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbACTUATOR) return obj;
  };
  return obj;
}


RN CCSBuildDoc::FindFirstMonster(const LOCATIONREL locr)
{
  RN obj;
  for (obj=FindFirstObject(locr); 
       obj!=RNeof; 
       obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbMONSTER) return obj;
  };
  return RNeof;
}

RN CCSBuildDoc::FindNextMonster(RN obj)
{
  for (obj=GetDBRecordLink(obj); obj!=RNeof; obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbMONSTER) return obj;
  };
  return obj;
}


RN CCSBuildDoc::FindNextTeleporter(
                     const LOCATIONREL dest, LOCATIONABS *src)
{
  DB1 *pDB1;
  RN obj;
  while (src->Next())
  {
    if (RoomType(GetCellFlag(src)) != roomTELEPORTER) continue;
    obj = FindFirstTeleporter(src);
    if (obj == RNeof) continue;
    pDB1 = GetRecordAddressDB1(obj);
    if (pDB1->destX() != dest.x()) continue;
    if (pDB1->destY() != dest.y()) continue;
    if (pDB1->destLevel() != dest.l()) continue;
    return obj;
  };
  return RNeof;
}

RN CCSBuildDoc::FindFirstTeleporter(int level, int x, int y)
{
  RN obj;
  for (obj=FindFirstObject(level,x,y); 
       obj!=RNeof; 
       obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbTELEPORTER) return obj;
  };
  return obj;
}

RN CCSBuildDoc::FindFirstDoor(int level, int x, int y)
{
  RN obj;
  for (obj=FindFirstObject(level,x,y); 
       obj!=RNeof; 
       obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbDOOR) return obj;
  };
  return obj;
}

RN CCSBuildDoc::FindFirstDoor(LOCATIONREL locr)
{
  return FindFirstDoor(locr.l(), locr.x(), locr.y());
}


RN CCSBuildDoc::FindFirstTextRecord(const LOCATIONREL locr) const
{
  RN obj;
  for (obj=FindFirstObject(locr); 
       obj!=RNeof; 
       obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbTEXT) return obj;
  };
  return obj;
}

RN CCSBuildDoc::FindNextTextRecord(RN obj)
{
  for (obj=GetDBRecordLink(obj); obj!=RNeof; obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbTEXT) return obj;
  };
  return obj;
}


RN CCSBuildDoc::FindFirstTeleporter(LOCATIONREL locr)
{
  return FindFirstTeleporter(locr.l(), locr.x(), locr.y());
}


RN CCSBuildDoc::FindFirstTeleporter(LOCATIONABS *loca)
{
  LOCATIONREL locr;
  locr = *loca;
  return FindFirstTeleporter(locr);
}

RN CCSBuildDoc::FindNextTeleporter(RN obj)
{
  for (obj=GetDBRecordLink(obj); obj!=RNeof; obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() == dbTELEPORTER) return obj;
  };
  return obj;
}

int CCSBuildDoc::GetObjectListIndex(LOCATIONREL locr)
{ // Return -1 if illegal location
  int D0, i, index, levIndex;
  CELLFLAG *pColumn;
  pColumn = m_pppdPointer10450[locr.l()][locr.x()];
  if (locr.x() < 0) return -1;
  if (locr.x() > LastColumn(locr.l())) return -1;
  if (locr.y() < 0) return -1;
  if (locr.y() > LastRow(locr.l())) return -1;
  D0 = pColumn[locr.y()] & 16;
  if (D0 == 0) return -1; // Nothing here!
  levIndex = m_objectLevelIndex[locr.l()];
  index = m_objectColumnIndex[levIndex + locr.x()];
  for (i=0; i<locr.y(); i++)
  {
    if (pColumn[i] & 16) index++;
  };
  return index;
}


void CCSBuildDoc::RemoveObjectFromRoom(LOCATIONREL locr,  
                                       RN obj,
                                       bool Release,
                                       bool clearFwdLink)
{
  CLONES clones(NULL);
  // ***************************************************
  // 
  //  BEWARE -- Possessions, contents, timers, text, etc 
  //            are not removed unless the object is
  //            deleted (Release == true);
  //
  //****************************************************
  DBCOMMON *dbA3=NULL;
  RN objD4, objD7, curObj, nextObj;
  int objectListIndex;
  int totalColumnPointers, columnIndex, remainingColumnPointers;
  int maxOccupiedCells, remainingCells;
  RN *prnA2;
  ui16 *puwA2;
  CELLFLAG *pdA0;
  clones.MarkDungeonObjects();
  if (clones.IsObjectCloned(obj.dbType(),obj.dbIndex()))
  {
    if (AreYouSure("We are attempting to delete a cloned obect\n"
                   "from a dungeon cell.  That could be dangerous\n"
                   "Are you sure you want to do this?") == IDNO)
    {
      return;
    };
  };
  objD7 = obj;
  if (objD7 == RNeof) return;
  SetModifiedFlag();

  dbA3 = GetCommonAddress(objD7);
  ASSERT(dbA3->link() != RNnul);
  objectListIndex = GetObjectListIndex(locr);
  if (objectListIndex < 0)
  {
    Strange("Attempt to remove object from non-existent room");
    return;
  };
  prnA2 = &m_objectList[objectListIndex];
  ASSERT(prnA2->ConvertToInteger() != 0xbadd);
  // If specified object has no forward link
  //  and first object in room is the specified object
  //   then remove the entire room from
  if ((dbA3->link() == RNeof) && prnA2->IsSameObjectAs(objD7) )
  {
    //pdA0 = d.LevelCellFlags[mapX];
    pdA0 = m_pppdPointer10450[locr.l()][locr.x()];
    ASSERT((pdA0[locr.y()] & 0x10)!=0);
    pdA0[locr.y()] &= 0xef; // clear 'room has object'
    //pwA0 = m_dungeonDatIndex;
    maxOccupiedCells = m_dungeonDatIndex->ObjectListLength(); 
           //Total number of cells containing objects
    remainingCells = maxOccupiedCells - objectListIndex - 1;
    memcpy(prnA2, prnA2+1, 2*remainingCells);
    m_objectList[maxOccupiedCells-1] = RN(RNnul); // clear last entry
    //Now we need to fix the column indexes.
    //puwA2 = &m_pwPointer10420[mapX+1];
    puwA2 = &m_objectColumnIndex[m_objectLevelIndex[locr.l()]]+locr.x()+1;
    // Each column after the current column must
    // have its index decremented.  This includes
    // all the columns in higher numbered levels.
    totalColumnPointers = m_numColumnPointers; // for all levels
    columnIndex = m_objectLevelIndex[locr.l()];
    // columnIndex=index of first DUDAD for this level.
    columnIndex = columnIndex + locr.x();
    //columnIndex=index of DUDAD for this column
    remainingColumnPointers = totalColumnPointers - columnIndex;
    remainingColumnPointers--; 
            //#columns following this column in
            // this and following levels.
    while ((remainingColumnPointers--) != 0) (*(puwA2++))--;
    dbA3->link(RNeof);
    if (Release) objD7.Delete(&locr);
    return;
  };
  if (prnA2->IsSameObjectAs(objD7))
  { //If first on the list
    *prnA2 = dbA3->link();
    if (clearFwdLink) dbA3->link(RNeof);
    if (Release) objD7.Delete(&locr);
    return;
  }
  curObj = *prnA2;  //curObject initially the first on list
  nextObj = GetDBRecordLink(curObj);
  while (!nextObj.IsSameObjectAs(objD7))
  {
    if ((nextObj == RNeof) || (nextObj == RNnul))
    {
      InternalError("Deleted object not in list");
      dbA3->link(RNeof);  //This should not happen
      return;
    };

    curObj = nextObj;
    nextObj = GetDBRecordLink(nextObj);
  };
  dbA3 = GetCommonAddress(curObj);
  ASSERT(GetDBRecordLink(nextObj) != RNnul);
  dbA3->link(GetDBRecordLink(nextObj));
  dbA3 = GetCommonAddress(objD7);
  if (clearFwdLink) dbA3->link(RNeof);
  if (Release) objD7.Delete(&locr);
}


void CCSBuildDoc::AddObjectToRoom(RN newObj, LOCATIONREL locr)
{
  RN objD5;
  RN prevObj;
  CELLFLAG *cfA2;
  RN *prnA3;
  ui16 *puwA3;
  int objectIndex;
  int totalColumnPointers;
  int columnIndex;
  int remainingColumnPointers;
  int maxOccupiedCells;
  int remainingCells;
  int newSize;
  i32 j;
  DBCOMMON *newObjAddr;
  DBCOMMON *prevObjAddr;

  if (newObj == RNeof) return;
  newObj.pos(locr.p());
  newObjAddr = GetCommonAddress(newObj);
  newObjAddr->link(RNeof); // Clear forward link
  //pdA0 = d.ppdPointer10424[mapX];
    ////pdA0 = m_pppdPointer10450[locr->l][locr->x];
  //cfA2 = &d.LevelCellFlags[mapX][mapY];
  cfA2 = &m_pppdPointer10450[locr.l()][locr.x()][locr.y()];
  if (*cfA2 & 0x10) 
  { // Something in this room already
    // Add after prevObj???
    prevObj=FindFirstObject(locr);
    if (prevObj == RNeof)
    { //This should not happen.  Someone put an empty list
      // in a cell.  We will simply replace it.
      objectIndex = GetObjectListIndex(locr);
      newObjAddr->link(RNeof);
      m_objectList[objectIndex] = newObj;
      SetModifiedFlag();
      return;
    };
    objD5 = GetDBRecordLink(prevObj);
    switch(newObj.dbType())
    {
    case dbACTUATOR:
      if (prevObj.dbType() != dbACTUATOR)
      { //We have to put this object in the
        //front of the list.
        objD5 = prevObj;
        prevObj = RNnul;
      }
      else
      {
        while (objD5 != RNeof)
        { //Find last actuator
          if (objD5.dbType() != dbACTUATOR) break;
          prevObj = objD5;
          objD5 = GetDBRecordLink(objD5);
        };
      };
      if (prevObj == RNnul)
      { //Put at front
        objectIndex = GetObjectListIndex(locr);
        ASSERT(m_objectList[objectIndex].IsSameObjectAs(objD5));
        newObjAddr->link(objD5);
        m_objectList[objectIndex] = newObj;
      }
      else
      { //put between prevObj and objD5
        newObjAddr->link(objD5);
        GetCommonAddress(prevObj)->link(newObj);
      };
      break;
    default:  //Put at end of list
      while (objD5 != RNeof)
      { // Find end of list
        prevObj = objD5;
        objD5 = GetDBRecordLink(objD5);
      };
      prevObjAddr = GetCommonAddress(prevObj);
      ASSERT(newObj != RNnul);
      prevObjAddr->link(newObj);
      ASSERT(FindFirstObject(locr) != RNnul);
      ASSERT(GetCommonAddress(newObj)->link() != RNnul);
    };
  }
  else
  {
    *cfA2 |= 0x10;
    //puwA3 = &m_pwPointer10420[mapX+1];
    puwA3 = &m_objectColumnIndex[m_objectLevelIndex[locr.l()]]+locr.x()+1;
    // puwA3 points one column beyond the end of this column.
    totalColumnPointers = m_numColumnPointers;
    columnIndex = m_objectLevelIndex[locr.l()] + locr.x(); 
    remainingColumnPointers = totalColumnPointers - columnIndex;
    remainingColumnPointers--;
    while ((remainingColumnPointers--) != 0) (*(puwA3++))++;
    j = 0;
    cfA2 -= locr.y();

    ////puwA2 = &m_pwPointer10420[mapX+1];
    ////puwA2 = &m_pwPointer10454[m_puwPointer10458[locr->l]]+locr->x+1;
    
    //D4W = d.pwPointer10420[mapX];
    objectIndex = m_objectColumnIndex[m_objectLevelIndex[locr.l()]+locr.x()];
    while ((j++) != locr.y())
    {
      if (*(cfA2++) & 0x10) objectIndex++;
    };
    newSize = 1 + m_dungeonDatIndex->ObjectListLength();
    m_objectList = (RN *)realloc(m_objectList, 2*newSize, MALLOC038);
    if(m_objectList==NULL)
    {
      DIE("Cannot allocate memory");
    };
    m_dungeonDatIndex->ObjectListLength((ui16)newSize);
    maxOccupiedCells = m_dungeonDatIndex->ObjectListLength();
    remainingCells = maxOccupiedCells - objectIndex - 1;
    prnA3 = &m_objectList[objectIndex];
    memmove(prnA3+1, prnA3, 2*remainingCells);
    *prnA3 = newObj;
    ASSERT(FindFirstObject(locr)!=RNnul);
    ASSERT(GetCommonAddress(newObj)->link() != RNnul);
  };
  SetModifiedFlag();
}


void CCSBuildDoc::ReplaceRoomObjectList(
                           LOCATIONREL locr,  
                           RN obj)
{
  // ***************************************************
  // 
  // Whatever the room used to point to is simply orphaned
  // and the room is set to contain obj and any of its
  // descendents.
  // BEWARE -- This is used to 'repair' clones and is not
  //           much good for anything else.  You better 
  //           know what you are doing.
  // ALSO BEWARE -- The room cannot be empty....we only
  //           how to change the first pointer.  We cannot
  //           add any object to an empty room.
  //
  //****************************************************
  DBCOMMON *pCommon;
  int objectListIndex;
  objectListIndex = GetObjectListIndex(locr);
  if (objectListIndex < 0)
  {
    Strange("Attempt to replace list from non-existent room");
    return;
  };
  if (FindFirstObject(locr) == RNeof)
  {
    Strange("Attempt to replace objects in empty room");
    return;
  };
  pCommon = GetCommonAddress(obj);
  if (   m_objectList[objectListIndex].ConvertToInteger()
      != obj.ConvertToInteger())
  {
    m_objectList[objectListIndex] = obj;
    SetModifiedFlag();
  };
}



void CCSBuildDoc::Delete(RN object, int password)
{ //Delete indirectIndex and DBentry
  //*************************************************
  //
  // BEWARE -- Attachmments (text, possessions, etc)
  //           are not deleted!!
  //           The password is required so that you will
  //           be a trusted agent.  You must guarantee that
  //           you have cleaned the object of:
  //            -contents
  //            -possessions
  //            -text
  //            -movement timers
  //            -reactivation timers
  //            -and whatever else
  //           You shoulod also have checked that the 
  //           object is not cloned.
  //*************************************************
  DBCOMMON *pCommon;
  LOCATIONREL locr;

  if (password != 0x12abc)
  {
    InternalError("Illegal object deletion password");
  };
  //We really need to search the dungeon to make sure
  //that this object is not still referenced somewhere.
  //This can happen if the object is cloned or if someone
  //has made a mistake.  If it is still referenced then
  //ask the user what we should do.
  {
    CLONES clones(NULL);
    clones.Clear();
    clones.MarkDungeonObjects();
    if (clones.IsObjectReferenced(object.dbType(),object.dbIndex()))
    {
      CString msg;
      msg.Format("We have been asked to delete an object from\n"
                 "the database.  But it is still being referenced.\n"
                 "We recommend that you answer\n"
                 "'No' to keep the object in the database to\n"
                 "satisfy that reference.  The worst that can happen\n"
                 "from this action is that an orphaned object will\n"
                 "be created.\n\n"
                 "Should we delete the database entry?");
      if (AreYouSure((LPCSTR)msg) == IDNO) return;
    };
  };
  pCommon = GetCommonAddress(object);
  ASSERT(pCommon->link() == RNeof);
  if (pCommon->link() == RNeof) pCommon->link(RNnul);
  if (object.IsDBIndexOK())
  {
    m_dataIndexMap[object.ConvertToInteger()] = RNnul;
  };
}

char *ASCIIWords[32] = {"x","y","THE ","YOU ","z","{","|","}","~"};
char BCDWords[32][8] =
{
  {0x1c,0},{0x1d,0},{0x13,7,4,0x1a,0},{0x18,0xe,0x14,0x1a,0},
  {0x1e,0},{0x1f,0},{0x20,0},{0x21,0},{0x22,0},{0x23,0}
};
char LowerCase[] = "abcdefghijklmnopqrstuvwx01234567";
//   TAG00a27c
//void CCSBuildDoc::ExpandText(char *result,RN textID,i16 flags)
int CCSBuildDoc::ExpandText(char *result,
                            DB2 *pDB2,
                            int flags, 
                            int max)
{
  //dReg D0, D5, D7;
  int len = 0;
  char *substitution;
  int substitutionMode;
  i8  Xlate28; //How 28 should be translated.
  char currentChar = 0;//To quiet the compiler
  int  currentWord = 0;//To quiet the compiler
  ui16 *pSource;
  int nibbleNum;

  max--; 

  if ((flags & 0x7fff) == 1)
  {
    *(result++) = 10;
    len++;
    if (len >= max) {*(result++) = 0; return len;};
    Xlate28 = 32;
  }
  else
  {
    if (flags == 0)
    {
      Xlate28 = -128;
    }
    else
    {
      Xlate28 = 10;
    };
  };
  nibbleNum = 0;
  substitutionMode = 0;
  pSource = m_compressedText + m_indirectTextIndex[pDB2->index()];
  for (;;)
  {
    switch (nibbleNum)
    {
    case 0:
      currentWord = LE16(*pSource);
      pSource++;
      currentChar = BITS10_14(currentWord);
      break;
    case 1:
        currentChar = BITS5_9(currentWord); break;
    case 2:
        currentChar = BITS0_4(currentWord); break;
    };
    nibbleNum = (nibbleNum + 1) % 3;
    if (substitutionMode != 0)
    {
      *result = 0;
      if (substitutionMode == 30)
      {
        if (flags != 0)
        {
          substitution = ASCIIWords[currentChar];
        }
        else
        {
          substitution = BCDWords[currentChar];
        };
      }
      else
      {
        if (flags != 0)
        {
          substitution = LowerCase + 2*currentChar;
        }
        else
        {
          substitution = LowerCase + 2*currentChar;
        };
      };
      strcat(result, substitution);
      result += strlen(substitution);
      len += strlen(substitution);
      if (len >= max){*(result++) = 0; return len;};
      substitutionMode = 0;
    }
    else
    {
      if (currentChar < 28)
      {
        if (flags != 0)
        {
          if (currentChar == 26)
          {
            currentChar = ' ';
          }
          else
          {
            if (currentChar == 27)
            {
              currentChar = 46;
            }
            else
            {
               currentChar += 'A';
            };
          };
        };
        *(result++) = currentChar;
        len++;
        if (len >= max) {*(result++)=0; return len;};
      }
      else
      {
        if (currentChar == 28)
        {
          *(result++) = Xlate28;
          len++;
          if (len >= max) {*(result++)=0; return len;};
        }
        else
        {
          if (currentChar <= 30)
          {
            substitutionMode = currentChar;
          }
          else
          {
            break;
          };
        };
      };
    };
  };
  if (flags == 0)
  {
    *result = -127;
  }
  else
  {
    *result = 0;
  };
  return len;
}

int CCSBuildDoc::ExpandText(char *result,
                            RN RNtext,
                            int flags, 
                            int max)
{
  return ExpandText(result, GetRecordAddressDB2(RNtext),flags,max);
}

int CCSBuildDoc::EncodeAndCompressText(CString& src, ui16 *dest, TEXTTYPE flags)
{
  int nibble = 0, len;
  int i, j=0;
  ui16 word;
  unsigned char ch;
  len = src.GetLength();
  for (i=0; i<len; i++)
  {
    ch = src.GetAt(i);
    switch (flags)
    {
    case TEXTTYPE_WALL:
      if (ch == 0x80) ch = 0x1c;
      else if (ch == '.') ch = 27;
      word = (ui16)((word<<5) | (ch&0x1f));
      nibble++;
      break;
    case TEXTTYPE_MIRROR:
      if (ch == 10) ch = 28;
      else if (ch == ' ') ch = 26;
      else if (ch == '.') ch = 27;
      else if (ch < 'A') ch = 26;
      else if (ch > 'Z') ch = 26;
      else ch = (unsigned char)(ch-'A');
      word = (ui16)((word<<5) | (ch&0x1f));
      nibble++;
      break;
    default: Sorry("Illegal Text Type");
    };
    if (nibble == 3)
    {
      word &= 0x7fff;
      dest[j] = LE16(word);
      j++;
      nibble = 0;
    };
  };
  word = (ui16)((word<<5) | 31);
  nibble++;
  if (nibble == 3)
  {
    word &= 0x7fff;
    dest[j] = LE16(word);
    j++;
    nibble = 0;
  };
  while (nibble != 0)
  {
    word = (ui16)((word << 5) & 0x7fe0);
    nibble = (nibble + 1)%3;
    if (nibble == 0) 
    {
      dest[j] = LE16(word);
      j++;
    };
  };
  return j;
}



CString CCSBuildDoc::GetRawText(RN objText, TEXTTYPE flags)
{
  int len;
  char result[1000];
  len = ExpandText(result, objText, flags, 900);
  return CString(result, len);
}

int CCSBuildDoc::GetCompressedTextIndex(RN text)
{
  return m_indirectTextIndex[GetRecordAddressDB2(text)->index()];
}

ui16 *CCSBuildDoc::FindRawText(int textIndex) const
{
  return m_compressedText + m_indirectTextIndex[textIndex];
}

bool CCSBuildDoc::IsValidIndirectTextIndex(int indirectTextIndex) const
{
  return   (indirectTextIndex >= 0)
        && (indirectTextIndex < NumWordsInTextArray());
}

bool CCSBuildDoc::IsValidCompressedTextIndex(int compressedTextIndex) const
{
  return   (compressedTextIndex >= 0)
        && (compressedTextIndex < m_sizeOfCompressedText);
}

int CCSBuildDoc::CompressedTextIndex(int indirectTextIndex) const
{
  if (!IsValidIndirectTextIndex(indirectTextIndex))
  {
    Error("Someone has presented an\n"
          "illegal indirectTextIndex");
    return 0;
  };
  return m_indirectTextIndex[indirectTextIndex];
}

int CCSBuildDoc::SizeOfCompressedText(void) const
{
  return m_sizeOfCompressedText;
}

int CCSBuildDoc::ComputeTextLength(ui16 *pCompText)
{ // Result is number of **16-bit WORDS** in text entry.
  int n1, n2, n3, len;
  len = 0;
  ui16 w;
  do
  {
    w = LE16(*pCompText);
    n1 = (w >> 10) & 31;
    n2 = (w >>  5) & 31;
    n3 = (w >>  0) & 31;
    pCompText++;
    len++;
  } while ((n1!=31)&&(n2!=31)&&(n3!=31));
  return len;
}

int CCSBuildDoc::ComputeTextLength(int textIndex)
{ // Result is number of **16-bit WORDS** in text entry.
  ui16 *pRaw;
  pRaw = m_compressedText + m_indirectTextIndex[textIndex];
  return ComputeTextLength(pRaw);
}

/*
int CCSBuildDoc::ComputeTextLength(int textIndex)
{ // Result is number of **16-bit WORDS** in text entry.
  int nextIndex;
  int i;
  //RN obj;
  DB2 *pText;
  nextIndex = m_dungeonDatIndex->NumWordsInTextArray();
  for (i=0; i<GetDBSize(2); i++)
  {
    //obj = RN(dbTEXT,i);
    pText = GetCommonAddress(dbTEXT,i)->CastToDB2();
    if (pText->link() == RNnul) continue;
    if (pText->index() <= textIndex) continue;
    if (pText->index() < nextIndex) nextIndex = pText->index();
  };
  return nextIndex - textIndex;
}
*/

void CCSBuildDoc::DeleteText(int textIndex)
{
  int i, num, nextIndex, ans, thisText, nextText, delta;
  //RN obj;
  DB2 *pText;
  if (  (textIndex >= NumWordsInTextArray())
      ||(textIndex < 0))
  {
    Strange("I have been assked to delete an indirectTextIndex\n"
            "that does not exist.  I'll pretend it is OK.");
    return;
  };
  if (m_indirectTextIndex[textIndex] < 0)
  {
    Strange("I have been asked to delete an indirectTextIndex\n"
            "that points to nowhere.  Oh, well.  I'll just\n"
            "pretend that it is OK.");
    return;
  };
  if (m_indirectTextIndex[textIndex] > m_sizeOfCompressedText)
  {
    Strange("I have been asked to delete an indirectTextIndex\n"
            "that points to nowhere.  Oh, well.  I'll just\n"
            "pretend that it is OK.");
    m_indirectTextIndex[textIndex] = -1;
    return;
  };
  for (i=0; i<GetDBSize(dbTEXT); i++)
  {
    pText = GetRecordAddressDB2(i);
    if (pText->link() == RNnul) continue;
    if (pText->index() != textIndex) continue;
    ans = AreYouSure("I have been asked to delete a\n"
                     "indirectTextIndex entry that is still\n"
                     "being used by a Text (DB2) record\n \n"
                     "Should I REALLY delete it?");
    if (ans == IDNO) return;
  };
  nextIndex = 99999999;
  for (i=0; i<NumWordsInTextArray(); i++)
  {
    if (i == textIndex) continue;
    if (m_indirectTextIndex[i] < 0) continue;
    if (m_indirectTextIndex[i] <= m_indirectTextIndex[textIndex]) continue;
    if (   (nextIndex == 99999999)
        || (m_indirectTextIndex[i] <= m_indirectTextIndex[nextIndex]))
    {
      nextIndex = i;
    };
  };
  if (nextIndex == 99999999) nextText = m_sizeOfCompressedText;
  else nextText = m_indirectTextIndex[nextIndex];
  thisText = m_indirectTextIndex[textIndex];
  num = m_sizeOfCompressedText-nextText;
  if (num > 0)
  {
    memcpy(m_compressedText+m_indirectTextIndex[textIndex], 
           m_compressedText+m_indirectTextIndex[nextIndex], 
           2*num);
  };
  delta = nextText-thisText;
  m_sizeOfCompressedText -= delta;
  for (i=0; i<NumWordsInTextArray(); i++)
  {
    if (m_indirectTextIndex[i] > thisText)
    {
      m_indirectTextIndex[i] -= delta;
    };
  };
  m_indirectTextIndex[textIndex] = -1;
  SetModifiedFlag();
}

int CCSBuildDoc::AddText(ui16 *text, int num)
{
  int i;
  int result = -1;
  if (ComputeTextLength(text) != num)
  {
    Strange("I have been asked to add a text entry\n"
            "but the size is wrong.  I will fix it");
    num = ComputeTextLength(text);
  };
  for (i=0; i<NumWordsInTextArray(); i++)
  {
    if (m_indirectTextIndex[i] < 0)
    {
      result = i;
      break;
    };
  };
  if (result < 0)
  {
    result = m_dungeonDatIndex->NumWordsInTextArray();
    if (result+1 >= 0x1ff0)
    {
      pDoc->Sorry("There is no more room for text");
      return 0;
    };
    m_dungeonDatIndex->NumWordsInTextArray(result+1);
    m_indirectTextIndex = (int *)realloc(m_indirectTextIndex, 
                                         4*(result+1),
                                         MALLOC006);
  };
  m_indirectTextIndex[result] = m_sizeOfCompressedText;
  m_sizeOfCompressedText += num;
  m_compressedText = (ui16 *)realloc(m_compressedText,
                                     m_sizeOfCompressedText*2,
                                     MALLOC069);
  memcpy(m_compressedText+m_indirectTextIndex[result], 
         text, 
         2*num);
  SetModifiedFlag();
  return result;
}

void CCSBuildDoc::SetText(RN objDB2, CString text, TEXTTYPE flags)
{
  ui16 encodedText[500];
  RN obj;
  bool deleteOldText;
  DB2 *pText;
  bool found, duplicate;
  int i, len, oldTextIndex, newTextIndex;
  len = EncodeAndCompressText(text, encodedText, flags);
  //What now?  We want to replace the text
  //that belongs to objD2.  Let us do this in two
  // stages.
  //1) If no other text record references this
  //   text then delete the text.
  //2) Add the new text at the end.
  pText = GetRecordAddressDB2(objDB2);
  oldTextIndex = pText->index();
  found = duplicate = false;
  for (i=0; i<GetDBSize(2); i++)
  {    
    if ( (objDB2.dbIndex() == i) && (objDB2.dbNum() == 2) )
    {
      found = true;
      continue;
    };
    pText = GetRecordAddressDB2(i);
    if (pText->link() == RNnul) continue;

    if (pText->index() == oldTextIndex) duplicate = true;
  };
  if (!found) Strange("I could not find that text object");
  pText = GetRecordAddressDB2(objDB2);
  deleteOldText = pText->ValidText() && !duplicate;
  newTextIndex = AddText(encodedText, len);
  pText->index(newTextIndex);
  if (deleteOldText) DeleteText(oldTextIndex);
}

void CCSBuildDoc::RemoveText(DB2 *pText)
{ //Delete the encoded text entry if no other 
  // text object is using it.
  //RN obj;
  int i, textIndex;
  DB2 *pT;
  bool duplicate;
  //pText = GetCommonAddress(dbTEXT,DB2Index)->CastToDB2();
  textIndex = pText->index();
  ASSERT(textIndex != 0x1fff);
  pText->index(0x1fff);
  duplicate = false;
  for (i=0; i<GetDBSize(2); i++)
  {    
    pT = GetCommonAddress(dbTEXT, i)->CastToDB2();
    if (pT->link() == RNnul) continue;
//    if (pT == pText) continue;
    if (pT->index() == textIndex) duplicate = true;
  };
  if (!duplicate)
  {
    DeleteText(textIndex);
  };
  //pText->index(0x1fff);
}

void CCSBuildDoc::InsertText(RN objDB2, CString text, TEXTTYPE flags)
{
  ui16 encodedText[500];
  RN obj;
  DB2 *pText;
  int len, textIndex;
  len = EncodeAndCompressText(text, encodedText, flags);
  // Add the new text at the end.
  textIndex = AddText(encodedText, len);
  pText = GetRecordAddressDB2(objDB2);
  pText->index(textIndex);
}

void CCSBuildDoc::setDSA(int index, DSA *pDSA)
{
  if (m_DSAIndex[index] == NULL)
  {
    m_DSAIndex[index] = new DSA;
  };
  if (*m_DSAIndex[index] != *pDSA) 
  {
    *m_DSAIndex[index] = *pDSA;
    SetModifiedFlag();
  };
};  

void CCSBuildDoc::setDSA(int level, int index, ui16 DSAindex)
{
  if (level > 63)
  {
    Strange("level > 63");
    return;
  };
  if (index > 31)
  {
    Strange("level DSA index > 31");
    return;
  };
  if (DSAindex>255)
  {
    if (DSAindex != 0xffff)
    {
      Strange("DSA index > 255");
      return;
    };
  };
  if (m_DSALevelIndex[level][index] != DSAindex)
  {
    SetModifiedFlag();
  };
  m_DSALevelIndex[level][index] = DSAindex;
}

bool CCSBuildDoc::RepairScrollNonText(CHKERRMSG *pcem)
{
  DB7 *pDB7;
  pDB7 = pcem->DBCommonAddress()->CastToDB7();
  pDB7->text(FindEmptyDB2Entry(TEXTTYPE_SCROLL, true));
  return true;
}

bool CCSBuildDoc::RemoveOrphan(CHKERRMSG *pcem)
{
  DBTYPE dbType;
  dbType = pcem->DBType();
  switch(dbType)
  {
  case dbTEXT:
    {
      DB2 *pDB2;
      pDB2 = pcem->DBCommonAddress()->CastToDB2();
      RemoveText(pDB2);
      pDB2->link(RNnul);
    };
    return true;
  case dbACTUATOR:
    {
      DB3 *pDB3;
      pDB3 = pcem->DBCommonAddress()->CastToDB3();
      pDB3->link(RNnul);
    };
    return true;
  case dbDOOR:
    {
      DB0 *pDB0;
      pDB0 = pcem->DBCommonAddress()->CastToDB0();
      pDB0->link(RNnul);
    };
    return true;
  case dbTELEPORTER:
    {
      DB1 *pDB1;
      pDB1 = pcem->DBCommonAddress()->CastToDB1();
      pDB1->link(RNnul);
    };
    return true;
  case dbMONSTER:
    {
      DB4 *pDB4;
      pDB4 = pcem->DBCommonAddress()->CastToDB4();
      pDB4->link(RNnul);
    };
    return true;
  case dbWEAPON:
    {
      DB5 *pDB5;
      pDB5 = pcem->DBCommonAddress()->CastToDB5();
      pDB5->link(RNnul);
    };
    return true;
  case dbCLOTHING:
    {
      DB6 *pDB6;
      pDB6 = pcem->DBCommonAddress()->CastToDB6();
      pDB6->link(RNnul);
    };
    return true;
  case dbPOTION:
    {
      DB8 *pDB8;
      pDB8 = pcem->DBCommonAddress()->CastToDB8();
      pDB8->link(RNnul);
    };
    return true;
  case dbSCROLL:
    {
      DB7 *pDB7;
      pDB7 = pcem->DBCommonAddress()->CastToDB7();
      pDB7->link(RNnul);
    };
    return true;
  case dbCHEST:
    {
      DB9 *pDB9;
      pDB9 = pcem->DBCommonAddress()->CastToDB9();
      pDB9->link(RNnul);
    };
    return true;
  case dbMISC:
    {
      DB10 *pDB10;
      pDB10 = pcem->DBCommonAddress()->CastToDB10();
      pDB10->link(RNnul);
    };
    return true;
  };
  Sorry("Don't know how to remove that Orphan");
  return false;
}
