// GetKey.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "GetKey.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GetKey dialog


GetKey::GetKey(CWnd* pParent /*=NULL*/)
	: CDialog(GetKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(GetKey)
	m_encryptionKey = _T("");
	m_graphicsSignature = _T("0");
	m_CSBgraphicsSignature = _T("0");
	m_hintKey = _T("");
	//}}AFX_DATA_INIT
  //m_key = "";
}


void GetKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
  if (!pDX->m_bSaveAndValidate)
  {
    m_graphicsSignature.Format("%08X%08X",
                     m_signature2, m_signature1);
    m_CSBgraphicsSignature.Format("%08X%08X",
                     m_CSBsignature2, m_CSBsignature1);
  };
	//{{AFX_DATA_MAP(GetKey)
	DDX_Text(pDX, IDC_EncryptionKey, m_encryptionKey);
	DDX_Text(pDX, IDC_GrahicsSignature, m_graphicsSignature);
	DDV_MaxChars(pDX, m_graphicsSignature, 16);
	DDX_Text(pDX, IDC_CSBgraphicsSignature, m_CSBgraphicsSignature);
	DDV_MaxChars(pDX, m_CSBgraphicsSignature, 16);
	DDX_Text(pDX, IDC_HintKey, m_hintKey);
	DDV_MaxChars(pDX, m_hintKey, 8);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
    int i, n;
    m_key = "";
    for (i=0; i<m_encryptionKey.GetLength(); i++)
    {
      if (m_encryptionKey[i] == ' ') continue;
      n=0;
      while (   (i < m_encryptionKey.GetLength())
              &&(m_encryptionKey[i] >= '0')
              &&(m_encryptionKey[i] <= '9'))
      {
        n = n*10 + m_encryptionKey[i] - '0';
        i++;
      };
      if (    (i < m_encryptionKey.GetLength())
           && (m_encryptionKey[i] != ' ')
           && (   (m_encryptionKey[i] < '0')
               || (m_encryptionKey[i] > '9')))
      {
        Error("Illegal key character");
        continue;
      };
      if (n>255) Error("Key number too large");
      m_key += (char)n;
    };
    m_signature1 = m_signature2 = 0; //In case of error.
    if (m_graphicsSignature.GetLength() == 16)
    {
      for (i=0; i<16; i++)
      {
        if ( (m_graphicsSignature[i] >= '0')
            && (m_graphicsSignature[i] <= '9')) continue;
        if ( (m_graphicsSignature[i] >= 'A')
            && (m_graphicsSignature[i] <= 'F')) continue;
        if ( (m_graphicsSignature[i] >= 'a')
            && (m_graphicsSignature[i] <= 'f')) continue;
        Error("Illegal Hex digit in Graphics Signature");
        break;
      };
      sscanf(m_graphicsSignature,"%8x%8x",
             &m_signature2, &m_signature1);
    }
    else
    {
      if (m_graphicsSignature != "0")
      {
        Error("Illegal Graphics Signature");
      };
    };
    m_CSBsignature1 = m_CSBsignature2 = 0; //In case of error.
    if (m_CSBgraphicsSignature.GetLength() == 16)
    {
      for (i=0; i<16; i++)
      {
        if ( (m_CSBgraphicsSignature[i] >= '0')
            && (m_CSBgraphicsSignature[i] <= '9')) continue;
        if ( (m_CSBgraphicsSignature[i] >= 'A')
            && (m_CSBgraphicsSignature[i] <= 'F')) continue;
        if ( (m_CSBgraphicsSignature[i] >= 'a')
            && (m_CSBgraphicsSignature[i] <= 'f')) continue;
        Error("Illegal Hex digit in CSBgraphics Signature");
        break;
      };
      sscanf(m_CSBgraphicsSignature,"%8x%8x",
             &m_CSBsignature2, &m_CSBsignature1);
    }
    else
    {
      if (m_CSBgraphicsSignature != "0")
      {
        Error("Illegal CSBgraphics Signature");
      };
    };
  };
}


BEGIN_MESSAGE_MAP(GetKey, CDialog)
	//{{AFX_MSG_MAP(GetKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GetKey message handlers

void GetKey::OnOK() 
{
  // TODO: Add extra validation here

	CDialog::OnOK();
}
