// GlobalInfo.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "GlobalInfo.h"
#include "CSBuildDoc.h"
#include "ListDSAs.h"
#include "Misc.h"
#include "EditAsciiText.h"
#include "EditTarget.h"
#include "DatabaseEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool RecordDesignOption;
extern bool DMRulesOption;
extern bool invisibleMonsters;
extern bool drawAsSize4Monsters;
extern char *gameInfo;

/////////////////////////////////////////////////////////////////////////////
// GlobalInfo dialog


GlobalInfo::GlobalInfo(CWnd* pParent /*=NULL*/)
	: CDialog(GlobalInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(GlobalInfo)
	m_numberOfLevels = 0;
	m_autoRecord = FALSE;
	m_DMRules = FALSE;
	m_lightLevel = 0;
	m_specialLocationName = -1;
	m_specialFacing = -1;
	m_specialX = 0;
	m_specialY = 0;
	m_specialLevel = 0;
	m_invisibleMonsters = FALSE;
	m_drawAsSize4Monsters = FALSE;
  m_parentWindow = pParent;
	m_sameLevel = FALSE;
	m_maxDistance = 0;
	//}}AFX_DATA_INIT
}

void GlobalInfo::ExtractDataFromDungeon(void)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  bool bTemp;
  locr.x(pDoc->PartyX());
  locr.y(pDoc->PartyY());
  locr.l(pDoc->PartyLevel());
  locr.p(pDoc->PartyFacing());
  loca = locr;
  m_partyX = loca.x;
  m_partyY = loca.y;
  m_partyLevel = loca.l;
  m_partyFacing = loca.p;
  m_numberOfLevels = pDoc->NumLevel();
  locr.l(0);
  locr.x(pDoc->StartingX());
  locr.y(pDoc->StartingY());
  loca = locr;
  m_startingX = loca.x;
  m_startingY = loca.y;
  m_startingFacing = pDoc->StartingFacing();
  locr = pDoc->SpellFilterLocation();
  if (locr.l() < 0)
  {
    m_spellFilterLevel = -1;
    m_spellFilterX = 0;
    m_spellFilterY = 0;
  }
  else
  {
    loca = locr;
    m_spellFilterLevel = loca.l;
    m_spellFilterX = loca.x;
    m_spellFilterY = loca.y;
  };
  locr = pDoc->CharDeathFilterLocation();
  if (locr.l() < 0)
  {
    m_charDeathFilterLevel = -1;
    m_charDeathFilterX = 0;
    m_charDeathFilterY = 0;
  }
  else
  {
    loca = locr;
    m_charDeathFilterLevel = loca.l;
    m_charDeathFilterX = loca.x;
    m_charDeathFilterY = loca.y;
  };
  locr = pDoc->MonsterAttackFilterLocation();
  if (locr.l() < 0)
  {
    m_monsterAttackFilterLevel = -1;
    m_monsterAttackFilterX = 0;
    m_monsterAttackFilterY = 0;
  }
  else
  {
    loca = locr;
    m_monsterAttackFilterLevel = loca.l;
    m_monsterAttackFilterX = loca.x;
    m_monsterAttackFilterY = loca.y;
  };
  locr = pDoc->PartyAttackFilterLocation();
  if (locr.l() < 0)
  {
    m_partyAttackFilterLevel = -1;
    m_partyAttackFilterX = 0;
    m_partyAttackFilterY = 0;
  }
  else
  {
    loca = locr;
    m_partyAttackFilterLevel = loca.l;
    m_partyAttackFilterX = loca.x;
    m_partyAttackFilterY = loca.y;
  };
  locr = pDoc->FeedingFilterLocation();
  if (locr.l() < 0)
  {
    m_feedingFilterLevel = -1;
    m_feedingFilterX = 0;
    m_feedingFilterY = 0;
  }
  else
  {
    loca = locr;
    m_feedingFilterLevel = loca.l;
    m_feedingFilterX = loca.x;
    m_feedingFilterY = loca.y;
  };

  locr = pDoc->CursorFilterLocation();
  if (locr.l() < 0)
  {
    m_cursorFilterLevel = -1;
    m_cursorFilterX = 0;
    m_cursorFilterY = 0;
  }
  else
  {
    loca = locr;
    m_cursorFilterLevel = loca.l;
    m_cursorFilterX = loca.x;
    m_cursorFilterY = loca.y;
  };
  
  locr = pDoc->AdjustSkillsFilterLocation();
  if (locr.l() < 0)
  {
    m_adjustSkillsFilterLevel = -1;
    m_adjustSkillsFilterX = 0;
    m_adjustSkillsFilterY = 0;
  }
  else
  {
    loca = locr;
    m_adjustSkillsFilterLevel = loca.l;
    m_adjustSkillsFilterX = loca.x;
    m_adjustSkillsFilterY = loca.y;
  };
  locr = pDoc->DeleteMonsterFilterLocation();
  if (locr.l() < 0)
  {
    m_deleteMonsterFilterLevel = -1;
    m_deleteMonsterFilterX = 0;
    m_deleteMonsterFilterY = 0;
  }
  else
  {
    loca = locr;
    m_deleteMonsterFilterLevel = loca.l;
    m_deleteMonsterFilterX = loca.x;
    m_deleteMonsterFilterY = loca.y;
  };
  locr = pDoc->IndirectActionLocation();
  if (locr.l() < 0)
  {
    m_indirectActionLevel = -1;
    m_indirectActionX = 0;
    m_indirectActionY = 0;
  }
  else
  {
    loca = locr;
    m_indirectActionLevel = loca.l;
    m_indirectActionX = loca.x;
    m_indirectActionY = loca.y;
  };
  locr = pDoc->ViewingFilterLocation();
  if (locr.l() < 0)
  {
    m_viewingFilterLevel = -1;
    m_viewingFilterX = 0;
    m_viewingFilterY = 0;
  }
  else
  {
    loca = locr;
    m_viewingFilterLevel = loca.l;
    m_viewingFilterX = loca.x;
    m_viewingFilterY = loca.y;
  };
  locr = pDoc->SoundFilterLocation();
  if (locr.l() < 0)
  {
    m_soundFilterLevel = -1;
    m_soundFilterX = 0;
    m_soundFilterY = 0;
  }
  else
  {
    loca = locr;
    m_soundFilterLevel = loca.l;
    m_soundFilterX = loca.x;
    m_soundFilterY = loca.y;
  };
  locr = pDoc->ActionNameFilterLocation();
  if (locr.l() < 0)
  {
    m_actionNameFilterLevel = -1;
    m_actionNameFilterX = 0;
    m_actionNameFilterY = 0;
  }
  else
  {
    loca = locr;
    m_actionNameFilterLevel = loca.l;
    m_actionNameFilterX = loca.x;
    m_actionNameFilterY = loca.y;
  };
  locr = pDoc->MonsterMoveFilterLocation(&bTemp, &m_maxDistance);
  m_sameLevel = bTemp;
  if (locr.l() < 0)
  {
    m_monsterMoveFilterLevel = -1;
    m_monsterMoveFilterX = 0;
    m_monsterMoveFilterY = 0;
    m_maxDistance = 0;
    m_sameLevel = false;
  }
  else
  {
    loca = locr;
    m_monsterMoveFilterLevel = loca.l;
    m_monsterMoveFilterX = loca.x;
    m_monsterMoveFilterY = loca.y;
  };
  m_autoRecord = RecordDesignOption;
  m_DMRules = DMRulesOption;
  m_invisibleMonsters = invisibleMonsters;
  m_drawAsSize4Monsters = drawAsSize4Monsters;
  m_lightLevel = pDoc->Brightness();
//  m_hintable = pDoc->IsHintable() == 1;
}

void GlobalInfo::EncodeDataIntoDungeon(void)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  loca.x = m_partyX;
  loca.y = m_partyY;
  loca.l = m_partyLevel;
  loca.p = m_partyFacing;
  locr = loca;
  pDoc->PartyX(locr.x());
  pDoc->PartyY(locr.y());
  pDoc->PartyLevel(locr.l());
  pDoc->PartyFacing(locr.p());
  loca.l = 0;
  loca.x = m_startingX;
  loca.y = m_startingY;
  locr = loca;
  pDoc->StartingX(locr.x());
  pDoc->StartingY(locr.y());
  pDoc->StartingFacing(m_startingFacing);
  loca.l = m_spellFilterLevel;
  loca.x = m_spellFilterX;
  loca.y = m_spellFilterY;
  locr = loca;
  pDoc->SpellFilterLocation(locr);
  //
  loca.l = m_charDeathFilterLevel;
  loca.x = m_charDeathFilterX;
  loca.y = m_charDeathFilterY;
  locr = loca;
  pDoc->CharDeathFilterLocation(locr);
  //
  loca.l = m_monsterAttackFilterLevel;
  loca.x = m_monsterAttackFilterX;
  loca.y = m_monsterAttackFilterY;
  locr = loca;
  pDoc->MonsterAttackFilterLocation(locr);
  //
  loca.l = m_partyAttackFilterLevel;
  loca.x = m_partyAttackFilterX;
  loca.y = m_partyAttackFilterY;
  locr = loca;
  pDoc->PartyAttackFilterLocation(locr);
  //
  loca.l = m_feedingFilterLevel;
  loca.x = m_feedingFilterX;
  loca.y = m_feedingFilterY;
  locr = loca;
  pDoc->FeedingFilterLocation(locr);
  //
  loca.l = m_cursorFilterLevel;
  loca.x = m_cursorFilterX;
  loca.y = m_cursorFilterY;
  locr = loca;
  pDoc->CursorFilterLocation(locr);
  //
  loca.l = m_adjustSkillsFilterLevel;
  loca.x = m_adjustSkillsFilterX;
  loca.y = m_adjustSkillsFilterY;
  locr = loca;
  pDoc->AdjustSkillsFilterLocation(locr);
  //
  loca.l = m_deleteMonsterFilterLevel;
  loca.x = m_deleteMonsterFilterX;
  loca.y = m_deleteMonsterFilterY;
  locr = loca;
  pDoc->DeleteMonsterFilterLocation(locr);
  //
  loca.l = m_indirectActionLevel;
  loca.x = m_indirectActionX;
  loca.y = m_indirectActionY;
  locr = loca;
  pDoc->IndirectActionLocation(locr);
  //
  loca.l = m_viewingFilterLevel;
  loca.x = m_viewingFilterX;
  loca.y = m_viewingFilterY;
  locr = loca;
  pDoc->ViewingFilterLocation(locr);
  //
  loca.l = m_soundFilterLevel;
  loca.x = m_soundFilterX;
  loca.y = m_soundFilterY;
  locr = loca;
  pDoc->SoundFilterLocation(locr);
  //
  //
  loca.l = m_actionNameFilterLevel;
  loca.x = m_actionNameFilterX;
  loca.y = m_actionNameFilterY;
  locr = loca;
  pDoc->ActionNameFilterLocation(locr);
  //
  loca.l = m_monsterMoveFilterLevel;
  loca.x = m_monsterMoveFilterX;
  loca.y = m_monsterMoveFilterY;
  locr = loca;
  pDoc->MonsterMoveFilterLocation(locr,m_sameLevel?true:false, m_maxDistance);
  if ((m_autoRecord!=0) != RecordDesignOption) MODIFY;
  RecordDesignOption = m_autoRecord != 0;
  if ((m_DMRules!=0) != DMRulesOption) MODIFY;
  DMRulesOption = m_DMRules != 0;
  if ((m_invisibleMonsters!=0) != invisibleMonsters) MODIFY;
  invisibleMonsters = m_invisibleMonsters!=0;
  if ((m_drawAsSize4Monsters!=0) != drawAsSize4Monsters) MODIFY;
  drawAsSize4Monsters = m_drawAsSize4Monsters!=0;
  pDoc->Brightness((i16)m_lightLevel);
//  pDoc->IsHintable(m_hintable==TRUE);
}

void GlobalInfo::Show(int id, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->ShowWindow(show);
}

void GlobalInfo::ReadOnly(int id, bool RO)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->EnableWindow(!RO);
}

void GlobalInfo::DoDataExchange(CDataExchange* pDX)
{
  ui32 lastLevel;
  if (!pDX->m_bSaveAndValidate)
  {
    if (m_specialLocationName < 0) m_specialLocationName = 0;
    switch(m_specialLocationName)
    {
    case 0: // Prison Starting Location
      m_specialLevel = 0;
      ReadOnly(IDC_SpecialLevel, true);
      m_specialX = m_startingX;
      m_specialY = m_startingY;
      m_specialFacing = m_startingFacing;
      Show(IDC_SpecialFacing, true);
      Show(IDC_SpecialPosTitle, true);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 1: // Resume Location
      m_specialLevel = m_partyLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_partyX;
      m_specialY = m_partyY;
      m_specialFacing = m_partyFacing;
      Show(IDC_SpecialFacing, true);
      Show(IDC_SpecialPosTitle, true);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 2: // Spell Filter Location
      m_specialLevel = m_spellFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_spellFilterX;
      m_specialY = m_spellFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 3: // Monster Attack Filter Location
      m_specialLevel = m_monsterAttackFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_monsterAttackFilterX;
      m_specialY = m_monsterAttackFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 4: // Feeding Filter Location
      m_specialLevel = m_feedingFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_feedingFilterX;
      m_specialY = m_feedingFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 5: // Monster Move Filter Location
      m_specialLevel = m_monsterMoveFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_monsterMoveFilterX;
      m_specialY = m_monsterMoveFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, true);
      Show(IDC_MaxDistanceText, true);
      Show(IDC_SameLevel, true);
      break;
    case 6: // Viewing Filter Location
      m_specialLevel = m_viewingFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_viewingFilterX;
      m_specialY = m_viewingFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 7: // Party Attack Filter Location
      m_specialLevel = m_partyAttackFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_partyAttackFilterX;
      m_specialY = m_partyAttackFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 8: // Indirect Action Location
      m_specialLevel = m_indirectActionLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_indirectActionX;
      m_specialY = m_indirectActionY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 9: // Adjust Skills Filter Location
      m_specialLevel = m_adjustSkillsFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_adjustSkillsFilterX;
      m_specialY = m_adjustSkillsFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 10: // Delete Monster Filter Location
      m_specialLevel = m_deleteMonsterFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_deleteMonsterFilterX;
      m_specialY = m_deleteMonsterFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 11: // Sound Filter Location
      m_specialLevel = m_soundFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_soundFilterX;
      m_specialY = m_soundFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 12: // Cursor Filter Location
      m_specialLevel = m_cursorFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_cursorFilterX;
      m_specialY = m_cursorFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 13: // Action Name Filter Location
      m_specialLevel = m_actionNameFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_actionNameFilterX;
      m_specialY = m_actionNameFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    case 14: // Character Death Filter Location
      m_specialLevel = m_charDeathFilterLevel;
      ReadOnly(IDC_SpecialLevel, false);
      m_specialX = m_charDeathFilterX;
      m_specialY = m_charDeathFilterY;
      Show(IDC_SpecialFacing, false);
      Show(IDC_SpecialPosTitle, false);
      Show(IDC_MaxDistance, false);
      Show(IDC_MaxDistanceText, false);
      Show(IDC_SameLevel, false);
      break;
    };
  };
	CDialog::DoDataExchange(pDX);
  lastLevel = pDoc->NumLevel() - 1;
	//{{AFX_DATA_MAP(GlobalInfo)
	DDX_Text(pDX, IDC_NumberOfLevels, m_numberOfLevels);
	DDX_Check(pDX, IDC_AutoRecord, m_autoRecord);
	DDX_Check(pDX, IDC_DMRules, m_DMRules);
	DDX_Text(pDX, IDC_LightLevel, m_lightLevel);
	DDV_MinMaxUInt(pDX, m_lightLevel, 0, 32767);
	DDX_CBIndex(pDX, IDC_SpecialLocationName, m_specialLocationName);
	DDX_CBIndex(pDX, IDC_SpecialFacing, m_specialFacing);
	DDX_Text(pDX, IDC_SpecialX, m_specialX);
	DDX_Text(pDX, IDC_SpecialY, m_specialY);
	DDX_Text(pDX, IDC_SpecialLevel, m_specialLevel);
	DDV_MinMaxInt(pDX, m_specialLevel, -1, 63);
	DDX_Check(pDX, IDC_InvisibleMonsters, m_invisibleMonsters);
	DDX_Check(pDX, IDC_DrawAsSize4, m_drawAsSize4Monsters);
	DDX_Check(pDX, IDC_SameLevel, m_sameLevel);
	DDX_Text(pDX, IDC_MaxDistance, m_maxDistance);
	DDV_MinMaxUInt(pDX, m_maxDistance, 0, 31);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
  };
  if (pDX->m_bSaveAndValidate)
  {
  };
}

void GlobalInfo::CaptureSpecialLocation(int locationID)
{
  switch(locationID)
  {
  case 0: // Prison starting location
    m_startingX = m_specialX;
    m_startingY = m_specialY;
    m_startingFacing = m_specialFacing;
    break;
  case 1: // Resume location
    m_partyLevel = m_specialLevel;
    m_partyX = m_specialX;
    m_partyY = m_specialY;
    m_partyFacing = m_specialFacing;
    break;
  case 2: // Spell filter location
    m_spellFilterLevel = m_specialLevel;
    m_spellFilterX = m_specialX;
    m_spellFilterY = m_specialY;
    break;
  case 3: // Monster attack filter location
    m_monsterAttackFilterLevel = m_specialLevel;
    m_monsterAttackFilterX = m_specialX;
    m_monsterAttackFilterY = m_specialY;
    break;
  case 4: // Feeding filter location
    m_feedingFilterLevel = m_specialLevel;
    m_feedingFilterX = m_specialX;
    m_feedingFilterY = m_specialY;
    break;
  case 5: // Monster move filter location
    m_monsterMoveFilterLevel = m_specialLevel;
    m_monsterMoveFilterX = m_specialX;
    m_monsterMoveFilterY = m_specialY;
    break;
  case 6: // Viewing filter location
    m_viewingFilterLevel = m_specialLevel;
    m_viewingFilterX = m_specialX;
    m_viewingFilterY = m_specialY;
    break;
  case 7: // Party attack filter location
    m_partyAttackFilterLevel = m_specialLevel;
    m_partyAttackFilterX = m_specialX;
    m_partyAttackFilterY = m_specialY;
    break;
  case 8: // Indirect Action location
    m_indirectActionLevel = m_specialLevel;
    m_indirectActionX = m_specialX;
    m_indirectActionY = m_specialY;
    break;
  case 9: // Adjust Skills filter location
    m_adjustSkillsFilterLevel = m_specialLevel;
    m_adjustSkillsFilterX = m_specialX;
    m_adjustSkillsFilterY = m_specialY;
    break;
  case 10: // Delete Monster filter location
    m_deleteMonsterFilterLevel = m_specialLevel;
    m_deleteMonsterFilterX = m_specialX;
    m_deleteMonsterFilterY = m_specialY;
    break;
  case 11: // Sound filter location
    m_soundFilterLevel = m_specialLevel;
    m_soundFilterX = m_specialX;
    m_soundFilterY = m_specialY;
    break;
  case 12: // Cursor filter location
    m_cursorFilterLevel = m_specialLevel;
    m_cursorFilterX = m_specialX;
    m_cursorFilterY = m_specialY;
    break;
  case 13: // Action Name filter location
    m_actionNameFilterLevel = m_specialLevel;
    m_actionNameFilterX = m_specialX;
    m_actionNameFilterY = m_specialY;
    break;
  case 14: // Character Death filter location
    m_charDeathFilterLevel = m_specialLevel;
    m_charDeathFilterX = m_specialX;
    m_charDeathFilterY = m_specialY;
    break;
  };
}

BEGIN_MESSAGE_MAP(GlobalInfo, CDialog)
	//{{AFX_MSG_MAP(GlobalInfo)
	ON_BN_CLICKED(IDC_AddLevel, OnAddLevel)
	ON_BN_CLICKED(IDC_EditDSA, OnEditDSA)
	ON_BN_CLICKED(IDC_MaximizeDungeonSize, OnMaximizeDungeonSize)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_EditGameInfo, OnEditGameInfo)
	ON_CBN_SELCHANGE(IDC_SpecialLocationName, OnSelchangeSpecialLocationName)
	ON_BN_CLICKED(IDC_SpecialBrowse, OnSpecialBrowse)
	ON_BN_CLICKED(IDC_Database, OnDatabase)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GlobalInfo message handlers

void GlobalInfo::OnAddLevel() 
{
	// TODO: Add your control notification handler code here
  if (!pDoc->VerifyLevelData())
  {
    DungeonError();
    return;
  };
	if(!pDoc->AddLevel())
  {
    EnlargeError();
    return;
  };
  this->m_numberOfLevels = pDoc->NumLevel();
  UpdateData(false);
}

void GlobalInfo::OnEditDSA() 
{
	// TODO: Add your control notification handler code here
	ListDSAs dlg;
  dlg.DoModal();
}


void GlobalInfo::OnMaximizeDungeonSize() 
{
	// TODO: Add your control notification handler code here
  int level, row, col;
  CProgressCtrl progress;
  RECT prect = {10,10,400,60};
  progress.Create(WS_CAPTION|WS_VISIBLE|WS_CHILD,prect,this,12);
  progress.SetWindowText("Maximizing Dungeon Size");
  progress.SetRange(0,64);
  if (!pDoc->VerifyLevelData())
  {
    DungeonError();
    return;
  };
  UpdateData(true);
  for (level=0; level<64; level++)
  {
    progress.SetPos(level);
	  if (level >= pDoc->NumLevel())
    {
      if (!pDoc->AddLevel())
      {
        EnlargeError();
        return;
      };
    };
    for (row=pDoc->LastRow(level); row<32; row++)
    {
      if (!pDoc->AddRow(level))
      {
        EnlargeError();
        return;
      };
    };
    for (col=pDoc->LastColumn(level); col<32; col++)
    {
      if (!pDoc->AddColumn(level))
      {
        EnlargeError();
        return;
      };
    };
  };
  pDoc->UpdateAllViews(NULL);
  UpdateData(false);
}

BOOL GlobalInfo::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CString s;
  int id;
  switch (pHelpInfo->iCtrlId)
  {
  case IDC_LightLevel: id = IDH_GlobalInfo_LightLevel; break;
  default: id = IDH_Context_None;
  };
	s.LoadString(id);
  HelpMsg(s);
  return true;
}

void GlobalInfo::OnEditGameInfo() 
{
	// TODO: Add your control notification handler code here
	EditAsciiText dlg;
  dlg.m_title = "Edit Game Information";
  dlg.m_text = gameInfo;
  if (dlg.DoModal() == IDOK)
  {
    int len;
    len = dlg.m_text.GetLength();
    free (gameInfo);
    gameInfo = (char *)malloc(len+1,MALLOC079);
    memcpy(gameInfo, (LPCTSTR)dlg.m_text, len+1);
  };
}

void GlobalInfo::EnableControl(int id, bool enable)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->EnableWindow(enable);
}

BOOL GlobalInfo::OnInitDialog() 
{
  ExtractDataFromDungeon();

  CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//EnableControl(IDC_Hintable, pDoc->IsHintable() >= 0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void GlobalInfo::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(true);
  CaptureSpecialLocation(m_specialLocationName);
  EncodeDataIntoDungeon();
	CDialog::OnOK();
}

void GlobalInfo::OnSelchangeSpecialLocationName() 
{
	// TODO: Add your control notification handler code here
  int prevSel;
  prevSel = m_specialLocationName;
  UpdateData(true);
  CaptureSpecialLocation(prevSel);
  UpdateData(false);
}

void GlobalInfo::OnSpecialBrowse() 
{
	// TODO: Add your control notification handler code here
  LOCATIONABS loca, locaSpecial;
  LOCATIONREL locrTarget;
  UpdateData(true);
  loca.l = m_specialLevel;
  loca.x = m_specialX;
  loca.y = m_specialY;
  locrTarget = loca;
	EditTarget dlg(locrTarget,"Special Location",locaSpecial,true);
  if (dlg.DoModal() == IDOK)
  {
    locrTarget.l(dlg.m_locr.l());
    locrTarget.x(dlg.m_locr.x());
    locrTarget.y(dlg.m_locr.y());
    loca = locrTarget;
    m_specialLevel = loca.l;
    m_specialX = loca.x;
    m_specialY = loca.y;
    CaptureSpecialLocation(m_specialLocationName);
    UpdateData(false);
  };
	
}

void GlobalInfo::OnDatabase() 
{
	// TODO: Add your control notification handler code here
	DatabaseEditor dlg;
  dlg.DoModal();		
}
