// LevelLocations.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "LevelLocations.h"
#include "CSBuildDoc.h"
#include "EditTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// LevelLocations dialog


LevelLocations::LevelLocations(int level, CWnd* pParent /*=NULL*/)
	: CDialog(LevelLocations::IDD, pParent)
{
	//{{AFX_DATA_INIT(LevelLocations)
	m_maxDistance = 0;
	m_partyLevelOnly = FALSE;
	m_specialLocationName = -1;
	m_y = 0;
	m_x = 0;
	m_level = 0;
	//}}AFX_DATA_INIT
  m_editLevel = level;
}


void LevelLocations::CaptureSpecialLocation(int locationID)
{
  switch(locationID)
  {
  case 0: // Monster Movement Filter location
    m_monsterMoveFilterLevel = m_level;
    m_monsterMoveFilterX = m_x;
    m_monsterMoveFilterY = m_y;
    break;
  };
}

void LevelLocations::ExtractDataFromDungeon(void)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  bool bTemp;
  locr = pDoc->MonsterMoveFilterLocation(&bTemp, &m_maxDistance, m_editLevel);
  m_partyLevelOnly = bTemp;
  if (locr.l() < 0)
  {
    m_monsterMoveFilterLevel = -1;
    m_monsterMoveFilterX = 0;
    m_monsterMoveFilterY = 0;
    m_maxDistance = 0;
    m_partyLevelOnly = false;
  }
  else
  {
    loca = locr;
    m_monsterMoveFilterLevel = loca.l;
    m_monsterMoveFilterX = loca.x;
    m_monsterMoveFilterY = loca.y;
  };
}

void LevelLocations::EncodeDataIntoDungeon(void)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  loca.l = m_monsterMoveFilterLevel;
  loca.x = m_monsterMoveFilterX;
  loca.y = m_monsterMoveFilterY;
  locr = loca;
  pDoc->MonsterMoveFilterLocation(locr,m_partyLevelOnly?true:false, m_maxDistance, m_editLevel);
}



void LevelLocations::DoDataExchange(CDataExchange* pDX)
{
  if (!pDX->m_bSaveAndValidate)
  {
    if (m_specialLocationName < 0) m_specialLocationName = 0;
    switch(m_specialLocationName)
    {
    case 0: // Monster Move Filter Location
      m_level = m_monsterMoveFilterLevel;
      //ReadOnly(IDC_SpecialLevel, false);
      m_x = m_monsterMoveFilterX;
      m_y = m_monsterMoveFilterY;
      //Show(IDC_SpecialFacing, false);
      //Show(IDC_SpecialPosTitle, false);
      //Show(IDC_MaxDistance, true);
      //Show(IDC_MaxDistanceText, true);
      //Show(IDC_SameLevel, true);
      break;
    };
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LevelLocations)
	DDX_Text(pDX, IDC_MaxDistance, m_maxDistance);
	DDX_Check(pDX, IDC_PartyLevelOnly, m_partyLevelOnly);
	DDX_CBIndex(pDX, IDC_SpecialLocationName, m_specialLocationName);
	DDX_Text(pDX, IDC_Y, m_y);
	DDX_Text(pDX, IDC_X, m_x);
	DDX_Text(pDX, IDC_Level, m_level);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(LevelLocations, CDialog)
	//{{AFX_MSG_MAP(LevelLocations)
	ON_CBN_SELCHANGE(IDC_SpecialLocationName, OnSelchangeSpecialLocationName)
	ON_BN_CLICKED(IDC_Browse, OnBrowse)
	ON_BN_CLICKED(IDC_Delete, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LevelLocations message handlers

void LevelLocations::OnSelchangeSpecialLocationName() 
{
	// TODO: Add your control notification handler code here
  int prevSel;
  prevSel = m_specialLocationName;
  UpdateData(true);
  CaptureSpecialLocation(prevSel);
  UpdateData(false);
	
}

void LevelLocations::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
  LOCATIONABS loca, locaSpecial;
  LOCATIONREL locrTarget;
  UpdateData(true);
  loca.l = m_level;
  loca.x = m_x;
  loca.y = m_y;
  locrTarget = loca;
	EditTarget dlg(locrTarget,"Special Location",locaSpecial,true);
  if (dlg.DoModal() == IDOK)
  {
    locrTarget.l(dlg.m_locr.l());
    locrTarget.x(dlg.m_locr.x());
    locrTarget.y(dlg.m_locr.y());
    loca = locrTarget;
    m_level = loca.l;
    m_x = loca.x;
    m_y = loca.y;
    CaptureSpecialLocation(m_specialLocationName);
    UpdateData(false);
  };	
}

BOOL LevelLocations::OnInitDialog() 
{
  CString windowTitle;
  ExtractDataFromDungeon();
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  windowTitle.Format("Edit Special Locations for Level %d", m_editLevel);
	SetWindowText(windowTitle);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void LevelLocations::OnOK() 
{
	// TODO: Add extra validation here
  UpdateData(true);
  CaptureSpecialLocation(m_specialLocationName);
	EncodeDataIntoDungeon();
	CDialog::OnOK();
}

void LevelLocations::OnDelete() 
{
	// TODO: Add your control notification handler code here
  LOCATIONREL locr;
  UpdateData(true);
  m_level = -1;
  m_x = 0;
  m_y = 0;
  CaptureSpecialLocation(m_specialLocationName);
  UpdateData(false);
}
