// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "CSBuildView.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString encipheredDataFile;
extern CCSBuildView *pMainView;
extern char *gameInfo;

CMainFrame *pCMainFrame;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CAPTURECHANGED()
	ON_WM_INITMENU()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDM_Compressed, OnCompressed)
	ON_COMMAND(IDM_Dungeon, OnDungeon)
	ON_COMMAND(IDM_TargetMode, OnTargetMode)
  ON_UPDATE_COMMAND_UI(ID_INDICATOR_POS, OnUpdatePos)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
  ID_INDICATOR_POS,
  ID_INDICATOR_EMPTYSPACE,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	pCMainFrame = this;
}



CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
  m_wndStatusBar.SetPaneInfo(m_wndStatusBar.CommandToIndex(ID_INDICATOR_POS),
                             ID_INDICATOR_POS,SBPS_NORMAL,90);
  m_wndStatusBar.SetPaneInfo(m_wndStatusBar.CommandToIndex(ID_INDICATOR_EMPTYSPACE),
                             ID_INDICATOR_POS,SBPS_NOBORDERS,300);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar, AFX_IDW_DOCKBAR_LEFT );

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
  cs.style |= WS_MAXIMIZE;
  cs.cx = 800;
  cs.cy = 580;
  cs.x = 0;
  cs.y = 0;
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnUpdatePos(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(); 
}



void CMainFrame::SetPositionStatus(int level, int x, int y, int pos)
{ 
  int index;
  char msg[30];
  index = m_wndStatusBar.CommandToIndex(ID_INDICATOR_POS);
  if (level >= 0)
  {
    sprintf(msg,"Level[%02d(%02d,%02d)%d]",level,x,y,pos);
  }
  else
  {
    msg[0] = 0;
  };
  m_wndStatusBar.SetPaneText(index,msg,TRUE);
}

void CMainFrame::OnCaptureChanged(CWnd *pWnd) 
{
	// TODO: Add your message handler code here
	
	CFrameWnd::OnCaptureChanged(pWnd);
}

void CMainFrame::OnInitMenu(CMenu* pMenu) 
{
	CFrameWnd::OnInitMenu(pMenu);
	
	// TODO: Add your message handler code here
	
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	
	// TODO: Add your message handler code here
	if (nIndex == 0) // File Menu
  {
    pPopupMenu->EnableMenuItem(IDM_WriteAscii, MF_ENABLED);
    pPopupMenu->CheckMenuItem(IDM_WriteAscii, MF_UNCHECKED);

    pPopupMenu->EnableMenuItem(IDM_Compressed, MF_ENABLED);
    pPopupMenu->CheckMenuItem(IDM_Compressed,
           pDoc->Compressed() ? MF_CHECKED : MF_UNCHECKED);

    pPopupMenu->EnableMenuItem(IDM_Dungeon, MF_ENABLED);
    pPopupMenu->CheckMenuItem(IDM_Dungeon,
           pDoc->DungeonFormat() ? MF_CHECKED : MF_UNCHECKED);

    pPopupMenu->EnableMenuItem(IDM_LittleEndian, MF_ENABLED);
    pPopupMenu->CheckMenuItem(IDM_LittleEndian,
           pDoc->m_littleEndian ? MF_CHECKED : MF_UNCHECKED);

    pPopupMenu->EnableMenuItem(IDM_Encrypt, MF_ENABLED);
    pPopupMenu->CheckMenuItem(IDM_Encrypt,
           (encipheredDataFile != "") ? MF_CHECKED : MF_UNCHECKED);
    if (encipheredDataFile != "")
    {
      pPopupMenu->CheckMenuItem(IDM_Compressed,MF_UNCHECKED);
      pPopupMenu->EnableMenuItem(IDM_Compressed,MF_DISABLED|MF_GRAYED);
    };
  };
  if (nIndex == 1) // Edit Menu
  {
    pPopupMenu->EnableMenuItem(ID_EDIT_UNDO,
      (pDoc->IsCellUndoAvailable())?MF_ENABLED:MF_DISABLED|MF_GRAYED);
    pPopupMenu->EnableMenuItem(ID_EDIT_REDO,
      (pDoc->IsCellRedoAvailable())?MF_ENABLED:MF_DISABLED|MF_GRAYED);
  };
  if (nIndex == 2) //View Menu
  {
    pPopupMenu->EnableMenuItem(IDM_TargetMode, MF_ENABLED);
    pPopupMenu->CheckMenuItem(IDM_TargetMode,
      pDoc->m_targetMode ? MF_CHECKED : MF_UNCHECKED);
  };
}

void CMainFrame::OnCompressed() 
{
	// TODO: Add your command handler code here
	
	pDoc->Compressed(!pDoc->Compressed());
}

void CMainFrame::OnDungeon() 
{
	// TODO: Add your command handler code here

  pDoc->DungeonFormat(!pDoc->DungeonFormat());
  if (pMainView != NULL) pMainView->Invalidate();
}

void CMainFrame::OnTargetMode() 
{
	// TODO: Add your command handler code here
  pDoc->m_targetMode = !pDoc->m_targetMode;	
}

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();
	
	// TODO: Add your message handler code here
	
}
