// ObjectListBox.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "ObjectListBox.h"
#include "Actuator.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CObjectListBox

CObjectListBox::CObjectListBox()
{
}

CObjectListBox::~CObjectListBox()
{
}


BEGIN_MESSAGE_MAP(CObjectListBox, CListBox)
	//{{AFX_MSG_MAP(CObjectListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CObjectListBox message handlers

void CObjectListBox::AddObject(const char *item, RN obj, int depth)
{
  int index;
  CString name = item;
//  if (obj.IsCloned()) name = CString("!!!!") + name; 
  if (depth < 0)
  {
    index = AddString(name);
  }
  else
  {
    CString s;
    s.Format("<%d>[%04x]%s",depth, obj.ConvertToInteger(),name);
    index = AddString(s);
  };
  if ((index==LB_ERR)||(index==LB_ERRSPACE)) return;
  SetItemData(index, obj.ConvertToInteger());
}

void CObjectListBox::AddMonster(RN obj, int depth)
{
  DB4 *pDB4;
  MONSTERTYPE mt;
  char listitem[80];
  RN possession;
  pDB4 = pDoc->GetRecordAddressDB4(obj);
  if (pDB4->link() == RNnul)
  {
    AddObject("Monster NULL record",RNnul,depth);
    return;
  };
  mt = pDB4->monsterType();
  sprintf(listitem,"MT%02d=", mt);
  sprintf(listitem+strlen(listitem),"%s ",mt.Name(pDB4->alternateGraphics()));
  AddObject(listitem,obj,depth);
}

void CObjectListBox::AddActuator(RN obj, ROOMTYPE rt, int depth)
{
  DB3 *pDB3;
  ACTUATOR_PressurePad *pAC_PressurePad;
  ACTUATORCLASS ac;
  CString name;
  char listitem[80];
  pDB3 = pDoc->GetRecordAddressDB3(obj);
  if (pDB3->link() == RNnul)
  {
    AddObject("Actuator NULL record",RNnul,depth);
    return;
  };
  ac = pDB3->actuatorClass(rt);
  name = pDB3->Name(rt);
  sprintf(listitem,"%04x-AC%02d=",obj.ConvertToInteger(),ac);
  switch (ac)
  {
  case AC_PRESSUREPAD:
    pAC_PressurePad = pDB3->Cast2AC_PressurePad(rt);
    if (!pAC_PressurePad->localAction() && (rt!=roomSTONE))
    {
      sprintf(listitem+strlen(listitem),name);
      break;
    };
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_MONSTERGENERATOR:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_PUSHBUTTON:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_LAUNCHER:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_ENDGAME:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_COUNTER:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_ANDOR:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_DISABLED:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_OBJECTHOLDER:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_SWAPOBJECT:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_PORTRAIT:
    sprintf(listitem+strlen(listitem),name);
    break;
  case AC_DSA:
    sprintf(listitem+strlen(listitem),name);
    break;
  default: 
    sprintf(listitem+strlen(listitem),name);
  };
  AddObject(listitem,obj,depth);
}


void CObjectListBox::AddTeleporter(RN obj, int depth)
{
  DB1 *pDB1;
  char line[80];
  LOCATIONREL locr;
  LOCATIONABS loca;
  pDB1 = pDoc->GetRecordAddressDB1(obj);
  if (pDB1->link() == RNnul)
  {
    AddObject("Teleporter NULL record",RNnul,depth);
    return;
  };
  locr.l(pDB1->destLevel());
  locr.x(pDB1->destX());
  locr.y(pDB1->destY());
  locr.p(0);
  loca = locr;
  sprintf(line,"Teleporter to %d(%02d,%02d)",
            loca.l, loca.x, loca.y);
  AddObject(line,obj,depth);
}


void CObjectListBox::AddDoor(RN obj, int depth)
{
  DB0 *pDB0;
  pDB0 = pDoc->GetRecordAddressDB0(obj);
  if (pDB0->link() == RNnul)
  {
    AddObject("Door NULL record",RNnul,depth);
    return;
  };
  AddObject("Door",obj,depth);
}

void CObjectListBox::AddClothing(RN obj, int depth)
{
  DB6 *pDB6;
  MODIFIEDOBJECTTYPE mot;
  char listitem[80];
  CString obName;
  pDB6 = pDoc->GetRecordAddressDB6(obj);
  if (pDB6->link() == RNnul)
  {
    AddObject("Clothing Item NULL record", RNnul, depth);
    return;
  };
  mot = MODIFIEDOBJECTTYPE(obj);
  obName = mot.Name();
  sprintf(listitem, "CL%03d=%s", mot.Integer(), obName);
  AddObject(listitem, obj, depth);
}

void CObjectListBox::AddChest(RN obj, int depth)
{
  AddObject("Chest",obj,depth);
}

void CObjectListBox::AddMissile(RN obj, int depth)
{
  AddObject("Missile",obj,depth);
}

void CObjectListBox::AddCloud(RN obj, int depth)
{
  AddObject("Cloud",obj,depth);
}

void CObjectListBox::AddPit(int depth)
{
  AddObject("Pit",RNpit,depth);
}

void CObjectListBox::AddMisc(RN obj, int depth)
{
  DB10 *pDB10;
  MODIFIEDOBJECTTYPE mot;
  char listitem[80];
  CString obName;
  pDB10 = pDoc->GetRecordAddressDB10(obj);
  if (pDB10->link() == RNnul)
  {
    AddObject("Misc NULL record",RNnul,depth);
    return;
  };
  mot = MODIFIEDOBJECTTYPE(obj);
  obName = mot.Name();
  sprintf(listitem, "MI%03d=%s", mot.Integer(), obName);
  AddObject(listitem,obj,depth);
}

void CObjectListBox::AddPotion(RN obj, int depth)
{
  DB8 *pDB8;
  MODIFIEDOBJECTTYPE mot;
  char listitem[80];
  CString obName;
  pDB8 = pDoc->GetRecordAddressDB8(obj);
  if (pDB8->link() == RNnul)
  {
    AddObject("Potion NULL record",RNnul,depth);
    return;
  };
  mot = MODIFIEDOBJECTTYPE(obj);
  obName = mot.Name();
  sprintf(listitem, "PO%03d=%s", mot, obName);
  AddObject(listitem,obj,depth);
}

void CObjectListBox::AddScroll(RN obj, int depth)
{
  AddObject((LPCSTR)obj.Name(roomSTONE),obj,depth);
}

void CObjectListBox::AddWeapon(RN obj, int depth)
{
  DB5 *pDB5;
  MODIFIEDOBJECTTYPE mot;
  char listitem[80];
  CString obName;
  pDB5 = pDoc->GetRecordAddressDB5(obj);
  if (pDB5->link() == RNnul)
  {
    AddObject("Weapon NULL record",RNnul,depth);
    return;
  };
  mot = MODIFIEDOBJECTTYPE(obj);
  obName = mot.Name();
  sprintf(listitem, "WP%03d=%s", mot.Integer(), obName);
  AddObject(listitem,obj,depth);
}

void CObjectListBox::AddText(RN obj, int depth)
{
  AddObject("Text",obj,depth);
}

void CObjectListBox::AddObject(RN obj, ROOMTYPE rt) 
{
  DBTYPE dbType;
  dbType = obj.dbType();
  switch (dbType)
  {
  case dbACTUATOR:
    AddActuator(obj, rt);
    break;
  case dbCLOTHING:
    AddClothing(obj);
    break;
  case dbMISC:
    AddMisc(obj);
    break;
  case dbSCROLL:
    AddScroll(obj);
    break;
  case dbCHEST:
    AddChest(obj);
    break;
  case dbPOTION:
    AddPotion(obj);
    break;
  case dbWEAPON:
    AddWeapon(obj);
    break;
  case dbMONSTER:
    AddMonster(obj);
    break;
  case dbTEXT:
    AddText(obj);
    break;
  default:
    pDoc->Sorry("Illegal object type in\nCObjectListBox::AddObjectToList");
  };
}

bool CObjectListBox::Pop(RN *objectList)
{
  int index;
  RN objID;
  index = GetCurSel();
  if (index < 0)
  {
    pDoc->Sorry("You first need to make a selection");
    return false;
  };
  objID.ConstructFromInteger(GetItemData(index));
  pDoc->DeleteObjectFromList(objID, objectList, false);
  pDoc->AddObjectToList(objID, objectList, RNeof);
  return true;
}
