// ShowLocations.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "CSBuildView.h"
#include "misc.h"
#include "ShowLocations.h"

extern CCSBuildView *pMainView;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ShowLocations dialog


ShowLocations::ShowLocations(
                             OBJECTLIST *objectList,
                             CWnd* pParent /*=NULL*/)
	: CDialog(ShowLocations::IDD, pParent)
{
	//{{AFX_DATA_INIT(ShowLocations)
	//}}AFX_DATA_INIT
  m_pObjectList = objectList;
  m_title = "Locations";
}

void ShowLocations::DrawLevel(CPaintDC *pDC, 
                              int level, 
                              bool drawTarget)
{
  CDC myDC;
  int row, col;
  int top, bottom, left, right;
  CBitmap *origBitmap;
  CPen pen1, pen2, *pOldPen;
  myDC.CreateCompatibleDC(pDC);
  origBitmap = myDC.SelectObject(&pMainView->m_tileBitmap);
  for (row=0; row<=pDoc->LastRow(level); row++)
  {
    for (col=0; col<=pDoc->LastColumn(level); col++)
    {
      pMainView->DrawCell(pDC, &myDC, level, col, row); 
    };
  };
  if (drawTarget)
  {
    top = m_currentY*16;
    left = m_currentX*16;
    bottom = top+16;
    right = left + 16;
    pen1.CreatePen( PS_SOLID, 2, RGB(0,255,255) );
    pOldPen = pDC->SelectObject(&pen1);
    top -= 1;
    left -= 1;
    bottom += 1;
    right += 1;
    pDC->MoveTo(left,top);
    pDC->LineTo(right,top);
    pDC->LineTo(right,bottom);
    pDC->LineTo(left,bottom);
    pDC->LineTo(left,top);
    top -= 3;
    left -= 3;
    bottom += 2;
    right += 2;
    pen2.CreatePen(PS_SOLID, 3, RGB(255,0,0));
    pDC->SelectObject(&pen2);
    pDC->MoveTo(left,top);
    pDC->LineTo(right,top);
    pDC->LineTo(right,bottom);
    pDC->LineTo(left,bottom);
    pDC->LineTo(left,top);
    pDC->SelectObject(pOldPen);
    top -= 2;
    left -= 2;
    bottom += 3;
    right += 3;
    pDC->SelectObject(&pen1);
    pDC->MoveTo(left,top);
    pDC->LineTo(right,top);
    pDC->LineTo(right,bottom);
    pDC->LineTo(left,bottom);
    pDC->LineTo(left,top);
    pDC->MoveTo(0,0);
    pDC->LineTo(left,top);
    pDC->MoveTo(16*32,0);
    pDC->LineTo(right,top);
    pDC->MoveTo(16*32, 16*32);
    pDC->LineTo(right,bottom);
    pDC->MoveTo(0,16*32);
    pDC->LineTo(left,bottom);
    pDC->SelectObject(pOldPen);
  };
}

void ShowLocations::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ShowLocations)
	DDX_Control(pDX, IDC_LocationList, m_locationList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ShowLocations, CDialog)
	//{{AFX_MSG_MAP(ShowLocations)
	ON_CBN_SELCHANGE(IDC_LocationList, OnSelchangeLocationList)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ShowLocations message handlers

void ShowLocations::FillLocationList(void)
{
  int i;
  CString line;
  LOCATIONABS loca;
  for (i=0; i<m_pObjectList->NumEnt(); i++)
  {
    loca = m_pObjectList->GetLocation(i);
    line.Format("%02d(%02d,%02d)%d",
                loca.l,
                loca.x,
                loca.y,
                loca.p);
    m_locationList.AddString(line);
  };
}

BOOL ShowLocations::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	// TODO: Add extra initialization here
//	MoveWindow(0,0,16*32 + 125, 16*32 + 24);
  SetWindowText(m_title);
  FillLocationList();
  m_locationList.SetCurSel(0);
  OnSelchangeLocationList();
  GotoDlgCtrl(GetDlgItem(IDC_LocationList));
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void ShowLocations::OnSelchangeLocationList() 
{
	// TODO: Add your control notification handler code here
	int n;
  n = m_locationList.GetCurSel();
  m_currentX = m_pObjectList->GetLocation(n).x();
  m_currentY = m_pObjectList->GetLocation(n).y();
  m_currentL = m_pObjectList->GetLocation(n).l();
  Invalidate();
}

void ShowLocations::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
  DrawLevel(&dc, m_currentL, true);
	
	// Do not call CDialog::OnPaint() for painting messages
}
