// SwapLevels.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "SwapLevels.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SwapLevels dialog


SwapLevels::SwapLevels(CWnd* pParent /*=NULL*/)
	: CDialog(SwapLevels::IDD, pParent)
{
	//{{AFX_DATA_INIT(SwapLevels)
	m_firstLevel = 0;
	m_secondLevel = 0;
	m_firstLevelThrough = 0;
	//}}AFX_DATA_INIT
}


void SwapLevels::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SwapLevels)
	DDX_Text(pDX, IDC_FirstLevel, m_firstLevel);
	DDV_MinMaxUInt(pDX, m_firstLevel, 0, 63);
	DDX_Text(pDX, IDC_SecondLevel, m_secondLevel);
	DDV_MinMaxUInt(pDX, m_secondLevel, 0, 63);
	DDX_Text(pDX, IDC_FirstLevelThrough, m_firstLevelThrough);
	DDV_MinMaxUInt(pDX, m_firstLevelThrough, 0, 63);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SwapLevels, CDialog)
	//{{AFX_MSG_MAP(SwapLevels)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SwapLevels message handlers

void SwapLevels::OnOK() 
{
	// TODO: Add extra validation here
  bool overlap;
  UpdateData(true);
  if (    (m_firstLevel >= (unsigned)pDoc->NumLevel())
       || (m_firstLevelThrough >= (unsigned)pDoc->NumLevel())
       || (m_secondLevel >= (unsigned)pDoc->NumLevel()))
  {
    CString str;
    str.Format
          ("All the specified levels must\n"
           "be less than %d.", 
           pDoc->NumLevel());
    Error(str);
    return;
  };
  overlap = false;
  if (m_firstLevelThrough < m_firstLevel) 
  {
    m_delta = -1;
    if (   (m_secondLevel <= m_firstLevel)
        && (m_secondLevel >= m_firstLevelThrough) )
    {
      overlap = true;
    };
  }
  else
  {
    m_delta = 1;
    if (   (m_secondLevel >= m_firstLevel)
        && (m_secondLevel <= m_firstLevelThrough) )
    {
      overlap = true;
    }
  };
  if (overlap)
  {
    Error("The levels overlap.  That\n"
          "is not allowed");
    return;
  };
  m_secondLevelThrough = m_secondLevel;
  if (m_secondLevel < m_firstLevel)
  {
    UINT temp;
    temp = m_firstLevel;
    m_firstLevel = m_secondLevel;
    m_secondLevel = temp;
    temp = m_firstLevelThrough;
    m_firstLevelThrough = m_secondLevelThrough;
    m_secondLevelThrough = temp;
  };
  UpdateData(false);
	CDialog::OnOK();
}
