// dlg_InsertObject.cpp : implementation file
//

#include "stdafx.h"
//#include "types.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "dlg_InsertObject.h"
#include "misc.h"
#include "Actuator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString TranslateObjectName(const char *name);

/////////////////////////////////////////////////////////////////////////////
// dlg_InsertObject dialog


dlg_InsertObject::dlg_InsertObject(LOCATIONREL locr,
                                   int typeMask,
                                   CWnd* pParent /*=NULL*/)
	: CDialog(dlg_InsertObject::IDD, pParent)
{
  int i;
  m_locr = locr;
  m_typeMask = typeMask;
	//{{AFX_DATA_INIT(dlg_InsertObject)
	m_dataType = -1;
	m_option1Value = FALSE;
	//}}AFX_DATA_INIT
  m_objectListIndex = -1;
  m_weaponType = TranslateObjectName("ARROW");
  m_potionType = TranslateObjectName("VI POTION(HEALTH)");
  m_miscType = TranslateObjectName("APPLE");
  m_clothingType = TranslateObjectName("SANDALS");
  m_modifiedObjectType = "NONE";
  m_monsterType = TranslateObjectName("Giggler");
  m_title = "";
  for (i=0; i<16; i++) m_allowedOptions[i] = 0;
}

void dlg_InsertObject::Enable(int id)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd != NULL) pWnd->EnableWindow(true);
}

void dlg_InsertObject::Disable(int id)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd != NULL) pWnd->EnableWindow(false);
}

DBTYPE listorder[11] = {
  dbWEAPON,
  //dbTELEPORTER,
  //dbDOOR,
  dbTEXT,
  dbACTUATOR,
  dbMONSTER,
  dbCLOTHING,
  dbPOTION,
  dbCHEST,
  dbSCROLL,
  dbMISC
};

void dlg_InsertObject::AddObject(ACTUATORCLASS actype, char *name)
{
  int index;
  index = m_objectList.AddString(name);
  m_objectList.SetItemData(index, actype);
}

void dlg_InsertObject::Show(int id, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->ShowWindow(show);
}

void dlg_InsertObject::SetText(int id, CString& text)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->SetWindowText(text);
}

void dlg_InsertObject::DoDataExchange(CDataExchange* pDX)
{
  int i;
  if (!pDX->m_bSaveAndValidate)
  {
    Enable(IDC_InsertObjectWeapon);
    Enable(IDC_InsertObjectTeleporter);
    Enable(IDC_InsertObjectDoor);
    Enable(IDC_InsertObjectText);
    Enable(IDC_InsertObjectActuator);
    Enable(IDC_InsertObjectMonster);
    Enable(IDC_InsertObjectClothing);
    Enable(IDC_InsertObjectPotion);
    Enable(IDC_InsertObjectChest);
    Enable(IDC_InsertObjectScroll);
    Enable(IDC_InsertObjectMisc);
    Enable(IDC_ObjectList);
    if (m_dataType == -1)
    {
      for (i=0; i<11; i++)
      {
        if ((m_typeMask & (1<<listorder[i])) != 0)
        {
          m_dataType = i;
        };
      };
    };
    if (m_option1Title != "")
    {
      Show(IDC_Option1,true);
      SetText(IDC_Option1, m_option1Title);
    }
    else
    {
      Show(IDC_Option1,false);
    };
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(dlg_InsertObject)
	DDX_Control(pDX, IDC_Option1, m_Option1Ctrl);
	DDX_Control(pDX, IDC_ObjectList, m_objectList);
	DDX_Radio(pDX, IDC_InsertObjectWeapon, m_dataType);
	DDX_Check(pDX, IDC_Option1, m_option1Value);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    if ((m_typeMask & (1<<dbACTUATOR)) == 0)
                      Disable(IDC_InsertObjectActuator);
    if ((m_typeMask & (1<<dbTEXT)) == 0)
                      Disable(IDC_InsertObjectText);
    if ((m_typeMask & (1<<dbDOOR)) == 0)
                      Disable(IDC_InsertObjectDoor);
    if ((m_typeMask & (1<<dbTELEPORTER)) == 0)
                      Disable(IDC_InsertObjectTeleporter);
    if ((m_typeMask & (1<<dbMISC)) == 0)
                      Disable(IDC_InsertObjectMisc);
    if ((m_typeMask & (1<<dbSCROLL)) == 0)
                      Disable(IDC_InsertObjectScroll);
    if ((m_typeMask & (1<<dbCHEST)) == 0)
                      Disable(IDC_InsertObjectChest);
    if ((m_typeMask & (1<<dbPOTION)) == 0)
                      Disable(IDC_InsertObjectPotion);
    if ((m_typeMask & (1<<dbCLOTHING)) == 0)
                      Disable(IDC_InsertObjectClothing);
    if ((m_typeMask & (1<<dbMONSTER)) == 0)
                      Disable(IDC_InsertObjectMonster);
    if ((m_typeMask & (1<<dbWEAPON)) == 0)
                      Disable(IDC_InsertObjectWeapon);
    if (m_objectListIndex == -1) m_objectListIndex = 0;
    switch (listorder[m_dataType])
    {
    case dbWEAPON: //Weapon
      m_weaponIndex = m_weaponType.FillComboBox(&m_objectList);
      m_dbType = dbWEAPON;
      break;
    //case 1: //Teleporter
      //m_dbType = dbTELEPORTER;
      //m_objectList.ResetContent();
      //Disable(IDC_ObjectList);
      //break;
    case dbTEXT: //Text
      m_dbType = dbTEXT;
      m_objectList.ResetContent();
      Disable(IDC_ObjectList);
      break;
    case dbACTUATOR: //Actuator
      m_objectList.ResetContent();
      if (IsActuatorClassAllowed(AC_PRESSUREPAD, m_locr))
        AddObject(AC_PRESSUREPAD,"Pressure Pad");
      if (IsActuatorClassAllowed(AC_MONSTERGENERATOR, m_locr))
        AddObject(AC_MONSTERGENERATOR,"Monster Generator");
      if (IsActuatorClassAllowed(AC_LAUNCHER, m_locr))
        AddObject(AC_LAUNCHER,"Shooter");
      if (IsActuatorClassAllowed(AC_PUSHBUTTON, m_locr))
        AddObject(AC_PUSHBUTTON,"Pushbutton");
      if (IsActuatorClassAllowed(AC_ANDOR, m_locr))
        AddObject(AC_ANDOR,"AND/OR Gate");
      if (IsActuatorClassAllowed(AC_COUNTER, m_locr))
        AddObject(AC_COUNTER,"Counter");
      if (IsActuatorClassAllowed(AC_ENDGAME, m_locr))
        AddObject(AC_ENDGAME,"End Game");
      if (IsActuatorClassAllowed(AC_OBJECTHOLDER, m_locr))
        AddObject(AC_OBJECTHOLDER,"Object Holder");
      if (IsActuatorClassAllowed(AC_SWAPOBJECT, m_locr))
        AddObject(AC_SWAPOBJECT,"Swap Object");
      if (IsActuatorClassAllowed(AC_PORTRAIT, m_locr))
        AddObject(AC_PORTRAIT,"Champion Portrait");
      if (IsActuatorClassAllowed(AC_DISABLED, m_locr))
        AddObject(AC_DISABLED,"Disabled");
      if (IsActuatorClassAllowed(AC_DSA, m_locr))
        AddObject(AC_DSA,"Designer-Specified Actuator");
      m_dbType = dbACTUATOR;
      break;
    case dbMONSTER: //Monster
      {
        m_objectList.ResetContent();
        int i, index;
        MONSTERTYPE mt;
        m_objectList.ResetContent();
        if (m_locr.l() >= 0)
        {
          //List monsters on a single level.
          for (i=0; i<pDoc->NumMonsterType(m_locr.l()); i++)
          {
            mt = pDoc->MonsterType(m_locr.l(),i);
            index = m_objectList.AddString(mt.Name());
            m_objectList.SetItemData(index, mt.Integer());
          }
        }
        else
        {
          //List all possible monsters
          m_monsterIndex = m_monsterType.FillComboBox(&m_objectList);
          m_objectList.SetCurSel(m_monsterIndex);
        };
        m_dbType = dbMONSTER;
      };
      break;
    case dbCLOTHING: //Clothing
      m_clothingIndex = m_clothingType.FillComboBox(&m_objectList);
      m_dbType = dbCLOTHING;
      break;
    case dbPOTION: //Potion
      m_potionIndex = m_potionType.FillComboBox(&m_objectList);
      m_dbType = dbPOTION;
      break;
    case dbCHEST: //Chest
      m_dbType = dbCHEST;
      m_objectList.ResetContent();
      Disable(IDC_ObjectList);
      break;
    case dbSCROLL: //Scroll
      m_dbType = dbSCROLL;
      m_objectList.ResetContent();
      Disable(IDC_ObjectList);
      break;
    case dbMISC: //Miscellaneous
      m_miscIndex = m_miscType.FillComboBox(&m_objectList);
      m_dbType = dbMISC;
      break;
    default: 
      m_objectList.ResetContent();
      NotImplemented();
      break;
    };
    m_objectList.SetCurSel(m_objectListIndex);
    Show(IDC_Option1, (m_allowedOptions[m_dbType]&1)!=0);
  };
  if (pDX->m_bSaveAndValidate)
  {
    m_dbType = listorder[m_dataType];
    switch (m_dbType)
    {
    case dbWEAPON:
      i = m_objectList.GetCurSel();
      m_weaponType = WEAPONTYPE(m_objectList.GetItemData(i));
      m_modifiedObjectType = m_weaponType;
      break;
    case dbCLOTHING:
      i = m_objectList.GetCurSel();
      m_clothingType = CLOTHINGTYPE(m_objectList.GetItemData(i));
      m_modifiedObjectType = m_clothingType;
      break;
    case dbPOTION:
      i = m_objectList.GetCurSel();
      m_potionType = POTIONTYPE(m_objectList.GetItemData(i));
      m_modifiedObjectType = m_potionType;
      break;
    case dbMISC:
      i = m_objectList.GetCurSel();
      m_miscType = MISCTYPE(m_objectList.GetItemData(i));
      m_modifiedObjectType = m_miscType;
      break;
    case dbMONSTER:
      i = m_objectList.GetCurSel();
      m_monsterType = MONSTERTYPE(m_objectList.GetItemData(i));
      m_modifiedObjectType = "NONE";
      break;
    case dbCHEST:
      m_modifiedObjectType = "NONE";
      break;
    case dbSCROLL:
      m_modifiedObjectType = "NONE";
      break;
    case dbTEXT:
      m_modifiedObjectType = "NONE";
      break;
    case dbACTUATOR:
      m_modifiedObjectType = "NONE";
      break;
    case dbTELEPORTER:
      m_modifiedObjectType = "NONE";
      break;
    default:
      m_modifiedObjectType = "NONE";
      NotImplemented();
    };
  };
}


BEGIN_MESSAGE_MAP(dlg_InsertObject, CDialog)
	//{{AFX_MSG_MAP(dlg_InsertObject)
	ON_BN_CLICKED(IDC_InsertObjectActuator, OnInsertObjectActuator)
	ON_BN_CLICKED(IDC_InsertObjectChest, OnInsertObjectChest)
	ON_BN_CLICKED(IDC_InsertObjectClothing, OnInsertObjectClothing)
//	ON_BN_CLICKED(IDC_InsertObjectDoor, OnInsertObjectDoor)
	ON_BN_CLICKED(IDC_InsertObjectMisc, OnInsertObjectMisc)
	ON_BN_CLICKED(IDC_InsertObjectMonster, OnInsertObjectMonster)
	ON_BN_CLICKED(IDC_InsertObjectPotion, OnInsertObjectPotion)
	ON_BN_CLICKED(IDC_InsertObjectScroll, OnInsertObjectScroll)
//	ON_BN_CLICKED(IDC_InsertObjectTeleporter, OnInsertObjectTeleporter)
	ON_BN_CLICKED(IDC_InsertObjectText, OnInsertObjectText)
	ON_BN_CLICKED(IDC_InsertObjectWeapon, OnInsertObjectWeapon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// dlg_InsertObject message handlers

int dlg_InsertObject::EncodeDataIntoRecord(void)
{
  if (m_locr.l() == -1) return 0; //Don't create an object!
  switch(m_dbType)
  {
  case dbACTUATOR:
    m_actuatorType = (ACTUATORCLASS)m_objectList.GetItemData(m_objectList.GetCurSel());
    m_insertObject = pDoc->FindEmptyDB3Entry(m_actuatorType);
    break;
  case dbWEAPON:
    m_insertObject = pDoc->FindEmptyDB5Entry(m_weaponType);
    break;
  case dbCLOTHING:
    m_insertObject = pDoc->FindEmptyDB6Entry(m_clothingType);
    break;
  case dbPOTION:
    m_insertObject = pDoc->FindEmptyDB8Entry(m_potionType);
    break;
  case dbMISC:
    m_insertObject = pDoc->FindEmptyDB10Entry(m_miscType);
    break;
  case dbMONSTER:
    m_insertObject = pDoc->FindEmptyDB4Entry(m_monsterType);
    break;
  case dbCHEST:
    m_insertObject = pDoc->FindEmptyDB9Entry();
    break;
  case dbSCROLL:
    m_insertObject = pDoc->FindEmptyDB7Entry();
    break;
  case dbTEXT:
    m_insertObject = pDoc->FindEmptyDB2Entry(TEXTTYPE_WALL);
    break;
  case dbTELEPORTER:
    m_insertObject = pDoc->FindEmptyDB1Entry();
    break;
  default:
    NotImplemented();
    return 1;
  };
  return 0;
}

void dlg_InsertObject::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(true);
  m_dbType = dbILLEGAL;
  if (m_dataType >= 0) m_dbType = listorder[m_dataType];
  if (EncodeDataIntoRecord() != 0) 
  {
    CDialog::OnCancel();
    return;
  };
	CDialog::OnOK();
}

int dlg_InsertObject::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
  if (m_typeMask == 0) return IDCANCEL;
	return CDialog::DoModal();
}

static int computeDataType(DBTYPE dbtype)
{
  int i;
  for (i=0; i<sizeof(listorder)/sizeof(listorder[0]); i++)
  {
    if (listorder[i] == dbtype) return i;
  };
  return 0;
}

void dlg_InsertObject::OnInsertObjectActuator() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbACTUATOR);
  UpdateData(false);
}

void dlg_InsertObject::OnInsertObjectChest() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbCHEST);
  UpdateData(false);
	
}

void dlg_InsertObject::OnInsertObjectClothing() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbCLOTHING);
  UpdateData(false);
	
}
/*
void dlg_InsertObject::OnInsertObjectDoor() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbDOOR);
  UpdateData(false);
	
}
*/
void dlg_InsertObject::OnInsertObjectMisc() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbMISC);
  UpdateData(false);
	
}

void dlg_InsertObject::OnInsertObjectMonster() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbMONSTER);
  UpdateData(false);
	
}

void dlg_InsertObject::OnInsertObjectPotion() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbPOTION);
  UpdateData(false);
	
}

void dlg_InsertObject::OnInsertObjectScroll() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbSCROLL);
  UpdateData(false);
	
}
/*
void dlg_InsertObject::OnInsertObjectTeleporter() 
{
	// TODO: Add your control notification handler code here
  m_dataType = 1;
  UpdateData(false);
	
}
*/
void dlg_InsertObject::OnInsertObjectText() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbTEXT);
  UpdateData(false);
}

void dlg_InsertObject::OnInsertObjectWeapon() 
{
	// TODO: Add your control notification handler code here
  m_dataType = computeDataType(dbWEAPON);
  UpdateData(false);
	
}

BOOL dlg_InsertObject::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  if (m_title != "") SetWindowText(m_title);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
