#if !defined(AFX_HINTS1_H__C35D7DAF_5F1A_4493_9B91_055FD74783AB__INCLUDED_)
#define AFX_HINTS1_H__C35D7DAF_5F1A_4493_9B91_055FD74783AB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//




/////////////////////////////////////////////////////////////////////////////
// Hints dialog


enum
{
  HINTERR_NoCells = 1,
  HINTERR_NoMemory,
  HINTERR_NoHint,
  HINTERR_NoOpenParen,
  HINTERR_NoCloseParen,
  HINTERR_BadDigit,
  HINTERR_NoComma
};

class HINT
{
  friend class HINTS;
  int CountCells(char *buf);
  int ReadCells(char *buf);
  int AddHint(char *buf);
  int Decimal(char *buf, int& col, int& n);
  HINT         *m_next;
private:
  CString       m_text;
  unsigned int *m_cells;
  int           m_numCell;
  HINT         *m_firstHint;
  bool  AnyHintsFor(int location);
  bool  AnyHintForLevel(int level);
  void  SetHint(unsigned int location);
  void  RemoveHint(unsigned int location);
  
public:
  HINT(CString& title);
  ~HINT(void);
  int Read(FILE *f, char *buf, int& lineNum);
  int Write(FILE *f);
  CString Title(void){return m_text;};
  int   NumCell(void){return m_numCell;};
  unsigned int GetCell(int cellNum);
};

class HINTS
{
private:
  HINT **m_hintArray;
  int    m_numHint;
public:
  HINTS(void);
  ~HINTS(void);
  void Clear(void);
  int Read(FILE *f);
  int Write(FILE *f);
//  int GetHint(int level, int col, int row);
  void SetHint(int level, int col, int row, int hint);
  void RemoveHint(int level, int col, int row, int hint);
  bool HasHint(int location, int hint);
  bool LevelHasHint(int level, int hint);
  int  NumHint(void){return m_numHint;};
  HINT *GetHint(int hintNum);
  CString GetTitle(int hint){return m_hintArray[hint]->Title();};
};

extern HINTS hintLib;

class Hints : public CDialog
{
// Construction
public:
	Hints(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(Hints)
	enum { IDD = IDD_Hints };
	CListBox	m_hintList;
	BOOL	m_showAll;
	UINT	m_currentLevel;
	//}}AFX_DATA

  int m_currentHint;
  CString m_title;
  int m_currentL;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Hints)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL

  void FillHintList(void);
  void DrawLevel(CPaintDC *pDC,
                 int level);


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(Hints)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeHintList();
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnDeltaposLevelSpin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeLevel();
	afx_msg void OnShowAll();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRead();
	afx_msg void OnWrite();
	afx_msg void OnFind();
	afx_msg void OnCountByCell();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HINTS1_H__C35D7DAF_5F1A_4493_9B91_055FD74783AB__INCLUDED_)
